SystemOrganization addCategory: #CooperatingLanguages!
SystemOrganization addCategory: #'CooperatingLanguages-Demos'!
SystemOrganization addCategory: #'CooperatingLanguages-Examples'!
SystemOrganization addCategory: #'CooperatingLanguages-Libraries'!
SystemOrganization addCategory: #'CooperatingLanguages-Tests'!

OMeta2 subclass: #CoopLangParser
	instanceVariableNames: 'program'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

CoopLangParser subclass: #CoopLangCassowaryInputParser
	instanceVariableNames: 'variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 6/27/2012 15:25'!
constraint =
	// return a ClConstraint (computed by performing the relation symbol on the first expression)
	{relation:r singleExpr:e1 singleExpr:e2} 
		-> [e1 perform: r with: e2]
! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 6/27/2012 16:30'!
constraints =
	// return a collection of constraints
	constraint:c -> [{c}] 
	| { #and constraints:c1 constraints:c2 } -> [c1 , c2]
	// filter away true expr (becomes the empty array)
	| true -> [{}]! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 5/2/2012 20:42'!
operator =
	#plus -> ['+' asSymbol] 
	| #minus -> ['-' asSymbol] 
	| #multiply -> ['*' asSymbol] ! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 6/27/2012 16:35'!
prioritizedConstraints =
	// match an array of constraints, with the tag #constraint and a priority (a symbol)
	{#constraint symbol:p constraints:cs}
		-> [cs collect: [:c | c strength: (ClStrength perform: p)]; yourself]
! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 6/27/2012 16:36'!
programExpr =
	// a program is an array of an array of prioritized constraints.  Collapse this into just an array of prioritized constraints.
	prioritizedConstraints+:cs
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ s , e] ] ]! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'AHB 5/2/2012 20:44'!
relation =
	#eq -> [#cnEqual:] 
	| #lte -> [#cnLEQ:] 
	| #gte -> [#cnGEQ:] ! !

!CoopLangCassowaryInputParser methodsFor: 'rules' stamp: 'hs 6/18/2012 01:27'!
singleExpr =

	  {operator:op singleExpr:x singleExpr:y} 
		-> [x perform: op with: y]
	| {#minus singleExpr:x}
		-> [x negated]
 	| symbol:n 
		-> [variables at: n]
	| {#old symbol:n}
		-> [program envAt: n]
	| literal:n 
		-> [n]! !

!CoopLangCassowaryInputParser methodsFor: 'initialization' stamp: 'AHB 5/2/2012 21:35'!
variables: vars
	" 'variables' is an IdentityDictionary whose values are ClVariables - used to bind names in constraints"
	variables := vars! !

CoopLangParser subclass: #CoopLangDatalogInputParser
	instanceVariableNames: 'toAtomMap fromAtomMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:07'!
addExpr =

	{(#plus -> ['+'] | #minus -> ['-']):op addExpr:x addExpr:y}	
		-> [{'(' , x first, ' ' ,  op , ' ' , y first, ')'. x second}]
  |	mulExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
andExpr =

	{#and:op typedExpr:x typedExpr:y}	
		-> [{'(' , x first, ' ' , ',  ' , ' ' , y first ,')'. CoopLangType Bool}]
|	impliesExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/2/2012 18:04'!
andedConstraintExpr =

	{ prioritizedConstraintExpr+:cs }
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ s , ', ' , e ] ] ]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:51'!
andedRuleExpr =

	prioritizedRuleExpr+:cs
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ s , Character lf , e ] ] ]	! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 22:28'!
callExpr =

  	{#call symbol:p { addExpr+:args } }
		-> [ self translateCall: p args: args ]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
eqExpr =

	{(#eq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first , ' ' , op, ' ' , y first, ')'. CoopLangType Bool}] 
  |   {(#neq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first , ' !!' , op , ' ' , y first, ')'. CoopLangType Bool}] 
  |	relExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
expExpr =

	{(#power -> ['^']):op addExpr:x number:y}
	//FIXME: '* 1.0'
		-> [ {(y rounded = y)
				ifTrue: [ (1 to: y) inject: nil into: [:s :e | s := s isNil ifTrue: [ x first ] ifFalse: [ '(' , '*' , ' ', s , ' ' , x first , ')' ]] ]
				ifFalse: [ '(' , op, ' ' , x first , ' ' , ([y * 1.0] value) , 
							')' ]. x second} ]
  | 	{(#power -> ['^']):op addExpr:x expr:y}
	//FIXME: '* 1.0'
		-> [ {'(' , op, ' ' , x first , ' ' , y , ')'. x second} ]
  |	unary! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
expr =

	typedExpr:e
		-> [e first]
! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:56'!
higherFunCall =

	{(#size -> ['length'] | #sum -> ['sum']):op typedExpr:x}		
		-> [{'(' , 'Set' , x second base name , '.' , op, ' ' , x first , ')'. CoopLangType Int}]	
  |	{#abs typedExpr:x}
		-> [self translateAbs: x]
  |	postfix! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
impliesExpr =

	{(#implies -> ['implies'] | #iff -> ['='] ):op typedExpr:x typedExpr:y}
		-> [{'(' , op , ' ' , x first, ' ', y first ,')'. CoopLangType Bool}]
|	quantExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:26'!
injectAndRegisterVarDecls: y

	| vars | 
	vars := program program environment variables.
	^y do: [:x | | v t |
		v := x second.
		t := x third name. 
		"FIXME"
		vars at: v put: (CoopLangType of: t) ]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
mulExpr =

	{(#multiply -> ['*'] | #divide -> ['/'] | #mod -> ['mod']):op addExpr:x addExpr:y}
		-> [{'(' , x first , ' ' , op, ' ' , y first , ')'. x second}]
  |	expExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
orExpr =

	{#or:op typedExpr:x typedExpr:y}		
		-> [{'(' ,  x first, ' ', '; ' , ' ' , y first, ')'. CoopLangType Bool}]
  |	andExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:08'!
postfix =

	primExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
primExpr =

	primExprNormal
  |   primExprOld:o
		-> [true ifTrue: [ program involvesOld: true. o]]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
primExprHd =

	"(" typedExpr:e ")"							
		-> [e]
	//HACK FIXME
  |	#this
		-> [{toAtomMap at: #this. program getVarType: #this}]
  |	symbol:n
		-> [{n. program getVarType: n}]
  |	numberTyped
  |	booleanAsStr:n
		-> [{n. CoopLangType Bool}]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 13:09'!
primExprNormal =

  	{#get primExpr:p symbol:f}
		-> [self translateVar: p getField: f isOld: false]
  |   callExpr
  |	primExprHd! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
primExprOld =

  	{#old primExprOldHd:o}
		-> [o]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
primExprOldHd =

  	{#get primExprOldHd:p symbol:f}
		-> [self translateVar: p getField: f isOld: true]
	//HACK FIXME
  |	#this
		-> [self translateOldThis]
  |	symbol:n
		-> [self translateOldVar: n]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
prioritizedConstraintExpr =

	{#constraint #required expr:e}
		-> [e]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:55'!
prioritizedRuleExpr =

	{ #rule symbol:n { addExpr+:a } (ruleExpr:r -> [' <- ' , r] | nil->['.']):e }
		-> [n , '(' , (a allButFirst inject: a first first into: [:s :x | s := s , ', ' , x first]) ,')' , e]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/2/2012 17:53'!
programExpr =

	andedRuleExpr:e
		-> [e]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 17:11'!
quantExpr =

	{(#exists):q varDecls:x typedExpr:z}
		-> [{'(' , z first , ')'. CoopLangType Bool}]
  |	eqExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
relExpr =

	{(#gte -> ['>='] | #gt -> ['>'] | #lte -> ['<='] | #lt -> ['<']):op addExpr:x addExpr:y}
		-> [{'('  , x first , ' ' , op , ' ' , y first , ')'. CoopLangType Bool}]
  |	addExpr! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/2/2012 17:56'!
ruleExpr =

	andedConstraintExpr:e
		-> [e , '.' ]! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
translateAbs: x

	| res e tp z |
	e := x first.
	tp := x second.
	z := program zeroForType: tp.
	res := '(ite (< ' , e , ' ' , z , ') (- ' , z , ' ' , e , ') ' , e , ')'.   
	^{res. tp}
! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 22:29'!
translateCall: p args: args

	| res s |
	res := p , '('.
	s := args size.
	( s > 0 ) ifTrue: [
		res := res , (args at: 1) first.
		2 to: s do: [:i | res := res , ', ' , (args at: i) first ]	
		].
	^ { res , ')'. CoopLangType Bool }! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
translateObject: p getField: f

	| otp obtp ftp |
	otp := p second.
	obtp := otp base.
	ftp := (program getRelation: (obtp name , '_' ,  f) asSymbol) type second. "rangeType."
	^{program object: p first fieldAt: f getAtom: ftp isPrimitive not. ftp}! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:09'!
translateOldThis

	| var tp |
	var := toAtomMap at: #this.
	tp := program getVarType: #this.
	^"{'(' , tp , '.old ' , var , ')'. tp}"
	"FIXME: assuming old(this) = this"
	{var. tp}! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
translateOldVar: var

	| tp |
	tp := program getVarType: var.
	^{var , '_old'. tp}! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:01'!
translateVar: p getField: f isOld: old

	| otp obtp rel ftp fn |
	otp := p second.
	obtp := otp base.
	rel := program getRelation: (obtp name , '_' ,  f) asSymbol.
	ftp := rel type second. "rangeType."
	fn := obtp name , '_' , f , (old ifTrue: ['_old'] ifFalse: ['']).
	otp isCollection ifTrue: [ 
		fn := 'Set' , fn.  
		ftp := CoopLangType of: #Set with: {ftp name}.
	] ifFalse: [
	
	].
	^{fn , '[' , p first , ']'. ftp}! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
translateVarValue: var

	| tp val |
	tp := program getVarType: var.
	val := program envAt: var ofType: tp. 
	^{program translateValue: val ofType: tp. tp}! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
typedExpr =

	orExpr
! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:56'!
unary =

	{#minus typedExpr:e}
		-> [{'(- ' , (program zeroForType: e second) , ' ' , e first ,')'. e second}]
  | 	{#not typedExpr:e}
		-> [{'(not ' , e first , ')'. e second}]
  |	higherFunCall! !

!CoopLangDatalogInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:10'!
varDecls =

	anything:y
		-> [self injectAndRegisterVarDecls: y]! !

CoopLangParser subclass: #CoopLangDatalogOutputParser
	instanceVariableNames: 'toAtomMap fromAtomMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:55'!
assign =

	spaces value:v ("," space value:x -> [x])*:vs spaces
		-> [{v} , vs asArray]! !

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:55'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:55'!
model =

	relModel+! !

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 14:27'!
relModel =

	(~"/---" char)*
	"/--- start of " symbolName:n space "facts ---\"
	assign*:as
	"\---- end of " name space "facts ----/" spaces
	-> [{n. as}]! !

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:55'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangDatalogOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 14:21'!
value =

	"[" numberStr "]" "A" numberStr:i
		-> [fromAtomMap at: (#A , i) asSymbol]
	| numberStr! !

CoopLangParser subclass: #CoopLangKodkodInputParser
	instanceVariableNames: 'toAtomMap fromAtomMap upperbounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 18:53'!
addExpr =

	{(#plus -> ['+'] | #minus -> ['-']):op addExpr:x addExpr:y}	
		-> [{'(' , x first, ' ' , op, ' ' , y first, ')'. CoopLangType Int}]
  |	mulExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:33'!
andExpr =

	{#and typedExpr:x typedExpr:y}	
		-> [{'(' , x first , ' && ', y first ,')'. CoopLangType Bool}]
  |	impliesExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'AHB 6/27/2012 16:37'!
andedConstraintExpr =

	prioritizedConstraintExpr+:cs
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ '(' , s , ' && ' , e , ')' ] ] ]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:33'!
eqExpr =

	{(#eq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first, ' ' , op , ' ' , y first, ')'. CoopLangType Bool}] 
  |   {(#neq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'!! (' , x first, ' ' , op , ' ' , y first, ')'. CoopLangType Bool}] 
  |	relExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 14:00'!
expExpr =

	{(#power -> ['*']):op addExpr:x number:n}
		-> [{(1 to: n) inject: nil into: [:s :e | s := s isNil ifTrue: [ x first ] ifFalse: [ '(' , s, ' ' , op , ' ' , x first , ')' ]]. x second }]
  |	unary! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 00:39'!
expr =

	typedExpr:e
		-> [e first]
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:57'!
higherFunCall =

	{(#size -> ['#'] | #sum -> ['sum']):op primExpr:x}		
		-> [{op, '(' , x first , ')'. CoopLangType of: #None}]  
  |	postfix:e
	//FIXME
		-> [(e second isInt not or: [e first isNumber]) 
				ifTrue: [e]
				ifFalse: [{'sum(' , e first ,')'. e second}]]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/16/2012 14:15'!
impliesExpr =

	{(#implies -> ['=>'] | #iff -> ['=>']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first , ' ' , op , ' ', y first , ')'. CoopLangType Bool}]
  |	quantExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:26'!
injectAndRegisterVarDecls: xs

	| vars | 
	vars := program program environment variables.
	^xs inject: '' into: 
		[:z :x | | v t | v := x second. t := x third name. 
					program addRel: v prefix: #S. 
					"FIXME"
					vars at: v put: (CoopLangType of: t).
			   		z := z , ' ' , (toAtomMap at: v), ' : one ', (upperbounds at: t)  ]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 13:24'!
mulExpr =

	{(#multiply -> ['*'] | #divide -> ['/'] | #mod -> ['%']):op addExpr:x addExpr:y}
		-> [{'(' , x first, ' ' , op , ' ' , y first , ')'. CoopLangType Int}]
  |	expExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:33'!
orExpr =

	{#or typedExpr:x typedExpr:y}		
		-> [{'(' , x first , ' || ' , y first , ')'. CoopLangType Bool}]
  |	andExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:41'!
postfix =

	primExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:47'!
primExpr =

	primExprNormal
  |	primExprOld:o
		-> [true ifTrue: [ program involvesOld: true. o]]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 00:18'!
primExprHd =

	"(" typedExpr:e ")"							
		-> [e]
  |	symbol:n
		-> [{(toAtomMap at: n). program getVarType: n}]
  |	number:n
		-> [{n. CoopLangType Int}]
  |	booleanAsStr:n
		-> [{n. CoopLangType Bool}]
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:56'!
primExprNormal =

  	{#get primExpr:p symbol:f}
		-> [self translateVar: p getField: f isOld: false]
  |	primExprHd:n
		-> [n]

! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 00:19'!
primExprOld =

	{#old primExprOldHd:o}
		-> [o]


! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/23/2012 01:29'!
primExprOldHd =

  	{#get primExprOldHd:p symbol:f}
		-> [self translateVar: p getField: f isOld: true]
  |	symbol:n
		-> [self translateOldVar: n]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'AHB 6/27/2012 16:38'!
prioritizedConstraintExpr =

	{#constraint #required expr:e}
		-> [e]! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:33'!
programExpr =

	andedConstraintExpr
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:32'!
quantExpr =

	{(#forall -> ['all'] | #exists -> ['some']):q varDecls:x typedExpr:z}
		-> [{'(' , q, ' ' , '[' , x ,' ] ', z first, ')'. CoopLangType Bool}]
  |	eqExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:32'!
relExpr =

	{(#gte -> ['>='] | #gt -> ['>'] | #lte -> ['<='] | #lt -> ['<']):op addExpr:x addExpr:y}
		-> [{'(' , x first , ' ' , op , ' ' , y first , ')'. CoopLangType Bool}]
  |	addExpr! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:36'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:59'!
translateObject: p getField: f

	| o otp obtp ftp |
	o := fromAtomMap at: p first.
	otp := p second.
	obtp := otp base.
	ftp := (program getRelation: (obtp name , '_' ,  f) asSymbol) rangeType.
	^{toAtomMap at: (program object: o fieldAt: f). ftp}! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 12:35'!
translateOldVar: var

	| tp rel |
	tp := program getVarType: var.
	rel := (var , '_old') asSymbol.
	^{toAtomMap at: rel. tp}! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 02:15'!
translateVar: p getField: f isOld: old

	| ftp rel |
	rel := (p second base name , '_' ,  f , (old ifTrue: ['_old'] ifFalse: [''])) asSymbol.
	ftp := (self program getRelation: rel isOld: old) rangeType. 
	^{p first , '.' , (toAtomMap at: rel). ftp}
	
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 17:44'!
translateVarValue: var

	| tp val |
	tp := program getVarType: var.
	val := program envAt: var ofType: tp.
	^{toAtomMap at: val. tp}! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 00:39'!
typedExpr =

	orExpr
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:55'!
unary =

	{#minus typedExpr:e}
		-> [{'(0 - ' , e first , ')'. e second}]
  | 	{#not typedExpr:e}
		-> [{'(!! ' , e first , ')'. e second}]
  |	higherFunCall! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:39'!
upperbounds: m

	upperbounds := m
! !

!CoopLangKodkodInputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:06'!
varDecls =

	anything:y
		-> [self injectAndRegisterVarDecls: y]! !

CoopLangParser subclass: #CoopLangKodkodOutputParser
	instanceVariableNames: 'toAtomMap fromAtomMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/10/2012 01:18'!
assign =

	spaces symbolName:x "=[" (tuples | empty -> [{{}}]):y "]"
		-> [self assign: x to: y] ! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:55'!
assign: x to: y

	| xp |
	xp := fromAtomMap at: x.
	^(program isScalar: xp) 
		ifTrue: [(self program isModifiableVar: xp) ifTrue: [{{xp. nil. nil. y first first}}] ifFalse: [{}]]
		ifFalse: [
			(y first size > 1) 
				ifTrue: [ | isSet rel mods |
					(program isOldRelation: xp) 
						ifTrue: [{}]
						ifFalse: [
					rel := self program getRelation: xp.
					mods := y select: [:e | self program isModifiableObj: e first].
					isSet := rel rangeType isCollection.
					isSet 
						ifTrue: [ | d f s |
							d := IdentityDictionary new.
							mods do: [:e | 
								f := e first.
								s := e second.
								(d includesKey: f) 
									ifTrue: [ (d at: f) add: s ]
									ifFalse: [ d at: f put: (OrderedCollection with: s) ] ].
							d keys asArray collect: [: e | {e. rel name. nil. (d at: e) asArray}]		
						]
						ifFalse: [
							mods collect: [:e | {e first. rel name. nil. e second} ] 	
						]
					]
				]
				ifFalse: [{}] 
		]! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 19:57'!
assigns =

	assigns:x "," spaces assign:y -> [x , y]
  | 	assign:x -> [x]! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:04'!
model =

	pre
	outcome
	modelPart?:x
	stats
		-> [x]! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 13:21'!
modelPart =

	spaces "---INSTANCE---" spaces "relations:" spaces "{" assigns:x "}"
		-> [x]! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:04'!
outcome =

	spaces "---OUTCOME---" spaces "TRIVIALLY_"? "UN"? "SATISFIABLE" ! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:04'!
pre =
	
	(~``***'' char)* "*** PROBLEM 1 ***"! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:03'!
stats =

	spaces "---STATS---" anything*! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:36'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:03'!
tuple =

	  "[" values:x "]"
		-> [x]
! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:03'!
tuples =

	tuples:x "," spaces tuple:y -> [x , {y}]
	| tuple:x -> [{x}]! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 17:54'!
value =

	  symbolName:x
		-> [fromAtomMap at: x]
! !

!CoopLangKodkodOutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:03'!
values =

	values:x "," spaces value:y -> [x , {y}]
	| value:x -> [{x}]! !

CoopLangParser subclass: #CoopLangOMetaInputParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 16:26'!
body =

	{ bodyChoice+:b }
		-> [b first , (b allButFirst inject: '' into: [:s :e | s := s , ' | ' , e])]! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 16:26'!
bodyChoice =

	{ bodyElement+:b }
		-> [b inject: '' into: [:s :e | s := s , ' ' , e]]! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 15:17'!
bodyElement =

	{ bodyElementSymbol:s bodyElementTag:t bodyElementAction:a }
		-> [s , (t isNil ifTrue: [''] ifFalse: [ ':' , t ]) , (a isNil ifTrue: [''] ifFalse: [ ' -> [' , a , ']'])]! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 15:54'!
bodyElementAction =

	nil
  |	symbol
  |	string:s
		-> ['''' , s , '''']
  |	{#concat bodyElementAction:a bodyElementAction:b}
		-> [a , ' , ' , b]! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 15:03'!
bodyElementSymbol =

	symbol
  |	stringQuoted! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 15:55'!
bodyElementTag =

	nil
  |	symbol! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:22'!
programExpr =
	// a program is an array of an array of rules.  Collapse this into just an array of prioritized rules.
	
	rules+:cs
		-> [cs]! !

!CoopLangOMetaInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 16:27'!
rules =
	// match an array of rules, with the tag #rule and a priority (a symbol)
	
	{#ometaRule symbol:h body:b}
		-> [h , ' = ' , b]
! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 4/27/2012 16:10'!
alphanum =

	letter | digit! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/8/2012 13:01'!
boolean =
	
	  true
	| false! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/8/2012 13:06'!
booleanAsStr =
	
	  true -> ['true']
	| false -> ['false']! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/8/2012 13:01'!
booleanStr =
	
	  "true" -> [true]
	| "false" -> [false]! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:45'!
float = 

	anything:x ?[x isFloat] -> [x]
! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/8/2012 15:11'!
floatStr = 

	spaces <("-"? digit+ ($. digit+))>:n
		-> [n asNumber]! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:46'!
fractionStr = 

	integerStr:n "/" integerStr:d
		-> [n / d]! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:49'!
integer = 

	anything:x ?[x isInteger] -> [x]
! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:46'!
integerStr = 

	spaces <("-"? digit+)>:n
		-> [n asNumber]! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 9/26/2012 11:06'!
literal =
	
	  number
	| boolean
	| string! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/8/2012 15:00'!
literalStr = 

     numberStr
  |  booleanStr

! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 4/27/2012 16:11'!
name =
	
	spaces <(letter | $_ ) (alphanum | $_ )*>! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 4/27/2012 16:11'!
names  =

	names:x ","  name:y
		-> [x , {y asSymbol}]
	|  name:x
		-> [{x asSymbol}]
		
! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:46'!
numberStr = 

      fractionStr:f
		-> [f * '1.0' asNumber]
  |   floatStr
  |	integerStr 

! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 6/4/2012 10:53'!
numberTyped =

  	integer:n
		-> [{n. CoopLangType Int}]
  |	float:n
		-> [{n. CoopLangType Real}]! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/18/2012 13:37'!
posNumber = 

	spaces <(digit+ ($. digit+)?)>:n -> [n asNumber]! !

!CoopLangParser methodsFor: 'instance var access' stamp: 'hs 4/27/2012 22:58'!
program

	^program! !

!CoopLangParser methodsFor: 'instance var access' stamp: 'hs 4/27/2012 22:58'!
program: p

	program := p! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 9/26/2012 11:08'!
string = 

	anything:x ?[x isString] -> [x]
! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 9/26/2012 14:14'!
stringQuoted =
	
	string:s
		-> ['"' , s , '"']! !

!CoopLangParser methodsFor: 'parsing rules' stamp: 'hs 5/6/2012 17:54'!
symbolName =
	
	name:n
		-> [n asSymbol]! !

CoopLangParser subclass: #CoopLangProblemFlattenerInputParser
	instanceVariableNames: 'toAtomMap fromAtomMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

CoopLangProblemFlattenerInputParser subclass: #CoopLangOCassowaryInputParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangOCassowaryInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 13:33'!
makeNonLinearExpr: arg1 and: arg2 op: op

	"FIXME!!"
	
	| a1 a2 | 
	a1 := arg1.
	a2 := arg2.
	(program langModifiableVars contains: arg1)
		ifTrue: [ a2 := program langEnv at: arg2 ]
		ifFalse: [ a1 := program langEnv at: arg1 ].
	^'(' , a1 , ' ' , op, ' ' , a2 , ')'
! !

!CoopLangOCassowaryInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/14/2012 09:03'!
mulExpr =

	{(#multiply -> ['*'] | #divide -> ['/'] | #mod -> ['mod']):op addExpr:x addExpr:y}
		-> [{self makeNonLinearExpr: x first and: y first op: op. CoopLangType Int}]
  |	unary! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:09'!
addExpr =

	{(#plus -> ['+'] | #minus -> ['-']):op addExpr:x addExpr:y}	
		-> [{'(' , x first, ' ' , op , ' '  , y first, ')'. CoopLangType Int}]
  |	mulExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/2/2012 18:38'!
andExpr =

	{#and -> ['&&']:op typedExpr:x typedExpr:y}	
		-> [{'(' , x first, ' ' , op, ' ' , y first , ')'. CoopLangType Bool}]
|	impliesExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 7/1/2012 22:13'!
andedConstraintExpr =

	prioritizedConstraintExpr+:cs
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ s , Character cr , e ] ] ]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:09'!
eqExpr =

	{(#eq -> ['='] | #neq -> ['!!=']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first , ' ' , op , ' ' , y first, ')'. CoopLangType Bool}] 
  |	relExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:09'!
expr =

	typedExpr:e
		-> [e first]
! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:09'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:57'!
higherFunCall =

	{(#size -> ['length']):op typedExpr:x}
		-> [ {x first size. CoopLangType Int} ]
  |   {(#sum -> ['sum']):op typedExpr:x}		
		-> [ {x first isEmpty ifTrue: [ 0 ] ifFalse: [ (x first allButFirst inject: x first first asString into: [:z :e | z := z , ' + ' , e ]) ]. CoopLangType Int} ]
  |	{#abs:op typedExpr:x}
		-> [{'abs(' , x first , ')'. x second.}]
  |	postfix! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:10'!
impliesExpr =

	{(#implies -> ['=>'] | #iff -> ['<=>']):op typedExpr:x typedExpr:y}
		-> [{'(' , x first, ' ', op , ' ' , y first ,')'. CoopLangType Bool}]
|	quantExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:27'!
injectAndRegisterVarDecls: y

	| vars | 
	vars := program program environment variables.
	^(y inject: '' into: [:z :x | | v t | 
		v := x second.
		t := x third name. 
		"FIXME"
		vars at: v put: (CoopLangType of: t).
		z := z , '(' , v , ' ' , t , ') '])! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:44'!
mulExpr =

	{(#multiply -> ['*'] | #divide -> ['/'] | #mod -> ['%']  | #power -> ['^']):op addExpr:x addExpr:y}
		-> [{'(' , x first, ' ' , op , ' '  , y first, ')'. CoopLangType Int}]
  |	unary! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/3/2012 12:16'!
orExpr =

	{#or -> ['||']:op typedExpr:x typedExpr:y}		
		-> [{'(' , x first , ' ' , op , ' ' , y first , ')'. CoopLangType Bool}]
  |	andExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:12'!
postfix =

	primExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:12'!
primExpr =

  	primExprNormal
  |	primExprOld:o
		-> [true ifTrue: [ program involvesOld: true. o]]	! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/4/2012 10:53'!
primExprHd =

	"(" typedExpr:e ")"							
		-> [e]
 |	symbol:n
		-> [self translateVar: n ofType: (program getVarType: n)]
  |	numberTyped
  |	booleanAsStr:n	
		-> [{n. CoopLangType Bool}]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:12'!
primExprNormal =

	{#get primExpr:p symbol:f}
		-> [self translateVar: p getField: f isOld: false]
  |	primExprHd:n
		-> [n]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:12'!
primExprOld =

	{#old primExprOldHd:o}
		-> [o]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:12'!
primExprOldHd =

  	{#get primExprOldHd:p symbol:f}
		-> [self translateObject: {(fromAtomMap at: p first). p second} getField: f]
  |	symbol:n
		-> [self translateVarValue: n]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 13:42'!
prioritizedConstraintExpr =

	 {#constraint #required:p expr:e}
		-> [e]
  |	 {#constraint symbol:p expr:e}
		-> ['[priority: ' , p , '] ' , e]   
! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:11'!
programExpr =

	andedConstraintExpr:e
		-> [e , Character lf ]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:13'!
quantExpr =

	{(#forall  | #exists):q varDecls:x typedExpr:z}
		-> [{'(' , q, ' ' , '(' , x ,') ', z first , ')'. CoopLangType Bool}]
  |	eqExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:13'!
relExpr =

	{(#gte -> ['>='] | #gt -> ['>'] | #lte -> ['<='] | #lt -> ['<']):op addExpr:x addExpr:y}
		-> [{'(', x first , ' ' , op ,  ' ' , y first , ')'. CoopLangType Bool}]
  |	addExpr! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:13'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 01:14'!
translateObject: p getField: f

	| res o otp obtp ftp |
	o := p first.
	otp := p second.
	obtp := otp base.
	ftp := (program getRelation: (obtp name , '_' ,  f) asSymbol) rangeType.
	res := self translateVar: (program object: o fieldAt: f) ofType: ftp.
	^res! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:13'!
translateValue: val ofType: tp

	^tp isReal
		ifTrue: [ val ]
		ifFalse: [ toAtomMap at: val ]! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 13:08'!
translateVar: p getField: f isOld: old

	| res o otp obtp ftp accepted vars |
	vars := program langVars.
	o := p first.
	otp := p second.
	obtp := otp base.
	ftp := (program getRelation: (obtp name , '_' ,  f) asSymbol) rangeType.
	accepted := program isAcceptedType: ftp.
	res := otp isCollection 
		ifTrue: [ "FIXME" 
			ftp := CoopLangType of: #Set with: {ftp base name}.
			accepted 
				ifTrue: [
					o collect: [:e | | v | 
						v := (e , f) asSymbol. 
						(vars includesKey: v) ifFalse: [ vars at: v put: ftp base ].
						v 
					] 
				]
				ifFalse: [ 
					o collect: [:e | program getAtom: (program object: (fromAtomMap at: e) fieldAt: f)]		
				].
		]
		ifFalse: [
			accepted
				ifTrue: [
					ftp isCollection 
						ifTrue: [
							| c0 v ftpb |
							c0 := program object: (fromAtomMap at: o) fieldAt: f.
							v := (o , f) asSymbol. 
							ftpb := ftp base.
							"env0 := program langEnv."
							(1 to: c0 size) collect: [:i | 
								| vp | 
								vp := (v , i) asSymbol.
								(vars includesKey: vp) ifFalse: [ 
									vars at: vp put: ftpb.
									"env0 at: vp put: (c0 at: i)."
								].
								vp
							]
						]
						ifFalse: [
					 		| v | 
							v := (o , f) asSymbol. 
							(vars includesKey: v) ifFalse: [ vars at: v put: ftp base ].
							v
						]
				]
				ifFalse: [ program object: (fromAtomMap at: o) fieldAt: f ofType: ftp getAtom: ftp base isNumeric not isCollection: ftp isCollection ]
		].
	^{res. ftp}! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/2/2012 11:51'!
translateVar: n ofType: tp

	" translate var for wrapped language if real type keep unchanged, otherwise use atom id of object "
	^{(program isAcceptedType: tp) 
		ifTrue: [n] 
		ifFalse: [toAtomMap at: n].
		tp}! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/2/2012 12:26'!
translateVarValue: var

	| tp val |
	tp := program getVarType: var.
	val := program envAt: var ofType: tp.
	^{self translateValue: val ofType: tp. tp}! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:13'!
typedExpr =

	orExpr
! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:55'!
unary =

	{#minus typedExpr:e}
		-> [{'(' , (e second isReal ifTrue: [ '0.0' ] ifFalse: [ '0' ]) , ' - ' , e first ,')'. e second}]
  | 	{#not typedExpr:e}
		-> [{'(!! ' , e first , ')'. e second}]
  |	higherFunCall! !

!CoopLangProblemFlattenerInputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:14'!
varDecls =

	anything:y
		-> [self injectAndRegisterVarDecls: y]! !

CoopLangParser subclass: #CoopLangZ3InputParser
	instanceVariableNames: 'toAtomMap fromAtomMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 13:27'!
addExpr =

	{(#plus -> ['+'] | #minus -> ['-']):op addExpr:x addExpr:y}	
		-> [{'(' , op , ' ' , x first, ' ' , y first, ')'. x second}]
  |	mulExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:38'!
andExpr =

	{#and:op typedExpr:x typedExpr:y}	
		-> [{'(' , op, ' ' , x first, ' ' , y first ,')'. CoopLangType Bool}]
|	impliesExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'AHB 6/27/2012 16:37'!
andedConstraintExpr =

	prioritizedConstraintExpr+:cs
		-> [cs inject: nil into: [:s :e | s := s isNil ifTrue: [ e ] ifFalse: [ '(and ' , s , ' ' , e , ')' ] ] ]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:38'!
eqExpr =

	{(#eq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(' , op, ' ' , x first , ' ' , y first, ')'. CoopLangType Bool}] 
  |   {(#neq -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(not (' , op, ' ' , x first , ' ' , y first, '))'. CoopLangType Bool}] 
  |	relExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/14/2012 11:13'!
expExpr =

	{(#power -> ['^']):op addExpr:x number:y}
	//FIXME: '* 1.0'
		-> [ {(y rounded = y)
				ifTrue: [ (1 to: y) inject: nil into: [:s :e | s := s isNil ifTrue: [ x first ] ifFalse: [ '(' , '*' , ' ', s , ' ' , x first , ')' ]] ]
				ifFalse: [ '(' , op, ' ' , x first , ' ' , ([y * 1.0] value) , 
							')' ]. x second} ]
  | 	{(#power -> ['^']):op addExpr:x expr:y}
	//FIXME: '* 1.0'
		-> [ {'(' , op, ' ' , x first , ' ' , y , ')'. x second} ]
  |	unary! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 00:54'!
expr =

	typedExpr:e
		-> [e first]
! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:19'!
higherFunCall =

	{(#size -> [{false. 'length'}] | #sum -> [{true. 'sum'}]):op typedExpr:x}		
		-> [true ifTrue: [
				op first ifTrue: [
					program usedSetTheoryTypeDefs at: x second base  put: true
				].
				{'(' , 'Set' , x second base name , '.' , op second, ' ' , x first , ')'. CoopLangType Int}]]
  |	{#abs typedExpr:x}
		-> [self translateAbs: x]
  |	postfix! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:28'!
impliesExpr =

	{(#implies -> ['or']):op typedExpr:x typedExpr:y}
		-> [{'(' , op , ' (not ' , x first, ') ', y first ,')'. CoopLangType Bool}]
  | 	{(#iff -> ['=']):op typedExpr:x typedExpr:y}
		-> [{'(' ,  op , ' ' , x first, ' ', y first ,')'. CoopLangType Bool}]
  |	quantExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:27'!
injectAndRegisterVarDecls: y

	| vars | 
	vars := program program environment variables.
	^(y inject: '' into: [:z :x | | v t | 
		v := x second.
		t := x third name. 
		"FIXME"
		vars at: v put: (CoopLangType of: t).
		z := z , '(' , v , ' ' , t , ') '])! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 13:27'!
mulExpr =

	{(#multiply -> ['*'] | #divide -> ['/'] | #mod -> ['mod']):op addExpr:x addExpr:y}
		-> [{'(' , op, ' ' , x first , ' ' , y first , ')'. x second}]
  |	expExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:37'!
orExpr =

	{#or:op typedExpr:x typedExpr:y}		
		-> [{'(' , op , ' ' , x first, ' ', y first, ')'. CoopLangType Bool}]
  |	andExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:40'!
postfix =

	primExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:05'!
primExpr =

	primExprNormal
  |   primExprOld:o
		-> [true ifTrue: [ program involvesOld: true. o]]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/4/2012 10:53'!
primExprHd =

	"(" typedExpr:e ")"							
		-> [e]
	//HACK FIXME
  |	#this
		-> [{toAtomMap at: #this. program getVarType: #this}]
  |	symbol:n
		-> [{n. program getVarType: n}]
  |	numberTyped
  |	booleanAsStr:n
		-> [{n. CoopLangType Bool}]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/12/2012 10:47'!
primExprNormal =

  	{#get primExpr:p symbol:f}
		-> [self translateVar: p getField: f isOld: false]
  |	{#access primExpr:p addExpr:f}
		-> [self translateVar: p accessIndex: f isOld: false]
  |	primExprHd:n
		-> [n]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/19/2012 18:56'!
primExprOld =

  	{#old primExprOldHd:o}
		-> [o]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/23/2012 01:18'!
primExprOldHd =

  	{#get primExprOldHd:p symbol:f}
		-> [self translateVar: p getField: f isOld: true]
	//HACK FIXME
  |	#this
		-> [self translateOldThis]
  |	symbol:n
		-> [self translateOldVar: n]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'AHB 6/27/2012 16:39'!
prioritizedConstraintExpr =

	{#constraint #required expr:e}
		-> [e]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 00:48'!
programExpr =

	andedConstraintExpr:e
		-> ['(assert ' , e , ')' ]! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:36'!
quantExpr =

	{(#forall  | #exists):q varDecls:x typedExpr:z}
		-> [{'(' , q, ' ' , '(' , x ,') ', z first , ')'. CoopLangType Bool}]
  |	eqExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:36'!
relExpr =

	{(#gte -> ['>='] | #gt -> ['>'] | #lte -> ['<='] | #lt -> ['<']):op addExpr:x addExpr:y}
		-> [{'(' , op , ' ' , x first , ' ' , y first , ')'. CoopLangType Bool}]
  |	addExpr! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 10:47'!
translateAbs: x

	| res e tp z |
	e := x first.
	tp := x second.
	z := program zeroForType: tp.
	res := '(ite (< ' , e , ' ' , z , ') (- ' , z , ' ' , e , ') ' , e , ')'.   
	^{res. tp}
! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 01:18'!
translateObject: p getField: f

	| otp obtp ftp |
	otp := p second.
	obtp := otp base.
	ftp := (program getRelation: (obtp name , '_' ,  f) asSymbol) rangeType.
	^{program object: p first fieldAt: f getAtom: ftp isPrimitive not. ftp}! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/27/2012 13:42'!
translateOldThis

	| var tp |
	var := toAtomMap at: #this.
	tp := program getVarType: #this.
	^"{'(' , tp , '.old ' , var , ')'. tp}"
	"FIXME: assuming old(this) = this"
	{var. tp}! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 23:15'!
translateOldVar: var

	| tp |
	tp := program getVarType: var.
	^{var , (program noOldVar ifTrue: [''] ifFalse: ['_old']). tp} "HACK FIXME: remove noOldVar"! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/12/2012 12:04'!
translateVar: p accessIndex: f isOld: old

	| ftp |
	ftp := p second base.
	^{'(select ' , p first , ' (- ' , f first , ' 1))'. ftp}! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:14'!
translateVar: p getField: f isOld: old

	| otp obtp rel ftp fn |
	otp := p second.
	obtp := otp base.
	rel := program getRelation: (obtp name , '_' ,  f) asSymbol.
	ftp := rel rangeType.
	fn := obtp name , '_' , f , (old ifTrue: ['_old'] ifFalse: ['']).
	otp isCollection ifTrue: [ 
		program usedSetTheoryTypeDefs at: ftp  put: false.
		program usedSetTheoryJoinDefs at: rel put: nil.
		fn := 'Set' , fn.  
		ftp := CoopLangType of: #Set with: {ftp name}.
	] ifFalse: [
	ftp isCollection ifTrue: [
		program usedSetTheoryTypeDefs at: ftp base put: false.
		program usedSetTheoryRelDefs at: rel put: nil. 
	]
	].
	^{'(' , fn , ' ' , p first , ')'. ftp}! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 17:40'!
translateVarValue: var

	| tp val |
	tp := program getVarType: var.
	val := program envAt: var ofType: tp. 
	^{program translateValue: val ofType: tp. tp}! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 01:18'!
typedExpr =

	orExpr
! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 12:55'!
unary =

	{#minus typedExpr:e}
		-> [{'(- ' , (program zeroForType: e second) , ' ' , e first ,')'. e second}]
  | 	{#not typedExpr:e}
		-> [{'(not ' , e first , ')'. e second}]
  |	higherFunCall! !

!CoopLangZ3InputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 01:44'!
varDecls =

	anything:y
		-> [self injectAndRegisterVarDecls: y]! !

CoopLangParser subclass: #CoopLangZ3OutputParser
	instanceVariableNames: 'toAtomMap fromAtomMap modelTempVars truncateReals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 20:40'!
assign =

	spaces symbolName:var (
		( "." symbolName:n ("." ("#" -> [#'#'] | numberStr:ai))?:as ) -> [n] 
		| empty -> [nil]):field 
			spaces ( literalValue:l | specialSymbolName:s ):val
		-> [ as isNil
				ifTrue: [
					s isNil 
						ifTrue: [ {field isNil ifTrue: [ var ] ifFalse: [ fromAtomMap at: var ]. field. nil. val} ] 
						ifFalse: [ {var. field. nil. fromAtomMap at: (modelTempVars at: val)} ]
				]
				ifFalse: [
					ai isNil
						ifTrue: [ {fromAtomMap at: var. field. nil. (OrderedCollection ofSize: val) asArray} ]
						ifFalse: [ {fromAtomMap at: var. field. ai. s isNil ifTrue: [ val ] ifFalse: [ fromAtomMap at: (modelTempVars at: val) ] }]
				]
			]
		! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 20:40'!
atomAssign =

	spaces "atom" symbolName:var spaces specialSymbolName:val
		-> [modelTempVars at: val put: var]
		! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
fromAtomMap: m

	fromAtomMap := m
! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/7/2012 19:29'!
getValueMaybeTempVar: v

	^(modelTempVars includesKey: v)
		ifTrue: [ fromAtomMap at: (modelTempVars at: v) ]
		ifFalse: [ v ]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/15/2012 20:08'!
literalValue =

	z3NegNumberStr
  | 	z3RealNumberStr
  | 	numberStr
  | 	booleanStr

! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/5/2012 00:33'!
miscMsgs =
	
	spaces ("success" -> [nil] | ("(error" (~")" char)* ")"):e -> [e])*:m
		-> [(m select: [:x | x isNil]) size = m size]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 19:09'!
model =

	miscMsgs:e
	spaces ( ( ( "sat" | "unknown" ) //FIXME
				modelPart:m 
					-> [e ifTrue: [m] ifFalse: [nil]] )
			| "unsat" anything* end -> [nil] )! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 17:17'!
modelPart =

	spaces ":model" spaces 
		"(z3_model" spaces ":atoms" spaces atomAssign* ":vars" spaces assign*:x spaces ")" spaces
		-> [x]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/7/2012 18:33'!
modelTempVars: m

	modelTempVars := m! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/5/2012 00:30'!
outcome =

	satUnsatUnknown! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 13:48'!
satUnsatUnknown =

	spaces ( "sat" | "unknown" ) //FIXME
		-> [true]
	| spaces ( "unsat" )
		-> [false]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 18:30'!
simpleValue =

	  literalValue
	| specialSymbolName

! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 02:50'!
specialAlphanum =

	letter | digit | "!!" | "." | "_" | "[" | "]"! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 19:11'!
specialName =
	
	spaces <(letter | $_ ) (specialAlphanum | $_ )*>! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/7/2012 16:38'!
specialSymbolName =
	
	specialName:n
		-> [n asSymbol]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:35'!
toAtomMap: m

	toAtomMap := m
! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 15:57'!
truncFloatStr = 

	spaces <("-"? digit+ ($. digit+))>:n
		-> [program truncateReals 
				ifTrue: [ (true ifTrue: [ n asNumber quo: 0.01]) / 100 asFloat ]
				ifFalse: [ n asNumber ] ]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 18:30'!
value =

	  simpleValue


! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 18:00'!
z3NegNumberStr =

	 "(-"  ( numberStr | z3RealNumberStr ):n ")"
		-> [n negated]! !

!CoopLangZ3OutputParser methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 15:29'!
z3RealNumberStr =

	truncFloatStr:f "?"?
		-> [f]
  |	"(" "-" space truncFloatStr:f "?"? ")"
		-> [f negated]
  |	"(/"  numberStr:n numberStr:d ")"
		-> [n / d]
! !

!OMeta2 class methodsFor: '*cooperatinglanguages-uniclass' stamp: 'yo 10/10/2013 17:17'!
newUniClass
	^ self newUniClass: ''
! !

!OMeta2 class methodsFor: '*cooperatinglanguages-uniclass' stamp: 'yo 10/10/2013 17:17'!
newUniClass: instVarString
	"Make a new uni class just like me"
	| baseClass newClass |
	baseClass := self.
	"Create a new anonymous subclass"
	newClass := ClassBuilder new
		newSubclassOf: baseClass
		type: baseClass typeOfClass
		instanceVariables: instVarString substrings
		from: (self == baseClass ifFalse:[self]).
	baseClass removeSubclass: newClass.
	^newClass! !

Morph subclass: #CoopLangMovingBoxesDemo
	instanceVariableNames: 'shell main form da gc gcw buffer grabBox dragBox lastPoint cs errorPixel editX editY activeWorld worlds env boxes resizeGrabBox resizeBox moveConstraintsOff moveConstraintsOn sortedBoxes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangMovingBoxesDemo class methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:26'!
maxWorlds
	"any number 1 or less will suppress multi-world behaviour"
	^1
! !

!CoopLangMovingBoxesDemo class methodsFor: 'as yet unclassified' stamp: 'hs 8/28/2012 18:56'!
movingBoxesDemo

	CoopLangMovingBoxesDemo new openInWorld.! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:08'!
addWorld
	"keep only a limited number of worlds (out of which not all are necessarily being drawn; see drawOn:)"
	| oldestWorld maxWorlds |
	maxWorlds := self class maxWorlds.
	maxWorlds <= 1 ifTrue: [ ^activeWorld := worlds first ].	"only use top-level world"
	
	worlds size > (maxWorlds + 1)
	  ifTrue: [
		"NB: the following - in particular, the introduction of the 'reparent' operation - is not an 'approved' use of worlds.
		oldestWorld is the oldest non-top-level world in our list.  we remove it, commit its changes into the (top-level) parent , then reparent the next world to take its place."
		oldestWorld := worlds removeAt: 2.
		oldestWorld commit.
		(worlds at: 2) reparent: worlds first.
		].
	
	activeWorld := worlds add: worlds last sprout.
! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:09'!
constraintBoxesDo: aBlock

	boxes do: [:b | aBlock value: b ].
	! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:10'!
drawBackgroundOn: aCanvas

	aCanvas fillRectangle: self bounds fillStyle: self fillStyle! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 00:51'!
drawForegroundOn: aCanvas
	| colors index col |
	colors := Color wheel: 5.
	index := 1.

	self constraintBoxesDo: [:each | | p vp width |
		col := (colors at: index) lighter lighter.
		width := each width.
		index := index + 1.
		p := each corner.
		vp := (p x)@(p y).
		aCanvas 
			fillRectangle: (((0)@(0) corner: width@width) translateBy: vp + self position)
			color: col]
! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 01:02'!
drawGrabBoxOn: aCanvas

	grabBox ifNotNil: [ | grabPoint valuePoint mid |
		mid := grabBox width / 2.
		grabPoint := grabBox corner.
		valuePoint := (grabPoint x + mid)@(grabPoint y + mid).
		aCanvas 
			frameRectangle: ((valuePoint - self grabThreshold + self position) corner: 
								(valuePoint + self grabThreshold + self position))
			color: Color yellow]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:33'!
drawOn: aCanvas

	| maxWI logScale |
	WTopLevelWorld default eval: [ self drawBackgroundOn: aCanvas ].

	maxWI := worlds size.
	logScale := (maxWI min: 25) ln.		"aim for invisibility at 25 worlds into the past"
	worlds allButLast withIndexDo: [ :w :wi | w eval: [ self drawForegroundOn: (FixedAlphaCanvas on: aCanvas withAlpha: ((1.0-((maxWI-wi) ln / logScale)) max: 0)) ] ].

	worlds last eval: [ self drawForegroundOn: aCanvas; drawGrabBoxOn: aCanvas; drawResizeBoxOn: aCanvas ].
! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 01:32'!
drawResizeBoxOn: aCanvas

	resizeGrabBox ifNotNil: [ | resizeGrabPoint valuePoint |
		resizeGrabPoint := resizeGrabBox corner.
		valuePoint := (resizeGrabPoint x)@(resizeGrabPoint y).
		aCanvas 
			frameRectangle: ((valuePoint - self grabThreshold + self position) corner: 
								(valuePoint + self grabThreshold + self position))
			color: Color yellow]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:11'!
endManipulation
	"This method is called when a constrainable point is ending being manipulated, i.e., upon mouse up.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.

	The order of messages is:
		1. #beginManipulation
		2-N. #manipulationMoveTo:
		N+1. #endManipulation"

	cs endEdit.
	self changed.! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:11'!
fixupPoint: aPoint with: deepCopier
	"Answer a Point that contains the deeply copied counterparts of its x and y values"

	^ (deepCopier references at: aPoint x) @ (deepCopier references at: aPoint y)
	! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 15:03'!
grabThreshold

	^ 5@5! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 01:32'!
handleListenEvent: evt

	| pv threshold |
activeWorld eval: [
	dragBox ifNil: [
		threshold := self grabThreshold * 2.
		self constraintBoxesDo: [:b | | pt vp grabPoint mid |
			pt := b corner.
			mid := b width / 2.
			vp := (pt x + mid)@(pt y + mid).
			pv := vp rounded + self position.
			(((pv - threshold + 4) corner: (pv + threshold - 4)) containsPoint: evt position) ifTrue: [
				grabPoint := b corner.
				grabPoint == pv ifFalse: [
					grabBox := b.
					self changed].
				^ self]
			ifFalse: [ 
				| resizeGrabPoint |
				vp := (pt x)@(pt y).
				pv := vp rounded + self position.
				(((pv - threshold) corner: (pv + threshold)) containsPoint: evt position) ifTrue: [
				resizeGrabPoint := b corner.
				resizeGrabPoint == pv ifFalse: [
					resizeGrabBox := b.
					self changed].
				^ self] ]
			].
		grabBox ifNotNil: [
			grabBox := nil.
			self changed
			].
		resizeGrabBox ifNotNil: [
			resizeGrabBox := nil.
			self changed
			].
		]
	]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:15'!
handlesMouseDown: evt

	evt redButtonPressed ifTrue: [^ true].
	^ super handlesMouseDown: evt! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:15'!
handlesMouseOver: evt

	^ true! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/28/2012 18:33'!
initialExtent

	^ 600@300! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:52'!
initialize

	| coords Box Point |
	super initialize.
	cs := ClSimplexSolver new.
	errorPixel := nil.
	self initializeWorlds.
	
	self extent: self initialExtent.
	moveConstraintsOn := true.
	env := CoopLangs newModel: CoopLangsLibrary Point , 
'class Box : Thing
	Attributes
		corner : Point
		width : Real
		contents : Set ( Box )
relation DragBox(a: Box)
relation DragAlong(a: Box)
	Rules
		DragAlong(a) <--
			DragBox(a) || 
			exists b : Box | (Box_contents(b, a) && DragAlong(b))
	' andProblem: '
var p1, p2, p3, p4, p5 : Point
var b1, b2, b3, b4, b5 : Box
var padding : Real'.
	Point := env getClass: #Point.
	Box := env getClass: #Box.
	env at: #padding put: 4.0.
	coords := {30.0@180.0. 80.0@180.0. 130.0@180.0. 180.0@180.0. 230.0@180.0}.
	boxes := OrderedCollection new.
	(1 to: coords size) do: 
		[:i |  | c b p | 
			c := coords at: i. 
			p := Point new x: c x; y: c y; var: (#p, i) asSymbol.
			b := Box new corner: p; width: 40.0; contents: {}; var: (#b , i) asSymbol.
			boxes add: b. 
		].! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:16'!
initializeWorlds
	worlds := OrderedCollection with: WTopLevelWorld default.
	self addWorld.
! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 12:46'!
insertBySortedWidth: box

	"keep boxes sorted in ascending width order"
	| s i w |
	w := box width.
	sortedBoxes := OrderedCollection withAll: boxes.
	sortedBoxes remove: box.
	s :=  sortedBoxes size.
	i := 1.
	[(i <= s) and: [(sortedBoxes at: i) width < w ]] whileTrue: [ i := i + 1 ].
	sortedBoxes add: box beforeIndex: i.! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 13:44'!
manipulationMoveTo: aPoint
	"This method is called when a constrainable point is manipulated using the mouse, i.e., during mouse motion.  aPoint is the location of the mouse and thus the new requested location of the constrainable point.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.
	"
	| p1 model stays points dragPoint hwidth xdisplacement ydisplacement movables | 
	
	lastPoint = aPoint ifTrue: [ ^self ].
	lastPoint := aPoint.

	dragPoint := dragBox corner.
	hwidth := dragBox width / 2.
	xdisplacement := dragPoint x - aPoint x + hwidth.
	ydisplacement := dragPoint y - aPoint y + hwidth.
	
	" Task #2: Figure out boxes that should be moved along with the one user moves... (Using Datalog) "
	
	(env relations at: #DragBox) add: {dragBox}.
	(dragBox contents isEmpty or: [CoopLangDatalog new available not])
		ifTrue: [ movables := {dragBox} , dragBox contents. ]
		ifFalse: [  
			env resolveRelations: #(debug true).
			movables := (env relations at: #DragAlong) tuples collect: [:tp | tp first ].
		].
	movables do: [:b | | p |
		p := b corner.
		p x: (p x - xdisplacement).
		p y: (p y - ydisplacement).
	].
	(moveConstraintsOn) ifFalse: [ | search width owidth ocenter currentContainer |
		"if a box is moved inside a bigger box, mark it as a content"
		width := dragBox width.
		owidth :=  width / 2.
		ocenter := (dragBox corner x + owidth)@(dragBox corner y + owidth).
		search := true.
		currentContainer := nil.
		sortedBoxes do: [:b | 
			(b ~= dragBox and: [b contents contains: dragBox]) ifTrue: [
				b contents: (b contents select: [:x | x ~= dragBox]).
			].
			(search and: [ b width > width ]) ifTrue: [ | bwidth corner1 corner2 rect |
				bwidth := b width.
				corner1 := (b corner x)@(b corner y).
				corner2 := corner1 + bwidth@bwidth. 
				rect := corner1 corner: corner2.
				(rect containsPoint: ocenter) ifTrue: 
					[ 
						search := false. 
						(b contents contains: dragBox) ifFalse: [ b contents: (b contents , {dragBox})] ]
				].
		].
		self changed. 
		^true 
	].
	
	" Task #1: Move boxes according to soft constraints... (Using OCassowary)"
	
	stays := ''.
	points :=  boxes collect: [:b | b corner].
	"since stay support isnt there yet, we need to give the point being dragged a higher stay prioriy"
	1 to: boxes size do: [:i | | pn b | 
		pn := (#p , i) asSymbol.
		b := boxes at: i.
		b contents: {}.
		stays := stays , Character lf , Character tab, '[priority: ' , 
			(b == dragBox ifTrue: ['strong'] ifFalse: ['weak']) , '] ' , pn , '.x = old(' , pn , '.x)' ].
	p1 := env hostProgram: stays , '
	p1.x >= padding
	p5.x <= 600 - b5.width - padding
	p1.x + b1.width + padding <= p2.x
	p2.x + b2.width + padding <= p3.x
	p3.x + b3.width + padding <= p4.x
	p4.x + b4.width + padding <= p5.x
	' in: #OCassowary modifiableObjects: points modifiableAttributes: #((Point x)) options: #().
	model := p1 runAndCommit.
	self changed.	
	self addWorld.! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 15:13'!
manipulationResizeTo: aPoint
	"This method is called when a constrainable point is manipulated using the mouse, i.e., during mouse motion.  aPoint is the location of the mouse and thus determines the resizing of the 'resizePoint'.
	"
	| newWidth|
	
	lastPoint = aPoint ifTrue: [ ^self ].
	lastPoint := aPoint.
	newWidth := resizeBox width + (resizeBox corner x - aPoint x).
	resizeBox width: newWidth.
	self insertBySortedWidth: resizeBox.
	self changed.
	self addWorld.
	! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 02:07'!
mouseDown: evt

	super mouseDown: evt.
	
	activeWorld eval: [
		(grabBox isNil not) ifTrue: [
			dragBox := grabBox.
			grabBox := nil.
		] ifFalse: [
			(resizeGrabBox isNil not) ifTrue: [
				resizeBox:= resizeGrabBox..
				resizeGrabBox := nil.
				moveConstraintsOn := moveConstraintsOn not.
			]
		]
	]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:20'!
mouseEnter: evt

	super mouseEnter: evt.
	evt hand addMouseListener: self! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:20'!
mouseLeave: evt

	super mouseLeave: evt.
	evt hand removeMouseListener: self! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:22'!
mouseMove: evt

	super mouseMove: evt.
	activeWorld eval: [
		dragBox isNil not ifTrue: [
			self manipulationMoveTo: (evt cursorPoint - self position)
		] ifFalse: [
			(resizeBox isNil not) ifTrue: [
				self manipulationResizeTo: (evt cursorPoint - self position)
			]
		]
	]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:23'!
mouseStillDown: evt

	super mouseStillDown: evt.
	activeWorld eval: [
		(dragBox isNil and: [ resizeBox isNil ]) ifTrue: [^ self].
		self manipulationMoveTo: (evt cursorPoint - self position)
	]! !

!CoopLangMovingBoxesDemo methodsFor: 'as yet unclassified' stamp: 'hs 8/29/2012 16:24'!
mouseUp: evt

	super mouseUp: evt.
	activeWorld eval: [
		(dragBox isNil and: [resizeBox isNil]) ifTrue: [^ self].
		dragBox := nil.
		resizeBox := nil.
		self endManipulation.
	].

	"fold into the top world all changes that happened during this manipulation, then re-initialise the worlds collection"
	worlds reverseDo: [ :w | w commit ].
	self initializeWorlds.

	"and draw"
	self changed.
! !

Morph subclass: #CoopLangNoOverlapDemo
	instanceVariableNames: 'shell main form da gc gcw buffer lastPoint cs errorPixel editX editY activeWorld worlds env boxes grabBox dragBox resizeGrabBox resizeBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangNoOverlapDemo class methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:05'!
maxWorlds
	"any number 1 or less will suppress multi-world behaviour"
	^1! !

!CoopLangNoOverlapDemo class methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:06'!
noOverlapDemo

	CoopLangNoOverlapDemo new openInWorld.! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:12'!
addWorld
	"keep only a limited number of worlds (out of which not all are necessarily being drawn; see drawOn:)"
	| maxWorlds |
	maxWorlds := self class maxWorlds.
	maxWorlds <= 1 ifTrue: [ ^activeWorld := worlds first ].	"only use top-level world"
	activeWorld := worlds add: worlds last sprout.
! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 12:03'!
computeNearbyBoxes

	| res modBoxes mbs |
	res := #().
	mbs := #().
	modBoxes := { dragBox }.
	[modBoxes size == mbs size] whileFalse: [ 
		mbs := modBoxes.
		modBoxes := self computeNearbyBoxesH: modBoxes.
	].
	^modBoxes collect: [:b | b corner]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 12:06'!
computeNearbyBoxesH: bs

	| res gh gw gx gy |
	res := OrderedCollection withAll: bs.
	bs do: [:g |
		gw := g width.
		gh := g height.
		gx := g corner x.
		gy := g corner y.
		boxes do: [:b | | c bc | 
			c := b corner.
			(b == g) 
				ifFalse: [ | bx by bw bh |
					bx := c x.
					by := c y.
					bw := b width.
					bh := b height.
					bc := (bx)@(by). 
					((((bx <= gx) and: [ bx + bw >= gx ]) or: 
						[ gx <= bx and: [ gx + gw >= bx ] ]) and: [
						((by <= gy) and: [ by + bh >= gy ]) or: 
						[ gy <= by and: [ gy + gh >= by  ] ]
						]) ifTrue: [ res addIfNotPresent: b].
				]
			]
	].
	^res! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:12'!
constraintBoxesDo: aBlock

	boxes do: [:b | aBlock value: b ].
	! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:51'!
drawBackgroundOn: aCanvas

	aCanvas fillRectangle: self bounds color: Color white "fillStyle: self fillStyle"! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/17/2012 00:22'!
drawForegroundOn: aCanvas

	| colors index col |
	colors := Color wheel: boxes size.
	index := 1.

	self constraintBoxesDo: [:each | | p vp width height |
		col := (colors at: index) lighter lighter.
		width := each width.
		height := each height.
		index := index + 1.
		p := each corner.
		vp := (p x)@(p y).
		aCanvas 
			fillRectangle: (((0)@(0) corner: width@height) translateBy: vp + self position)
			color: col]
! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:51'!
drawGrabBoxOn: aCanvas

	grabBox ifNotNil: [ | grabPoint valuePoint midw midh |
		midw := grabBox width / 2.
		midh := grabBox height / 2.
		grabPoint := grabBox corner.
		valuePoint := (grabPoint x + midw)@(grabPoint y + midh).
		aCanvas 
			frameRectangle: ((valuePoint - self grabThreshold + self position) corner: 
								(valuePoint + self grabThreshold + self position))
			color: Color black]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:29'!
drawOn: aCanvas

	| maxWI logScale |
	WTopLevelWorld default eval: [ self drawBackgroundOn: aCanvas ].

	maxWI := worlds size.
	logScale := (maxWI min: 25) ln.		"aim for invisibility at 25 worlds into the past"
	worlds allButLast withIndexDo: [ :w :wi | w eval: [ self drawForegroundOn: (FixedAlphaCanvas on: aCanvas withAlpha: ((1.0-((maxWI-wi) ln / logScale)) max: 0)) ] ].

	worlds last eval: [ self drawForegroundOn: aCanvas; drawGrabBoxOn: aCanvas; drawResizeBoxOn: aCanvas ].
! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:51'!
drawResizeBoxOn: aCanvas

	resizeGrabBox ifNotNil: [ | resizeGrabPoint valuePoint |
		resizeGrabPoint := resizeGrabBox corner.
		valuePoint := (resizeGrabPoint x)@(resizeGrabPoint y).
		aCanvas 
			frameRectangle: ((valuePoint - self grabThreshold + self position) corner: 
								(valuePoint + self grabThreshold + self position))
			color: Color black]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:24'!
endManipulation
	"This method is called when a constrainable point is ending being manipulated, i.e., upon mouse up.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.

	The order of messages is:
		1. #beginManipulation
		2-N. #manipulationMoveTo:
		N+1. #endManipulation"

	cs endEdit.
	self changed.! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:17'!
grabThreshold

	^ 5@5! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:30'!
handleListenEvent: evt

	| pv threshold |
activeWorld eval: [
	dragBox ifNil: [
		threshold := self grabThreshold * 2.
		self constraintBoxesDo: [:b | | pt vp grabPoint midw midh |
			pt := b corner.
			midw := b width / 2.
			midh := b height / 2.
			vp := (pt x + midw)@(pt y + midh).
			pv := vp rounded + self position.
			(((pv - threshold + 4) corner: (pv + threshold - 4)) containsPoint: evt position) ifTrue: [
				grabPoint := b corner.
				grabPoint == pv ifFalse: [
					grabBox := b.
					self changed].
				^ self]
			ifFalse: [ 
				| resizeGrabPoint |
				vp := (pt x)@(pt y).
				pv := vp rounded + self position.
				(((pv - threshold) corner: (pv + threshold)) containsPoint: evt position) ifTrue: [
				resizeGrabPoint := b corner.
				resizeGrabPoint == pv ifFalse: [
					resizeGrabBox := b.
					self changed].
				^ self] ]
			].
			grabBox ifNotNil: [
				grabBox := nil.
				self changed
			].
			resizeGrabBox ifNotNil: [
				resizeGrabBox := nil.
				self changed
			].
		]
	]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:22'!
handlesMouseDown: evt

	evt redButtonPressed ifTrue: [^ true].
	^ super handlesMouseDown: evt! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:22'!
handlesMouseOver: evt

	^true! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:10'!
initialExtent

	^ 600@300! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:52'!
initialize

	| coords sizes Box Point |
	super initialize.
	cs := ClSimplexSolver new.
	errorPixel := nil.
	self initializeWorlds.
	
	self extent: self initialExtent.
	env := CoopLangs newModel: CoopLangsLibrary Point , 
'class Box : Thing
	Attributes
		corner : Point
		width, height : Real
		flexibility : Real
	' andProblem: '
var dragBox: Box'.
	Point := env getClass: #Point.
	Box := env getClass: #Box.
	env at: #padding put: 4.0.
	coords := {30.0@180.0. 80.0@180.0. 130.0@180.0. 180.0@180.0. 230.0@180.0. 320.0@180.0}.
	sizes := {20.0@20.0. 40.0@10.0. 20.0@30.0. 30.0@40.0. 30.0@30.0. 50.0@30.0}.
	boxes := OrderedCollection new.
	(1 to: coords size) do: 
		[:i |  | c s b p | 
			c := coords at: i.
			s := sizes at: i. 
			p := Point new x: c x; y: c y.
			b := Box new corner: p; width: s x; height: s y; flexibility: 20.0.
			boxes add: b. 
		].! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:11'!
initializeWorlds
	worlds := OrderedCollection with: WTopLevelWorld default.
	self addWorld.
! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/17/2012 00:20'!
manipulationAddBox: aPoint
	"This method is called when a place on canvas is clicked on to place a new box
	"
	| Box Point p b |
	Point := env getClass: #Point.
	Box := env getClass: #Box.
	p := Point new x: (aPoint x + 0.0); y: (aPoint y + 0.0).
	b := Box new corner: p; width: 30.0; height: 30.0; flexibility: 20.0.
	boxes add: b.
	self changed.! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/17/2012 14:17'!
manipulationMoveTo: aPoint
	"This method is called when a constrainable point is manipulated using the mouse, i.e., during mouse motion.  aPoint is the location of the mouse and thus the new requested location of the constrainable point.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.
	"
	| p1 model dragPoint hwidth xdisplacement ydisplacement dragBoxCorner modPoints | 
	
	lastPoint = aPoint ifTrue: [ ^self ].
	lastPoint := aPoint.

	dragPoint := dragBox corner.
	hwidth := dragBox width / 2.
	xdisplacement := dragPoint x - aPoint x + hwidth.
	ydisplacement := dragPoint y - aPoint y + hwidth.
	dragBoxCorner := dragBox corner.
	dragBoxCorner x: (dragBoxCorner x - xdisplacement).
	dragBoxCorner y: (dragBoxCorner y - ydisplacement).
	
	" Task: Move boxes according to soft constraints... (Using Z3)"
	modPoints := self computeNearbyBoxes.
	dragBox flexibility: 0.0.
	p1 := env hostProgram: '
	all b : Box | 
		(b.corner.x >= 0.0 && 
		 b.corner.x + b.width <= 600.0 &&
		 b.corner.y >= 0.0 &&
		 b.corner.y + b.height <= 300.0 && 
		 abs(b.corner.x - old(b.corner.x)) <= b.flexibility &&
		 abs(b.corner.y - old(b.corner.y)) <= b.flexibility)
	all b1 : Box | 
		all b2 : Box | 
			(b1 !!= b2 => (b2.corner.x >= b1.corner.x + b1.width || 
						   b1.corner.x >= b2.corner.x + b2.width || 
						   b2.corner.y >= b1.corner.y + b1.height ||
						   b1.corner.y >= b2.corner.y + b2.height))
	' in: #Z3 modifiableObjects: modPoints modifiableAttributes: #((Point x) (Point y)) options: #(noOldVar true).
	model := p1 runAndCommit.
	"model == false ifTrue: [ self error: 'oops, it is unsat!!']."
	dragBox flexibility: 20.0.
	self changed.! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:58'!
manipulationResizeTo: aPoint
	"This method is called when a constrainable point is manipulated using the mouse, i.e., during mouse motion.  aPoint is the location of the mouse and thus determines the resizing of the 'resizePoint'.
	"
	| newWidth newHeight |
	
	lastPoint = aPoint ifTrue: [ ^self ].
	lastPoint := aPoint.
	newWidth := resizeBox width + (resizeBox corner x - aPoint x).
	newHeight := resizeBox height + (resizeBox corner y - aPoint y).
	resizeBox width: newWidth; height: newHeight.
	self changed.
	! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:56'!
mouseDown: evt

	super mouseDown: evt.
	
	activeWorld eval: [
		(grabBox isNil not) ifTrue: [
			dragBox := grabBox.
			grabBox := nil.
		] ifFalse: [
			(resizeGrabBox isNil not) ifTrue: [
				resizeBox := resizeGrabBox..
				resizeGrabBox := nil.
			] ifFalse: [ 
				self manipulationAddBox: (evt cursorPoint - self position)
			]
		]
	]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:23'!
mouseEnter: evt

	super mouseEnter: evt.
	evt hand addMouseListener: self! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 19:23'!
mouseLeave: evt

	super mouseLeave: evt.
	evt hand removeMouseListener: self! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:33'!
mouseMove: evt

	super mouseMove: evt.
	activeWorld eval: [
		dragBox isNil not ifTrue: [
			self manipulationMoveTo: (evt cursorPoint - self position)
		]  ifFalse: [
			(resizeBox isNil not) ifTrue: [
				self manipulationResizeTo: (evt cursorPoint - self position)
			]
		]
	]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:33'!
mouseStillDown: evt

	super mouseStillDown: evt.
	activeWorld eval: [
		(dragBox isNil and: [ resizeBox isNil ]) ifTrue: [^ self].
		self manipulationMoveTo: (evt cursorPoint - self position)
	]! !

!CoopLangNoOverlapDemo methodsFor: 'as yet unclassified' stamp: 'hs 10/16/2012 23:33'!
mouseUp: evt

	super mouseUp: evt.
	activeWorld eval: [
		(dragBox isNil and: [resizeBox isNil]) ifTrue: [^ self].
		dragBox := nil.
		resizeBox := nil.
		self endManipulation.
	].

	"fold into the top world all changes that happened during this manipulation, then re-initialise the worlds collection"
	worlds reverseDo: [ :w | w commit ].
	self initializeWorlds.

	"and draw"
	self changed.
! !

Morph subclass: #CoopLangSpreadsheetDemo
	instanceVariableNames: 'shell main form da gc gcw buffer grabColumn dragColumn lastPoint cs errorPixel editX editY activeWorld worlds env table cellPadding grabColumnX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangSpreadsheetDemo class methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 16:22'!
maxWorlds
	"any number 1 or less will suppress multi-world behaviour"
	^1
! !

!CoopLangSpreadsheetDemo class methodsFor: 'as yet unclassified' stamp: 'hs 9/15/2012 19:50'!
spreadsheetDemo

	CoopLangSpreadsheetDemo new openInWorld.! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 16:20'!
addWorld
	"keep only a limited number of worlds (out of which not all are necessarily being drawn; see drawOn:)"
	| oldestWorld maxWorlds |
	maxWorlds := self class maxWorlds.
	maxWorlds <= 1 ifTrue: [ ^activeWorld := worlds first ].	"only use top-level world"
	
	worlds size > (maxWorlds + 1)
	  ifTrue: [
		"NB: the following - in particular, the introduction of the 'reparent' operation - is not an 'approved' use of worlds.
		oldestWorld is the oldest non-top-level world in our list.  we remove it, commit its changes into the (top-level) parent , then reparent the next world to take its place."
		oldestWorld := worlds removeAt: 2.
		oldestWorld commit.
		(worlds at: 2) reparent: worlds first.
		].
	
	activeWorld := worlds add: worlds last sprout.
! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:05'!
drawBackgroundOn: aCanvas

	aCanvas fillRectangle: self bounds color: Color white! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:20'!
drawForegroundOn: aCanvas

	| index sumWidths sumHeights corner |
	index := 1.
	sumHeights := 0.
	corner := (table corner x)@(table corner y).
	table rows do: [:row | | height | 
		height := row height.
		sumWidths := 0.
		table columns do: [:column |	 | p width |
			width := column width.
			p := corner + (sumWidths@sumHeights).
			aCanvas 
				frameRectangle: (((0)@(0) corner: width@height) translateBy: p + self position)
				color: Color black. 
			sumWidths := sumWidths + width + cellPadding. 
		]. 
		sumHeights := sumHeights + height + cellPadding.
	].! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:23'!
drawGrabColumnOn: aCanvas

	grabColumn ifNotNil: [ | sumWidth sumHeight x y |
		sumWidth := 0.
		sumHeight := 0.
		table rows do: [:row | sumHeight := sumHeight + row height ].
		1 to: grabColumn index do: [:i | sumWidth := sumWidth + (table columns at: i) width + cellPadding ].
		x := table corner x + sumWidth - (cellPadding / 2).
		y := table corner y + 20.
		aCanvas line: x@y to: (x@(y + sumHeight)) width: 2 color: Color gray.
	]! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:06'!
drawOn: aCanvas

	WTopLevelWorld default eval: [ self drawBackgroundOn: aCanvas ].
	worlds last eval: [ self drawForegroundOn: aCanvas; drawGrabColumnOn: aCanvas ].
! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:28'!
endManipulation
	"This method is called when a constrainable point is ending being manipulated, i.e., upon mouse up.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.

	The order of messages is:
		1. #beginManipulation
		2-N. #manipulationMoveTo:
		N+1. #endManipulation"

	self changed.! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 18:11'!
grabThreshold

	^ 1@1! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 18:11'!
handleListenEvent: evt

	| pv threshold sumWidths sumHeights |
	activeWorld eval: [
		dragColumn ifNil: [
			threshold := self grabThreshold * 2.
			sumWidths := table corner x.
			sumHeights := table corner y.
			table rows do: [:row | 
				sumHeights := sumHeights + row height.
			].
			table columns do: [:column | | corner currX currY currX2 currY2 |
				currX := sumWidths + column width - threshold x.
				currY := table corner y.
				corner := currX@currY.
				currX2 := 2*(threshold x).
				currY2 := sumHeights.
				pv := corner + (currX2@currY2).
				((corner corner: pv) containsPoint: evt position) ifTrue: [				
					grabColumn == column ifFalse: [
						grabColumn := column.
						grabColumnX := evt position x.
						self changed.
					].
					^ self
				].
				sumWidths := sumWidths + column width + cellPadding.
				].
			grabColumn ifNotNil: [
				grabColumn := nil.
				self changed
			].
		]
	]! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/16/2012 00:21'!
handlesMouseDown: evt

	evt redButtonPressed ifTrue: [^ true].
	^ super handlesMouseDown: evt! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/16/2012 00:21'!
handlesMouseOver: evt

	^ true! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/15/2012 19:51'!
initialExtent

	^ 600@300! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:21'!
initialize

	| Point Table Cell Column Row columns rows numColumns numRows cells  |
	
	super initialize.
	cs := ClSimplexSolver new.
	errorPixel := nil.
	self initializeWorlds.
	self extent: self initialExtent.
	
	env := CoopLangs newModel: CoopLangsLibrary Point ,
'class CellSequence : Thing
	Attributes
		index : Int
		cells : List(Cell)
class Row : CellSequence
	Attributes
		height : Real
class Column : CellSequence
	Attributes
		width : Real
class Cell : Thing
	Attributes
		row : Row
		column : Column
class Table : Thing
	Attributes
		cells : List(Cell)
		rows : List(Row)
		columns : List(Column)
		corner : Point
'.
	Cell := env getClass: #Cell.
	Row := env getClass: #Row.
	Column := env getClass: #Column.
	Table := env getClass: #Table.
	Point := env getClass: #Point.
	numRows := 4.
	numColumns := 4.
	cells := OrderedCollection new.
	rows := (1 to: numRows) collect: [:i | Row new index: i; height: 50.0; yourself ].
	columns := (1 to: numColumns) collect: [:i | Column new index: i; width: 50.0; yourself ].
	rows do: [:row |
		columns do: [:column |
			 cells add: (Cell new row: row; column: column; yourself) ] ].
	table := Table new cells: cells asArray; rows: rows; columns: columns; corner: (Point new x: 50.0; y: 50.0; yourself); var: #table.
	cellPadding := 2.! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 16:21'!
initializeWorlds
	worlds := OrderedCollection with: WTopLevelWorld default.
	self addWorld.
! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 18:11'!
manipulationMoveTo: aPoint
	"This method is called when a constrainable point is manipulated using the mouse, i.e., during mouse motion.  aPoint is the location of the mouse and thus the new requested location of the constrainable point.  The constrainable point is stored in the 'dragPoint' instance variable, and the corresponding plan for moving that point is stored in the 'plan' instance variable.
	"
	
	| xdisplacement | 
	
	lastPoint = aPoint ifTrue: [ ^self ].
	lastPoint := aPoint.
	
	xdisplacement := aPoint x - grabColumnX.
	dragColumn width: (dragColumn width + xdisplacement).
	grabColumnX := aPoint x.
	self changed.! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:02'!
mouseDown: evt

	super mouseDown: evt.
	
	activeWorld eval: [
		(grabColumn isNil not) ifTrue: [
			dragColumn := grabColumn.
			grabColumn := nil.
		] ifFalse: [
		
		]
	]! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 16:17'!
mouseEnter: evt

	super mouseEnter: evt.
	evt hand addMouseListener: self! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 16:17'!
mouseLeave: evt

	super mouseLeave: evt.
	evt hand removeMouseListener: self! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:26'!
mouseMove: evt

	super mouseMove: evt.
	activeWorld eval: [
		dragColumn isNil not ifTrue: [
			self manipulationMoveTo: (evt cursorPoint - self position)
		] ifFalse: [
			
		]
	]! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:02'!
mouseStillDown: evt

	super mouseStillDown: evt.
	activeWorld eval: [
		(dragColumn isNil) ifTrue: [^ self].
		self manipulationMoveTo: (evt cursorPoint - self position)
	]! !

!CoopLangSpreadsheetDemo methodsFor: 'as yet unclassified' stamp: 'hs 9/18/2012 17:02'!
mouseUp: evt

	super mouseUp: evt.
	activeWorld eval: [
		(dragColumn isNil) ifTrue: [^ self].
		dragColumn := nil.
		self endManipulation.
	].

	"fold into the top world all changes that happened during this manipulation, then re-initialise the worlds collection"
	worlds reverseDo: [ :w | w commit ].
	self initializeWorlds.

	"and draw"
	self changed.
! !

TestCase subclass: #CoopLangCassowaryTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'AHB 6/27/2012 18:06'!
testAddition1

	"
	CoopLangCassowaryTests new testAddition1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y = x+5
	' in: #Cassowary modifiableVars: #(y).
	p1 runAndCommit.
	self assert: ((env at: #y) clApprox: 15)
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'AHB 6/27/2012 18:06'!
testAddition2	
	
	"
	CoopLangCassowaryTests new testAddition2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	x = 5 + 6 + 8 + 7
	' in: #Cassowary readOnlyVars: #().
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 26)
! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'AHB 7/28/2012 19:07'!
testIncrementalAddition1

	"
	CoopLangCassowaryTests new testIncrementalAddition1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y = x+5
	' in: #Cassowary modifiableVars: #(x y).
	"setupIncrementalRun:strengths: takes an array of variable names and a matching array of constraint strengths.  The variables 
	  will be repeatedly given new values using an edit constraint of the given strength."
	p1 setupIncrementalRun: #(x) strengths: {ClStrength strong}.
	"test that there is one edit constraint"
	self assert: 1 equals: p1 solver cassowarySolver editConstraints size.
	"we haven't put any stays on x or y, so either could change -- but in any correct solution they should differ by 5"
	self assert: ((env at: #y) - (env at: #x) clApprox: 5).
	"updateValue: incrementally updates the value for a variable (we need to have set things up for this variable using setupIncrementalRun: first)"
	p1 updateValue: #x newValue: 20.
	p1 resolveAndCommit.
	self assert: ((env at: #y) clApprox: 25).
	p1 updateValue: #x newValue: 50.
	p1 resolveAndCommit.
	self assert: ((env at: #y) clApprox: 55).
	p1 endIncrementalRun.
	"test that the edit constraint was removed"
	self assert: p1 solver cassowarySolver editConstraints isEmpty
	
! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'yo 10/22/2012 11:22'!
testIncrementalAddition2

	"
	CoopLangCassowaryTests new testIncrementalAddition2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	env eval: 'this.x = this.streamOf(10)'.
	env eval: 'this.y = this.streamOf(nil)'.
	p1 := env hostProgram: '
	y = x+5
	' in: #Cassowary modifiableVars: #(x y).
	p1 setupIncrementalRun: #(x) strengths: {ClStrength strong}.
	self assert: 1 equals: p1 solver cassowarySolver editConstraints size.
	self assert: ((env at: #y) currentValue - (env at: #x) currentValue clApprox: 5).

	env at: #p1 put: p1.
	env eval: 'this.solver = $$(solver(() ->
		this.p1._updateValue_newValue("x".asSymbol(), @x)	
		this.p1.resolveAndCommit(), ["x"], ["x", "y"]))'.

	(env at: #x) set: 20.
	env sortAndEvaluateAt: 1.
	self assert: ((env at: #y) currentValue clApprox: 25).
	(env at: #x) set: 50.
	env sortAndEvaluateAt: 2.
	self assert: ((env at: #y) currentValue clApprox: 55).
	p1 endIncrementalRun.
	"test that the edit constraint was removed"
	self assert: p1 solver cassowarySolver editConstraints isEmpty
	
! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'AHB 7/28/2012 19:07'!
testIncrementalEditTwoVars

	"
	CoopLangCassowaryTests new testIncrementalEditTwoVars
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, z : Real
	'.
	p1 := env hostProgram: '
	z = x+y
	' in: #Cassowary modifiableVars: #(x y z).
	"setupIncrementalRun: takes a collection of variable names.  These will be the variables that are repeatedly given new values."
	p1 setupIncrementalRun: #(x z) strengths: {ClStrength strong.  ClStrength strong}.
	"test that there are two edit constraints"
	self assert: 2 equals: p1 solver cassowarySolver editConstraints size.
	"we haven't put any stays on the variables or given them values -- but in any correct solution the constraint must hold"
	self assert: ( (env at: #x) + (env at: #y) - (env at: #z) clApprox: 0).
	p1 updateValue: #x newValue: 20.
	p1 updateValue: #z newValue: 50.
	p1 resolveAndCommit.
	self assert: ((env at: #y) clApprox: 30).
	p1 updateValue: #x newValue: 5.
	p1 updateValue: #z newValue: 12.
	p1 resolveAndCommit.
	self assert: ((env at: #y) clApprox: 7).
	p1 endIncrementalRun.
	"test that the edit constraints were removed"
	self assert: p1 solver cassowarySolver editConstraints isEmpty
	
! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'hs 9/26/2012 13:41'!
testIncrementalSatisfiableSoftEdit

	"
	A soft edit constraint that can be satisfied.
	self halt. CoopLangCassowaryTests new testIncrementalSatisfiableSoftEdit
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	p1 := env hostProgram: '
	[priority: weak] x=10
	' in: #Cassowary modifiableVars: #(x).
	p1 setupIncrementalRun: #(x) strengths: {ClStrength medium}.
	p1 updateValue: #x newValue: 20.
	p1 resolveAndCommit.
	"the medium edit constraint on x means it should change to 20"
	self assert: ((env at: #x) clApprox: 20).
! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'AHB 7/29/2012 15:19'!
testIncrementalUnsatisfiableRequiredEdit

	"
	A required edit constraint that can't be satisfied .... check that an exception is raised.
	self halt. CoopLangCassowaryTests new testIncrementalUnsatisfiableRequiredEdit
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	p1 := env hostProgram: '
	x=10
	' in: #Cassowary modifiableVars: #(x).
	p1 setupIncrementalRun: #(x) strengths: {ClStrength required}.
	"first time is ok, since we are just setting x to its required value of 10"
	p1 updateValue: #x newValue: 10.
	p1 resolveAndCommit.
	self assert: ((env at: #x) clApprox: 10).
	p1 updateValue: #x newValue: 50.
	self should: [p1 resolveAndCommit] raise: TestResult error.! !

!CoopLangCassowaryTests methodsFor: 'incremental solving unit tests' stamp: 'hs 9/26/2012 13:41'!
testIncrementalUnsatisfiableSoftEdit

	"
	A soft edit constraint that can't be satisfied .... check that it's overridden
	self halt. CoopLangCassowaryTests new testIncrementalUnsatisfiableSoftEdit
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	p1 := env hostProgram: '
	[priority: strong] x=10
	' in: #Cassowary modifiableVars: #(x).
	p1 setupIncrementalRun: #(x) strengths: {ClStrength medium}.
	p1 updateValue: #x newValue: 20.
	p1 resolveAndCommit.
	"the strong constraint on x means it should stay at 10"
	self assert: ((env at: #x) clApprox: 10).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'AHB 6/27/2012 18:09'!
testInequalities

	"
	CoopLangCassowaryTests new testInequalities
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	p1 := env hostProgram: '
	y<=10
	x>=2
	x>=5
	2*x=y
	' in: #Cassowary readOnlyVars: #().
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 5).
	self assert: ((env at: #y) clApprox: 10).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'AHB 6/27/2012 18:07'!
testOld1
	
	"
	CoopLangCassowaryTests new testOld1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	x = old(x) + 1
	' in: #Cassowary readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: ((env at: #x) clApprox: 11).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'hs 9/26/2012 13:41'!
testReadOnlyVariable

	"
	CoopLangCassowaryTests new testReadOnlyVariable
	"
	
	|  env p1 |
	env := CoopLangs newProblem: 'var x : Real'.
	env at: #x put: 10.  "this becomes a required constraint, since x isn't modifiable"
	p1 := env hostProgram: '[priority: weak] x = 20' in: #Cassowary modifiableVars: #().
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 10).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'AHB 6/27/2012 18:08'!
testSimultaneousEquations

	"
	CoopLangCassowaryTests new testSimultaneousEquations
	"

	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	p1 := env hostProgram: '
	y = x+5
	2*y = x+20
	' in: #Cassowary readOnlyVars: #().
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 10).
	self assert: ((env at: #y) clApprox: 15).
! !

!CoopLangCassowaryTests methodsFor: 'stream unit tests' stamp: 'yo 10/22/2012 11:22'!
testStreams1

	"
	CoopLangCassowaryTests new testStreams1
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Real
	'.
	env eval: 'this.x = this.streamOf(10)'.
	env eval: 'this.y = this.streamOf(nil)'.
	p1 := env hostProgram: '
	y = x+5
	' in: #Cassowary modifiableVars: #(y).
	env at: #p1 put: p1.
	env eval: 'this.solver = $$(solver(() ->
		this.p1.runAndCommit(), ["x"], ["x", "y"]))'.
	env sortAndEvaluateAt: 1.
	self assert: 10 equals: (env eval:  'this.x.currentValue()').
	self assert: 15 equals: (env eval:  'this.y.currentValue()').
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths1

	"
	CoopLangCassowaryTests new testStrengths1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	p1 := env hostProgram: '
	[priority: weak] x = 10
	[priority: strong] x = 15
	' in: #Cassowary modifiableVars: #(x).
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 15).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths2

	"
	CoopLangCassowaryTests new testStrengths2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: 'var x : Real'.
	env at: #x put: 10.  "this is ignored since x is modifiable -- even the weak constraint clobbers it"
	p1 := env hostProgram: '[priority: weak] x = 20' in: #Cassowary modifiableVars: #(x).
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 20).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths3

	"
	CoopLangCassowaryTests new testStrengths3
	
	test some simultaneous equations (with strengths)
	"
	
	|  env p1 |
	env := CoopLangs newProblem: 'var x, y : Real'.
	p1 := env hostProgram: '[priority: weak] x = 20
	[priority: medium] x=y+2.8
	[priority: strong] x=3*y
	[priority: strong] x+y=40' in: #Cassowary modifiableVars: #(x y).
	p1 runAndCommit.
	self assert: ((env at: #x) clApprox: 30).
	self assert: ((env at: #y) clApprox: 10).
! !

!CoopLangCassowaryTests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 11:47'!
testTypeError

	"
	CoopLangCassowaryTests new testTypeError
	(Cassowary only works on reals - make sure an error is raised if not)
	"

	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y = x+5
	' in: #Cassowary modifiableVars: #(y).
	self should: [p1 runAndCommit] raise: TestResult error.! !

TestCase subclass: #CoopLangDatalogTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:57'!
testMovableBoxes

	"
	CoopLangDatalogTests new testMovableBoxes
	"
	
	|  env Box |
	env := CoopLangs newModel: '
class Box : Thing
	Attributes
		contents : Set ( Box )
relation Clicked(a: Box)
relation Movable(a : Box)
	Rules
		Movable(a) <--
			Clicked(a) ||
			exists b : Box |  (Box_contents(b, a) && Movable(b))
' andProblem: '
var a, b, c, d, e, f: Box
'.
	Box := env getClass: #Box.
	#(a b c d e f) do: [:n | Box new var: n].
	(env at: #a) contents: {env at: #b. env at: #c}.
	(env at: #b) contents: {env at: #d}.
	(env at: #e) contents: {env at: #f}.
	(env relations at: #Clicked) add: {env at: #a}.
	env resolveRelations: {#mockOutput. 
'/--- start of Movable facts ---\
  [2]A4
  [3]A6
  [4]A3
  [5]A5
\---- end of Movable facts ----/'}.
	"Transcript show: (env relations at: #Movable) tuples."
	self assert: true equals: (env relations at: #Movable) tuples size == 4.! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:56'!
testMultiRule1

	"
	CoopLangDatalogTests new testMultiRule1
	"
	
	|  env |
	env := CoopLangs newModel: '
relation Foo(i: Int)
	Rules
		Foo(i+1) <--
			Foo(i) && i < 9
		Foo(0) <--
'.
	env resolveRelations: {#mockOutput. 
	'/--- start of Foo facts ---\
  0
  1
  2
  3
  4
  5
  6
  7
  8
  9
\---- end of Foo facts ----/'}.
	self assert: true equals: (env relations at: #Foo) tuples size == 10.
! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:27'!
testReachable

	"
	CoopLangDatalogTests new testReachable
	"
	
	|  env Node p q r |
	env := CoopLangs newModel: '
class Node : Thing
relation Edge(n1: Node, n2: Node)
relation Reachable(n1: Node, n2: Node)
	Rules
		Reachable(n1, n2) <--
			Edge(n1, n2) || 
			exists n3 : Node | (Reachable(n1, n3) && Edge(n3, n2))
' andProblem: '
var p, q, r : Node
'.
	Node := env getClass: #Node.
	p := Node new var: #p.
	q := Node new var: #q.
	r := Node new var: #r.
	(env relations at: #Edge) addAll: {{p. q}. {q. r}}.
	env resolveRelations: {#mockOutput. '
/--- start of Reachable facts ---\
  [1]A4, [0]A5
  [2]A3, [0]A5
  [2]A3, [1]A4
\---- end of Reachable facts ----/
'}.
	self assert: true equals: (env relations at: #Reachable) tuples size == 3.
! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:59'!
testShortestPath

	"
	CoopLangDatalogTests new testShortestPath
	"
	
	|  env  inf |
	env := CoopLangs newModel: '
relation NumVertices(num: Int)
relation Edge(origin: Int, dest: Int, cost: Int)
relation ShortDist(origin: Int, dest: Int, hops: Int, cost: Int)
	Rules
		ShortDist(origin, dest, hops, cost) <--
			(hops = 0 && Edge(origin, dest, cost)) || 
			(exists c1: Int, c2 : Int, c3: Int, c4: Int | 
				(ShortDist(origin, hops, hops - 1, c1) && 
				ShortDist(hops, dest, hops - 1, c2) && 
				ShortDist(origin, dest, hops - 1, c3) && 
				c4 = c1 + c2 && 
				((c4 < c3 && cost = c4) || (c4 >= c3 && cost = c3))))
relation Solution(origin: Int, dest: Int, cost: Int)
	Rules
		Solution(origin, dest, cost) <--
			origin !!= dest
			exists num : Int | (NumVertices(num) && ShortDist(origin, dest, num, cost))
'.
	inf := 126.
	(env relations at: #NumVertices) add: {6}.
	(env relations at: #Edge) addAll: {{1. 1. inf}. {1. 2. 7}. {1. 3. 9}. {1. 4. inf}. {1. 5. inf}. {1. 6. 14}. {2. 1. 7}. {2. 2. inf}. {2. 3. 10}. {2. 4. 15}. {2. 5. inf}. {2. 6. inf}. {3. 1. 9}. {3. 2. 10}. {3. 3. inf}. {3. 4. 11}. {3. 5. inf}. {3. 6. 2}. {4. 1. inf}. {4. 2. 15}. {4. 3. 11}. {4. 4. inf}. {4. 5. 6}. {4. 6. inf}. {5. 1. inf}. {5. 2. inf}. {5. 3. inf}. {5. 4. 6}. {5. 5. inf}. {5. 6. 9}. {6. 1. 14}. {6. 2. inf}. {6. 3. 2}. {6. 4. inf}. {6. 5. 9}. {6. 6. inf}}.
	env resolveRelations: {#mockOutput. '
/--- start of Solution facts ---\
  1, 2, 7
  1, 3, 9
  1, 4, 20
  1, 5, 20
  1, 6, 11
  2, 1, 7
  2, 3, 10
  2, 4, 15
  2, 5, 21
  2, 6, 12
  3, 1, 9
  3, 2, 10
  3, 4, 11
  3, 5, 11
  3, 6, 2
  4, 1, 20
  4, 2, 15
  4, 3, 11
  4, 5, 6
  4, 6, 13
  5, 1, 20
  5, 2, 21
  5, 3, 11
  5, 4, 6
  5, 6, 9
  6, 1, 11
  6, 2, 12
  6, 3, 2
  6, 4, 13
  6, 5, 9
\---- end of Solution facts ----/
'}.
	self assert: true equals: (env relations at: #Solution) tuples size == 30.
! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:37'!
testVerticalLine

	"
	CoopLangDatalogTests new testVerticalLine
	"
	
	|  env Point p q r |
	env := CoopLangs newModel: '
class Point : Thing
	Attributes
		x, y : Int
relation VLine(p1: Point, p2: Point)
	Rules
		VLine(p1, p2) <--
			p1 !!= p2
			p1.x = p2.x
' andProblem: '
var p, q, r : Point
'.
	Point := env getClass: #Point.
	p := Point new x: 0; y: 2; var: #p.
	q := Point new x: 1; y: 3; var: #q.
	r := Point new x: 1; y: 5; var: #r.
	env resolveRelations: {#mockOutput. '
/--- start of VLine facts ---\
  [1]A4, [0]A5
  [0]A5, [1]A4
\---- end of VLine facts ----/
'}.
	self assert: true equals: (env relations at: #VLine) tuples size == 2.
! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:43'!
testVerticalLineAndHeight

	"
	CoopLangDatalogTests new testVerticalLineAndHeight
	"
	
	|  env Point p q r |
	env := CoopLangs newModel: '
class Point : Thing
	Attributes
		x, y : Int
relation VLine(p1: Point, p2: Point)
	Rules
		VLine(p1, p2) <--
			p1 !!= p2
			p1.x = p2.x
relation VLineH(p1: Point, p2: Point, h: Int)
	Rules
		VLineH(p1, p2, h) <--
			VLine(p1, p2)
			((p1.y >= p2.y && h = p1.y - p2.y) || 
			(p1.y < p2.y && h = p2.y - p1.y))
' andProblem: '
var p, q, r : Point
'.
	Point := env getClass: #Point.
	p := Point new x: 0; y: 2; var: #p.
	q := Point new x: 1; y: 3; var: #q.
	r := Point new x: 1; y: 5; var: #r.
	env resolveRelations: {#mockOutput. '
/--- start of VLineH facts ---\
  [0]A5, [1]A4, 2
  [1]A4, [0]A5, 2
\---- end of VLineH facts ----/
'}.
	self assert: true equals: (env relations at: #VLineH) tuples size == 2.
! !

!CoopLangDatalogTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:47'!
testVerticalOrHorizontalLine

	"
	CoopLangDatalogTests new testVerticalOrHorizontalLine
	"
	
	|  env Point p q r |
	env := CoopLangs newModel: '
class Point : Thing
	Attributes
		x, y : Int
relation VHLine(p1: Point, p2: Point)
	Rules
		VHLine(p1, p2) <--
			p1 !!= p2
			p1.x = p2.x || p1.y = p2.y
' andProblem: '
var p, q, r : Point
'.
	Point := env getClass: #Point.
	p := Point new x: 0; y: 2; var: #p.
	q := Point new x: 1; y: 2; var: #q.
	r := Point new x: 1; y: 5; var: #r.
	env resolveRelations: {#mockOutput. '
/--- start of VHLine facts ---\
  [1]A4, [0]A5
  [0]A5, [1]A4
  [2]A3, [1]A4
  [1]A4, [2]A3
\---- end of VHLine facts ----/
'}.
	self assert: true equals: (env relations at: #VHLine) tuples size == 4.
! !

TestCase subclass: #CoopLangKodkodTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangKodkodTests commentStamp: 'hs 5/11/2012 12:43' prior: 0!
A CoopLangKodkodTests is xxxxxxxxx.


	To run Kodkod examples:
	1) Download Kokod's text interface called Kodkodi from:
		http://www4.in.tum.de/~blanchet/kodkodi-1.5.2.tgz
	2) Assuming the location where you installed kodkodi is $tool; and $platform is 'darwin' for mac, 'linux' for linux, and 'cygwin' for windows; write a script called /usr/local/bin/kodkodi with this content:
		'java -cp $tool/jar/kodkod-1.5.jar:$tool/jar/kodkodi-1.5.2.jar:$tool/jar/antlr-runtime-3.1.1.jar -Djava.library.path=$tool/jni/x86-$platform de.tum.in.isabelle.Kodkodi.Kodkodi' 

!

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'AHB 8/15/2012 15:47'!
test1

	"
	See the class comment in CoopLangKodkod for directions on installing the kodkod solver.
	"

	"
	CoopLangKodkodTests new test1
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y <= x / y
	(y + 1) > x / (y + 1)
	y >= 0
	' in: #Kodkod modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: 3 equals: (env at: #y).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 10/4/2012 16:40'!
testCircuit0

	"
	CoopLangKodkodTests new testCircuit0
	"
	
	|  env p1 n1 n2 l1 l2 r1 Resistor Node Lead |
	env := CoopLangs newModel: '
class Node: Thing
	Attributes
		voltage: Int
class Lead: Thing
	Attributes
		node: Node
		current: Int
class TwoLeadedThing: Thing
	Attributes
    		lead1, lead2: Lead
	Constraints
		this.lead1.current + this.lead2.current = 0
class Resistor: TwoLeadedThing
	Attributes
		resistance: Int
	Constraints
		this.lead1.node.voltage - this.lead2.node.voltage = this.resistance * this.lead1.current
	' andProblem: '
var r1: Resistor
var l1, l2: Lead
var n1, n2: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 10; var: #n1.
	n2 := Node new voltage: 0; var: #n2.
	l1 := Lead new node: n1; var: #l1.
	l2 := Lead new node: n2; var: #l2.
	r1 := Resistor new lead1: l1; lead2: l2; resistance: 10; var: #r1.
	p1 := env hostProgram: '
	r1.lead1.current > 0
	' in: #Kodkod modifiableObjects: {l1. l2. n1} modifiableAttributes: #((Lead current) (Node voltage)).
	p1 runAndCommit.
	self assert: 0 equals: (r1 lead1 current + r1 lead2 current).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:15'!
testCircuit1

	"
	CoopLangKodkodTests new testCircuit1
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 r1a r1b r2a r2b v1a v1b v1 r1 r2 |
	env := CoopLangs newModel: '
class Node: Thing
	Attributes
		voltage: Int
		leads: Set (Lead)
	Constraints
		sum(this.leads.current) = 0
class Lead: Thing
	Attributes
		node: Node
		current: Int
class TwoLeadedThing: Thing
	Attributes
    		lead1, lead2: Lead
	Constraints
		this.lead1.current + this.lead2.current = 0
class Resistor: TwoLeadedThing
	Attributes
		resistance: Int
	Constraints
		this.lead1.node.voltage - this.lead2.node.voltage = this.resistance * this.lead2.current
class Battery: TwoLeadedThing
	Attributes
		voltage: Int
	Constraints
		this.lead1.node.voltage - this.lead2.node.voltage = this.voltage
	' andProblem: '
var v1: Battery
var r1, r2: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b: Lead
var n1, n2, n3: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0; yourself.
	n2 := Node new.
	n3 := Node new.
	v1a := Lead new node: n2; yourself.
	v1b := Lead new node: n1; yourself.
	r1a := Lead new node: n3; yourself.
	r1b := Lead new node: n1; yourself.
	r2a := Lead new node: n2; yourself.
	r2b := Lead new node: n3; yourself.
	n1 leads: {r1b. v1b}.
	n2 leads: {r2a. v1a}.
	n3 leads: {r1a. r2b}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 15; yourself.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 10; yourself.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 5; yourself.
	env at: #n1 put: n1.
	env at: #n2 put: n2.
	env at: #n3 put: n3.
	env at: #v1a put: v1a.
	env at: #v1b put: v1b.
	env at: #r1a put: r1a.
	env at: #r1b put: r1b.
	env at: #r2a put: r2a.
	env at: #r2b put: r2b.
	env at: #v1 put: v1.
	env at: #r1 put: r1.
	env at: #r2 put: r2.
	p1 := env hostProgram: '
	true
	' in: #Kodkod modifiableObjects: {n2. n3. v1a. v1b. r1a. r1b. r2a. r2b} modifiableAttributes: #((Node voltage) (Lead current)).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current."
	self assert: 15 equals: n2 voltage.
	self assert: 10 equals: n3 voltage.
	self assert: 1 equals: v1 lead1 current.
	self assert: -1 equals: v1 lead2 current.
	self assert: -1 equals: r1 lead1 current.
	self assert: 1 equals: r1 lead2 current.
	self assert: -1 equals: r2 lead1 current.
	self assert: 1 equals: r2 lead2 current.
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 10/4/2012 16:39'!
testCount1

	"
	CoopLangKodkodTests new testCount1
	"
	
	| env p1 r p q Person Room |
	
	env := CoopLangs newModel: '
class Person: Thing
	Attributes
		age: Int
	Constraints
		this.age > 0
class Room: Thing
	Attributes
		people: Set (Person)
	' andProblem: '
var p, q: Person
var r: Room
	'.
	Person := env getClass: #Person.
	Room := env getClass: #Room.
	p := Person new var: #p.
	q := Person new var: #q.
	r := Room new var: #r.
	p1 := env hostProgram: '
	#(r.people) = 2
	sum(r.people.age) = 9
	' in: #Kodkod modifiableObjects: {r. p. q} modifiableAttributes: #((Room people) (Person age)).
	p1 runAndCommit.
	"Transcript show: r people.
	Transcript show: p age , ' ' , q age."
	self assert: 2 equals: r people size.
	self assert: 9 equals: (r people collect: [:z | z age ]) sum.! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 6/7/2012 12:06'!
testImplies2

	" 
	CoopLangKodkodTests new testImplies2
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: false.
	p1 := env hostProgram: '
	x <=> y
	' in: #Kodkod modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: false equals: (env at: #y).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 6/7/2012 12:06'!
testImplies3

	" 
	CoopLangKodkodTests new testImplies3
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: true.
	p1 := env hostProgram: '
	x => !!y
	' in: #Kodkod modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: false equals: (env at: #y).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:18'!
testInvariants1

	"
	CoopLangKodkodTests new testInvariants1
	"
	
	|  env p1 APoint p q |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint ,
'class APoint : Point
	Constraints
		(this.x = 1 && this.y = 2) || this.x < 0
		this.y > 0
	' andProblem: '
var p, q : APoint
	'.
	APoint := env getClass: #APoint.
	p := APoint new x: 1; y: 2; yourself.
	q := APoint new x: 3; y: 4; yourself.
	env at: #p put: p.
	env at: #q put: q.
	p1 := env hostProgram: '
	p.x + p.y = q.x + q.y
	q.x !!= p.x
	' in: #Kodkod modifiableObjects: {q} modifiableAttributes: #((APoint x) (APoint y)).
	p1 runAndCommit.
	"Transcript show: ('' , p , ' ' , q)."
	self assert: true equals: (q x < 0).
	self assert: (p y + p x) equals: (q y + q x).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:18'!
testInvariants2

	"
	CoopLangKodkodTests new testInvariants2
	"
	
	|  env p1 p q w |
	env := CoopLangs newModel: '
class Line : Thing
	Attributes
		p1, p2: Point
class Point : Thing
	Attributes
		x, y : Int
	Constraints
		this.x >= 0
		this.y >= 0
	' andProblem: '
var p, q : Point
var w: Line
	'.
	p := (env getClass: #Point) new x: 0; y: 0; yourself.
	q := (env getClass: #Point) new x: 0; y: 0; yourself.
	w := (env getClass: #Line) new p1: p; p2: q; yourself.
	env at: #p put: p.
	env at: #q put: q.
	env at: #w put: w.
	p1 := env hostProgram: '
	p !!= q
	w.p1.x = w.p2.y
	w.p1.y = w.p2.x
	w.p1.x !!= w.p1.y
	' in: #Kodkod modifiableObjects: {p. q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: w"
	self assert: true equals: (w p1 x = w p2 y).
	self assert: true equals: (w p1 y = w p2 x).
	self assert: false equals: (w p1 x = w p1 y).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 6/7/2012 12:08'!
testNonlinear1
	
	"
	CoopLangKodkodTests new testNonlinear1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, r : Int
	'.
	env at: #r put: 10.
	env at: #x put: -8.
	p1 := env hostProgram: '
	(x >= -r && x <= r) => x ^ 2 + y ^ 2 = r ^ 2
	y >= -r
	y < r 
	' in: #Kodkod modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: true equals: 
		((env at: #r) squared - (((env at: #x) squared + (env at: #y) squared)) <= 0.001)
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:18'!
testObject1

	"
	CoopLangKodkodTests new testObject1
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint , 
'class Point : Thing
	Attributes
		x, y : Int
	' andProblem: '
var z : Int
var p : Point
	'.
	p := (env getClass: #Point) new x: 0; y: 0; yourself.
	env at: #z put: 5.
	env at: #p put: p.
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x < z
	p.y < z
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Kodkod modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: (env at: #z) squared equals: (p x squared)  + (p y squared).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:19'!
testObject2

	"
	CoopLangKodkodTests new testObject2
	"
	
	|  env p1 Point p q |
	env := CoopLangs newModel:  CoopLangsLibrary IntPoint andProblem: '
var p, q : Point
	'.
	Point := env getClass: #Point.
	p := Point new x: 1; y: 2; yourself.
	q := Point new x: 3; y: 4; yourself.
	env at: #p put: p.
	env at: #q put: q.
	p1 := env hostProgram: '
	p.x = q.y
	p.y = q.x
	' in: #Kodkod modifiableObjects: {q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: p.
	Transcript show: q."
	self assert: 0 equals: ((p x) - (q y)).
	self assert: 0 equals: ((p y) - (q x)).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 6/7/2012 12:10'!
testOld1
	
	"
	CoopLangKodkodTests new testOld1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	x = old(x) + 1
	' in: #Kodkod readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: (env at: #x) equals: 11.
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:19'!
testOld2
	
	"
	CoopLangKodkodTests new testOld2
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var p: Point
	'.
	p := (env getClass: #Point) new x: 10; y: 20; yourself.
	env at: #p put: p.
	p1 := env hostProgram: '
p.x = old(p.x) + 1
p.y = old(p.y) + 2
	' in: #Kodkod modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: (env at: #p) x equals: 11.
	self assert: (env at: #p) y equals: 22.
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:19'!
testOld3
	
	"
	CoopLangKodkodTests new testOld3
	"
	
	|  env Point Line p1 |
	env := CoopLangs newModel:  CoopLangsLibrary IntPoint , 
'class Line : Thing
	Attributes
		start, end : Point
	' andProblem: '
var p, q : Point
var w : Line
	'.
	Point := env getClass: #Point.
	Line := env getClass: #Line.
	env at: #p put: (Point new x: 1; y: 2; yourself).
	env at: #q put: (Point new x: 3; y: 4; yourself).
	env at: #w put: (Line new start: (env at: #p); end: (env at: #q); yourself).
	p1 := env hostProgram: '
w.start.x = old(w.end.x) 
w.start.y = old(w.end.y)
w.end.x = old(w.start.x) 
w.end.y = old(w.start.y)
p = old(p)
q = old(q)
	' in: #Kodkod modifiableObjects: {env at: #p. env at: #q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: (env at: #p).
	Transcript show: (env at: #q)."
	self assert: 3 equals: (env at: #p) x.
	self assert: 4 equals: (env at: #p) y.
	self assert: 1 equals: (env at: #q) x.
	self assert: 2 equals: (env at: #q) y.
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'AHB 8/14/2012 13:51'!
testQuantifier1

	"
	CoopLangKodkodTests new testQuantifier1
	"
	
	|  env p1 x |
	env := CoopLangs newProblem: '
	var x : Int
	'.
	p1 := env hostProgram: '
	x > 11
	x < 20
	all z : Int | ((z > 1 && z < x) => x % z !!= 0)
	' in: #Kodkod readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x)".
	x := env at: #x.
	self assert: (x=13 or: [x=17 or: [x=19]]).
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:20'!
testSet1

	"
	CoopLangKodkodTests new testSet1
	"
	
	| env p1 Room Person r |
	env := CoopLangs newModel: '
class Person: Thing
	Attributes
		age: Int
	Constraints
		this.age > 0
class Room: Thing
	Attributes
		people: Set (Person)
	' andProblem: '
var p1, p2: Person
var r: Room
	'.
	Person := env getClass: #Person.
	Room := env getClass: #Room.
	(1 to: 2) do: [:i | env at: (#p , i) asSymbol put: Person new ].
	r := Room new.
	env at: #r put: r.
	p1 := env hostProgram: '
	#(r.people) = 2
	sum(r.people.age) = 100
	' in: #Kodkod modifiableObjects: {r. env at: #p1. env at: #p2} modifiableAttributes: #((Room people) (Person age)) options: #(intBitWidth 7).
	p1 runAndCommit.
	"Transcript show: r people."
	self assert: 2 equals: r people size.
	self assert: true equals: 
		[ | s | 
		s := (r people collect: [:z | z age ]) sum. 
		s = 20 or: [ s > 31 ] ] value. ! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:20'!
testSubclass1

	"
	CoopLangKodkodTests new testSubclass1
	"
	
	|  env p1 p |
	env := CoopLangs newModel: '
class Point : Thing
	Attributes
		x, y : Int
	Constraints
		this.x > 0
		this.y > 0
class Point3D : Point
	Attributes
		z : Int
	Constraints
		this.z > 0
	' andProblem: '
var p : Point3D
	'.
	p := (env getClass: #Point3D) new x: 1; y: 2; z: 3; yourself.
	env at: #p put: p.
	p1 := env hostProgram: '
	p.x + p.y = 10
	p.z = p.y - p.x
	' in: #Kodkod modifiableObjects: {p} modifiableAttributes: #((Point3D x) (Point3D y) (Point3D z)).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: 10 equals: (p y + p x).
	self assert: 0 equals: (p y - p x - p z).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:20'!
testSubclass2

	"
	CoopLangKodkodTests new testSubclass2
	"
	
	|  env p1 b f |
	env := CoopLangs newModel: '
class Foo : Thing
	Attributes
		x, y : Int
	Constraints
		this.x < 0
		this.y > 0
class Bar : Foo
	Attributes
		z : Int
	Constraints
		this.z < 0
	' andProblem: '
var b : Bar
var f : Foo
	'.
	b := (env getClass: #Bar) new x: 1; y: 2; z: 3; yourself.
	f := (env getClass: #Foo) new x: 1; y: 2; yourself.
	env at: #b put: b.
	env at: #f put: f.
	p1 := env hostProgram: '
	b.y < 3
	f.x + f.y = -5
	' in: #Kodkod modifiableObjects: {b. f} modifiableAttributes: #((Bar x) (Bar y) (Bar z) (Foo x)).
	p1 runAndCommit.
	"Transcript show: b.
	Transcript show: f."
	self assert: true equals: (b y < 3).
	self assert: true equals: (b x < 0).
	self assert: true equals: (b y > 0).
	self assert: true equals: (b z < 0).
	self assert: true equals: (f x < 0).
	self assert: true equals: (f y > 0).
	self assert: -5 equals: (f x + f y).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:21'!
testSum1

	"
	CoopLangKodkodTests new testSum1
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		count, sum: Int
	Constraints
		this.count = #(this.things)
		this.sum = sum(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {}; yourself.
	env at: #b put: b.
	p1 := env hostProgram: '
	#(b.things) = 3
	' in: #Kodkod modifiableObjects: {b} modifiableAttributes: #((Bag things) (Bag count) (Bag sum)).
	p1 runAndCommit.
	"Transcript show: b things.
	Transcript show: b count.
	Transcript show: b sum."
	self assert: 3 equals: b things size.
	self assert: 3 equals: b count.
	self assert: true equals: ((b things sum = b sum) or: [b things sum < 0 or: [b things sum > 31]]).! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:21'!
testUnsat1

	"
	CoopLangKodkodTests new testUnsat1
	"
	
	|  env p1 res |
	env := CoopLangs newModel:  CoopLangsLibrary IntPoint andProblem: '
var p, q : Point
	'.
	env at: #p put: ((env getClass: #Point) new x: 1; y: 2; yourself).
	env at: #q put: ((env getClass: #Point) new x: 3; y: 4; yourself).
	p1 := env hostProgram: '
	p.x = q.y
	p.y = q.x
	' in: #Kodkod modifiableObjects: #() modifiableAttributes: #((Point x) (Point y)).
	res := p1 runAndCommit.
	"Transcript show: res."
	self assert: false equals: res.
! !

!CoopLangKodkodTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:21'!
testUnsat2

	"
	CoopLangKodkodTests new testUnsat2
	"
	
	|  env p1 res |
	env := CoopLangs newModel:  CoopLangsLibrary IntPoint andProblem: '
var z : Int
var p : Point
	'.
	env at: #z put: 5.
	env at: #p put: ((env getClass: #Point) new x: 0; y: 0; yourself).
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Kodkod modifiableObjects: {env at: #p} modifiableAttributes: #((Point y)).
	res := p1 runAndCommit.
	"Transcript show: res."
	self assert: false equals: res.
! !

TestCase subclass: #CoopLangOCassowaryTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 11:57'!
testAddition1

	"
	CoopLangOCassowaryTests new testAddition1
	"

	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
'.
	p := (env getClass: #Point) new x: 10; var: #p.
	p1 := env hostProgram: '
	p.y = p.x + 5
	' in: #OCassowary modifiableObjects: {p} modifiableAttributes: #((Point y)).
	p1 runAndCommit.
	self assert: 15 equals: p y.
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 11:57'!
testAddition2

	"
	CoopLangOCassowaryTests new testAddition2
	"

	|  env p1 p z |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
var z : Real
	'.
	z := 154.22.
	p := (env getClass: #Point) new var: #p.
	env at: #z put: z.
	p1 := env hostProgram: '
	p.x + p.y = z
	p.x >= 1.0
	p.y >= 1.0
	' in: #OCassowary modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	self assert: z equals: p x + p y.
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 11:58'!
testAlias1

	"
	CoopLangOCassowaryTests new testAlias1
	"

	|  env p1 p q z |
	env := CoopLangs newModel:CoopLangsLibrary Point andProblem: '
var p, q : Point
var z : Real
	'.
	z := 154.22.
	p := (env getClass: #Point) new var: #p.
	q := p.
	env at: #q put: q.
	env at: #z put: z.
	p1 := env hostProgram: '
	p.x + p.y = z
	q.x + q.y = z
	p.x >= 1.0
	p.y >= 1.0
	' in: #OCassowary modifiableObjects: {p. q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	self assert: z equals: p x + p y.
	self assert: z equals: q x + q y.
	self assert: p equals: q.
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 11:58'!
testCircuit1

	"
	CoopLangOCassowaryTests new testCircuit1
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 r1a r1b r2a r2b v1a v1b v1 r1 r2 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2: Resistor
var n1, n2, n3: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	v1a := Lead new node: n2; yourself.
	v1b := Lead new node: n1; yourself.
	r1a := Lead new node: n3; yourself.
	r1b := Lead new node: n1; yourself.
	r2a := Lead new node: n2; yourself.
	r2b := Lead new node: n3; yourself.
	n1 leads: {r1b. v1b}.
	n2 leads: {r2a. v1a}.
	n3 leads: {r1a. r2b}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 15.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 10.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 5.0; var: #r2.
	p1 := env hostProgram: '
	n1.voltage = 0.0
	' in: #OCassowary modifiableObjects: {n2. n3. v1a. v1b. r1a. r1b. r2a. r2b} modifiableAttributes: #((Node voltage) (Lead current)).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current."
	self assert: 15 equals: n2 voltage.
	self assert: 10 equals: n3 voltage.
	self assert: 1 equals: v1 lead1 current rounded.
	self assert: -1 equals: v1 lead2 current rounded.
	self assert: -1 equals: r1 lead1 current rounded.
	self assert: 1 equals: r1 lead2 current rounded.
	self assert: -1 equals: r2 lead1 current rounded.
	self assert: 1 equals: r2 lead2 current rounded.
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 11:59'!
testCircuit2

	"
	CoopLangOCassowaryTests new testCircuit2
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 n4 
	r1a r1b r2a r2b r3a r3b r4a r4b v1a v1b v1 r1 r2 r3 r4 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2, r3, r4: Resistor
var n1, n2, n3, n4: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	n4 := Node new.
	v1a := Lead new node: n2; yourself.
	v1b := Lead new node: n1; yourself.
	r1a := Lead new node: n2; yourself.
	r1b := Lead new node: n4; yourself.
	r2a := Lead new node: n2; yourself.
	r2b := Lead new node: n3; yourself.
	r3a := Lead new node: n4; yourself.
	r3b := Lead new node: n1; yourself.
	r4a := Lead new node: n3; yourself.
	r4b := Lead new node: n1; yourself.
	n1 leads: {r3b. r4b. v1b}.
	n2 leads: {r1a. r2a. v1a}.
	n3 leads: {r2b. r4a}.
	n4 leads: {r1b. r3a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 1.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 1.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 1.0;  var: #r2.
	r3 := Resistor new lead1: r3a; lead2: r3b; resistance: 1.0; var: #r3.
	r4 := Resistor new lead1: r4a; lead2: r4b; resistance: 1.0; var: #r4.
	p1 := env hostProgram: '
	true
	' in: #OCassowary modifiableObjects: {n2. n3. n4. v1a. v1b. r1a. r1b. r2a. r2b. r3a. r3b. r4a. r4b} modifiableAttributes: #((Node voltage) (Lead current)).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: n4 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current.
	Transcript show: r3 lead1 current.
	Transcript show: r3 lead2 current.
	Transcript show: r4 lead1 current.
	Transcript show: r4 lead2 current."
	self assert: (n2 voltage closeTo: 1.0).
	self assert: (n3 voltage closeTo: 0.5).
	self assert: ((n4 voltage - 0.5) closeTo: 0.0).
	self assert: (v1 lead1 current closeTo: 1.0).
	self assert: (v1 lead2 current closeTo: -1.0).
	self assert: (r1 lead1 current closeTo: -0.5).
	self assert: (r1 lead2 current closeTo: 0.5).
	self assert: (r2 lead1 current closeTo: -0.5).
	self assert: (r2 lead2 current closeTo: 0.5).
	self assert: (r3 lead1 current closeTo: -0.5).
	self assert: (r3 lead2 current closeTo: 0.5).
	self assert: (r4 lead1 current closeTo: -0.5).
	self assert: (r4 lead2 current closeTo: 0.5).


! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 12:00'!
testCircuit3

	"
	CoopLangOCassowaryTests new testCircuit3
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 n4 
	r1a r1b r2a r2b r3a r3b r4a r4b v1a v1b v1 r1 r2 r3 r4 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2, r3, r4: Resistor
var n1, n2, n3, n4: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	n4 := Node new.
	v1a := Lead new node: n2; yourself.
	v1b := Lead new node: n1; yourself.
	r1a := Lead new node: n2; yourself.
	r1b := Lead new node: n4; yourself.
	r2a := Lead new node: n2; yourself.
	r2b := Lead new node: n3; yourself.
	r3a := Lead new node: n4; yourself.
	r3b := Lead new node: n1; yourself.
	r4a := Lead new node: n3; yourself.
	r4b := Lead new node: n1; yourself.
	n1 leads: {r3b. r4b. v1b}.
	n2 leads: {r1a. r2a. v1a}.
	n3 leads: {r2b. r4a}.
	n4 leads: {r1b. r3a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 1.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 1.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 1.0; var: #r2.
	r3 := Resistor new lead1: r3a; lead2: r3b; resistance: 1.0; var: #r3.
	r4 := Resistor new lead1: r4a; lead2: r4b; resistance: 1.0; var: #r4.
	p1 := env hostProgram: '
	true
	' in: #OCassowary modifiableObjects: {n2. n3. n4. v1a. v1b. r1a. r1b. r2a. r2b. r3a. r3b. r4a. r4b} modifiableAttributes: #((Node voltage) (Lead current)).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: n4 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current.
	Transcript show: r3 lead1 current.
	Transcript show: r3 lead2 current.
	Transcript show: r4 lead1 current.
	Transcript show: r4 lead2 current."
	self assert: (n2 voltage closeTo: 1.0).
	self assert: (n3 voltage closeTo: 0.5).
	self assert: ((n4 voltage - 0.5) closeTo: 0.0).
	self assert: (v1 lead1 current closeTo: 1.0).
	self assert: (v1 lead2 current closeTo: -1.0).
	self assert: (r1 lead1 current closeTo: -0.5).
	self assert: (r1 lead2 current closeTo: 0.5).
	self assert: (r2 lead1 current closeTo: -0.5).
	self assert: (r2 lead2 current closeTo: 0.5).
	self assert: (r3 lead1 current closeTo: -0.5).
	self assert: (r3 lead2 current closeTo: 0.5).
	self assert: (r4 lead1 current closeTo: -0.5).
	self assert: (r4 lead2 current closeTo: 0.5).


! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 12:00'!
testInvariants1
	
	"
	CoopLangOCassowaryTests new testInvariants1
	"
	
	|  env p1 p q z APoint |
	env := CoopLangs newModel: (CoopLangsLibrary Point ,
'class APoint : Point
	Constraints
		this.x <= 75.9
		this.y <= 13.4
	') andProblem: '
var p, q : APoint
var z : Real
	'.
	APoint := env getClass: #APoint.
	z := 30.5.
	p := APoint new var: #p.
	q := APoint new var: #q.
	env at: #z put: z.
	p1 := env hostProgram: '
	p.x + p.y >= z + 1
	q.x + q.y <= z - 1
	' in: #OCassowary modifiableObjects: {p. q} modifiableAttributes: #((APoint x) (APoint y)).
	p1 runAndCommit.
	self assert: true equals: p x + p y >= (z + 1).
	self assert: true equals: q x + q y <= (z - 1).
	self assert: true equals: p x <= 75.9. 
	self assert: true equals: p y <= 13.4. 
	self assert: true equals: q x <= 75.9. 
	self assert: true equals: q y <= 13.4. 
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 9/18/2012 19:29'!
testList1

	"
	CoopLangOCassowaryTests new testList1
	"
	
	| env p1 Bag Item b i1 i2 |
	env := CoopLangs newModel: '
class Item: Thing
	Attributes
		weight: Real
	Constraints
		this.weight >= 0
class Bag: Thing
	Attributes
		items: List (Item)
		count: Real
		weight: Real
	Constraints
		this.count = #(this.items)
		this.weight = sum(this.items.weight)
	' andProblem: '
var i1, i2: Item
var b: Bag
	'.
	Item := env getClass: #Item.
	Bag := env getClass: #Bag.
	i1 := Item new weight: 2.4; var: #i1.
	i2 := Item new weight: 5.1; var: #i2..
	b := Bag new items: {i1. i2}; var: #b.
	p1 := env hostProgram: '
	b.count >= 0
	' in: #OCassowary modifiableObjects: {b} modifiableAttributes: #((Bag count) (Bag weight)).
	p1 runAndCommit.
	self assert: 2 equals: b count.
	self assert: 7.5 equals: (b items inject: 0 into: [:s :x | s := s + x weight. s]).! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 9/22/2012 14:29'!
testList2

	"
	CoopLangOCassowaryTests new testList2
	"
	
	| env p1 Bag b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		items: List (Real)
	Constraints
		sum(this.items) = #(this.items) + 1.5
	' andProblem: '
var b: Bag
	'.
	Bag := env getClass: #Bag.
	b := Bag new items: {1.1. 0.3}; var: #b.
	p1 := env hostProgram: '
	true
	' in: #OCassowary modifiableObjects: {b} modifiableAttributes: #((Bag items)).
	p1 runAndCommit.
	"Transcript show: b items."
	self assert: true equals: (b items first + b items second = 3.5).! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 6/7/2012 12:32'!
testOld1
	
	"
	CoopLangOCassowaryTests new testOld1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Real
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	x = old(x) + 1
	' in: #OCassowary readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: (env at: #x) equals: 11.
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/26/2012 02:25'!
testOld2
	
	"
	CoopLangOCassowaryTests new testOld2
	"
	
	|  env p1 |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p: Point
	'.
	env at: #p put: ((env getClass: #Point) new x: 10; y: 20; yourself).
	p1 := env hostProgram: '
p.x = old(p.x) + 1
p.y = old(p.y) + 2
	' in: #OCassowary modifiableObjects: {env at: #p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: (env at: #p) x equals: 11.
	self assert: (env at: #p) y equals: 22.
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 8/28/2012 12:01'!
testSet1

	"
	CoopLangOCassowaryTests new testSet1
	"
	
	| env p1 Bag Item b i1 i2 |
	env := CoopLangs newModel: '
class Item: Thing
	Attributes
		weight: Real
	Constraints
		this.weight >= 0
class Bag: Thing
	Attributes
		items: Set (Item)
		count: Real
		weight: Real
	Constraints
		this.count = #(this.items)
		this.weight = sum(this.items.weight)
	' andProblem: '
var i1, i2: Item
var b: Bag
	'.
	Item := env getClass: #Item.
	Bag := env getClass: #Bag.
	i1 := Item new weight: 2.4; var: #i1.
	i2 := Item new weight: 5.1; var: #i2..
	b := Bag new items: {i1. i2}; var: #b.
	p1 := env hostProgram: '
	b.count >= 0
	' in: #OCassowary modifiableObjects: {b} modifiableAttributes: #((Bag count) (Bag weight)).
	p1 runAndCommit.
	self assert: 2 equals: b count.
	self assert: 7.5 equals: (b items inject: 0 into: [:s :x | s := s + x weight. s]).! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths1

	"
	CoopLangOCassowaryTests new testStrengths1
	"

	|  env p1 p z |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
var z : Real
	'.
	z := 154.22.
	p := (env getClass: #Point) new var: #p.
	env at: #z put: z.
	p1 := env hostProgram: '
	p.x + p.y = z
	[priority: weak] p.x + p.y = z+10
	p.x >= 1.0
	p.y >= 1.0
	' in: #OCassowary modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	self assert: z equals: p x + p y.
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths2

	"
	CoopLangOCassowaryTests new testStrengths2
	"

	|  env p1 p z |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
var z : Real
	'.
	z := 154.22.
	p := (env getClass: #Point) new var: #p.
	env at: #z put: z.
	p1 := env hostProgram: '
	[priority: weak] p.x = z
	[priority: strong] p.y = z
	' in: #OCassowary modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	self assert: z equals: p x.
	self assert: z equals: p y.
	
! !

!CoopLangOCassowaryTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:40'!
testStrengths3

	"
	CoopLangOCassowaryTests new testStrengths3
	"

	|  env p1 p z |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
var z : Real
	'.
	z := 154.22.
	p := (env getClass: #Point) new x: 0; y: 0; var: #p.
	env at: #z put: z.
	p1 := env hostProgram: '
	[priority: weak] p.y = z
	[priority: strong] p.y = z + 1
	' in: #OCassowary modifiableObjects: {p} modifiableAttributes: #((Point y)).
	p1 runAndCommit.
	self assert: (z + 1) equals: p y.
	
! !

TestCase subclass: #CoopLangOMetaTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangOMetaTests methodsFor: 'as yet unclassified' stamp: 'tk 11/8/2012 08:25'!
test1
	
	"
	(CoopLangOMetaTests new) setTestSelector: #test1; test1
	"
	
	|  env  p1 res |
	env := CoopLangs newProblem: ''.
	p1 := env hostProgram: '
	[ometa] start = one:a four:b -> { a + " " +  b }
	[ometa] one = two
	[ometa] two = "tres" | "three"
	[ometa] four = "four" -> { "five" }
	' in: #OMeta.
	res := p1 apply: 'three four'.
	self assert: 'three five' equals: res.
! !

!CoopLangOMetaTests methodsFor: 'as yet unclassified' stamp: 'tk 11/8/2012 08:25'!
test2
	
	"
	(CoopLangOMetaTests new) setTestSelector: #test2; test2
	"
	
	|  env g1 p1 |
	env := CoopLangs newProblem: '
	var x, y : Int
	'.
	env at: #x put: 10.
	g1 := env hostProgram: '
	[ometa] start = local:l "is" expr:e -> {l + " = " + e}
	[ometa] local = name
	[ometa] expr = expr:a op:b lit:c -> {a + " " + b + " " + c} | local
	[ometa] op = "plus" -> {"+"}
	[ometa] lit = "one" -> {"1"} | "two" -> {"2"}
	' in: #OMeta.
	p1 := env hostProgram: (g1 apply: 'y is x plus two') in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: 12 equals: (env at: #y).
! !

TestCase subclass: #CoopLangSimpleSearchTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangSimpleSearchTests methodsFor: 'as yet unclassified' stamp: 'tk 8/27/2012 10:43'!
testBoard
	"Make a piece and place it.  Make sure the right squares ave covered.  Remove it.
	(CoopLangSimpleSearchTests new setTestSelector: #testBoard) runCase
	"
	
	| board piece list |
	board := (Board new) extent: 2@6.
	piece := (ElPiece new).
	piece set: #dir range: (1 to: 4).
	piece set: #position range: (1@1 corner: board extent).
	piece initState.
	self assert: (board evaluate: {piece}) = 1.
	list := board board collect: [:ee | ee notNil].
	self assert: list asArray = #(true true true false false false false false false false false false).
	board remove: piece.
	list := board board collect: [:ee | ee notNil].
	self assert: list asArray = #(false false false false false false false false false false false false).
! !

!CoopLangSimpleSearchTests methodsFor: 'as yet unclassified' stamp: 'tk 9/20/2012 16:41'!
testBoardOff
	"Make a piece and place it.  Make sure the right squares are covered.  Remove it.
	(CoopLangSimpleSearchTests new setTestSelector: #testBoardOff) runCase
	"
	
	| board piece list |
	board := (Board new) extent: 2@6.
	piece := (ElPiece new).
	piece set: #dir range: (1 to: 4).
	piece set: #position range: (1@1 corner: board extent).
	piece initState; advanceState.	"turn it!!"
	self assert: (board evaluate: {piece}) = 0.
	list := board board collect: [:ee | ee notNil].
	self assert: list asArray = #(false false false false false false false false false false false false).
! !

!CoopLangSimpleSearchTests methodsFor: 'as yet unclassified' stamp: 'tk 8/27/2012 10:44'!
testPieceAdvance
	"Make a piece and place it.  Make sure the right squares ave covered.  Remove it.
	(CoopLangSimpleSearchTests new setTestSelector: #testPieceAdvance) runCase
	"
	
	| piece  |
	piece := (ElPiece new).
	piece set: #dir range: (1 to: 4).
	piece set: #position range: (1@1 corner: 2@6).

	piece initState.  self assert: piece dir = 1.   self assert: piece position = (1@1).
	47 timesRepeat: [self assert: piece advanceState notNil].
	self assert: piece dir = 4.   self assert: piece position = (2@6).
	self assert: piece advanceState == nil.
! !

TestCase subclass: #CoopLangZ3Tests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangZ3Tests commentStamp: 'AHB 8/14/2012 12:08' prior: 0!
A CoopLangZ3Tests is a test suite for CoopLangZ3.  See the class comment for CoopLangZ3 for directions for installing the Z3 solver.


	To run Z3 examples:
	1) Download Z3 SMT solver from:
		http://research.microsoft.com/en-us/um/redmond/projects/z3/download.html
		(there is one link for mac there)
	2) Create a symbolic link called /usr/local/bin/z3 from the tool's binary location $tool/bin/z3   

!

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:20'!
TODOtestCircuitD1

	"
	CoopLangZ3Tests new TODOtestCircuitD1
	"
	
	|  env p1 Node Lead Battery Diode Resistor n1 n2 n3 r1a r1b v1a v1b v1 r1 d1 d1a d1b |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var e : Real
var v1: Battery
var r1: Resistor
var d1: Diode
var v1a, v1b, r1a, r1b, d1a, d1b: Lead
var n1, n2, n3: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Diode := env getClass: #Diode.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	v1a := Lead new node: n1; var: #v1a.
	v1b := Lead new node: n2; var: #v1b.
	r1a := Lead new node: n3; var: #r1a.
	r1b := Lead new node: n1; var: #r1b.
	d1a := Lead new node: n2; var: #d1a.
	d1b := Lead new node: n3; var: #d1b.
	n1 leads: {r1b. v1a}.
	n2 leads: {d1a. v1b}.
	n3 leads: {d1b. r1a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 15.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 10.0; var: #r1.
	d1 := Diode new lead1: d1a; lead2: d1b; isaturation: 1.0; vthreshold: 1.0; var: #d1.
	env at: #e put: 2.0. "2.718."
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {n2. n3. v1a. v1b. d1a. d1b. r1a. r1b} modifiableAttributes: #((Node voltage) (Lead current)) options: #(flatten true setLogic AUFNIRA).
	p1 runAndCommit.
	Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: 'd1 lead1 current ' , d1 lead1 current.
	Transcript show: d1 lead2 current.
	Transcript show: d1 lead1 node voltage.
	Transcript show: d1 lead2 node voltage.
	Transcript show: (d1 lead1 node voltage - d1 lead2 node voltage).
	Transcript show: d1 isaturation.
	"self assert: 15 equals: n2 voltage.
	self assert: 10 equals: n3 voltage.
	self assert: 1 equals: v1 lead1 current.
	self assert: -1 equals: v1 lead2 current.
	self assert: -1 equals: r1 lead1 current.
	self assert: 1 equals: r1 lead2 current.
	self assert: -1 equals: r2 lead1 current.
	self assert: 1 equals: r2 lead2 current."
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'AHB 8/14/2012 12:09'!
test1

	"See the class comment for CoopLangZ3 for directions for installing the Z3 solver"
	
	"
	CoopLangZ3Tests new test1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y ^ 2 <= x
	(y + 1) ^ 2 > x
	y >= 0
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: (env at: #y) equals: 3.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/8/2012 10:55'!
testAbs1

	"
	CoopLangZ3Tests new testAbs1
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
var x, y: Int
	'.
	env at: #x put: -14.
	p1 := env hostProgram: '
	y = abs(x)
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	self assert: (env at: #x) abs equals: (env at: #y).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/8/2012 11:06'!
testAbs2

	"
	CoopLangZ3Tests new testAbs2
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
var x, y, z: Real
	'.
	env at: #x put: -14.0.
	env at: #y put: 23.0.
	p1 := env hostProgram: '
	abs(z) = abs(x + y) + abs((x - y))
	' in: #Z3 modifiableVars: #(z).
	p1 runAndCommit.
	self assert: (env at: #z) abs equals: (((env at: #x) + (env at: #y)) abs + ((env at: #x) - (env at: #y)) abs).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:19'!
testCircuit1

	"
	CoopLangZ3Tests new testCircuit1
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 r1a r1b r2a r2b v1a v1b v1 r1 r2 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b: Lead
var n1, n2, n3: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
		n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	v1a := Lead new node: n2; var: #v1a.
	v1b := Lead new node: n1; var: #v1b.
	r1a := Lead new node: n3; var: #r1a.
	r1b := Lead new node: n1; var: #r1b.
	r2a := Lead new node: n2; var: #r2a.
	r2b := Lead new node: n3; var: #r2b.
	n1 leads: {r1b. v1b}.
	n2 leads: {r2a. v1a}.
	n3 leads: {r1a. r2b}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 15.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 10.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 5.0; var: #r2.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {n2. n3. v1a. v1b. r1a. r1b. r2a. r2b} modifiableAttributes: #((Node voltage) (Lead current)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current."
	self assert: 0 equals: n1 voltage.
	self assert: 15 equals: n2 voltage.
	self assert: 10 equals: n3 voltage.
	self assert: 1 equals: v1 lead1 current.
	self assert: -1 equals: v1 lead2 current.
	self assert: -1 equals: r1 lead1 current.
	self assert: 1 equals: r1 lead2 current.
	self assert: -1 equals: r2 lead1 current.
	self assert: 1 equals: r2 lead2 current.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:19'!
testCircuit1F

	"
	CoopLangZ3Tests new testCircuit1F
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 r1a r1b r2a r2b v1a v1b v1 r1 r2 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b: Lead
var n1, n2, n3: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	v1a := Lead new node: n2; var: #v1a.
	v1b := Lead new node: n1; var: #v1b.
	r1a := Lead new node: n3; var: #r1a.
	r1b := Lead new node: n1; var: #r1b.
	r2a := Lead new node: n2; var: #r2a.
	r2b := Lead new node: n3; var: #r2b.
	n1 leads: {r1b. v1b}.
	n2 leads: {r2a. v1a}.
	n3 leads: {r1a. r2b}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 15.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 10.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 5.0; var: #r2.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {n2. n3. v1a. v1b. r1a. r1b. r2a. r2b} modifiableAttributes: #((Node voltage) (Lead current)) options: #(flatten true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current."
	self assert: 15 equals: n2 voltage.
	self assert: 10 equals: n3 voltage.
	self assert: 1 equals: v1 lead1 current.
	self assert: -1 equals: v1 lead2 current.
	self assert: -1 equals: r1 lead1 current.
	self assert: 1 equals: r1 lead2 current.
	self assert: -1 equals: r2 lead1 current.
	self assert: 1 equals: r2 lead2 current.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:17'!
testCircuit2

	"
	CoopLangZ3Tests new testCircuit2
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 n4 
	r1a r1b r2a r2b r3a r3b r4a r4b v1a v1b v1 r1 r2 r3 r4 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2, r3, r4: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b, r3a, r3b, r4a, r4b: Lead
var n1, n2, n3, n4: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	n4 := Node new.
	v1a := Lead new node: n2; var: #v1a.
	v1b := Lead new node: n1; var: #v1b.
	r1a := Lead new node: n2; var: #r1a.
	r1b := Lead new node: n4; var: #r1b.
	r2a := Lead new node: n2; var: #r2a.
	r2b := Lead new node: n3; var: #r2b.
	r3a := Lead new node: n4; var: #r3a.
	r3b := Lead new node: n1; var: #r3b.
	r4a := Lead new node: n3; var: #r4a.
	r4b := Lead new node: n1; var: #r4b.
	n1 leads: {r3b. r4b. v1b}.
	n2 leads: {r1a. r2a. v1a}.
	n3 leads: {r2b. r4a}.
	n4 leads: {r1b. r3a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 1.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 1.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 1.0; var: #r2.
	r3 := Resistor new lead1: r3a; lead2: r3b; resistance: 1.0; var: #r3.
	r4 := Resistor new lead1: r4a; lead2: r4b; resistance: 1.0; var: #r4.
	p1 := env hostProgram: '
	true
	' in: #Z3 
	modifiableObjects: {n2. n3. n4. v1a. v1b. r1a. r1b. r2a. r2b. r3a. r3b. r4a. r4b} modifiableAttributes: #((Node voltage) (Lead current))
	"readOnlyObjects: {n1. r1. r2. r3. r4. v1} readOnlyAttributes: #('Node.leads' 'Lead.node' 'Battery.lead1' 'Battery.lead2' 'Resistor.lead1' 'Resistor.lead2' 'Resistor.resistance' 'Battery.voltage')"
	options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: n4 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current.
	Transcript show: r3 lead1 current.
	Transcript show: r3 lead2 current.
	Transcript show: r4 lead1 current.
	Transcript show: r4 lead2 current."
	self assert: 1.0 equals: n2 voltage.
	self assert: 0.5 equals: n3 voltage.
	self assert: 0.5 equals: n4 voltage.
	self assert: 1.0 equals: v1 lead1 current.
	self assert: -1.0 equals: v1 lead2 current.
	self assert: -0.5 equals: r1 lead1 current.
	self assert: 0.5 equals: r1 lead2 current.
	self assert: -0.5 equals: r2 lead1 current.
	self assert: 0.5 equals: r2 lead2 current.
	self assert: -0.5 equals: r3 lead1 current.
	self assert: 0.5 equals: r3 lead2 current.
	self assert: -0.5 equals: r4 lead1 current.
	self assert: 0.5 equals: r4 lead2 current.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:17'!
testCircuit3

	"
	CoopLangZ3Tests new testCircuit3
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 n4 
	r1a r1b r2a r2b r3a r3b r4a r4b v1a v1b v1 r1 r2 r3 r4 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2, r3, r4: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b, r3a, r3b, r4a, r4b: Lead
var n1, n2, n3, n4: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	n4 := Node new.
	v1a := Lead new node: n2; var: #v1a.
	v1b := Lead new node: n1; var: #v1b.
	r1a := Lead new node: n2; var: #r1a.
	r1b := Lead new node: n4; var: #r1b.
	r2a := Lead new node: n2; var: #r2a.
	r2b := Lead new node: n3; var: #r2b.
	r3a := Lead new node: n4; var: #r3a.
	r3b := Lead new node: n1; var: #r3b.
	r4a := Lead new node: n3; var: #r4a.
	r4b := Lead new node: n1; var: #r4b.
	n1 leads: {r3b. r4b. v1b}.
	n2 leads: {r1a. r2a. v1a}.
	n3 leads: {r2b. r4a}.
	n4 leads: {r1b. r3a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 1.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 1.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 1.0; var: #r2.
	r3 := Resistor new lead1: r3a; lead2: r3b; resistance: 1.0; var: #r3.
	r4 := Resistor new lead1: r4a; lead2: r4b; resistance: 1.0; var: #r4.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {n2. n3. n4. v1a. v1b. r1a. r1b. r2a. r2b. r3a. r3b. r4a. r4b} modifiableAttributes: #((Node voltage) (Lead current))
	"readOnlyObjects: {n1. v1. r1. r2. r3. r4} readOnlyAttributes: #('Node.leads' 'Lead.node' 'Resistor.resistance' 'Resistor.lead1' 'Resistor.lead2'  'Wire.lead1' 'Wire.lead2' 'Wire.resistance' 'Battery.voltage' 'Battery.lead1'  'Battery.lead2')" options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: n4 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current.
	Transcript show: r3 lead1 current.
	Transcript show: r3 lead2 current.
	Transcript show: r4 lead1 current.
	Transcript show: r4 lead2 current."
	self assert: 1.0 equals: n2 voltage.
	self assert: 0.5 equals: n3 voltage.
	self assert: 0.5 equals: n4 voltage.
	self assert: 1.0 equals: v1 lead1 current.
	self assert: -1.0 equals: v1 lead2 current.
	self assert: -0.5 equals: r1 lead1 current.
	self assert: 0.5 equals: r1 lead2 current.
	self assert: -0.5 equals: r2 lead1 current.
	self assert: 0.5 equals: r2 lead2 current.
	self assert: -0.5 equals: r3 lead1 current.
	self assert: 0.5 equals: r3 lead2 current.
	self assert: -0.5 equals: r4 lead1 current.
	self assert: 0.5 equals: r4 lead2 current.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:16'!
testCircuit3F

	"
	CoopLangZ3Tests new testCircuit3F
	"
	
	|  env p1 Node Lead Battery Resistor n1 n2 n3 n4 
	r1a r1b r2a r2b r3a r3b r4a r4b v1a v1b v1 r1 r2 r3 r4 |
	env := CoopLangs newModel: CoopLangsLibrary ElectricalComponents andProblem: '
var v1: Battery
var r1, r2, r3, r4: Resistor
var v1a, v1b, r1a, r1b, r2a, r2b, r3a, r3b, r4a, r4b: Lead
var n1, n2, n3, n4: Node
	'.
	Node := env getClass: #Node.
	Lead := env getClass: #Lead.
	Battery := env getClass: #Battery.
	Resistor := env getClass: #Resistor.
	n1 := Node new voltage: 0.0; var: #n1.
	n2 := Node new.
	n3 := Node new.
	n4 := Node new.
	v1a := Lead new node: n2; var: #v1a.
	v1b := Lead new node: n1; var: #v1b.
	r1a := Lead new node: n2; var: #r1a.
	r1b := Lead new node: n4; var: #r1b.
	r2a := Lead new node: n2; var: #r2a.
	r2b := Lead new node: n3; var: #r2b.
	r3a := Lead new node: n4; var: #r3a.
	r3b := Lead new node: n1; var: #r3b.
	r4a := Lead new node: n3; var: #r4a.
	r4b := Lead new node: n1; var: #r4b.
	n1 leads: {r3b. r4b. v1b}.
	n2 leads: {r1a. r2a. v1a}.
	n3 leads: {r2b. r4a}.
	n4 leads: {r1b. r3a}.
	v1 := Battery new lead1: v1a; lead2: v1b; voltage: 1.0; var: #v1.
	r1 := Resistor new lead1: r1a; lead2: r1b; resistance: 1.0; var: #r1.
	r2 := Resistor new lead1: r2a; lead2: r2b; resistance: 1.0; var: #r2.
	r3 := Resistor new lead1: r3a; lead2: r3b; resistance: 1.0; var: #r3.
	r4 := Resistor new lead1: r4a; lead2: r4b; resistance: 1.0; var: #r4.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {n2. n3. n4. v1a. v1b. r1a. r1b. r2a. r2b. r3a. r3b. r4a. r4b} modifiableAttributes: #((Node voltage) (Lead current))
	"readOnlyObjects: {n1. v1. r1. r2. r3. r4} readOnlyAttributes: #('Node.leads' 'Lead.node' 'Resistor.resistance' 'Resistor.lead1' 'Resistor.lead2'  'Battery.voltage' 'Battery.lead1'  'Battery.lead2')"  options: #(flatten true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: n2 voltage.
	Transcript show: n3 voltage.
	Transcript show: n4 voltage.
	Transcript show: r1 lead1 current.
	Transcript show: r1 lead2 current.
	Transcript show: r2 lead1 current.
	Transcript show: r2 lead2 current.
	Transcript show: r3 lead1 current.
	Transcript show: r3 lead2 current.
	Transcript show: r4 lead1 current.
	Transcript show: r4 lead2 current."
	self assert: 1.0 equals: n2 voltage.
	self assert: 0.5 equals: n3 voltage.
	self assert: 0.5 equals: n4 voltage.
	self assert: 1.0 equals: v1 lead1 current.
	self assert: -1.0 equals: v1 lead2 current.
	self assert: -0.5 equals: r1 lead1 current.
	self assert: 0.5 equals: r1 lead2 current.
	self assert: -0.5 equals: r2 lead1 current.
	self assert: 0.5 equals: r2 lead2 current.
	self assert: -0.5 equals: r3 lead1 current.
	self assert: 0.5 equals: r3 lead2 current.
	self assert: -0.5 equals: r4 lead1 current.
	self assert: 0.5 equals: r4 lead2 current.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:14'!
testCount1

	"
	CoopLangZ3Tests new testCount1
	"
	
	| env p1 Room Person r |
	env := CoopLangs newModel: '
class Person: Thing
	Attributes
		age: Int
	Constraints
		this.age > 0
class Room: Thing
	Attributes
		people: Set (Person)
	' andProblem: '
var p1, p2: Person
var r: Room
	'.
	Person := env getClass: #Person.
	Room := env getClass: #Room.
	(1 to: 2) do: [:i | env at: (#p , i) asSymbol put: Person new ].
	r := Room new people: {env at: #p1. env at: #p2}; var: #r.
	p1 := env hostProgram: '
	#(r.people) = 2
	sum(r.people.age) = 100
	' in: #Z3 modifiableObjects: {r. env at: #p1. env at: #p2} modifiableAttributes: #((Person age)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: r people."
	self assert: 2 equals: r people size.
	self assert: true equals: 
		[ | s | 
		s := (r people collect: [:z | z age ]) sum. 
		s = 20 or: [ s > 31 ] ] value. ! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:14'!
testCount2

	"
	CoopLangZ3Tests new testCount2
	"
	
	| env p1 Room Person r |
	env := CoopLangs newModel: '
class Person: Thing
	Attributes
		age: Int
	Constraints
		this.age > 0
class Room: Thing
	Attributes
		people: Set (Person)
	' andProblem: '
var p1, p2: Person
var r: Room
	'.
	Person := env getClass: #Person.
	Room := env getClass: #Room.
	(1 to: 2) do: [:i | env at: (#p , i) asSymbol put: Person new ].
	r := Room new people: {env at: #p1. env at: #p2}; var: #r.
	p1 := env hostProgram: '
	#(r.people) = 2
	sum(r.people.age) = 100
	' in: #Z3 modifiableObjects: {r. env at: #p1. env at: #p2} modifiableAttributes: #((Person age)) options: #(instantiateQuantifiers true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: r people."
	self assert: 2 equals: r people size.
	self assert: true equals: 
		[ | s | 
		s := (r people collect: [:z | z age ]) sum. 
		s = 20 or: [ s > 31 ] ] value. ! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:18'!
testForall1

	" 
	CoopLangZ3Tests new testForall1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Int
	'.
	p1 := env hostProgram: '
	x > 11
	x < 20
	all z : Int | ((z > 1 && z < x) => x % z !!= 0)
	' in: #Z3 readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x).".
	self assert: 13 equals: (env at: #x).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/26/2012 18:21'!
testForall2

	" 
	CoopLangZ3Tests new testForall2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Int
	'.
	p1 := env hostProgram: '
	x > 11
	x < 20
	all z : Int, d : Int | ((z > 1 && z < x) => x % z !!= 0)
	' in: #Z3 readOnlyVars: #().
	p1 runAndCommit.
	"Transcript show: (env at: #x).".
	self assert: 13 equals: (env at: #x).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:18'!
testGet1

	"
	CoopLangZ3Tests new testGet1
	"

	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	env at: #x put: 10.
	env at: #y put: nil.
	p1 := env hostProgram: '
	y * y <= x
	(y + 1) * (y + 1) > x
	y >= 0
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	env eval: 'this.y = this.p1._get("y")'.
	self assert: 3 equals: (env eval: 'this.y.currentValue()').
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:20'!
testImplies1

	" 
	CoopLangZ3Tests new testImplies1
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: true.
	p1 := env hostProgram: '
	x => y
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: true equals: (env at: #y).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:20'!
testImplies2

	" 
	CoopLangZ3Tests new testImplies2
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: false.
	p1 := env hostProgram: '
	x <=> y
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: false equals: (env at: #y).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:20'!
testImplies3

	" 
	CoopLangZ3Tests new testImplies3
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: true.
	p1 := env hostProgram: '
	x => !!y
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: false equals: (env at: #y).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:14'!
testInvariants1

	"
	CoopLangZ3Tests new testInvariants1
	"
	
	|  env p1 p q APoint |
	env := CoopLangs newModel: (CoopLangsLibrary IntPoint , 
'class APoint : Point
	Constraints
		(this.x = 1 && this.y = 2) || this.x < 0
		this.y > 0
') andProblem: '
var p, q : APoint
	'.
	APoint := env getClass: #APoint.
	p := APoint new x: 1; y: 2; var: #p.
	q := APoint new x: 3; y: 4; var: #q.
	p1 := env hostProgram: '
	p.x + p.y = q.x + q.y
	q.x !!= p.x
	' in: #Z3 modifiableObjects: {q} modifiableAttributes: #((APoint x) (APoint y)).
	p1 runAndCommit.
	"Transcript show: ('' , p , ' ' , q)."
	self assert: true equals: (q x < 0).
	self assert: (p y + p x) equals: (q y + q x).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:14'!
testInvariants2

	"
	CoopLangZ3Tests new testInvariants2
	"
	
	|  env p1 p q w Point |
	env := CoopLangs newModel: '
class Line : Thing
	Attributes
		p1, p2: Point
class Point : Thing
	Attributes
		x, y : Int
	Constraints
		this.x >= 0
		this.y >= 0
	' andProblem: '
var p, q : Point
var w: Line
	'.
	Point := env getClass: #Point.
	p := Point new x: 0; y: 0; var: #p.
	q := Point new x: 0; y: 0; var: #q.
	w := (env getClass: #Line) new p1: p; p2: q; var: #w.
	p1 := env hostProgram: '
	w.p1.x = w.p2.y
	w.p1.y = w.p2.x
	w.p1.x !!= w.p1.y
	' in: #Z3 modifiableObjects: {p. q} modifiableAttributes: #((Point x) (Point y)) options: #(instantiateQuantifiers true).
	p1 runAndCommit.
	"Transcript show: w."
	self assert: true equals: (w p1 x = w p2 y).
	self assert: true equals: (w p1 y = w p2 x).
	self assert: false equals: (w p1 x = w p1 y).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/12/2012 11:45'!
testList1

	"
	CoopLangZ3Tests new testList1
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: List (Int)
		nth: Int
		n: Int 
	Constraints
		this.nth = this.things(this.n)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {4. 2. 1. 3}; n: 3; var: #b.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag nth)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b things.
	Transcript show: b first."
	self assert: 1 equals: b nth.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/13/2012 16:30'!
testList2

	"
	CoopLangZ3Tests new testList2
	"
	
	| env p1 b Point |
	env := CoopLangs newModel: CoopLangsLibrary Point , 
'class Bag : Thing
	Attributes
		points : List (Point)
		xs : List (Real)
	Constraints
		#(this.xs) = #(this.points)
		all i : Int | ((i >= 1 && i <= #(this.points)) => this.xs(i) = this.points(i).x)
	' andProblem: '
var b: Bag
	'.
	Point := env getClass: #Point.
	b := (env getClass: #Bag) new points: {Point new x: 10.0; y: 20.0; yourself. Point new x: 30.0; y: 40.0; yourself.}; var: #b.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag xs)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b points.
	Transcript show: b xs."
	self assert: b points first x equals: b xs first.
	self assert: b points second x equals: b xs second.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:22'!
testNonlinear1
	
	"
	CoopLangZ3Tests new testNonlinear1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, r : Real
	'.
	env at: #r put: 10.3.
	env at: #x put: 7.2.
	p1 := env hostProgram: '
	x ^ 2 + y ^ 2 = r ^ 2
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: true equals: 
		((env at: #r) squared - (((env at: #x) squared + (env at: #y) squared)) <= 0.001)
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:13'!
testNonlinear1F
	
	"
	CoopLangZ3Tests new testNonlinear1F
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var p : Point
var r : Real
	'.
	p := (env getClass: #Point) new x: 150.0; y: 63.0; var: #p.
	p1 := env hostProgram: '
	 r = p.x ^ 0.5 + p.y ^ 0.5
	' in: #Z3 modifiableVars: #(r) options: #(flatten true).
	p1 runAndCommit.
	"Transcript show: (env at: #r)."
	self assert: true equals: 
		(((env at: #r) - (p x sqrt + p y sqrt)) <= 0.1)
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/8/2012 15:38'!
testNonlinear2
	
	"
	CoopLangZ3Tests new testNonlinear2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, r : Real
	'.
	env at: #r put: 10.0.
	env at: #x put: -8.0.
	p1 := env hostProgram: '
	(x >= -r && x <= r) => x ^ 2 + y ^ 2 = r ^ 2
	y <= 0.0
	' in: #Z3 modifiableVars: #(y).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: true equals: 
		((env at: #r) squared - (((env at: #x) squared + (env at: #y) squared)) <= 0.1)
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/8/2012 15:37'!
testNonlinear3
	
	"
	CoopLangZ3Tests new testNonlinear3
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, r : Real
	'.
	env at: #x put: 150.0.
	env at: #y put: 63.0.
	p1 := env hostProgram: '
	 r = x ^ 0.5 + y ^ 0.5
	' in: #Z3 modifiableVars: #(r).
	p1 runAndCommit.
	"Transcript show: (env at: #r)."
	self assert: true equals: 
		((env at: #r) - (((env at: #x) sqrt + (env at: #y) sqrt)) <= 0.1)
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:13'!
testObject1

	"
	CoopLangZ3Tests new testObject1
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var z : Int
var p : Point
	'.
	p := (env getClass: #Point) new x: 0; y: 0; var: #p.
	env at: #z put: 5.
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Z3 modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: (env at: #z) squared equals: ((p x squared)  + (p y squared)).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:13'!
testObject1F

	"
	CoopLangZ3Tests new testObject1F
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var z : Int
var p : Point
	'.
	p := (env getClass: #Point) new x: 0; y: 0; var: #p.
	env at: #z put: 5.
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Z3 modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)) options: #(flatten true).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: (env at: #z) squared equals: ((p x squared)  + (p y squared)).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:13'!
testObject2

	"
	CoopLangZ3Tests new testObject2
	"
	
	|  env p1 p q |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var p, q : Point
	'.
	p := (env getClass: #Point) new x: 1; y: 2; var: #p.
	q := (env getClass: #Point) new x: 3; y: 4; var: #q.
	p1 := env hostProgram: '
	p.x = q.y
	p.y = q.x
	' in: #Z3 modifiableObjects: {q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: ('' , p , ' ' , q)."
	self assert: 0 equals: (p x - q y).
	self assert: 0 equals: (p y - q x).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:13'!
testObject2F

	"
	CoopLangZ3Tests new testObject2F
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var z : Real
var p : Point
	'.
	p := (env getClass: #Point) new x: 0.0; y: 0.0; var: #p.
	env at: #z put: 10.0.
	p1 := env hostProgram: '
	p.x > 0.0
	p.y > 0.0
	p.x !!= p.y
	z ^ 2.0 = p.x ^ 2.0 + p.y ^ 2.0
	' in: #Z3 modifiableObjects: {p} modifiableAttributes: #((Point x) (Point y)) options: #(flatten true).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: true equals: ((env at: #z) squared - (p x squared + p y squared)) abs <= 0.1.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:12'!
testObject3F

	"
	CoopLangZ3Tests new testObject3F
	"
	
	|  env p1 p res |
	env := CoopLangs newModel: CoopLangsLibrary Point andProblem: '
var z : Real
var p : Point
	'.
	p := (env getClass: #Point) new x: 0.0; y: 0.0; var: #p.
	env at: #z put: 10.0.
	p1 := env hostProgram: '
	p.x > 0.0
	p.y > 0.0
	p.x !!= p.y
	z ^ 2.0 = p.x ^ 2.0 + p.y ^ 2.0
	' in: #Z3 modifiableObjects: {p} modifiableAttributes: #((Point y)) options: #(flatten true).
	res := p1 runAndCommit.
	"Transcript show: p."
	self assert: false equals: res
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:23'!
testOld1
	
	"
	CoopLangZ3Tests new testOld1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	x = old(x) + 1
	' in: #Z3 modifiableVars: #(x).
	p1 runAndCommit.
	"Transcript show: (env at: #x)."
	self assert: (env at: #x) equals: 11.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 10/4/2012 16:37'!
testOld2
	
	"
	CoopLangZ3Tests new testOld2
	"
	
	|  env p1 |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var p: Point
	'.
	env at: #p put: ((env getClass: #Point) new x: 10; y: 20).
	p1 := env hostProgram: '
p.x = old(p.x) + 1
p.y = old(p.y) + 2
	' in: #Z3 modifiableObjects: {env at: #p} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: (env at: #p)."
	self assert: (env at: #p) x equals: 11.
	self assert: (env at: #p) y equals: 22.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/26/2012 02:34'!
testOld2F
	
	"
	CoopLangZ3Tests new testOld2F
	"
	
	|  env p1 |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var p: Point
	'.
	env at: #p put: ((env getClass: #Point) new x: 10; y: 20; yourself).
	p1 := env hostProgram: '
p.x = old(p.x) + 1
p.y = old(p.y) + 2
	' in: #Z3 modifiableObjects: {env at: #p} modifiableAttributes: #((Point x) (Point y)) options: #(flatten true).
	p1 runAndCommit.
	"Transcript show: (env at: #p)."
	self assert: (env at: #p) x equals: 11.
	self assert: (env at: #p) y equals: 22.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 10/4/2012 16:38'!
testOld3
	
	"
	CoopLangZ3Tests new testOld3
	"

	|  env Point Line p1 |
	env := CoopLangs newModel:  CoopLangsLibrary IntPoint , 
'class Line : Thing
	Attributes
		start, end : Point
' andProblem: '
var p, q : Point
var w : Line
	'.
	Point := env getClass: #Point.
	Line := env getClass: #Line.
	env at: #p put: (Point new x: 10; y: 20).
	env at: #q put: (Point new x: 30; y: 40).
	env at: #w put: (Line new start: (env at: #p); end: (env at: #q)).
	p1 := env hostProgram: '
w.start.x = old(w.end.x) 
w.start.y = old(w.end.y)
w.end.x = old(w.start.x) 
w.end.y = old(w.start.y)
p = old(p)
q = old(q)
	' in: #Z3 modifiableObjects: {env at: #p. env at: #q} modifiableAttributes: #((Point x) (Point y)).
	p1 runAndCommit.
	"Transcript show: (env at: #p).
	Transcript show: (env at: #q)."
	self assert: (env at: #p) x equals: 30.
	self assert: (env at: #p) y equals: 40.
	self assert: (env at: #q) x equals: 10.
	self assert: (env at: #q) y equals: 20.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/25/2012 15:48'!
testOut1

	"
	CoopLangZ3Tests new testOut1
	"
	
	|  env p1 res |
	env := CoopLangs newProblem: '
	var x, output : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	output = x - 1
	' in: #Z3 modifiableVars: #(output).
	res := p1 apply.
	self assert: res equals: 9.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/25/2012 15:18'!
testOut2

	"
	CoopLangZ3Tests new testOut2
	"
	
	|  env p1 res |
	env := CoopLangs newProblem: '
	var input, output : Int
	'.
	p1 := env hostProgram: '
	output = input - 1
	' in: #Z3 modifiableVars: #(output).
	res := p1 apply: (p1 apply: 10).
	self assert: 8 equals: res.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:25'!
testReadOnly1

	"
	CoopLangZ3Tests new testReadOnly1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Int
	'.
	env at: #x put: 10.
	p1 := env hostProgram: '
	y ^ 2 <= x
	(y + 1) ^ 2 > x
	y >= 0
	' in: #Z3 readOnlyVars: #(x).
	p1 runAndCommit.
	"Transcript show: (env at: #y)."
	self assert: (env at: #y) equals: 3.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:12'!
testReadOnly2

	"
	CoopLangZ3Tests new testReadOnly2
	"
	
	|  env p1 p |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var z : Int
var p : Point
	'.
	p := (env getClass: #Point) new x: 0; y: 0; var: #p.
	env at: #z put: 5.
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Z3 readOnlyVars: #(z).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: (env at: #z) squared equals: ((p x squared)  + (p y squared)).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:26'!
testReals1

	"
	CoopLangZ3Tests new testReals1
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y, r : Real
	'.
	env at: #x put: 3.5.
	env at: #y put: 4.4.
	p1 := env hostProgram: '
	x + y = r
	' in: #Z3 modifiableVars: #(r).
	p1 runAndCommit.
	"Transcript show: (env at: #r)."
	self assert: 7.9 equals: (env at: #r).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:26'!
testReals2

	"
	CoopLangZ3Tests new testReals2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var r1, r2, m, i, v : Real
	'.
	env at: #r1 put: 100.0.
	env at: #r2 put: 50.0.
	env at: #v put: 9.0.
	p1 := env hostProgram: '
	v = (r1 + r2) * i
	m = r1 * i
	' in: #Z3 modifiableVars: #(i m).
	p1 runAndCommit.
	"Transcript show: 'i=' , (env at: #i) , ' m=' , (env at: #m)."
	self assert: 6 equals: (env at: #m) abs.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 6/7/2012 13:27'!
testRun1

	" 
	CoopLangZ3Tests new testRun1
	"
	
	| env p1 model |
	env := CoopLangs newProblem: '
	var x, y: Bool
	'.
	env at: #x put: true.
	env at: #y put: false.
	p1 := env hostProgram: '
	x => y
	' in: #Z3 modifiableVars: #(y).
	model := p1 run.
	"Transcript show: model."
	"Transcript show: (env at: #y)."
	self assert: true equals: (model at: #y).
	self assert: false equals: (env at: #y).
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/13/2012 16:23'!
testSet1

	"
	CoopLangZ3Tests new testSet1
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		count: Int
	Constraints
		this.count = #(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {}; var: #b.
	p1 := env hostProgram: '
	#(b.things) = 4
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag things) (Bag count)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b things.
	Transcript show: b count."
	self assert: 4 equals: b things size.
	self assert: 4 equals: b count.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/13/2012 16:24'!
testSet2

	"
	CoopLangZ3Tests new testSet2
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		count, sum: Int
	Constraints
		this.count = #(this.things)
		this.sum = sum(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new var: #b.
	p1 := env hostProgram: '
	#(b.things) = 4
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag things) (Bag count) (Bag sum)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b things.
	Transcript show: b count.
	Transcript show: b sum."
	self assert: 4 equals: b things size.
	self assert: 4 equals: b count.
	self assert: b things sum equals: b sum.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:11'!
testSet3

	"
	CoopLangZ3Tests new testSet3
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		count, sum: Int
	Constraints
		this.count = #(this.things)
		this.sum = sum(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {0. 0. 0. 0}; var: #b.
	p1 := env hostProgram: '
	#(b.things) = 4
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag things) (Bag count) (Bag sum)) 
		options: #(instantiateQuantifiers true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b things.
	Transcript show: b count.
	Transcript show: b sum."
	self assert: 4 equals: b things size.
	self assert: 4 equals: b count.
	self assert: b things sum equals: b sum.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:11'!
testSprings1
	
	"
	CoopLangZ3Tests new testSprings1
	"
	
	| env p1 FreeMass Mass Spring mass1 mass2 spring g pos01 pos02 t |

	env := CoopLangs newModel: CoopLangsLibrary SpringsAndMasses1D
		andProblem: '
var t, dt, g : Real
var mass1: Mass
var mass2: FreeMass
var spring : Spring
	'.
	FreeMass := env getClass: #FreeMass.
	Mass := env getClass: #Mass.
	Spring := env getClass: #Spring.
	t := 0.0.
	g := 9.8.
	pos01 := 0.0.
	pos02 := 50.0.
	mass1 := Mass new position: pos01; var: #mass1.
	mass2 := FreeMass new mass: 100.0; position: pos02; velocity: 0.0; acceleration: g; var: #mass2.
	spring := Spring new naturalLength: 50.0; k: 50.0; end1: mass1; end2: mass2; var: #spring.
	mass1 beams: { spring }.
	mass2 beams: { spring }.
	env at: #t put: t.
	env at: #g put: g.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 readOnlyVars: #(g) readOnlyObjects: {mass1} readOnlyAttributes: #((Spring end1) (Spring end2) (Spring k) (Spring naturalLength) (FreeMass mass) (FreeMass position0) (FreeMass beams) (Mass position) (Mass beams)) options: #(instantiateQuantifiers true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: '' , mass2 force , Character lf.
	Transcript show: '' , spring length , Character lf."
	self assert: true equals: (spring length > 50.0 and: [ spring length < 51.0 ]). ! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:11'!
testSprings1F
	
	"
	CoopLangZ3Tests new testSprings1F
	"
	
	| env p1 FreeMass Mass Spring mass1 mass2 spring g pos01 pos02 t |

	env := CoopLangs newModel: CoopLangsLibrary SpringsAndMasses1D
		andProblem: '
var t, dt, g : Real
var mass1: Mass
var mass2: FreeMass
var spring : Spring
	'.
	FreeMass := env getClass: #FreeMass.
	Mass := env getClass: #Mass.
	Spring := env getClass: #Spring.
	t := 0.0.
	g := 9.8.
	pos01 := 0.0.
	pos02 := 50.0.
	mass1 := Mass new position: pos01; var: #mass1.
	mass2 := FreeMass new mass: 100.0; position: pos02; velocity: 0.0; acceleration: g; var: #mass2.
	spring := Spring new naturalLength: 50.0; k: 50.0; end1: mass1; end2: mass2; var: #spring.
	mass1 beams: { spring }.
	mass2 beams: { spring }.
	env at: #t put: t.
	env at: #g put: g.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 readOnlyVars: #(g) readOnlyObjects: {mass1} readOnlyAttributes: #((Spring end1) (Spring end2) (Spring k) (Spring naturalLength) (FreeMass mass) (FreeMass position0) (FreeMass beams) (Mass position) (Mass beams)) options: #(flatten true instantiateQuantifiers true setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: '' , mass2 force , Character lf.
	Transcript show: '' , spring length , Character lf."
	self assert: true equals: (spring length > 50.0 and: [ spring length < 51.0 ]). ! !

!CoopLangZ3Tests methodsFor: 'stream unit tests' stamp: 'yo 10/22/2012 11:22'!
testStreams1

	"
	CoopLangZ3Tests new testStreams1
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	env eval: 'this.x = this.streamOf(10)'.
	env eval: 'this.y = this.streamOf(nil)'.
	p1 := env hostProgram: '
	y = x+5
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	env eval: 'this.solver = $$(solver(() ->
		this.p1.runAndCommit(), ["x"], ["x", "y"]))'.
	env sortAndEvaluateAt: 1.
	self assert: 10 equals: (env eval:  'this.x.currentValue()').
	self assert: 15 equals: (env eval:  'this.y.currentValue()').
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:10'!
testSubclass1

	"
	CoopLangZ3Tests new testSubclass1
	"
	
	|  env p1 p |
	env := CoopLangs newModel: '
class Point : Thing
	Attributes
		x, y : Int
	Constraints
		this.x > 0
		this.y > 0
class Point3D : Point
	Attributes
		z : Int
	Constraints
		this.z > 0
	' andProblem: '
var p : Point3D
	'.
	p := (env getClass: #Point3D) new x: 1; y: 2; z: 3; var: #p.
	p1 := env hostProgram: '
	p.x + p.y = 10
	p.z = p.y - p.x
	' in: #Z3 modifiableObjects: {p} modifiableAttributes: #((Point3D x) (Point3D y) (Point3D z)).
	p1 runAndCommit.
	"Transcript show: p."
	self assert: 10 equals: (p y + p x).
	self assert: 0 equals: (p y - p x - p z).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:10'!
testSubclass2

	"
	CoopLangZ3Tests new testSubclass2
	"
	
	|  env p1 b f |
	env := CoopLangs newModel: '
class Foo : Thing
	Attributes
		x, y : Int
	Constraints
		this.x < 0
		this.y > 0
class Bar : Foo
	Attributes
		z : Int
	Constraints
		this.z < 0
	' andProblem: '
var b : Bar
var f : Foo
	'.
	b := (env getClass: #Bar) new x: 1; y: 2; z: 3; var: #b.
	f := (env getClass: #Foo) new x: 1; y: 2; var: #f.
	p1 := env hostProgram: '
	b.y < 3
	f.x + f.y = -5
	' in: #Z3 modifiableObjects: {b. f} modifiableAttributes: #((Bar x) (Bar y) (Bar z) (Foo x)).
	p1 runAndCommit.
	"Transcript show: b.
	Transcript show: f."
	self assert: true equals: (b y < 3).
	self assert: true equals: (b x < 0).
	self assert: true equals: (b y > 0).
	self assert: true equals: (b z < 0).
	self assert: true equals: (f x < 0).
	self assert: true equals: (f y > 0).
	self assert: -5 equals: (f x + f y).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/13/2012 16:32'!
testSum1

	"
	CoopLangZ3Tests new testSum1
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		sum: Int
	Constraints
		this.sum = sum(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {5. 6. 8. 7}; var: #b.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag sum)) options: #(setLogic AUFNIRA).
	p1 runAndCommit.
	"Transcript show: b sum."
	self assert: b things sum equals: b sum.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 9/19/2012 15:00'!
testSum1F

	"
	CoopLangZ3Tests new testSum1F
	"
	
	| env p1 b |
	env := CoopLangs newModel: '
class Bag: Thing
	Attributes
		things: Set (Int)
		sum: Int
	Constraints
		this.sum = sum(this.things)
	' andProblem: '
var b: Bag
	'.
	b := (env getClass: #Bag) new things: {5. 6. 8. 7}; var: #b.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: {b} modifiableAttributes: #((Bag sum)) options: #(flatten true).
	p1 runAndCommit.
	"Transcript show: b sum."
	self assert: b things sum equals: b sum.! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/28/2012 12:09'!
testTens1

	" 
	CoopLangZ3Tests new testTens1
	"
	
	|  env p1 Ring rings ring1 ring2 ring3 ring4 |
	env := CoopLangs newModel: '
class Ring : Thing
	Attributes
		i1, i2, i3, i4 : Int
	Constraints
		this.i1 = 1 || this.i1 = 10 || this.i1 = 100 || this.i1 = 1000
		this.i2 = 1 || this.i2 = 10 || this.i2 = 100 || this.i2 = 1000
		this.i3 = 1 || this.i3 = 10 || this.i3 = 100 || this.i3 = 1000
		this.i4 = 1 || this.i4 = 10 || this.i4 = 100 || this.i4 = 1000
		this.i1 + this.i2 + this.i3 + this.i4 = 1111
	' andProblem: '
var ring1, ring2, ring3, ring4 : Ring
	'.
	Ring := env getClass: #Ring.
	ring1 := Ring new var: #ring1.
	ring2 := Ring new var: #ring2.
	ring3 := Ring new var: #ring3.
	ring4 := Ring new var: #ring4.
	rings := {ring1. ring2. ring3. ring4}.
	p1 := env hostProgram: '
	all ring1 : Ring, ring2 : Ring | 
		(ring1 !!= ring2 => (ring1.i1 !!= ring2.i1 || ring1.i2 !!= ring2.i2 || ring1.i3 !!= ring2.i3 || ring1.i4 !!= ring2.i4))
	' in: #Z3 readOnlyObjects: {} readOnlyAttributes: #().
	p1 runAndCommit.
	"rings do: [:ring |
		Transcript show: '' , ring i1 , ' ' , ring i2 , ' ' , ring i3 , ' ' , ring i4 , Character lf ]."
	self assert: true equals: (ring1 i1 ~= ring2 i1 or: [ ring1 i2 ~= ring2 i2 or: [ ring1 i3 ~= ring2 i3 or: [ ring1 i4 ~= ring2 i4 ]]]).! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/26/2012 02:34'!
testUnsat1

	"
	CoopLangZ3Tests new testUnsat1
	"
	
	|  env p1 res |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var z : Int
var p : Point
	'.
	env at: #z put: 5.
	env at: #p put: ((env getClass: #Point) new x: 0; y: 0; yourself).
	p1 := env hostProgram: '
	p.x > 0
	p.y > 0
	p.x !!= p.y
	z ^ 2 = p.x ^ 2 + p.y ^ 2
	' in: #Z3 modifiableObjects: {env at: #p} modifiableAttributes: #((Point y)).
	res := p1 runAndCommit.
	"Transcript show: res."
	self assert: false equals: res.
! !

!CoopLangZ3Tests methodsFor: 'batch solving unit tests' stamp: 'hs 8/26/2012 02:34'!
testUnsat2

	"
	CoopLangZ3Tests new testUnsat2
	"
	
	|  env p1 res |
	env := CoopLangs newModel: CoopLangsLibrary IntPoint andProblem: '
var p, q : Point
	'.
	env at: #p put: ((env getClass: #Point) new x: 1; y: 2; yourself).
	env at: #q put: ((env getClass: #Point) new x: 3; y: 4; yourself).
	p1 := env hostProgram: '
	p.x = q.y
	p.y = q.x
	' in: #Z3 modifiableObjects: #() modifiableAttributes: #((Point x) (Point y)).
	res := p1 runAndCommit.
	"Transcript show: res."
	self assert: false equals: res.
! !

TestCase subclass: #CoopLangsSpecsParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangsSpecsParserTests methodsFor: 'unit tests' stamp: 'hs 10/8/2012 15:49'!
testConstraints

	"
	CoopLangsSpecsParserTests new testConstraints
	"

	"test forming equality and inequality constraints"
	self assert: #((constraint required (eq x 3))) equals: (CoopLangsSpecsParser matchAll: 'x=3' with: #prioritizedConstraints). 
	self assert: #((constraint required (lte x 3))) equals: (CoopLangsSpecsParser matchAll: 'x<=3' with: #prioritizedConstraints).
	self assert: #((constraint required (gte x 3))) equals: (CoopLangsSpecsParser matchAll: 'x>=3' with: #prioritizedConstraints).
	"test  with a more complex expression"
	self assert: #((constraint required (gte (plus x (multiply (multiply 3 y) z)) (divide z 10) ))) equals: (CoopLangsSpecsParser matchAll: 'x + 3*y*z >= z/10' with: #prioritizedConstraints).
	"test with a priority"
	self assert: #((constraint weak (gte x 3))) equals: (CoopLangsSpecsParser matchAll: '[priority: weak] x>=3' with: #prioritizedConstraints).
! !

!CoopLangsSpecsParserTests methodsFor: 'unit tests' stamp: 'hs 10/8/2012 15:48'!
testExpressions
	
	"
	CoopLangsSpecsParserTests new testExpressions
	"
	
	"test name and constant (both integer and floating point)"
	self assert: #x equals: (CoopLangsSpecsParser matchAll: 'x' with: #expr).
	self assert: 3 equals: (CoopLangsSpecsParser matchAll: '3' with: #expr).
	self assert: 3.5 equals: (CoopLangsSpecsParser matchAll: '3.5' with: #expr).
	
	"test addition"
	self assert: #(plus 3 x) equals: (CoopLangsSpecsParser matchAll: '3+x' with: #expr).
	self assert: #(plus x 3) equals: (CoopLangsSpecsParser matchAll: 'x+3' with: #expr).
	self assert: #(plus (plus x 3) y) equals: (CoopLangsSpecsParser matchAll: 'x+3+y' with: #expr).

	"multiplication"
	self assert: #(multiply 3 x) equals: (CoopLangsSpecsParser matchAll: '3*x' with: #expr).
	self assert: #(multiply x 3) equals: (CoopLangsSpecsParser matchAll: 'x*3' with: #expr).
	self assert: #(multiply (multiply x 3) y) equals: (CoopLangsSpecsParser matchAll: 'x*3*y' with: #expr).
	
	"unary minus"
	self assert: #(minus x) equals: (CoopLangsSpecsParser matchAll: '-x' with: #expr).
	self assert: #(multiply x (minus y)) equals: (CoopLangsSpecsParser matchAll: 'x*-y' with: #expr).
	self assert: #(minus (minus x) y) equals: (CoopLangsSpecsParser matchAll: '-x-y' with: #expr).
	
	"expressions involving both addition and multiplication"
	self assert: #(plus (multiply 3 x) y) equals: (CoopLangsSpecsParser matchAll: '3*x + y' with: #expr).
	self assert: #(minus (plus (multiply 3 x) y) 10) equals: (CoopLangsSpecsParser matchAll: '3*x + y - 10' with: #expr).
	
	"parenthesized expressions"
	self assert: #(multiply 3 (plus x y)) equals: (CoopLangsSpecsParser matchAll: '3*(x+y)' with: #expr).
	
	"division"
	self assert: #(plus (divide x 3) (divide y (plus a b))) equals: (CoopLangsSpecsParser matchAll: 'x/3 + y/(a+b)' with: #expr).
	
	"derivation"
	self assert: #(derivative x t) equals: (CoopLangsSpecsParser matchAll: 'd x / d t' with: #expr).
	self assert: #(derivative (plus (power x 2) y) x) equals: (CoopLangsSpecsParser matchAll: 'd (x ^ 2 + y) / d x' with: #expr).! !

!CoopLangsSpecsParserTests methodsFor: 'unit tests' stamp: 'hs 10/8/2012 15:48'!
testStays

	"
	CoopLangsSpecsParserTests new testStays
	"
	
	self assert: #((stay required x)) equals: (CoopLangsSpecsParser matchAll: 'x stay' with: #prioritizedConstraints).
	self assert: #((stay weak x)) equals: (CoopLangsSpecsParser matchAll: '[priority: weak] x stay' with: #prioritizedConstraints).
	self assert: #((stay required x) (stay required y) (stay required squid)) equals: (CoopLangsSpecsParser matchAll: 'x, y, squid stay' with: #prioritizedConstraints).
	self assert: #((stay weak x) (stay weak y) (stay weak squid)) equals: (CoopLangsSpecsParser matchAll: '[priority: weak] x, y, squid stay' with: #prioritizedConstraints).
! !

TestCase subclass: #CoopLangsThingsParserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Tests'!

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:15'!
testClassAttributes

	"
	CoopLangsThingsParserTests new testClassAttributes
	"

	| def1 def2 def3 def4 def5 |
	"test class definition with 0, 1, 2 attributes"
	
	"two versions of 0 attributes"
	def1 := 
'class Point: Thing 
  Attributes
'.
	self assert: "#( (class Point Thing (attributes () ) (constraints () ) ) )" 
		{{#classDecl. #Point. CoopLangType of: #Thing. #(attributes () ). #(constraints () )}} equals:
		(CoopLangsThingsParser matchAll: def1 with: #programModel).
	
	def2 := 
'class Point: Thing 
'.
	self assert: "#( (class Point Object (attributes () ) (constraints () ) ) )" 
	{{#classDecl. #Point. CoopLangType of: #Thing. #(attributes () ). #(constraints () )}}
	equals:
		(CoopLangsThingsParser matchAll: def2 with: #programModel).	

	def3 := 
'class Point: Thing 
  Attributes
    x: Float
'.
	self assert: "#( (class Point Object (attributes ((attribute x Float))) (constraints () ) ) )"
	{{#classDecl. #Point. CoopLangType of: #Thing. {#attributes. {{#attribute. #x. CoopLangType of: #Float}} }. #(constraints () )}} equals:
		(CoopLangsThingsParser matchAll: def3 with: #programModel).	

	def4 := 
'class Point: Thing 
  Attributes
    x: Float
    y: Float
'.
	self assert:   "#( (class Point Object (attributes ((attribute x Float)  (attribute y Float))) (constraints () ) ) )" {{#classDecl. #Point. CoopLangType of: #Thing. {#attributes. {{#attribute. #x. CoopLangType of: #Float}. {#attribute. #y. CoopLangType of: #Float} }}. #(constraints () )}} equals:
		(CoopLangsThingsParser matchAll: def4 with: #programModel).	

	def5 := 
'class Point: Thing 
  Attributes
    x, y: Float
'.
	self assert:  "#( (class Point Object (attributes ((attribute x Float)  (attribute y Float))) (constraints () ) ) )" {{#classDecl. #Point. CoopLangType of: #Thing. {#attributes. {{#attribute. #x. CoopLangType of: #Float}. {#attribute. #y. CoopLangType of: #Float} }}. #(constraints () )}} equals:
		(CoopLangsThingsParser matchAll: def4 with: #programModel).	
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:15'!
testClassDefBlanks

	"
	CoopLangsThingsParserTests new testClassDefBlanks
	"
	

	| def1 |
	"test putting some blank lines at the end"
	def1 := 
'class Point: Thing



'.
	self assert: "#( (class Point Object (attributes () ) (constraints () ) ) )"
	{{#classDecl. #Point. CoopLangType of: #Thing. #(attributes () ). #(constraints () )}} equals:
		(CoopLangsThingsParser matchAll: def1 with: #programModel).	



! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:15'!
testConstraints

	"
	CoopLangsThingsParserTests new testConstraints
	"

	| def1 def2 |

	def1 := 
'class Adder: Thing
  Attributes
    a: Real
    b: Real
    c: Real
  Constraints
    a+b=c

'.
	self assert: {{
		#classDecl. #Adder. CoopLangType of: #Thing. 
		{#attributes. {{#attribute. #a. CoopLangType of: #Real}. {#attribute. #b. CoopLangType of: #Real}. {#attribute. #c. CoopLangType of: #Real}}}.
		#(constraints ((constraint required (eq (plus a b) c) )))
	}}
	equals: (CoopLangsThingsParser matchAll: def1 with: #programModel).

	"this horizontal line definition assumes that we have a Line class defined as follows:
		class Line: Object
		  Attributes
		    end1, end2: Point
	"
	def2 := 
'class HorizontalLine: Line
  Constraints
    end1.y = end2.y

'.
	self assert: {{
		#classDecl. #HorizontalLine. CoopLangType of: #Line.
		#(attributes ()).
		#(constraints ((constraint required (eq (get end1 y) (get end2 y)))))
	}}
	equals: (CoopLangsThingsParser matchAll: def2 with: #programModel).
! !

!CoopLangsThingsParserTests methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:57'!
testRelationDecl1

	"
	CoopLangsThingsParserTests new testRelationDecl1
	"

	| def1  |
	def1 := 
'relation VLine(p: Point, q: Point)
	Rules
		VLine(p, q) <--
			p.x = q.x
'.
	self assert: {{#relationDecl. #VLine. true. {{#p. CoopLangType of: #Point}. {#q. CoopLangType of: #Point}}. #(rules ((rule VLine (p q) ((constraint required (eq (get p x) (get q x)))))))}} equals:
		(CoopLangsThingsParser matchAll: def1 with: #programModel).! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:38'!
testSoftConstraints
	| def1 |

	"
	CoopLangsThingsParserTests new testSoftConstraints
	"
	
"for now, the strengths are hard-wired.  If we add strength declarations, add this line to the front of the definition:
    Strengths required, strong, medium, weak
"

	def1 := 
'class SoftTest: Thing
  Attributes
    a: Real
    b: Real
    c: Real
  Constraints
    a = 4
    [priority: medium] a = 5
    [priority: weak] b = 2*a
    [priority: weak] a, b, c stay

'.
	self assert: { {#classDecl. #SoftTest. CoopLangType of: #Thing. 
		{#attributes. {
			{#attribute. #a. CoopLangType of: #Real}. 
			{#attribute. #b. CoopLangType of: #Real}.
			{#attribute. #c. CoopLangType of: #Real}}}.
		#(constraints (
			(constraint required  (eq a 4))
			(constraint medium  (eq a 5))
			(constraint weak (eq b (multiply 2 a)))
			(stay weak a)
			(stay weak b)
			(stay weak c)))}}
	equals:
	(CoopLangsThingsParser matchAll: def1 with: #programModel).
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:17'!
testStays1

	"
	CoopLangsThingsParserTests new testStays1
	"
	
	"test a program with class definition containing a required stay (not that interesting a constraint but it should parse)"
	| def1 |
	def1 := 
'class Const : Thing
	Attributes
		x: Real
	Constraints
		x stay
'.
	self assert: "#( 
		( class Const Thing)
			(attributes ((attribute x Real)))
			(constraints ((constraint (x stay)))))  "
	{{#classDecl. #Const. CoopLangType of: #Thing. 
	 {#attributes. {{#attribute. #x. CoopLangType of: #Real}}}.
	 #(constraints ((stay required x))) }}
	equals: (CoopLangsThingsParser matchAll: def1 with: #programModel)
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:37'!
testStays2

	"
	CoopLangsThingsParserTests new testStays2
	"
	
	"test a program with class definition containing a weak stay"
	| def1 |
	def1 := 
'class Const : Thing
	Attributes
		x: Real
	Constraints
		[priority: weak] x stay
'.
	self assert: "#( 
		( class Const Thing)
			(attributes ((attribute x Real)))
			(constraints ((constraint (x stay)))))  "
	{{#classDecl. #Const. CoopLangType of: #Thing. 
	 {#attributes. {{#attribute. #x. CoopLangType of: #Real}}}.
	 #(constraints ((stay weak x))) }}
	equals: (CoopLangsThingsParser matchAll: def1 with: #programModel)
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 13:38'!
testStays3

	"
	CoopLangsThingsParserTests new testStays3
	"
	
	"test a program with class definition containing several weak stays"
	| def1 |
	def1 := 
'class Const : Thing
	Attributes
		x, y, z: Real
	Constraints
		[priority: weak] x, y, z stay
'.
	self assert: "#( 
		( class Const Thing)
			(attributes ((attribute x Real)))
			(constraints ((constraint (x stay)))))  "
	{{#classDecl. #Const. CoopLangType of: #Thing. 
	 {#attributes. { {#attribute. #x. CoopLangType of: #Real}. {#attribute. #y. CoopLangType of: #Real}. {#attribute. #z. CoopLangType of: #Real}. }}.
	 #(constraints ((stay weak x) (stay weak y) (stay weak z))) }}
	equals: (CoopLangsThingsParser matchAll: def1 with: #programModel)
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:17'!
testThreeConstraints
	| def1 |

	"
	CoopLangsThingsParserTests new testThreeConstraints
	"
	
	def1 := 
'class DoubleTwice: Thing
  Attributes
    a: Real
    b: Real
    c: Real
  Constraints
    a = 4
    b = 2*a
    c = 2*b

'.
	self assert: {{#classDecl. #DoubleTwice. CoopLangType of: #Thing. 
		{#attributes. {
			{#attribute. #a. CoopLangType of: #Real}. 
			{#attribute. #b. CoopLangType of: #Real}.
			{#attribute. #c. CoopLangType of: #Real}}}.
		#(constraints (
			(constraint required  (eq a 4))
			(constraint required (eq b (multiply 2 a)))
			(constraint required (eq c (multiply 2 b)))))}}
	equals:
	(CoopLangsThingsParser matchAll: def1 with: #programModel).
! !

!CoopLangsThingsParserTests methodsFor: 'unit tests' stamp: 'hs 9/26/2012 12:18'!
testVars

	"
	CoopLangsThingsParserTests new testVars
	"

	| def1 def2 |
	"test var definitions"
	
	"
	ThingsParserTests new testVars
	"
	def1 := 
'var p: Point'.
	self assert: {{#varDecl . {{#var . #p . CoopLangType of: #Point}}}} equals:
		(CoopLangsThingsParser matchAll: def1 with: #programProblem).
	
	def2 := 
'var p, q: Point
var z: Int'.
	self assert: {{#varDecl . {{#var . #p . CoopLangType of: #Point}. 
							   {#var . #q . CoopLangType of: #Point}}}.
				 {#varDecl . {{#var . #z . CoopLangType of: #Int}}}} equals:
		(CoopLangsThingsParser matchAll: def2 with: #programProblem).	! !

OffsideRuleParser subclass: #CoopLangsSpecsParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 4/25/2012 22:54'!
addExpr =

	<addExpr:x	 ("+" -> [#plus] | "-" -> [#minus]):op	mulExpr:y>:src	
		-> [{op. x. y}]
  |	mulExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 18:10'!
addExprs =

	addExprs:xs "," addExpr:y
		-> [xs , {y}]
	| addExpr:x
		-> [{x}]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 4/25/2012 22:55'!
alphanum =

	letter | digit! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 23:39'!
andExpr =

	<andExpr:x	"&&":op eol? impliesExpr:y>:src	
		-> [{#and. x. y}]
  |	impliesExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/8/2012 12:57'!
boolean =
	
	  "true" -> [true]
	| "false" -> [false]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 18:12'!
callExpr =

	symbolName:n "(" addExprs:as ")"							
		-> [{#call. n. as}]


! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 5/18/2012 12:37'!
comment  =

	"//" (~eol anything)*
		-> [true]! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 13:24'!
constraintStmt  =
	
	// stays can define multiple constraints on one line .....
	stays:s -> [s]
	// if it's just one constraint (which will just be an expression) put it into an array, with the given priority
  | 	priority:p expr:c -> [{{#constraint. p. c}}] 
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/24/2012 23:06'!
derivation =

	"d" primExpr:x "/" "d" symbolName:t
		-> [{#derivative. x. t}]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 4/25/2012 23:01'!
eqExpr =

	< eqExpr:x	 ( "=" -> [#eq] | "!!=" -> [#neq]):op	relExpr:y >:src	
		-> [{op. x. y}]
  |	relExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 6/13/2012 01:01'!
expExpr =

  	expExpr:x ( "^" -> [#power]):op unary:y
			-> [{op. x. y}]
  |	unary! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 9/26/2012 12:09'!
expr =

	orExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 12:58'!
higherFunCall =

	("#" -> [#size] | "sum" -> [#sum] | "abs" -> [#abs]):op "(" expr:e ")"
		-> [{op. e}]
	| derivation
	| postfix! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/16/2012 14:01'!
impliesExpr =

	impliesExpr:x ("=>" -> [#implies] | "<=>" -> [#iff]):op quantExpr:y
		-> [{op. x. y}]
  |	quantExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 9/26/2012 10:44'!
literal =
	
	  number
	| boolean
	| string! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/17/2012 12:21'!
mulExpr =

	mulExpr:x ( "*" -> [#multiply] | "/" -> [#divide] | "%" -> [#mod] ):op expExpr:y
		-> [{op. x. y}]
  |	expExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 4/25/2012 14:24'!
name =
	spaces <(letter | $_ ) (alphanum | $_ )*>! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/6/2012 17:57'!
names  =

	names:x ","  symbolName:y
		-> [x , {y}]
	|  symbolName:x
		-> [{x}]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 9/26/2012 10:43'!
number = 

	spaces <("-"? digit+ ($. digit+)?)>:n -> [n asNumber]
	! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 16:23'!
ometaRuleBody  =
	
	ometaRuleBodyChoice:c ("|" ometaRuleBodyChoice)*:cs
		-> [cs isNil ifTrue: [{c}] ifFalse: [{c} , cs]]
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 16:18'!
ometaRuleBodyChoice  =
	
	ometaRuleBodyElement+
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 15:48'!
ometaRuleBodyElement  =
	
 	ometaRuleBodySymbol:m (":" symbolName)?:t ("->" "{" ometaRuleBodyElementAction:a "}")?
		-> [{m. t. a}]
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 15:50'!
ometaRuleBodyElementAction  =
	
 	ometaRuleBodyElementAction:a "+" ometaRuleBodySymbol:b
		-> [{#concat. a. b}]
  |	ometaRuleBodySymbol
	! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 15:08'!
ometaRuleBodySymbol =
	
 	symbolName | string
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 10/8/2012 13:39'!
ometaRuleStmt  =
	
 	"[" "ometa" "]" symbolName:h "=" ometaRuleBody:b -> [{{#ometaRule. h. b}}] 
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 23:38'!
orExpr =

	< orExpr:x	"||" eol? andExpr:y >:src		
		-> [{#or. x. y}]
  |	andExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/11/2012 13:30'!
posNumber = 
	spaces <(digit+ ($. digit+)?)>:n -> [n asNumber]
	! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/7/2012 23:58'!
postfix =

	primExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/19/2012 20:48'!
primExpr =

  	primExprOld
  |	primExprNormal


! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/19/2012 18:31'!
primExprHd =

	"(" expr:e ")"							
		-> [e]
  |	literal
  |	symbolName! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 9/12/2012 10:41'!
primExprNormal =

	primExprNormal:p "." symbolName:f							
		-> [{#get. p. f}]
  |	primExprNormal:n "(" addExpr:i ")"							
		-> [{#access. n. i}]
  |   callExpr
  |	primExprHd


! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/20/2012 12:46'!
primExprOld =

	"old" "(" primExprNormal:s  ")"
		-> [{#old. s}]

! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 13:31'!
prioritizedConstraints  =
	// parse a single line consisting of constraint definitions, and return an array of prioritized constraints
	spaces (
		  comment -> [#()] 
		| constraintStmt
	)
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 13:34'!
prioritizedStatements  =
	
	prioritizedConstraints
  |	ometaRuleStmt
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 13:37'!
priority  =
	// a priority has the form 
	//		[weak] 
	// if omitted, it defaults to required
	"[" "priority" ":" name:p "]" -> [p asSymbol] | empty ->  [#required]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 23:41'!
quantExpr =

	<("all" -> [#forall] |  "exists" -> [#exists]):q 
		varsDecls:x "|" eol? quantExpr:z>:src
		-> [{q. x. z}]
  |	eqExpr! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 4/25/2012 22:58'!
relExpr =

	< relExpr:x	( ">=" -> [#gte] | ">" -> [#gt]  | "<=" -> [#lte]  | "<" -> [#lt] ):op	addExpr:y >:src	
		-> [{op. x. y}]
  |	addExpr! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'hs 9/26/2012 13:27'!
statementsMultiLine  =
	// prioritizedConstraints returns an array of constraints, so when we use '+' we get an ordered collection of arrays.
	// for the result, append these to just get an array
	
	eol* ((prioritizedStatements:cs eol?) -> [cs])+:collectionOfCs spaces
		-> [collectionOfCs inject: #() into: [:a :b | a , b] ]
! !

!CoopLangsSpecsParser methodsFor: 'contraint rules' stamp: 'AHB 6/23/2012 13:26'!
stays  =
	// a stay is of the form 
	//		var1, var2, var3 stay
	// or with an optional priority:
	//		[weak] var1, var2, var3 stay
	// and generates an array of stays on each variable 
	//		#( (stay p var1) (stay p var2) (stay p var3))
	// where p is the priority
	priority:p names:ns spaces ``stay''  -> [ns collect: [:n | {#stay. p.  n}]]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 9/26/2012 10:47'!
string =

	spaces $" (~$" char)*:cs $"	-> [String newFrom: cs]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/6/2012 17:56'!
symbolName =
	
	name:n
		-> [n asSymbol]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 12:54'!
symbolNames =

	symbolNames:xs "," symbolName:y
		-> [xs , {y}]
	| symbolName:x
		-> [{x}]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/7/2012 23:13'!
type  =

	symbolName:t (("(" names:p ")") -> [p] | empty -> [nil]):ps
		-> [CoopLangType of: t with: ps]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/7/2012 22:48'!
typedName  =

	symbolName:x ":" type:y
		-> [{x. y}]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/25/2012 23:52'!
typedNames =

	typedNames:xs "," typedName:y
		-> [xs , {y}]
	| typedName:x
		-> [{x}]
! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 12:55'!
unary =
		"-" postfix:p
			-> [{#minus. p}]
	|	"+" postfix:p
			-> [p]
	|	"!!" expr:p
			-> [{#not. p}]
	| 	higherFunCall
		! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 5/7/2012 22:39'!
varsDecl =

	names:xs ":" type:y
		-> [(xs collect: [:x | {#var. x. y}]) asArray]! !

!CoopLangsSpecsParser methodsFor: 'expression rules' stamp: 'hs 8/26/2012 18:17'!
varsDecls =

	varsDecls:xs "," varsDecl:y
		-> [xs , y]
	| varsDecl
! !

CoopLangsSpecsParser subclass: #CoopLangsThingsParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 5/7/2012 23:27'!
attr =

	varsDecl:n eol 
		-> [n collect: [:a | {#attribute. a second. a third}]]
	
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 4/25/2012 14:14'!
attributeSection  =
	indent(nil)
	    (``Attributes'' eol
			( indented(#attrs):as | empty -> [#()] )):s
				-> [{#attributes. s}]
		
	     ! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 5/18/2012 14:57'!
attrs  =
	indent(nil)
		(attr | comment eol -> [nil] )+:b 
			-> [ b inject: {} into: [:a :e | e isNil ifFalse: [ a := a , e ]. a ] ]	! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 6/7/2012 20:01'!
classDef :dummy =

		``class'':n typedName:x eol?
		( indented(#attributeSection):as | (empty->[#(attributes #())]):as )
		( indented(#constraintSection):cs | (empty->[#(constraints #())]):cs )
		-> [{#classDecl. x first. x second. as. cs}]
		
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'AHB 6/21/2012 19:30'!
constraintSection  =
	indent(nil)
	    ``Constraints'' eol
			( indented(#constraintsWithEols):cns
				 ->  [{#constraints. cns}] 
			 | empty 
				-> [#(constraints #())] )! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'AHB 6/23/2012 13:39'!
constraintsWithEols  =
	// one or more constraints, each on a separate line
	// prioritizedConstraints returns an array of constraints, so when we use '+' we get an ordered collection of arrays.
	// for the result, append these to just get an array
	indent(nil)
		(prioritizedConstraints:cs eol -> [cs])+:collectionOfCs
			-> [collectionOfCs inject: #() into: [:a :b | a , b] ]! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 8/25/2012 23:51'!
modelMember  =
	// a model member can be either a class definition or a strengths definition
	// we want the strengths definition to be here rather than in the problem, since the classDef may include constraint strengths
	indent(nil) (
	(classDef | relationDef | strengthsDef):def -> [def]
	)
	! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 5/23/2012 15:47'!
modelMembers  =
	modelMember(nil)*:ms
		-> [ms asArray]
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 6/7/2012 20:02'!
problemMember  =

	indent(nil) (
	(varDef):def -> [def]
	) 
		
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 9/26/2012 12:11'!
problemMembers  =

	problemMember(nil)*:ms
		-> [ms asArray]
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 5/23/2012 15:47'!
programModel  =
	( space | nl )* modelMembers:m ( space | nl )* end -> [m]
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 9/26/2012 12:11'!
programProblem  =

	( space | nl )* problemMembers:m ( space | nl )* end -> [m]
! !

!CoopLangsThingsParser methodsFor: 'as yet unclassified' stamp: 'hs 10/2/2012 16:49'!
relationDef :dummy =

		``relation'':n symbolName:x "(" typedNames:as ")" eol?
			( indented(#ruleSection):cs -> [true]:i | empty:cs -> [false]:i )
		-> [{#relationDecl. x. i. as. {#rules. cs}}]
		
! !

!CoopLangsThingsParser methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:59'!
ruleSection  =

	indent(nil)
	    ``Rules'' eol
			( indented(#ruleWithEols):cns
				 ->  [cns] 
			 )+:rs
		-> [rs asArray]! !

!CoopLangsThingsParser methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 11:49'!
ruleWithEols  =

	indent(nil)
	    symbolName:x "(" addExprs:as ")" "<--" eol
			( (indented(#constraintsWithEols) | empty->[nil]):cns
				 ->  [{#rule. x. as. cns}] 
			 )! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'AHB 6/26/2012 13:53'!
strengthsDef :dummy =
	// defines a list of strengths of soft constraints.  The first strength in the list is the required strength, and there is a
	// very strong convention that it is written (surprise) 'required'
	// NOTE: this is currently not used .....
	``Strengths'' names:ns eol -> [#(Strengths) , ns]
! !

!CoopLangsThingsParser methodsFor: 'rules' stamp: 'hs 6/7/2012 20:01'!
varDef :dummy  =

	 ``var'' varsDecl:z eol? -> [{#varDecl. z}]
		
! !

IdentityDictionary subclass: #CoopLangs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:28'!
instance

	" gives an instance of CoopLangs "
	
	^CoopLangs new! !

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'mg 5/9/2014 17:03'!
new

	^ super new initialize; yourself! !

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:28'!
newModel: m0

	" parses the text model (class defs) specification and gives an instance of CoopLangs "
	
	^CoopLangs new
		model: m0;
		yourself
! !

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:28'!
newModel: m0 andProblem: p0

	"  parses the text model (class defs) and problem (var defs) specification and gives an instance of CoopLangs "
	
	^CoopLangs new
		model: m0;
		problem: p0;
		yourself
! !

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:28'!
newProblem: p0

 	" parses the text problem (var defs) specification and gives an instance of CoopLangs "
	
	^CoopLangs new
		problem: p0;
		yourself
! !

!CoopLangs class methodsFor: 'as yet unclassified' stamp: 'hs 10/4/2012 17:06'!
newVariables: p0

 	" parses the text problem (var defs) specification and gives an instance of CoopLangs "
	
	^self newProblem: p0! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 15:27'!
classes

	^self at: #classes
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'mg 5/12/2014 10:13'!
defaultValueIfUndef: val ofType: tp

	" defaults if undefined "
	^(val isDictionary and: [val isEmpty])
		ifTrue: [ tp isPrimitive
				ifTrue: [ tp isReal
						ifTrue: [ 0.0 ]
						ifFalse: [ 0 ] 
				]
				ifFalse: [ tp isCollection 
						ifTrue: [ #() ]
						ifFalse: [ nil ] 
				] 
		]
		ifFalse: [ val ]
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'mg 5/12/2014 10:04'!
envAt: var

	^(self environment at: var ifAbsent: [IdentityDictionary new])
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 17:37'!
envAt: var ofType: tp

	"gets value in environment, if undefined uses default"

	| val |
	val := self envAt: var.
	^self defaultValueIfUndef: val ofType: tp
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 4/28/2012 22:30'!
envAt: var put: val

	^self environment at: var put: val
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/2/2012 12:33'!
envRemove: var

	^self environment removeKey: var
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 4/28/2012 22:31'!
environment

	^self "at: #environment"
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 8/24/2012 20:01'!
getAllAttributesAndInvariantsFor: c currentAttributes: ca currentInvariants: ci

	"computes all attributes and invariants for class based on inheritance hierarchy"
	"FIXME: Use bindingsOf: instead"

	| cp as is p |
	as := ca.
	is := ci.
	cp := c.
	[cp superclass = CoopLangsThing] whileFalse: [
		cp := cp superclass.
		p := cp classPool.
		as := as , (p at: #Attributes).
		is := is ,  (p at: #Invariants).
	].
	^{as. is}


! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 4/28/2012 13:57'!
getClass: c

	^(self at: #classes) at: c
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 10/4/2012 16:00'!
getRelation: r

	^(self at: #relations) at: r
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 16:35'!
hostProgram: p in: lang
	"defines a program given in a language"

	^self hostProgram: p in: lang options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:33'!
hostProgram: p in: lang modifiableObjects: objs modifiableAttributes: attrs
	"defines a program given in a language given modfiable relations"

	^self hostProgram: p in: lang modifiableVars: #() modifiableObjects: objs modifiableAttributes: attrs options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:24'!
hostProgram: p in: lang modifiableObjects: objs modifiableAttributes: attrs options: opts
	"defines a program given in a language given modfiable relations"

	^self hostProgram: p in: lang modifiableVars: #() modifiableObjects: objs modifiableAttributes: attrs options: opts
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:34'!
hostProgram: p in: lang modifiableVars: vars
	"defines a program given in a language given modfiable relations"

	^self hostProgram: p in: lang modifiableVars: vars modifiableObjects: #() modifiableAttributes: #() options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:35'!
hostProgram: p in: lang modifiableVars: vars modifiableObjects: objs modifiableAttributes: attrs
	"defines a program given in a language given modfiable relations"

	^self hostProgram: p in: lang modifiableVars: vars modifiableObjects: objs modifiableAttributes: attrs options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 16:33'!
hostProgram: p in: lang modifiableVars: vars modifiableObjects: objs modifiableAttributes: attrs options: x
	"defines a program given in a language given modfiable relations and run options for the language"

	^(self hostProgram: p in: lang options: x)
		modifiableVars: vars;
		modifiableObjs: objs;
		modifiableAttrs: (attrs collect: [:r | (r first , '_' , r second) asSymbol ]);
		yourself
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:20'!
hostProgram: p in: lang modifiableVars: vars options: opts
	"defines a program given in a language given modfiable relations"

	^self hostProgram: p in: lang modifiableVars: vars modifiableObjects: #() modifiableAttributes: #() options: opts
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 16:17'!
hostProgram: p in: lang options: x
	"defines a program given in a language"

	^(CoopLangsGuestProgram new) 
		language: lang; 
		program: (CoopLangsSpecsParser new matchAll: p with: #statementsMultiLine); 
		environment: self; 
		options: (IdentityDictionary newFromPairs: x);
		yourself
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:35'!
hostProgram: p in: lang  readOnlyObjects: objs readOnlyAttributes: attrs
	"defines a program given in a language given unmodfiable relations and run options for the language"

	^self hostProgram: p in: lang readOnlyVars: #() readOnlyObjects: objs readOnlyAttributes: attrs options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 22:19'!
hostProgram: p in: lang  readOnlyObjects: objs readOnlyAttributes: attrs options: opts
	"defines a program given in a language given unmodfiable relations and run options for the language"
	| vars |
	vars := self variables keys.
	^self hostProgram: p in: lang readOnlyVars: vars readOnlyObjects: objs readOnlyAttributes: attrs options: opts
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:36'!
hostProgram: p in: lang readOnlyVars: rVars
	"defines a program given in a language given unmodfiable relations and run options for the language"

	^self hostProgram: p in: lang readOnlyVars: rVars readOnlyObjects: #() readOnlyAttributes: #() options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:21'!
hostProgram: p in: lang readOnlyVars: rVars options: x
	"defines a program given in a language given unmodfiable relations and run options for the language"

	^self hostProgram: p in: lang readOnlyVars: rVars readOnlyObjects: #() readOnlyAttributes: #() options: x
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:39'!
hostProgram: p in: lang readOnlyVars: rVars readOnlyObjects: rObjs readOnlyAttributes: rAttrs
	"defines a program given in a language given unmodfiable relations"

	^self hostProgram: p in: lang readOnlyVars: rVars readOnlyObjects: rObjs readOnlyAttributes: rAttrs options: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'mg 5/12/2014 10:44'!
hostProgram: p in: lang readOnlyVars: rVars readOnlyObjects: rObjs readOnlyAttributes: rAttrs options: opts 
	"defines a program given in a language given unmodfiable relations"

	| rs vs mVars mAttrs mObjs classes variables rels rpAttrs |
	classes := self classes keys.
	vs := self variables.
	variables := vs keys.
	rs := self relations.
	rels := rs keys.
	rpAttrs := rAttrs collect: [:r | (r first , '_' , r second) asSymbol].
	mVars := variables select: [:x | (rVars includes: x) not].
	mAttrs := (rels select: [:x | (rpAttrs contains: x) not and: [ (classes contains: x) not and: [ (rs at: x) fn] ] ]) collect: [:rn | | r | r := (rs at: rn). {r domainType name. r name} ].
	mObjs := (variables select: [:x | | val | val := self envAt: x. (rObjs contains: val) not and: [ (vs at: x) isReference ] ]) collect: [:x | self envAt: x ].
	^self hostProgram: p in: lang modifiableVars: mVars modifiableObjects: mObjs modifiableAttributes: mAttrs options: opts
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:29'!
initialize

	"init the necessary environment info"
	CoopLangType initializePrimitives.
	^self
		at: #variables put: IdentityDictionary new;
		at: #relations put: IdentityDictionary new;
		at: #oldRelations put: IdentityDictionary new;
		at: #classes put: IdentityDictionary new;
		yourself
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 10/4/2012 16:36'!
model: m0

	" parses the text model (class defs) specification "

	| m variables relations classes oldRelations cr fr |
	m := CoopLangsThingsParser matchAll: m0 with: #programModel.
	variables := self at: #variables.
	relations := self at: #relations.
	oldRelations := self at: #oldRelations.
	classes := self at: #classes.
m do: [:i | 
	| rs  as cs asp csp aspcsp c s tmpClass pool sp isThingSubclass newm varm dtp  |
	rs := i second.
	(i first = #classDecl) ifTrue: [
	 "a class def " 
	as := i fourth second.
	cs := i fifth second. 
	c := rs.
	s := i third name. 
	isThingSubclass := s = #Thing.
	tmpClass := (isThingSubclass ifTrue: [ CoopLangsThing ] ifFalse: [ classes at: s ]) newUniClass.			
	pool := IdentityDictionary new.
	tmpClass classPool: pool.
	aspcsp := self getAllAttributesAndInvariantsFor: tmpClass currentAttributes: as currentInvariants: cs.
	asp := aspcsp first.
	csp := aspcsp second.
	pool at: #Environment put: self.
	pool at: #Attributes put: asp.
	pool at: #Invariants put: csp.
	pool at: #Instances put: OrderedCollection new.
	classes at: c put: tmpClass.
	sp := '', (Character lf) , (Character tab).
	dtp := CoopLangType of: c.
	cr := CoopLangRelation new id: c; name: c; type: {dtp}; head: {#o}; yourself.
	pool at: #Relation put: cr.
	relations at: c asSymbol put: cr.
	newm := 'initialize' , sp , '(self class classPool at: #Instances) add: self.' , sp , '(self class classPool at: #Relation) add: {self}.'.
	tmpClass compile: newm classified: '*generated'.
	varm := 'var: n' , sp , '(self class classPool at: #Environment) at: n put: self.' , sp , '^self'.
	tmpClass compile: varm classified: '*generated'.
	asp do: [:a | | n setm getm tpgetm tp isCol rn rno hd |
		n := a second.
		tp := a third.
		isCol := tp isCollection.
		setm := n, ': v' , sp, '| rel |' , sp , 'rel := self class classPool at: #' , n , 'Relation.' , sp , 'self at: #' , n, ' put: v.' , sp , (isCol ifTrue: ['rel removeTuplesFor: self.' , sp , 'v do: [:e | rel add: {self. e}].'] ifFalse: ['rel add: {self. v}.']) , sp , '^self'.
		getm := n, sp, '^self ksAt: #' , n.
		tpgetm := n, 'Type', sp, '^#' , tp name.
		tmpClass compile: setm classified: '*generated'.
		tmpClass compile: getm classified: '*generated'.
		tmpClass compile: tpgetm classified: '*generated'.
		rn := (c , '_', n) asSymbol.
		rno := (rn , '_old') asSymbol.
		hd := {#o. #f}.
		fr := CoopLangRelation new id: rn; name: n; type: {dtp. tp}; fn: isCol not; head: hd; yourself.
		relations at: rn put: fr.
		oldRelations at: rno put: 
			(CoopLangRelation new id: rno; name: n; type: {dtp. tp}; fn: isCol not; head: hd; yourself).
		pool at: (n , #Relation) asSymbol put: fr.
		]
	] ifFalse: [ | h tp hd intensional |
		" a relation def "
		intensional := i third.
		h := i fourth.
		hd := h collect: [:p | p first].
		tp := h collect: [:p | p second].
		relations at: rs put: (CoopLangRelation new id: rs; name: rs; type: tp; intensional: intensional;
			head: hd; body: i fifth second; yourself).
	]
	].
	^self
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 15:35'!
oldRelations

	^self at: #oldRelations
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 14:28'!
problem: m0

	" parses the text problem (variables) specification "

	| m variables relations classes oldRelations |
	m := CoopLangsThingsParser matchAll: m0 with: #programProblem.
	variables := self at: #variables.
	relations := self at: #relations.
	oldRelations := self at: #oldRelations.
	classes := self at: #classes.
	m do: [:i | 
		| rs |
		rs := i second.
		 "a variable def" 
		rs do: [:r | | s tp os |
			s := r second.
			tp := r third.
			variables at: s put: tp.
			os := (tp name , '_old') asSymbol.
			(oldRelations includesKey: os)
				ifFalse: [ 
					oldRelations at: os put: 
						(CoopLangRelation new id: os; 
							name: #old; type: {tp}; yourself)
				]
		] 
	].
	^self
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 15:52'!
relations

	^self at: #relations
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 13:45'!
resolveRelations

	^self resolveRelations: #()
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 13:45'!
resolveRelations: opts

	| p1 |
	p1 := self hostProgram: 'true
	' in: #Datalog readOnlyVars: #() options: opts.
	p1 runAndCommit.
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 16:48'!
variables

	^self at: #variables
! !

!CoopLangs methodsFor: 'as yet unclassified' stamp: 'hs 10/4/2012 17:05'!
variables: m0

	" parses the text problem (variables) specification "

	self problem: m0
! !

Matrix subclass: #PuzzleBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!PuzzleBoard commentStamp: 'tk 3/2/2013 09:01' prior: 0!
A PuzzleBoard is a Matrix.  It is the board where pieces with variables are placed.  The most common variable is position on the board.  

We are using Math coordinates.  Y is upward.  Y is the row number.  X is the column number.  (aPuzzleBoard at: row at: column) is confusing because it is really (aPuzzleBoard at: y at: x).  This reversal of x and y is a bit confusing.

If you think of a PuzzleBoard as a spreadsheet, it is upside down.  Row 1 is at the bottom and row 2 is above it. 

!

!PuzzleBoard class methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:14'!
extent: aPoint
	"Specify size using an integer point"
	
	^ self rows: aPoint x columns: aPoint y! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 09:02'!
atLoc: integerPoint
	"Index the board using a point with positive integers."
	
	^ self at: integerPoint y "row" at: integerPoint x "column"! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 09:02'!
atLoc: integerPoint ifInvalid: reply
	"Index the board using a point with positive integers."
	
	^ self at: integerPoint y "row" at: integerPoint x "column" ifInvalid: reply! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 09:03'!
atLoc: integerPoint put: value
	"Store into the board using a point with positive integers."
	
	^ self at: integerPoint y "row" at: integerPoint x "column" put: value! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/29/2013 21:04'!
emptyAtLoc: integerPoint
	"Return true of a piece can be placed in this square of the board"
	
	| res |
	res := self atLoc: integerPoint ifInvalid: #outOfBounds.
	res == #outOfBounds ifTrue: [^ false].
	^ (res == nil) or: [res isInteger]! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 09:04'!
extent
	"return the board size"
	
	^ self columnCount "x" @ self rowCount "y"! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 4/1/2013 16:16'!
locAfter: aPoint
	"return the location of the next square.  nil if off the end.  Move across a column (y) fastest."
	
	| pt |
	pt := aPoint + (1@0).
	pt x > ncols ifFalse: [^ pt].
	pt := 1 @ (aPoint y + 1).
	pt y > nrows ifTrue: [^ nil].
	^ pt
! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 09:06'!
slideToLowerLeft
	"Return translated copy that will have some occupied square in the first column and at least one in the first row.  Push all to the lower left.  Note that we are using Math coordinates with Y going upward."
	
	| thisSolution cnt |
	thisSolution := self.
	cnt := thisSolution rowCount + thisSolution columnCount.
	[((thisSolution atColumn: 1) occurrencesOf: nil) = thisSolution rowCount] whileTrue:
		["rotate the columns to the left"
		 thisSolution := thisSolution atRows: (1 to: thisSolution rowCount) 
				columns: (2 to: thisSolution columnCount), #(1).
		 (cnt := cnt - 1) < 0 ifTrue: [^ thisSolution]].	"no infinite loop"
	[((thisSolution atRow: 1) occurrencesOf: nil) = thisSolution columnCount] whileTrue:
		["rotate the rows up"
		 thisSolution := thisSolution atRows: (2 to: thisSolution rowCount), #(1) 
				columns: (1 to: thisSolution columnCount).
		 (cnt := cnt - 1) < 0 ifTrue: [^ thisSolution]].	"no infinite loop"
	^ thisSolution! !

!PuzzleBoard methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:19'!
squaresAround: loc
	"return the four adjoining square.  These share a side with the square at loc.  Do return squares that may be out of bounds."
	
	^ { loc + (1@0).  loc + (0@1).  loc + (-1@0).  loc + (0@ -1) }! !

Object subclass: #AreaTracer
	instanceVariableNames: 'prob board activeSqs activeIDs groupDict firstID groups sizeApprovalBlock result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!AreaTracer commentStamp: 'tk 3/7/2013 09:27' prior: 0!
An AreaTracer is the state used to incrementally and in parallel trace the blank areas on the board.  The sizeApprovalBlock tests whether an enclosed empty area is the right size for pieces to fit into.  For pentominoes, test if size is 0 mod 5. 
	Clever thing:  When there is only one area left (one group of IDs), we return true because it must be the rest of the board.  Usually we will only search the number of squares immediately around the new piece.  

Instance Variables
activeIDs
	- OC of ID numbers in squares in activeSqs. These are still being explored.  List is parallel to activeSqs.

activeSqs
	- OC of locations of squares.  Each has an ID in it now, and is waiting to search its surrounding 4 squares.

board
	- A Matrix from the problem

firstID
	- start of our range of IDs  (prob lastID)

groupDict
	- Dictionary (ID -> count of squares)

groups
	- OC of sets of IDs.  Squares of IDs in a set touch each other. 

prob
	- The problem description
	
sizeApprovalBlock
	- give it the size of an enclosed blank area and it will return true if that is OK.  False causes the entire search to return false (area is not 0 mod 5).!

!AreaTracer methodsFor: 'as yet unclassified' stamp: 'tk 3/8/2013 16:28'!
closeGroup: myID
	"All blank squares with this ID have been found.  Border is all other stuff.  If all IDs in this group closed, test its size"
	
	| cnt |
	groups do: [:setOfIDs |
		(setOfIDs includes: myID) ifTrue: [
			setOfIDs do: [:anID |
				(activeIDs includes: anID) ifTrue: [^ self]].
				"Group is still searching for blank squares"
			"entire group finished"
			cnt := 0.				
			setOfIDs do: [:anID |
				cnt := cnt + (groupDict at: anID)].
			(sizeApprovalBlock value: cnt) ifFalse: [
				^ result := false].
				"quit early -- no piece can fit into this hole"
			self ensureTwoGroups.
			^ result
			]].
	self error: 'id not found in any group'! !

!AreaTracer methodsFor: 'as yet unclassified' stamp: 'tk 3/7/2013 09:39'!
ensureTwoGroups
	"Count the groups that are still searching.  If less than 2, we are done."
	
	| cnt alive |
	groups size < 2 ifTrue: ["each alive or finished"
		^ result := true].
	cnt := 0.
	groups do: [:setOfIDs |
		alive := false.
		setOfIDs do: [:anID |
			(activeIDs includes: anID) ifTrue: [
				alive := true]].
			"Group is still searching for blank squares"
		alive ifTrue: [
			(cnt := cnt + 1) > 1 ifTrue: [^ self]].
		"entire group finished"
		].
	"only 1 group, and we know it has the right number of squares"
	^ result := true! !

!AreaTracer methodsFor: 'as yet unclassified' stamp: 'tk 3/7/2013 09:33'!
join: oneID with: otherID
	"these two groups touch.  Join them.  Test how many groups left."
	
	| gr1 gr2 |
	oneID = otherID ifTrue: [^ self].
	gr1 := groups detect: [:setOfIDs | setOfIDs includes: oneID].
	gr2 := groups detect: [:setOfIDs | setOfIDs includes: otherID].
	gr1 == gr2 ifTrue: [^ self].
	groups remove: gr1.
	gr2 addAll: gr1.
	self ensureTwoGroups.! !

!AreaTracer methodsFor: 'as yet unclassified' stamp: 'tk 3/7/2013 09:38'!
run
	"make some incremental search progress"
	
	| loc res myID |
	activeSqs isEmpty ifTrue: ["all areas found"
		"already checked the sizes of all closed groups"
		^ result := true].
	loc := activeSqs removeFirst.
	myID := activeIDs removeFirst.
	(board squaresAround: loc) do: [:ploc |
		res := board atLoc: ploc ifInvalid: #outOfBounds.
		res ifNil: [board atLoc: ploc put: -1.  res := -1].
		res isInteger 
			ifTrue: [res < firstID 
				ifTrue: ["add to this group"
					board atLoc: ploc put: myID.
					activeSqs addLast: ploc.
					activeIDs addLast: myID.
					groupDict at: myID put: (groupDict at: myID) + 1.
					]
				ifFalse: ["part of a group we are already counting"
					"don't count, but do join the groups"
					self join: myID with: res]]
			"ifFalse: [occupied or off the board]"
		].
	"see if this group is finished -- all squares found"
	(activeIDs includes: myID) ifFalse: [self closeGroup: myID].! !

!AreaTracer methodsFor: 'as yet unclassified' stamp: 'tk 3/7/2013 13:51'!
search: pieceSquares problem: prob approvalBlock: appBlock
	"look at all areas of empty squares around the piece.  when the size of an area is known, ask for approval (0 mod 5).  When there is only one area still being searched, we are done."

	| newID res |
	sizeApprovalBlock := appBlock.
	board  := prob board.
	activeSqs := OrderedCollection new.
	activeIDs := OrderedCollection new.
	groupDict := Dictionary new.
	firstID := prob lastID.
	groups := OrderedCollection new.
	
	newID := firstID - 1.
	"add initial squares around the piece"
	pieceSquares do: [:loc |
		(board squaresAround: loc) do: [:ploc |
			res := board atLoc: ploc ifInvalid: #outOfBounds..
			res ifNil: [board atLoc: ploc put: -1.  res := -1].
			res isInteger ifTrue: [
				res < firstID 
					ifTrue: ["fresh group"
						board atLoc: ploc put: (newID := newID + 1).
						prob lastID: newID + 1.
						activeSqs addLast: ploc.
						activeIDs addLast: newID.
						groupDict at: newID put: 1.
						groups addLast: (Set with: newID).
						]
					ifFalse: ["part of a group we just set up, don't count it twice"]
				]]].
	result := nil.
	[self run.	"may set result to true or false"
	 result == nil] whileTrue.
	^ result
	! !

!AreaTracer methodsFor: 'testing' stamp: 'tk 3/7/2013 13:49'!
test1
	" (AreaTracer new) test1; explore
	reject an area of 4"
	
	| pr filled |
	pr := FillTheBoard new.
	pr solver board: (PuzzleBoard rows: 5 columns: 5). 
	pr lastID: 1.
	filled := {3@1. 3@2. 3@3. 2@3. 1@3}.
	filled do: [:pt | pr board atLoc: pt put: $S].
	^ (self search: filled  "L pento"
		problem: pr 
		approvalBlock: [:cnt | cnt \\ 5 = 0]) = false! !

!AreaTracer methodsFor: 'testing' stamp: 'tk 3/7/2013 13:55'!
test2
	" (AreaTracer new) test2; explore
	accept a shape along an edge"
	
	| pr filled |
	pr := FillTheBoard new.
	pr solver board: (PuzzleBoard rows: 5 columns: 5). 
	pr lastID: 1.
	filled := {3@1. 2@1. 1@1. 1@2. 1@3}.
	filled do: [:pt | pr board atLoc: pt put: $S].
	^ (self search: filled  "L pento"
		problem: pr 
		approvalBlock: [:cnt | cnt \\ 5 = 0]) = true! !

!AreaTracer methodsFor: 'testing' stamp: 'tk 3/7/2013 13:56'!
test3
	" (AreaTracer new) test3; explore
	accept a shape with a pocket"
	
	| pr filled |
	pr := FillTheBoard new.
	pr solver board: (PuzzleBoard rows: 5 columns: 5). 
	pr lastID: 1.
	filled := {3@2. 2@2. 1@2. 1@3. 1@4}.
	filled do: [:pt | pr board atLoc: pt put: $S].
	^ (self search: filled  "L pento"
		problem: pr 
		approvalBlock: [:cnt | cnt \\ 5 = 0]) = true! !

!AreaTracer methodsFor: 'testing' stamp: 'tk 3/7/2013 13:57'!
test4
	" (AreaTracer new) test4; explore
	reject an area with a kitty corner open"
	
	| pr filled |
	pr := FillTheBoard new.
	pr solver board: (PuzzleBoard rows: 5 columns: 5). 
	pr lastID: 1.
	filled := {3@1. 3@2. 2@3. 1@3}.
	filled do: [:pt | pr board atLoc: pt put: $S].
	^ (self search: filled  "L pento"
		problem: pr 
		approvalBlock: [:cnt | cnt \\ 5 = 0]) = false! !

Object subclass: #CoopLang
	instanceVariableNames: 'program inputParser outputParser involvesOld'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLang class methodsFor: 'as yet unclassified' stamp: 'hs 6/2/2012 11:59'!
newProgram: p

	"comment stating purpose of message"

	|  res |
	res := self selectSolver: p.
	res program: p.
	^res! !

!CoopLang class methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 15:56'!
selectSolver: program
	"select the correct language/solver combination.  This is the method to extend with new solvers"
	
	| lang |
	lang := program language.
	lang = #Datalog ifTrue: [^CoopLangDatalog new].
	lang = #Z3 ifTrue: [^
		(program checkOption: #flatten)
			ifTrue: [CoopLangProblemFlattener new]
			ifFalse: [CoopLangZ3 new] ].
	lang = #Kodkod ifTrue: [^CoopLangKodkod new].
	lang = #Cassowary ifTrue: [^CoopLangCassowary new].
	lang = #OCassowary ifTrue: [^CoopLangOCassowary new].
	lang = #OMeta ifTrue: [^CoopLangOMeta new].
	self error: 'unable to find a solver for specified language ' , lang.
! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 18:56'!
addEditVars: editVars strengths: strengths
	"set up the solver to repeatedly change the values of editVar."
	self subclassResponsibility! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/26/2012 16:11'!
anyPostParsingEnvironmentActions
	
	"sometimes depending on whats's been parsed, we may need to set env accordingly. Default is no action. Subclasses can override"

	! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'mg 5/12/2014 10:18'!
applyModel: m to: env
	"applies the model (the result of calling the hosted program) to the environment"

	m do: [:itm | | var field idx val |
		var := itm first.
		field:= itm second.
		idx := itm third.
		val := itm fourth.
		field ifNil:
			 [ env at: var put: val]
			ifNotNil: [
				idx ifNil: [
						self object: var fieldAt: field put: val 
					]
					ifNotNil: [
						| o |
						o := self object: var fieldAt: field.
						(o size >= idx) ifTrue: [ "FIXME"
							o at: idx put: val
						]
					]
			]
	]! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 11:16'!
endIncrementalRun
	self subclassResponsibility! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/21/2012 00:36'!
envAt: v
	"gets value of var in env"

	| env |
	env := program environment.
	^env envAt: v ofType: (self getVarType: v)! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 17:34'!
envAt: v ofType: tp
	"gets value of var in env, if undefined defaults"

	| env |
	env := program environment.
	^env envAt: v ofType: tp"env at: v"! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'AHB 5/2/2012 17:57'!
environment: env
	"given the environment, sets the environment in the language of the hosted program"
	self subclassResponsibility! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 18:37'!
getRelation: r
	"get named relation representing a field of a class"

	^self getRelation: r isOld: false! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 18:36'!
getRelation: r isOld: o
	"get named relation representing a field of a class"

	| rels env |
	env := program environment.
	rels := o ifTrue: [ env oldRelations ] ifFalse: [ env relations ].
	^(rels at: r)! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/10/2012 16:52'!
getRelationsForClass: c
	"get relations representing fields of a class"

	| rels env |
	env := program environment.
	rels := env relations.
	^rels select: [:x | x class = CoopLangRelation 
		and: [x domainType name = c ] ]! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:25'!
getVarType: v
	"gets class name for named id"

	| vars env |
	env := program environment.
	vars := env variables.
	^(vars at: v)! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/19/2012 23:58'!
getVarValueAndType: v
	"gets value and class name for named id"

	| vars env |
	env := program environment.
	vars := env variables.
	^{self envAt: v. vars at: v}! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'AHB 5/4/2012 14:31'!
initParsers
	"initializes input and output parsers"
	| in out |
	in := self inputParserClass.
	out := self outputParserClass.
	in notNil ifTrue: 
		[inputParser := in new.  inputParser program: self].
	out notNil ifTrue: 
		[outputParser := out new.  outputParser program: self].
	! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/4/2012 00:14'!
instancesOf: c
	"get all class c's instances"

	^(program environment classes at: c) classPool at: #Instances! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/4/2012 00:29'!
invariantsOf: c
	"get all class c's instances"

	^(program environment classes at: c) classPool at: #Invariants! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:06'!
involvesOld

	^involvesOld! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:06'!
involvesOld: b

	^involvesOld := b! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:01'!
isModifiableAttr: rel
	"is relation marked as modifiable"

	^program isModifiableAttr: rel! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:02'!
isModifiableObj: o
	"is object marked as modifiable"

	^program isModifiableObj: o! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:16'!
isModifiableVar: var
	"is variable marked as modifiable"

	^program isModifiableVar: var! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 18:42'!
isOldRelation: r
	"get named relation representing value of field of a class. say if represents old value"

	^program environment oldRelations includesKey: r! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 00:28'!
isScalar: x

	| env res |
	env := program environment.
	res := env variables includesKey: x.
	^res
! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 4/28/2012 15:07'!
object: o fieldAt: f
	"accessor for field f of object o"

	
	^o perform: f
						! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 17:38'!
object: o fieldAt: f ofType: tp
	"accessor for field f of object o. if undefined use default value 0 or nil depending on type"

	| val |
	val := o perform: f.
	^program environment defaultValueIfUndef: val ofType: tp

						! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 4/28/2012 15:07'!
object: o fieldAt: f put: v
	"setter for field f of object o"

	
	^o perform: ((f , ':') asSymbol) with: v 
						! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/4/2012 00:21'!
parse: program
	"given raw hosted program, translates it to one understood by hosted language"
	self subclassResponsibility! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/10/2012 01:49'!
parseOutput: out
	"Parses raw output from hosted program to construct the model.  If 'outputParser' is nil, then return the output unchanged."

	| outp |
	outputParser isNil ifTrue: [^out].
	outp := outputParser matchAll: out with: #model.
	"Transcript show: outp."
	^outp! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:43'!
program

	^program! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:44'!
program: p

	program := p! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/10/2012 01:50'!
resetParsers

	"FIXME!! ometa caches results, we don't want that since our parsers have state!!"
	inputParser forgetEverything! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 18:09'!
resolveAndCommit
	self subclassResponsibility! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 16:11'!
run
	"runs the given program: first parses the raw program into one understood by hosted language, then executes it, the parses the output and applies the model to environment"

	| out model env | 
	(program checkOption: #debug) ifTrue: [
		program printModifiables.
	].
	env := program environment.
	self initParsers.
	self environment: env.
	self parse: program program.
	self anyPostParsingEnvironmentActions.
	out := self execute.
	"Transcript show: out."
	model := self parseOutput: out.
	"(program checkOption: #debug)
		ifTrue: [ Transcript show: model ]."
	 ^model! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 08:10'!
runAndCommit
	"runs the given program: first parses the raw program into one understood by hosted language, then executes it, the parses the output and applies the model to environment"

	| model | 
	model := self run.
	model isNil ifTrue: [^false].
	self applyModel: model to: program environment environment.
	"Transcript show: model."
	 ^model! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 18:59'!
setupIncrementalRun: editVars
	"Incremental version of run -- see the comment for setupIncrementalRun: strengths:
	 The default is that all edits are required."
	self setupIncrementalRun: editVars strengths: (Array new: editVars size withAll: ClStrength required)! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 18:55'!
setupIncrementalRun: editVars strengths: strengths
"Incremental version of run.  First parses the raw program into one understood by hosted language, then sets up the solver for repeatedly solving a problem incrementally involving changing the values of the variables in editVars.  This is done using constraints of the given strength for each variable.  editVars is an array of names of variables, and strengths is an array of the same size of strengths for the edit constraint on the corresponding variable."

	| env | 
	(program checkOption: #debug) ifTrue: [
		program printModifiables.
	].
	env := program environment.
	self initParsers.
	self environment: env.
	self parse: program program.
	self anyPostParsingEnvironmentActions.
	self addEditVars: editVars strengths: strengths! !

!CoopLang methodsFor: 'as yet unclassified' stamp: 'hs 5/4/2012 00:32'!
translateInvariants
	"return a string that is the translation of any invariants - default is to do nothing"
	
	^''! !

!CoopLang methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 11:23'!
updateValue: v newValue: x
	"update the value for variable v"
	self subclassResponsibility! !

CoopLang subclass: #CoopLangCassowary
	instanceVariableNames: 'variables constraints cassowarySolver requiredEditVarValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangCassowary commentStamp: 'hs 5/25/2012 12:29' prior: 0!
A CoopLangCassowary is a CoopLang as an API to Cassowary linear arithmetic solver.

Instance Variables
	constraints:		<Object>
	solver:		<Object>
	variables:		<Object>

constraints
	- xxxxx

solver
	- xxxxx

variables
	- xxxxx
!

!CoopLangCassowary methodsFor: 'evaluation' stamp: 'AHB 8/1/2012 15:08'!
addConstraints
"Add all constraints to the Cassowary solver.  (Note that this won't include edit constraints that are temporarily added later if we're doing incremental solving.)"
	| env cn |
	"For variables that aren't modifiable, add constraints to require them to have their given values.  (Otherwise Cassowary may set them to 0.)"
	env := self program environment environment.
	self program environment variables keys do: 
		[:k | (self isModifiableVar: k) ifFalse: [
			"get the current value of val, in case it is an event stream (this returns self otherwise, so works for any object as well)"
			cn := (variables at: k) cnEqual: (env at: k) currentValue.
			cassowarySolver addConstraint: cn]].
	"add the constraints for the given program"
	constraints do: [:c | cassowarySolver addConstraint: c].
! !

!CoopLangCassowary methodsFor: 'incremental solving' stamp: 'AHB 7/29/2012 14:51'!
addEditVars: editVars strengths: strengths
	"set up the solver to repeatedly change the values of editVar."
	| model realStrength |
	self addConstraints.
	"requiredEditVarValues is a dictionary whose keys are variables with a required edit constraint, and whose values 
	 will be the value assigned to the corresponding variable.  Since Cassowary itself only handles soft edit constraints,
	 we make these very high strength (but not required).  Then, after we're done solving, we check that the variables
	 do have the values they were asssigned.  Initially we just put a nil in the dictionary."
	requiredEditVarValues := IdentityDictionary new.
	editVars with: strengths do: [:v :s | 
		s isRequired ifTrue: [realStrength := ClStrength virtuallyRequired.  requiredEditVarValues at: v put: nil] ifFalse: [realStrength := s].
		cassowarySolver addEditVar: (variables at: v) strength: realStrength].
	cassowarySolver solve.
	model := self computeModel.
	self applyModel: model to: program environment environment.
	cassowarySolver beginEdit.
! !

!CoopLangCassowary methodsFor: 'incremental solving' stamp: 'AHB 7/27/2012 17:14'!
cassowarySolver
	^cassowarySolver! !

!CoopLangCassowary methodsFor: 'evaluation' stamp: 'AHB 7/28/2012 17:55'!
computeModel
	"Return a dictionary mapping the modified variables to their new values.  This is already
	in the form expected for the parsed output."
	^ program modifiableVars collect: [:v | {v. nil. nil. (variables at: v) value}].
! !

!CoopLangCassowary methodsFor: 'incremental solving' stamp: 'AHB 7/28/2012 11:16'!
endIncrementalRun
	cassowarySolver endEdit! !

!CoopLangCassowary methodsFor: 'evaluation' stamp: 'AHB 7/27/2012 17:13'!
environment: env
	"Given the environment, sets the environment in the language of the hosted program.
	For Cassowary, we get the names of the variables and use them as keys in a dictionary of CLVariables that
	is stored the dictionary 'variables' and also in the input parser."
	"check that all constraints are on reals"
	env variables do: [:tp | tp isReal ifFalse: 
		[self error: 'Cassowary solver can only solve problems with real numbers - invoked on a variable with type ' , tp name]].
	"Set autoSolve to false -- then we don't resatisfy after adding the initial constraints.  There is a call to 'solve' in execute because of this."
	cassowarySolver := ClSimplexSolver new autoSolve: false..
	variables := IdentityDictionary new.
	"make all variables be 0 initially (not sure this is totally necessary ...)"
	env variables keysDo: [:k | variables at: k put: (ClVariable newWith: 0.0 name: k)].
	inputParser variables: variables
	! !

!CoopLangCassowary methodsFor: 'evaluation' stamp: 'AHB 7/28/2012 17:55'!
execute
	"invoke Cassowary on the given set of constraints and environment"
	self addConstraints.
	cassowarySolver solve.   "need to invoke solve explicitly since autoSolve is off for the Cassowary solver"
	^self computeModel! !

!CoopLangCassowary methodsFor: 'parser classes' stamp: 'AHB 5/4/2012 14:35'!
inputParserClass
	^CoopLangCassowaryInputParser! !

!CoopLangCassowary methodsFor: 'parser classes' stamp: 'AHB 5/4/2012 14:35'!
outputParserClass
	^nil! !

!CoopLangCassowary methodsFor: 'evaluation' stamp: 'hs 6/18/2012 01:13'!
parse: program
	"Given raw hosted program, translates it to one understood by hosted language.
	  For Cassowary, we generate a collection of constraints based on the input program."
	constraints := inputParser matchAll: program with: #programExpr! !

!CoopLangCassowary methodsFor: 'incremental solving' stamp: 'AHB 7/29/2012 15:17'!
resolveAndCommit
	| model |
	cassowarySolver resolve.
	"check that for all required edits we managed to set the variables to the desired values"
	requiredEditVarValues keysAndValuesDo: [:var :desiredValue | ((variables at: var) value clApprox: desiredValue) ifFalse: [ClError requiredFailure signal]].
	"in general the solvers need to parse the output - but for Cassowary this is already done"
	model := self computeModel.
	self applyModel: model to: program environment environment.! !

!CoopLangCassowary methodsFor: 'incremental solving' stamp: 'AHB 7/29/2012 14:54'!
updateValue: var newValue: x
	"Update the value for variable var.  If the edit constraint is required, save the value also so that we can check that
	 the variable was in fact set t that value after solving all the constraints."
	cassowarySolver suggestValue: (variables at: var) newValue: x.
	(requiredEditVarValues includesKey: var) ifTrue: [requiredEditVarValues at: var put: x]! !

CoopLang subclass: #CoopLangDatalog
	instanceVariableNames: 'toAtomMap fromAtomMap atomCtr translatedProgram translatedFacts relationsToResolve'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:06'!
addAtom: item

	| idp |
	idp := (#A , atomCtr) asSymbol.
	toAtomMap at: item  put: idp.
	fromAtomMap at: idp put: item.
	atomCtr := atomCtr + 1.
	^idp! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:06'!
applyModel: m to: env
	"applies the model (the result of calling the hosted program) to the environment intensional relations"

	| rels |
	rels := env relations.
	m do: [:itm | | relN tuples r |
		relN := itm first.
		tuples := itm second.
		r := rels at: relN.
		r addAll: tuples.
	].! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 15:24'!
available

	^FileDirectory default fileExists: self binary! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/27/2012 18:35'!
binary

	"path to Datalog engine binray file"

	^'/usr/local/bin/logicblox'.
! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:49'!
environment: environment

	| rels vars cs part0 part1 part2 nl def0 def1 first intensional |
	relationsToResolve := nil.
	cs := environment classes.
	rels := environment relations.
	vars := environment variables.
	part0 := WriteStream with: ''.
	part1 := WriteStream with: ''.
	part2 := WriteStream with: ''.
	nl := Character lf.
	self setPrimitivesEnv.
	cs associationsDo: [:a |  | cid is num |
		cid := a key.
		is := self instancesOf: cid.
		num := is size.
		num > 0 ifTrue: [ is do: [:ai | self addAtom: ai ] ].
		part0 nextPutAll: (cid , '(o), has' ,  cid , 'Name(o:s) -> string(s).' , nl).
	].
	rels do: [:r | | rn rtp prims vp arity hd ps fn cl |
		rn := r id.
		hd := r head.
		rtp := r type.
		arity := rtp size.
		first := true.
		intensional := r intensional.
		cl := cs includesKey: rn.
		fn := r fn.
		ps := ''.
		def0 := ''.
		def1 := ''.
		1 to: arity do: [:j | | pn pt xtra |
			pn := hd at: j.
			pt := rtp at: j.
			intensional ifTrue: [ vars at: pn put: pt ].
			xtra := first ifTrue: [''] ifFalse: [', '].
			ps := ps , xtra , pn.
			def1 := def1 , xtra , (self toDatalogType: pt) , '(' , pn , ')'.
			first := false.
			].
		cl ifFalse: [
			part0 nextPutAll: (rn , 
				(fn ifTrue: [ '[' , hd first first , '] = ' , hd second first ] 
				    ifFalse: [ '(' ,  ps , ')']) , ' -> ' , def1 , '.' , nl).
			].
		intensional 
			ifTrue: [
				relationsToResolve := relationsToResolve isNil ifTrue: [ rn ] ifFalse: [ relationsToResolve , ',' , rn ].
				part2 nextPutAll: (inputParser matchAll: r body with: #programExpr) , nl.
			] ifFalse: [
			prims := rtp collect: [:z | z isNumeric ].
			cl ifFalse: [
			r tuples do: [:v | | ip |
				ip := v at: 1.
				vp := '', ((prims at: 1) ifTrue: [ip] ifFalse: ['"' , (toAtomMap at: ip) , '"' ]).
				2 to: arity do: [:i | 
					ip := v at: i.
					vp := vp , ', ' , ((prims at: i) ifTrue: [ip] ifFalse: ['"' , (toAtomMap at: ip) , '"' ]).
					]. 
				part1 nextPutAll: ('+' , rn , '(' ,  vp ,').' , nl). 
				]. 
			]. 
		].
	].
	translatedProgram := part0 contents , part2 contents.
	translatedFacts :=  part1 contents.
	^true! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:37'!
execute
	"executes external solvers binary on given program given environment env"

	| bin out proc |
	(program checkOption: #mockOutput) 
		ifTrue: [ out := program getOption: #mockOutput ]
		ifFalse: [
			bin := self binary.
			(FileDirectory default fileExists: bin) 
				ifTrue: [ | programFile factsFile cmd |
					programFile := FileStream forceNewFileNamed: '/tmp/lb-program.logic'.
					factsFile := FileStream forceNewFileNamed: '/tmp/lb-facts.logic'.
					programFile nextPutAll: translatedProgram.
					factsFile nextPutAll: translatedFacts.
					programFile close.
					factsFile close.
					cmd := bin , ' "' , relationsToResolve , '" compile'.
					(program checkOption: #debug)
						ifTrue: [ 
							Transcript show: (translatedProgram , translatedFacts). 
							Transcript show: cmd.
							]. 
					proc := PipeableOSProcess command: cmd.
					out := proc output.
					(program checkOption: #debug)
						ifTrue: [ Transcript show: out. ]. 
					proc closePipes ]
				ifFalse: [ 
					"self error: ('oops binary not here: ') "
					self error: 'sorry, since no real datalog engine binary is found, please use option #mockOutput to stub the output.'.
					]
		].
	^out! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:06'!
initParsers

	"initializes input and output parsers"
	
	super initParsers.
	toAtomMap := IdentityDictionary new.
	fromAtomMap := IdentityDictionary new.
	inputParser toAtomMap: toAtomMap.
	inputParser fromAtomMap: fromAtomMap.
	outputParser toAtomMap: toAtomMap.
	outputParser fromAtomMap: fromAtomMap.
! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:07'!
inputParserClass

	^CoopLangDatalogInputParser! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:07'!
outputParserClass

	^CoopLangDatalogOutputParser! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:06'!
parse: program
	"given raw hosted program, translates it to one understood by hosted language"

	! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:07'!
setPrimitivesEnv
	"for the environment in the language of the hosted program sets up the primitive types: null."

	atomCtr := 0.
	({nil. true. false}) do: [:i | self addAtom: i ].
	^atomCtr
	! !

!CoopLangDatalog methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 13:57'!
toDatalogType: tp

	^tp isNumeric ifTrue: [tp isInt ifTrue: [#'uint[8]'] ifFalse: [#'float[64]'] ] ifFalse: [tp base name].! !

CoopLang subclass: #CoopLangExternal
	instanceVariableNames: 'translatedProgram translatedEnvironmentTypes translatedEnvironmentDefs translatedEnvironmentAssertions translatedOldEnvironmentDefs translatedOldEnvironmentAssertions translatedProgramHead translatedProgramTail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangExternal methodsFor: 'as yet unclassified' stamp: 'hs 5/27/2012 14:34'!
anyPostParsingEnvironmentActions

	" assert old values are unchanged "
	
	 involvesOld isNil ifFalse: 
		[
			translatedEnvironmentDefs := translatedEnvironmentDefs , 
				translatedOldEnvironmentDefs.
			translatedEnvironmentAssertions := translatedEnvironmentAssertions ,
				translatedOldEnvironmentAssertions.
		].
				! !

!CoopLangExternal methodsFor: 'executing' stamp: 'mg 5/9/2014 15:08'!
execute
	"executes external solvers binary on given program given environment env"

	| out proc bin parms fullProgram |
	bin := self binary.
	(FileDirectory default fileExists: bin) 
		ifTrue: [
			parms := self binaryParams.
			fullProgram := 
				translatedProgramHead , 
				translatedEnvironmentTypes ,
				translatedEnvironmentDefs , 
				translatedEnvironmentAssertions , 
				translatedProgram , 
				translatedProgramTail.
			(program checkOption: #debug)
				ifTrue: [ Transcript show: fullProgram ].
			OSProcess isWindows
				ifFalse: [
					proc := PipeableOSProcess command: 'echo ''' , fullProgram , ''' | ' , bin ,  parms.
					out := proc output.
					proc closePipes]
				ifTrue: [
					(StandardFileStream forceNewFileNamed: 'tmp.smt2') nextPutAll: fullProgram; close.
					proc := ExternalWindowsOSProcess command: 'cmd /c ', bin, parms, ' tmp.smt2 > out.z3'.
					[proc update: #runState. proc isRunning] whileTrue: [(Delay forMilliseconds: 50) wait].
					out := (StandardFileStream readOnlyFileNamed: 'out.z3') upToEnd.
				]
		]
		ifFalse: [ self error: ('oops binary not here: ' ,  bin) ].
	^out! !

!CoopLangExternal methodsFor: 'parsing' stamp: 'hs 6/18/2012 00:58'!
parse: program
	"given raw hosted program, translates it to one understood by hosted language"

	| part2 part1 nl |
	translatedProgram isNil ifTrue: [
		nl := Character lf.
		part2 := (inputParser matchAll: program with: #programExpr) , nl.
		part1 := self translateInvariants.
		translatedProgram :=  part1 , part2.
	]! !

CoopLangExternal subclass: #CoopLangKodkod
	instanceVariableNames: 'toAtomMap fromAtomMap idCtr atomCtr upperbounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangKodkod commentStamp: 'AHB 8/15/2012 15:46' prior: 0!
A CoopLangKodkod is  CoopLang as an API to Kodkod SAT-based relational 1st order solver.

To run Kodkod examples:
	1) Download Kokod's text interface called Kodkodi from:
		http://www4.in.tum.de/~blanchet/kodkodi-1.5.2.tgz
	2) Assuming the location where you installed kodkodi is $tool; and $platform is 'darwin' for mac, 'linux' for linux, and 'cygwin' for windows; write a script called /usr/local/bin/kodkodi with this content:
		'java -cp $tool/jar/kodkod-1.5.jar:$tool/jar/kodkodi-1.5.2.jar:$tool/jar/antlr-runtime-3.1.1.jar -Djava.library.path=$tool/jni/x86-$platform de.tum.in.isabelle.Kodkodi.Kodkodi' 



Instance Variables
	atomCtr:		<Object>
	fromAtomMap:		<Object>
	idCtr:		<Object>
	toAtomMap:		<Object>
	upperbounds:		<Object>

atomCtr
	- xxxxx

fromAtomMap
	- xxxxx

idCtr
	- xxxxx

toAtomMap
	- xxxxx

upperbounds
	- xxxxx
!

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:59'!
SATSolver

	^#MiniSat! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:59'!
addAtom: item

	| idp |
	idp := (#A , atomCtr) asSymbol.
	toAtomMap at: item  put: idp.
	fromAtomMap at: idp put: item.
	atomCtr := atomCtr + 1.
	^idp! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/29/2012 16:09'!
addRel: item prefix: p

	| idp |
	idp := (p , idCtr) asSymbol.
	toAtomMap at: item put: idp.
	fromAtomMap at: idp put: item.
	idCtr := idCtr + 1.
	^idp! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 01:53'!
binary

	"path to Kodkod solver binray file"

	| res |
	res := '/usr/local/bin/kodkodi'.
	^res! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/3/2012 01:54'!
binaryParams
	"command line parameters to call binary with"

	^''! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 13:36'!
environment: env
	"given the environment, sets the environment in the language of the hosted program"

	| vars rels cs part1 part2 part3 part4 part2o nl ints min univ intBnds |
	self setPrimitivesEnv.
	nl := Character lf.
	vars := env variables.
	cs := env classes.
	rels := env relations.
	ints := 2 bitShift: (self intBitWidth - 1).
	min := (2 bitShift: (self intBitWidth - 2)) negated.
	part1 := ''.
	part2 := WriteStream with: ''.
	part3 := WriteStream with: ''.
	part4 := WriteStream with: ''.
	part2o := WriteStream with: ''.
	cs associationsDo: [:a | | cid is idp num up |
		cid := a key.
		is := self instancesOf: cid.
		num := is size.
		num > 0 ifTrue: [
			up := nil.
			idp := self addRel: cid prefix: #s.
			up := #u , num , '@' , atomCtr.
			part2 nextPutAll:  'bounds ', idp , ' /* class ' , cid , ' */: ' , up , nl.
			is do: [:ai | self addAtom: ai ].
			upperbounds at: cid put: up.
		]
	].
	univ := #u , atomCtr.
	part1 := 'solver: "' , self SATSolver , '"' , nl ,
			  'bit_width: ' , self intBitWidth , nl ,
                    'univ: ', univ , nl.
	vars associationsDo: [:a |
		| tp tp1 tp2 r id idp idpo sym  |
		id := a key.
		tp := a value.
		tp2 := tp base name.
		sym := #s.
		r := env envAt: id ofType: tp.
		idp := self addRel: id prefix: sym.
		idpo := self addRel: (id , '_old') asSymbol prefix: sym.
		part2o nextPutAll:  'bounds ', idpo , ' /* ', tp , ' ' , id , '_old */: '.
		part2o nextPutAll:  '{[', (toAtomMap at: r), ']' , '}', nl.
		part2 nextPutAll:  'bounds ', idp , ' /* ', tp , ' ' , id , ' */: '.
		(self isModifiableVar: id) 
			ifTrue: [
				part4 nextPutAll:  ' one ' , idp , ' && '. 
				part2 nextPutAll:  '[{}, ', (upperbounds at: tp2) , ']' , nl ]
			ifFalse: [ 
				part2 nextPutAll:  '{[', (toAtomMap at: r), ']' , '}', nl.
			]
	].
	rels associationsDo: [:a |
		| tp tp0 tp1 tp2 isCol id idp idpo sym add f |
		id := a key.
		tp := a value.
		(tp unary) ifFalse: [
		tp0 := tp name.
		tp1 := tp domainType name.
		(self instancesOf: tp1) isEmpty ifFalse: [
		tp2 := tp rangeType.
		isCol := tp2 isCollection.
		sym := #r.
		idp := self addRel: id prefix: sym.
		idpo := self addRel: (id , '_old') asSymbol prefix: sym.
		part2 nextPutAll:  'bounds ', idp , ' /* ', tp2 , ' ' , id , ' */: '.
		part2o nextPutAll:  'bounds ', idpo , ' /* ', tp2 , ' ' , id , '_old */: '.
		add := WriteStream with: ''.
		f := true.
		(self instancesOf: tp1) do: [:o |
			add nextPutAll: (f ifTrue: [f := false. ''] ifFalse: [', ']) , 
				(self translateObject: o fieldAt: tp0 ofType: tp2 isCollection: isCol).
		].
		part2o nextPutAll: '{' , add contents , '}', nl.
		(self isModifiableAttr: id) 
			ifTrue: [
				| low dom up |
				dom := upperbounds at: tp1.
				up := upperbounds at: tp2 base name.
				low := WriteStream with: ''.
				f := true.
				(self instancesOf: tp1) do: [:o | 
					(self isModifiableObj: o) 
						ifFalse: [ | add1 |
							add1 := self translateObject: o fieldAt: tp0 ofType: tp2 isCollection: isCol. 
							low nextPutAll: (f ifTrue: [f := false. ''] ifFalse: [', ']) , add1 ] ].
				isCol ifFalse: [ part4 nextPutAll: '  FUNCTION(' , idp , ', ' , dom , '->one ', up , ') && ' ].
				part2 nextPutAll:  '[{' , low contents , '} , ', dom , '->', up , ']' , nl ]
			ifFalse: [ 
				part2 nextPutAll: '{' , add contents , '}', nl. ] ]
		]
	].
	part3 nextPutAll: '{A0}'.
	(1 to: (ints - 1)) do: [:i | part3 nextPutAll: (', {A' , i , '}') ].
	intBnds := 'int_bounds: ' , min , ': [' ,  part3 contents , ']' , nl.
	translatedProgramHead := part1.
	translatedProgramTail := ';' , nl.
	translatedEnvironmentTypes := ''.
	translatedEnvironmentDefs := part2 contents.
	translatedEnvironmentAssertions := intBnds , 'solve ' , part4 contents.
	translatedOldEnvironmentDefs := part2o contents.
	translatedOldEnvironmentAssertions := ''.! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:39'!
initParsers

	"initializes input and output parsers"
	
	super initParsers.
	toAtomMap := IdentityDictionary new.
	fromAtomMap := IdentityDictionary new.
	upperbounds := IdentityDictionary new.
	inputParser toAtomMap: toAtomMap.
	inputParser fromAtomMap: fromAtomMap.
	inputParser upperbounds: upperbounds.
	outputParser toAtomMap: toAtomMap.
	outputParser fromAtomMap: fromAtomMap.
! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:24'!
inputParserClass

	^CoopLangKodkodInputParser! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 12:19'!
intBitWidth

	| opts |
	opts := program options.
	^(opts isNil not and: [opts includesKey: #intBitWidth]) 
		ifTrue: [ opts at: #intBitWidth ]
		ifFalse: [ 6 ]! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:00'!
liftToQuantExpr: e over: c

	^'(all [' , (toAtomMap at: #this),  ' : one ', (upperbounds at: c), '] | ', e, ')'! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:24'!
outputParserClass

	^CoopLangKodkodOutputParser! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 14:03'!
removeVar: item

	"FIXME"
	idCtr := idCtr - 1.
	program environment variables removeKey: item.! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/16/2012 14:24'!
setPrimitivesEnv
	"for the environment in the language of the hosted program sets up the primitive types: ints, bools, etc."

	|  t0 min max ints |
	"Transcript show:  'Kodkod set env ' , env."
	atomCtr := 0.
	idCtr := 0.
	t0 := 2 bitShift: (self intBitWidth - 2).
	max := t0 - 1.
	min := t0 negated.
	ints := max - min + 1.
	((min to: max) , {true. false. nil}) do: [:i | self addAtom: i ].
	upperbounds at: #Int put: #u , ints.
	upperbounds at: #Bool put: #u , 2 , #@ , ints. 
	^atomCtr
	! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:31'!
translateInvariants

	| env vars part1 el cs expand |
	part1 := WriteStream with: ''.
	el := ' && '.
	env := self program environment.
	vars := env variables.
	cs := env classes.
	expand := program checkOption: #instantiateQuantifiers.
	cs keys do: [:cid | | insts cinvs |
		insts := self instancesOf: cid.
		insts isEmpty ifFalse: [
			cinvs := self invariantsOf: cid.
			vars at: #this put: (CoopLangType of: cid).
			expand
				ifTrue: [
					insts do: [:o | 
						toAtomMap at: #this put: (toAtomMap at: o). "HACK FIXME"
						cinvs do: [:cinv |
							part1 nextPutAll: ('(' , 
								(inputParser match: cinv third with: #expr) , ')') , el.
						].
						"FIXME: seems like ometa parser caches results we don't want that because parsing on different toatommap but same input may result in different output!!"
						self resetParsers.
					]
				]
				ifFalse: [ 
					self addRel: #this prefix: #S.
					cinvs do: [:cinv |
						part1 nextPutAll: (self liftToQuantExpr: 
							(inputParser match: cinv third with: #expr) over: cid) , el.
					].
					"FIXME: seems like ometa parser caches results we don't want that because parsing on different toatommap but same input may result in different output!!"
					self resetParsers.
				].
				self removeVar: #this. "HACK FIXME!!"
			]
	].
	^part1 contents! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:41'!
translateObject: o fieldAt: f ofType: tp isCollection: c

	| res val op |
	val := self object: o fieldAt: f ofType: tp.
	op := toAtomMap at: o.
	res := ''.
	c ifTrue: [
		val isEmpty ifFalse: [
			res := '['  , op, ',' , (self translateValue: val first) , ']'.
			val allButFirst do: [:v | res := res , ', ['  , op, ',' , (self translateValue: v) , ']' ]
		]
	]
	ifFalse: [
		res := '['  , op, ',' , (self translateValue: val) , ']'.
	].
	^res! !

!CoopLangKodkod methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 13:48'!
translateValue: val
	"translation of value for kodkod"

	^(toAtomMap includesKey: val) 
		ifTrue: [toAtomMap at: val]
		ifFalse: [self addAtom: val]! !

CoopLangExternal subclass: #CoopLangZ3
	instanceVariableNames: 'toAtomMap fromAtomMap idCtr atomCtr usedSetTheoryTypeDefs usedSetTheoryRelDefs usedSetTheoryJoinDefs definedAtoms truncateReals noOldVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangZ3 commentStamp: 'AHB 8/14/2012 12:07' prior: 0!
A CoopLangZ3 is CoopLang as an API to the Z3 SMT solver.

To use Z3, you need to:

1) Download the Z3 SMT solver from:
        http://research.microsoft.com/en-us/um/redmond/projects/z3/download.html
        (there is one link for mac there)
2) Create a symbolic link called /usr/local/bin/z3 from the tool's binary location $tool/bin/z3

CoopLangs has been tested with version 4.1 .... newer versions may work as well, but if need be (until things are fixed), follow the link to "Download: Older Versions" and get 4.1.


Instance Variables
	atomCtr:		<Object>
	fromAtomMap:		<Object>
	idCtr:		<Object>
	toAtomMap:		<Object>

atomCtr
	- xxxxx

fromAtomMap
	- xxxxx

idCtr
	- xxxxx

toAtomMap
	- xxxxx
!

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:45'!
addAtom: item

	| idp |
	idp := (#A , atomCtr) asSymbol.
	toAtomMap at: item  put: idp.
	fromAtomMap at: idp put: item.
	atomCtr := atomCtr + 1.
	^idp! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:45'!
addRel: item prefix: p

	| idp |
	idp := (p , idCtr) asSymbol.
	toAtomMap at: item  put: idp.
	fromAtomMap at: idp put: item.
	idCtr := idCtr + 1.
	^idp! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 03:03'!
addSetTheoryJoinDefsFor: r join: jr over: insts with: part1p and: part2p expand: expand

	"adds set related theory assertions about sum, count, etc. for Set(b) type"
	
	| nl tpr tpb  dp rn rp0 rid0 bn bnp tp sn sp sf newInsts |
	nl := Character lf.
	tpr := jr rangeType.
	tpb := tpr base.
	tp := tpb name.	
	rid0 := jr id.
	rn := jr name.
	dp := jr domainType.
	rp0 := jr rangeType.
	bn := tpr base name.
	bnp := dp name.
	sn := 'Set' , bnp.
	sp := 'Set' , tp.
	sf := (sn , '_' , jr name) asSymbol.
	part1p nextPutAll: '(declare-fun ' , sf , ' (' , sn , ') ' , sp , ')' , nl.
	expand
		ifTrue: [
			newInsts := self addSetTheoryJoinDefsForHelper: r join: jr over: insts part1p: part1p part2p: part2p.
		]
		ifFalse: [	
			part2p nextPutAll:  '(assert (forall ((x Int) (s ' , sn , '))' , nl ,
				'    (or (or (< x 0) (>= x (' , sn , '.length s)))' , nl , 
				'        	(and (= (select (' , sf, ' s) x) (' , bnp , '_' , rn , ' (select s x)))' , nl ,
				'        	    (= (', sp , '.length (' , sf , ' s)) (' , sn , '.length s))))))' , nl.
				
		].
	^newInsts
	
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 03:00'!
addSetTheoryJoinDefsForHelper: r join: jr over: insts part1p: part1p part2p: part2p

	""
	| nl prim numeric jrb dn jrn rn rp0 jrp0 jrid0 bn jbn dp sn jsf newInsts |
	nl := Character lf.
	rp0 := r rangeType.
	jrid0 := jr id.
	rn := r name.
	jrn := jr name.
	dp := r domainType.
	jrp0 := jr rangeType.
	dn := dp name.
	jrb := jrp0 base.
	bn := rp0 base name.
	jbn := jrp0 base name.
	sn := 'Set' , bn.
	jsf := (sn , '_' , jrn) asSymbol.
	prim := jrb isPrimitive.
	numeric := jrb isNumeric.
	newInsts := OrderedCollection new.
	insts do: [:val0 |
	 	| val0p val valp o2p part |
		val0p := toAtomMap at: val0.
		val := val0 collect: [:x | self object: x fieldAt: jrn ofType: rp0].
		newInsts add: val.
		valp := self getAtom: val.
		o2p := val0p.
		(definedAtoms includesKey: valp) ifFalse: [	
			definedAtoms at: valp put: nil.
			part2p nextPutAll: '(assert ' , '(= (' , jsf , ' ' , o2p , ') ' , valp , '))' , nl.
			part2p nextPutAll: '(assert (= (Set', jbn , '.length ' , valp , ') ' , val size , '))' , nl.
			part1p nextPutAll: '(declare-const ' , valp , ' Set' , jbn , ')' , nl.
			prim 
				ifTrue: [
					numeric ifTrue: [ 
						"sums..."
						part := WriteStream with: ''.
						(0 to: (val size - 1)) do: [:x | part nextPutAll: '(select ' , valp , ' ' , x , ') '. ].
						part2p nextPutAll: '(assert (= (Set', jbn , '.sum ' , valp , ') (+ ' , part contents , ')))' , nl.
					]
				]
				ifFalse: [
					(1 to: val size) do: 
						[:i | | v vp |
							v := val at: i. 
							vp := prim ifTrue: [ v ] ifFalse: [ toAtomMap at: v ].
							part2p nextPutAll: '(assert (= (select ' , valp , ' ' , (i - 1) , ') ' , vp , '))' , nl.
						]
				].
				part := WriteStream with: ''.
				(0 to: (val size - 1)) do: [:x | part nextPutAll: '(= (select (' , jsf, ' ' , val0p , ') ', x , ') (' , jrid0 , ' (select ' , val0p , ' ' , x , '))) '. ].
				part2p nextPutAll:  '(assert ' , 
					'(and ' , part contents , nl ,
					'        	    (= (Set', jbn , '.length (' , jsf , ' ' , val0p , ')) (' , sn , '.length ' , val0p , '))))' , nl.		
		]		
	].
	^newInsts

	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/30/2012 13:43'!
addSetTheoryRelDefsFor: r expand: expand

	"adds set related theory assertions about sum, count, etc. for Set(b) type"
	
	| nl part1p part2p rb currs news currInsts allInsts |
	part1p := WriteStream with: ''.
	part2p := WriteStream with: ''.
	nl := Character lf.
	expand ifTrue: [ 
		currInsts := self addSetTheoryRelDefsForHelper: r part1p: part1p part2p: part2p.
	].
	"joins over sets..."
	allInsts := IdentityDictionary new.
	allInsts at: r rangeType base put: currInsts. 
	currs := OrderedCollection with: r.
	[currs isEmpty not] whileTrue: [
		news := OrderedCollection new. 
		currs do: [:currR |
			usedSetTheoryJoinDefs keys do: [:jr |
				rb := currR rangeType base.
				(jr domainType = rb) ifTrue: [
					allInsts at: jr rangeType put: (self addSetTheoryJoinDefsFor: currR join: jr over: (allInsts at: rb) with: part1p and: part2p expand: expand).
					news add: jr.
				]
			]
		].
		currs := news.
	].
	^{part1p contents. part2p contents}
	
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 02:59'!
addSetTheoryRelDefsForHelper: r part1p: part1p part2p: part2p

	""
	| nl prim numeric insts rb dn rn rp0 rid0 bn tpr tpb tp dp bnp sn sp newInsts |
	nl := Character lf.
	tpr := r rangeType.
	tpb := tpr base.
	tp := tpb name.	
	rid0 := r id.
	rn := r name.
	dp := r domainType.
	rp0 := r rangeType.
	dn := dp name.
	rb := rp0 base.
	bn := tpr base name.
	bnp := bn.
	sn := 'Set' , bnp.
	sp := 'Set' , tp.
	prim := rb isPrimitive.
	numeric := rb isNumeric.
	insts := self instancesOf: dn.
	newInsts := OrderedCollection new.
	insts do: [:o |
	 	| op  val valp  |
		op := toAtomMap at: o.
		val := self object: o fieldAt: rn ofType: rp0.
		newInsts add: val.
		valp := self getAtom: val.
		(definedAtoms includesKey: valp) ifFalse: [	
			definedAtoms at: valp put: nil.
			part2p nextPutAll: '(assert ' , '(= (' , rid0 , ' ' , op , ') ' , valp , '))' , nl.
			part2p nextPutAll: '(assert (= (Set', bn , '.length ' , valp , ') ' , val size , '))' , nl.
			part1p nextPutAll: '(declare-const ' , valp , ' Set' , bn , ')' , nl.
			prim 
				ifTrue: [
					numeric ifTrue: [ | part |
						"sums..."
						part := WriteStream with: ''.
						(0 to: (val size - 1)) do: [:x | part nextPutAll: '(select ' , valp , ' ' , x , ') '. ].
						part2p nextPutAll: '(assert (= (Set', bn , '.sum ' , valp , ') (+ ' , part contents , ')))' , nl.
					]
				]
				ifFalse: [
					(1 to: val size) do: 
						[:i | | v vp |
							v := val at: i. 
							vp := prim ifTrue: [ v ] ifFalse: [ toAtomMap at: v ].
							part2p nextPutAll: '(assert (= (select ' , valp , ' ' , (i - 1) , ') ' , vp , '))' , nl.
						]
				]	
		]		
	].
	^newInsts

	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:23'!
addSetTheoryTypeDefsFor: b expand: expand defineSum: defSum

	"adds set related theory assertions about sum, count, etc. for Set(b) type"
	
	| nl bn part0p part1p part2p |
	part0p := WriteStream with: ''.
	part1p := WriteStream with: ''.
	part2p := WriteStream with: ''.
	nl := Character lf.
	bn := b name.
	part0p nextPutAll: '(define-sort Set' , bn , ' () (Array Int ' , bn , '))' , nl.
	part1p nextPutAll: '(declare-fun Set', bn, '.length', ' (Set' , bn , ') Int)' , nl.
	expand
		ifFalse: [
			part2p nextPutAll: '(assert (forall ((s Set', bn , ')) (>= (Set', bn, '.length s) 0)))' , nl.
		].
	(b isNumeric and: [defSum])
		ifTrue: [
			"define sum of values"
			| z |
			z := b isInt ifTrue: [ 0 ] ifFalse: [ 0.0 ].
			part1p nextPutAll: '(declare-fun Set', bn , '.sum (Set', bn , ') ', bn , ')' , nl.	
			expand
				ifFalse: [
					part1p nextPutAll: '(declare-fun Set', bn , 'H.sum (Set', bn , ' Int) ' , bn , ')' , nl.
					part2p nextPutAll: '(assert (forall ((s Set', bn , ')) (= (Set', bn, '.sum s) (Set', bn , 'H.sum s (- (Set', bn , '.length s) 1)))))' , nl.
					part2p nextPutAll: '(assert (forall ((s Set', bn , ') (x Int)) (or (or (< x (- 0 1)) (>= x (Set' , bn , '.length s))) (= (Set', bn , 'H.sum s x) (ite (< x 0) ' , z , ' (+ (select s x) (Set', bn , 'H.sum s (- x 1))))))))' , nl.
				]
		].
	^{part0p contents. part1p contents. part2p contents}.
	
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 9/13/2012 16:21'!
anyPostParsingEnvironmentActions

	" aside from usual defs, we add any needed set theory defs (coun, sum, join) here "
	
	| a b c expand |
	expand := program checkOption: #instantiateQuantifiers.
	super anyPostParsingEnvironmentActions.
	a := WriteStream with: ''.
	b := WriteStream with: ''.
	c := WriteStream with: ''.
	usedSetTheoryTypeDefs keys do: [:k | | defs |
		defs := self addSetTheoryTypeDefsFor: k expand: expand defineSum: (usedSetTheoryTypeDefs at: k).
		a nextPutAll:  defs first.
		b nextPutAll: defs second.
		c nextPutAll: defs third.
	].
	usedSetTheoryRelDefs keys do: [:r | | defs |
		defs := self addSetTheoryRelDefsFor: r expand: expand.
		b nextPutAll: defs first.
		c nextPutAll: defs second.
	].
	translatedEnvironmentTypes := translatedEnvironmentTypes , 
		a contents.
	translatedEnvironmentDefs := translatedEnvironmentDefs , 
		b contents.
	translatedEnvironmentAssertions := 
		c contents , translatedEnvironmentAssertions.
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'mg 5/8/2014 11:19'!
binary

	"path to SMT solver binray file"

	| res |
	res := 'c:\studium\masterarbeit\z3-4.3.0-x64\bin\z3.exe'. "'/usr/local/bin/z3'."
	^res! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'mg 5/9/2014 11:37'!
binaryParams
	"command line parameters to call binary with"

	^ OSProcess isWindows
		ifTrue: [' -nw -smt2 -T:20 '] 
		ifFalse: [' -in -nw -smt2 -T:20']! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/29/2012 09:31'!
checkAndGetAtom: item

	| e |
	
	e := toAtomMap includesKey: item.
	^{e. e 
		ifTrue: [ toAtomMap at: item ]
		ifFalse: [ self addAtom: item ]}! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/23/2012 11:22'!
defaultOptions
	"running options for solver"

	| opt defs |
	defs := '(set-option :pp-decimal true)'.
	opt := program getOption: #setLogic.
	^(opt isNil)
		ifTrue: [ defs ]
		ifFalse: [ defs , Character lf ,
		 		'(set-option :auto-config false)' , Character lf , 
				'(set-logic ' , opt , ')' ]! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 23:14'!
environment: env
	"given the environment, sets the environment in the language of the hosted program"

	| expand vars rels cs part0 part1 part2 part3 part4 part1o part2o nl setDefs |
	self setPrimitivesEnv.
	usedSetTheoryTypeDefs :=  IdentityDictionary new.
	usedSetTheoryRelDefs :=  IdentityDictionary new.
	usedSetTheoryJoinDefs :=  IdentityDictionary new.
	definedAtoms :=  IdentityDictionary new.
	expand := program checkOption: #instantiateQuantifiers.
	truncateReals := program checkOption: #truncateReals.
	noOldVar := program checkOption: #noOldVar.
	nl := Character lf.
	vars := env variables.
	cs := env classes.
	rels := env relations.
	part0 := WriteStream with: ''.
	part1 := WriteStream with: ''.
	part2 := WriteStream with: ''.
	part3 := WriteStream with: '(echo ":vars")' , nl.
	part4 := WriteStream with: '(echo ":atoms")' , nl.
	part1o := WriteStream with: ''.
	part2o := WriteStream with: ''.
	setDefs := IdentityDictionary new.
	cs associationsDo: [:a |  | cid is idp num |
		part0 nextPutAll: '(declare-sort ' , a key , ')' , nl.
		cid := a key.
		is := self instancesOf: cid.
		num := is size.
		num > 0 ifTrue: [
			idp := self addRel: cid prefix: #s.
			is do: [:ai | self addAtom: ai ]
		]
	].
	vars associationsDo: [:a |
		| id tp tp1 tp2 tpf prim r |
		id := a key.
		tp := a value.
		tp2 := tp name.
		prim := tp isPrimitive. 
		tpf := tp2.
		r := env envAt: id ofType: tp. 
		part1 nextPutAll: '(declare-const ' , id , ' ' , tpf , ')' , nl.
		part1o nextPutAll: '(declare-const ' , id , '_old ' , tpf , ')' , nl.
		part2o nextPutAll: '(assert (= ' , id , '_old ' , 
			(self translateValue: r ofType: tp) , '))' , nl.
		(self isModifiableVar: id) 
			ifTrue: [
				prim ifFalse: [
					| rp |
					rp := toAtomMap at: r.
					(definedAtoms includesKey: rp) ifFalse: [
						definedAtoms at: rp put: nil.
						part1 nextPutAll: '(declare-const ' , rp , ' ' , tp2 , ')' , nl.
					].
					part2 nextPutAll: '(assert (= ' , id , ' ', rp , '))' , nl.
					part4 nextPutAll: '(echo "atom ' , rp , '") ' , nl.
					part4 nextPutAll: '(eval ' , rp , ')' , nl.	
				].
				part3 nextPutAll: '(echo "' , id , '") ' , nl.
				part3 nextPutAll: '(eval ' , id , ')' , nl.	
			]
			ifFalse: [
				prim 
					ifTrue: [
						r := self getZ3Primitive: r ofType: tp.
						part2 nextPutAll:  '(assert (= ' , id , ' ', r , '))' , nl.
					]
					ifFalse: [ | rp |
						rp := toAtomMap at: r.
						(definedAtoms includesKey: rp) ifFalse: [
							definedAtoms at: rp put: nil.
							part1 nextPutAll: '(declare-const ' , rp , ' ' , tpf , ')' , nl.
						].
						part2 nextPutAll: '(assert (= ' , id , ' ', (toAtomMap at: r) , '))' , nl 
					]
				]		
	].
	rels associationsDo: [:a |
		| id tp tp0 dp tp1 tp2 tpf  prim isCol |
		id := a key.
		tp := a value.
		(tp unary) ifFalse: [ | insts |
			tp0 := tp name.
			dp := tp domainType.
			tp1 := dp name.
			insts := self instancesOf: tp1.
			insts isEmpty ifFalse: [
			tp2 := tp rangeType.
			prim := tp2 isPrimitive.
			isCol := tp2 isCollection.
			tpf := '(' , tp1 , ') ', (isCol 
				ifTrue: [ | b bn |
						b := tp2 base.
						bn := b name.
						'Set' , bn ] 
				ifFalse: [tp2 name]).
			part1 nextPutAll: '(declare-fun ' , id , ' ' , tpf , ')' , nl.
			part1o nextPutAll: '(declare-fun ', id , '_old ' , tpf , ')' , nl.
			(self isModifiableAttr: id) 
				ifTrue: [
					isCol ifTrue: [
						part1 nextPutAll: '(declare-fun ' , id , '.length (' , tp1, ') Int)', nl.
						part2 nextPutAll: '(assert (forall ((this ' , tp1, ')) (= (', id ,'.length this) (Set' , tp2 base name , '.length (' , id , ' this)))))', nl.
					].
					insts do: 
						[:o | | op val |
							op := toAtomMap at: o.
							(definedAtoms includesKey: op) 
								ifFalse: [
									definedAtoms at: op put: nil.
										part1 nextPutAll: '(declare-const ' , op , ' ' , tp1 , ')' , nl.	
								].
							val := self object: o fieldAt: tp0 ofType: tp2 getAtom: prim not.
							prim 
								ifTrue: [ val := self getZ3Primitive: val ofType: tp2 ].
							part2o nextPutAll: '(assert (= (' , id , '_old ' , op , ') ' , val , '))' , nl.
							(self isModifiableObj: o) 
								ifTrue: [
									| e |
									e := '(' , id , ' ' , op , ')'.
									isCol
										ifTrue: [
											part3 nextPutAll: '(echo "' , op , '.' , tp0 , '.#") ' , nl.
											part3 nextPutAll: '(eval (', id , '.length ' , op , '))' , nl.
											(1 to: (val size max: 10)) do: "HACK FIXME"
												[:i |
													part3 nextPutAll: '(echo "' , op , '.' , tp0 , '.', i ,'") ' , nl.
													part3 nextPutAll: '(eval (select ' , e , ' ' , (i - 1), '))' , nl.
												]
										]
										ifFalse: [
											part3 nextPutAll: '(echo "' , op , '.' , tp0 , '") ' , nl.
											part3 nextPutAll: '(eval ' , e , ')' , nl.
										]	
								]
								ifFalse: [ 
									part2 nextPutAll: '(assert (= (' , id , ' ', op , ') ' , val , '))' , nl.
								]
						]
				]
				ifFalse: [
					prim
						ifTrue: [
							insts do: 
								[:o | | op val |
									val := self object: o fieldAt: tp0 ofType: tp2.
									val := self getZ3Primitive: val ofType: tp2.
									op := toAtomMap at: o.
									part2o nextPutAll: '(assert (= (' , id , '_old ', op , ') ' ,  val , '))' , nl.
							 		part2 nextPutAll: '(assert (= (' , id , ' ', op , ') ' ,  val , '))' , nl.	
									
									(definedAtoms includesKey: op) 
										ifFalse: [
											definedAtoms at: op put: nil.
											part1 nextPutAll: '(declare-const ' , op , ' ' , tp1 , ')' , nl.	
										]
								].
						]
					ifFalse: [
						insts do: 
							[:o | | op val valp |
								val := self object: o fieldAt: tp0 ofType: tp2.
								valp := self getAtom: val.
								(definedAtoms includesKey: valp)
									ifFalse: [									
										definedAtoms at: valp put: nil.
										part1 nextPutAll: '(declare-const ' , valp , ' ' , 
											(isCol ifTrue: [ | b |
												b := tp2 base name.
												part2 nextPutAll:  '(assert (= (Set' , b , '.length ', valp ,') ' , val size , '))' , nl.
												(1 to: val size) do: 
													[:i | | v vp |
														v := val at: i. 
														vp := v isNumber ifTrue: [ v ] ifFalse: [ self getAtom: v ].
														part2 nextPutAll: '(assert (= (select ' , valp , ' ' , (i - 1) , ') ' , vp , '))' , nl.
													].
												'Set' , b ] 
												ifFalse: [ tp2 ] ), ')' , nl.
									].
								op := toAtomMap at: o.
								part2o nextPutAll:  '(assert (= (' , id , '_old ', op , ') ' , valp , '))' , nl.
					 			part2 nextPutAll:  '(assert (= (' , id , ' ', op , ') ' , valp , '))' , nl.
								(definedAtoms includesKey: op) 
									ifFalse: [
										definedAtoms at: op put: nil.
										part1 nextPutAll: '(declare-const ' , op , ' ' , tp1 , ')' , nl.
									]
							]
					]
				]
			]		
		]
	].
	translatedProgramHead := self defaultOptions , nl.
 	translatedProgramTail := '(check-sat)' , nl , '(echo ":model (z3_model")' , nl , 
		part4 contents , part3 contents , '(echo ")")' , nl.
	translatedEnvironmentTypes := part0 contents.
	translatedEnvironmentDefs :=  part1 contents.
	translatedEnvironmentAssertions := part2 contents.
	translatedOldEnvironmentDefs := part1o contents.
	translatedOldEnvironmentAssertions := part2o contents.! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/17/2012 18:37'!
getAtom: item

	^(toAtomMap includesKey: item) 
		ifTrue: [ toAtomMap at: item ]
		ifFalse: [ self addAtom: item ]! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/18/2012 07:32'!
getZ3Primitive: r ofType: tp
	"some primitives like neg nums represented differently"

	^(tp isNumeric and: [r negative]) 
		ifTrue: [ 
			| z | 
			z := self zeroForType: tp.
			'(- ' , z , ' ' , r negated , ')' 
		]
		ifFalse: [
			r
		]
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 15:48'!
initParsers

	"initializes input and output parsers"
	
	super initParsers.
	toAtomMap := IdentityDictionary new.
	fromAtomMap := IdentityDictionary new.
	inputParser toAtomMap: toAtomMap.
	inputParser fromAtomMap: fromAtomMap.
	outputParser toAtomMap: toAtomMap.
	outputParser fromAtomMap: fromAtomMap.
	outputParser modelTempVars: IdentityDictionary new.
! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:24'!
inputParserClass

	^CoopLangZ3InputParser! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 18:41'!
liftToQuantExpr: e over: c

	^'(assert (forall ((this ', c, ')) ', e, '))'! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 10/15/2012 23:14'!
noOldVar

	^noOldVar! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 16:39'!
object: o fieldAt: f ofType: tp getAtom: atom
	"accessor for the atom representing field f of object o"

	| val |
	val := self object: o fieldAt: f ofType: tp.
	^atom 
		ifTrue: [
			(toAtomMap includesKey: val) 
				ifTrue: [toAtomMap at: val]
				ifFalse: [self addAtom: val]]
		ifFalse: [val]
						! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:24'!
outputParserClass

	^CoopLangZ3OutputParser! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 14:03'!
removeVar: item

	"FIXME"
	idCtr := idCtr - 1.
	program environment variables removeKey: item.! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 19:40'!
setPrimitivesEnv
	"for the environment in the language of the hosted program sets up the primitive types: null."

	idCtr := 0.
	atomCtr := 0.
	({nil}) do: [:i | self addAtom: i ].
	^atomCtr
	! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:08'!
translateInvariants

	| vars part1 el env cs expand |
	part1 := WriteStream with: ''.
	el := Character lf.
	env := program environment.
	vars := env variables.
	cs := env classes.
	toAtomMap at: #this put: #this. "HACK FIXME"
	expand := program checkOption: #instantiateQuantifiers.
	cs keys do: [:cid | | insts cinvs |
		insts := self instancesOf: cid.
		insts isEmpty ifFalse: [
			cinvs := self invariantsOf: cid.
			vars at: #this put: (CoopLangType of: cid).
			expand
				ifTrue: [ 
					insts do: [:o | 
						toAtomMap at: #this put: (toAtomMap at: o). "HACK FIXME"
						cinvs do: [:cinv |
							part1 nextPutAll: '(assert ' , (inputParser match: cinv third with: #expr) , ')' , el
						].
						self resetParsers.
					].
				]
				ifFalse: [ 
					cinvs do: [:cinv |
						part1 nextPutAll: (self liftToQuantExpr: 
							(inputParser match: cinv third with: #expr) over: cid) , el
					].
					self resetParsers.
				].
				self removeVar: #this. "HACK FIXME!!"
		]
	].
	^part1 contents! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/20/2012 15:26'!
translateValue: val ofType: tp

	^tp isPrimitive
		ifTrue: [ val ]
		ifFalse: [ toAtomMap at: val ]! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 15:50'!
truncateReals

	^truncateReals! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/26/2012 17:50'!
usedSetTheoryDefs
	
	^usedSetTheoryDefs! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/29/2012 00:00'!
usedSetTheoryJoinDefs
	
	^usedSetTheoryJoinDefs! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 19:22'!
usedSetTheoryRelDefs
	
	^usedSetTheoryRelDefs! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 19:22'!
usedSetTheoryTypeDefs
	
	^usedSetTheoryTypeDefs! !

!CoopLangZ3 methodsFor: 'as yet unclassified' stamp: 'hs 5/15/2012 23:41'!
zeroForType: tp
	"in z3 real 0 only type checks as 0.0"

	^tp isReal ifTrue: [ '0.0' ] ifFalse: [ '0' ]! !

CoopLang subclass: #CoopLangOMeta
	instanceVariableNames: 'translatedProgram anonParser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangOMeta methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 15:59'!
environment: environment

	^nil! !

!CoopLangOMeta methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 10:57'!
execute
	"executes external solvers binary on given program given environment env"

	| env in out |
	env := program environment.
	in := env at: #input.
	"FIXME: replace with anonymous OMeta paser:"
 	out := {{#output. nil. nil. 
		(anonParser matchAll: in with: #start)
		}}.
	^out! !

!CoopLangOMeta methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 15:58'!
inputParserClass

	^CoopLangOMetaInputParser! !

!CoopLangOMeta methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 15:57'!
outputParserClass

	^nil! !

!CoopLangOMeta methodsFor: 'as yet unclassified' stamp: 'hs 9/26/2012 16:30'!
parse: program
	"given raw hosted program, translates it to one understood by hosted language"

	| nl |
	translatedProgram isNil ifTrue: [
		nl := Character lf.
		translatedProgram :=  (inputParser matchAll: program with: #programExpr).
		anonParser := CoopLangParser newUniClass.
		translatedProgram do: [:rule | 
			"Transcript show: rule , Character lf."
			anonParser compile: rule ].
	]! !

CoopLang subclass: #CoopLangProblemFlattener
	instanceVariableNames: 'langEnv langVars modelTmpVars toAtomMap fromAtomMap atomCtr translatedProgram translatedProgramTail langProblem langModifiableVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

CoopLangProblemFlattener subclass: #CoopLangOCassowary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangOCassowary commentStamp: 'hs 5/25/2012 12:29' prior: 0!
A CoopLangOCassowary is a CoopLang that refactors a problem involving objects into a flat one involving on real variables, suitable for CoopLangCassowry linear arithmetic solver.

Instance Variables
	atomCtr:		<Object>
	cswyEnv:		<Object>
	cswyModifies:		<Object>
	cswyProblem:		<Object>
	fromAtomMap:		<Object>
	modelTmpVars:		<Object>
	toAtomMap:		<Object>
	translatedProgram:		<Object>
	translatedProgramTail:		<Object>

atomCtr
	- xxxxx

cswyEnv
	- xxxxx

cswyModifies
	- xxxxx

cswyProblem
	- xxxxx

fromAtomMap
	- xxxxx

modelTmpVars
	- xxxxx

toAtomMap
	- xxxxx

translatedProgram
	- xxxxx

translatedProgramTail
	- xxxxx
!

!CoopLangOCassowary methodsFor: 'as yet unclassified' stamp: 'hs 5/11/2012 23:00'!
inputParserClass

	^CoopLangOCassowaryInputParser! !

!CoopLangOCassowary methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 12:01'!
isAcceptedBaseType: tp

	^tp base isReal! !

!CoopLangOCassowary methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 11:52'!
isAcceptedType: tp

	^self isAcceptedBaseType: tp! !

!CoopLangOCassowary methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:48'!
targetLanguage

	^#Cassowary! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 22:59'!
addAtom: item

	| idp |
	idp := (#A , atomCtr) asSymbol.
	toAtomMap at: item  put: idp.
	fromAtomMap at: idp put: item.
	atomCtr := atomCtr + 1.
	^idp! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 9/22/2012 14:06'!
environment: env
	"given the environment, sets the environment in the language of the hosted program"

	| vars rels cs nl |
	langEnv :=  CoopLangs instance.
	langVars := IdentityDictionary new.
	langModifiableVars := OrderedCollection new.
	modelTmpVars := IdentityDictionary new.
	self setPrimitivesEnv.
	vars := env variables.
	cs := env classes.
	rels := env relations.
	nl := Character lf.
	cs associationsDo: [:a |  | cid is num |
		cid := a key.
		is := self instancesOf: cid.
		num := is size.
		num > 0 ifTrue: [
			is do: [:ai | self addAtom: ai ]
		]
	].
	vars associationsDo: [:a |
		| id tp tp1 tp2 prim r accepted |
		id := a key.
		tp := a value.
		tp2 := tp name.
		accepted := self isAcceptedType: tp.
		prim := tp isPrimitive. 
		r := env envAt: id ofType: tp.
		toAtomMap at: id put: (prim ifTrue: [ r ] ifFalse: [ toAtomMap at: r]).
		accepted ifTrue: [ 
			langEnv at: id put: r. 
			langVars at: id put: tp 
		].
		(self isModifiableVar: id) 
			ifTrue: [
				accepted ifTrue: [ langModifiableVars add: id ]
			]	
	].
	rels associationsDo: [:a |
			| id tp tp0 tp1 tp2 prim isCol accepted |
			id := a key.
			tp := a value.
			(tp unary) ifFalse: [
			tp0 := tp name.
			tp1 := tp domainType name.
			(self instancesOf: tp1) isEmpty ifFalse: [
			tp2 := tp rangeType.
			prim := tp2 isPrimitive.
			accepted := self isAcceptedType: tp2.
			isCol := tp2 isCollection.
			(self isModifiableAttr: id) 
				ifTrue: [
					(self instancesOf: tp1) do: 
						[:o | | op |
							op := toAtomMap at: o.
							accepted ifTrue: [ 
								| sp val mod |
								val := nil.
								sp := (op , tp0) asSymbol.
								mod := self isModifiableObj: o.
								isCol 
									ifTrue: [  | tp2b |
										val := self object: o fieldAt: tp0.
										tp2b := tp2 base.
										1 to: val size do: [:i | | sp2 val2 |
											sp2 := (sp , i) asSymbol.
											modelTmpVars at: sp2 put: {op. tp0. tp2}.
											val2 := val at: i.
											mod ifTrue: [ langModifiableVars add: sp2 ].
											langEnv at: sp2 put: val2.
											langVars at: sp2 put: tp2b.
											"self halt."
										].
									]
									ifFalse: [
										modelTmpVars at: sp put: {op. tp0. tp2}.
										val := self object: o fieldAt: tp0 ofType: tp2 getAtom: prim not isCollection: false.
										mod ifTrue: [ langModifiableVars add: sp ].
										langEnv at: sp put: val.
										langVars at: sp put: tp2.
									].
								]
						]
				]
				ifFalse: [
					prim 
						ifTrue: [
							(self instancesOf: tp1) do: 
								[:o | | op |
									op := toAtomMap at: o.
									accepted ifTrue: [ 
										| sp |
										sp := (op  , tp0) asSymbol.
										modelTmpVars at: sp put: {op. tp0. tp2}.
										langEnv at: sp put: (self object: o fieldAt: tp0).
										langVars at: sp put: tp2.
									]
								]
						]
					ifFalse: [
						(tp unary) ifFalse: [ "FIXME!!"
							(self instancesOf: tp1) do: 
								[:o | | op val valp tp2b |
									op := toAtomMap at: o.
									val := self object: o fieldAt: tp0.
									(toAtomMap includesKey: val)
										ifFalse: [ valp := self addAtom: val ].
									(isCol and: [accepted]) ifTrue: [ | sp |
										tp2b := tp2 base.
										sp := (op , tp0) asSymbol.
										1 to: val size do: [:i | | sp2 val2 |
											sp2 := (sp , i) asSymbol.
											modelTmpVars at: sp2 put: {op. tp0. tp2}.
											val2 := val at: i.
											"mod ifTrue: [ langModifiableVars add: sp2 ]."
											langEnv at: sp2 put: val2.
											langVars at: sp2 put: tp2b.
										].
									]
								]
						]
					]
				]		
			]
		]
	].
	translatedProgramTail := nl.
! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 9/22/2012 14:22'!
execute

	"executes wrapped language on refactored real-only program given environment env"

	| out env p1 model oopts opts ct |
	oopts := program options.
	opts := OrderedCollection new.
	oopts associationsDo: [:a | | k |
		k := a key.
		(self propagatedOptions contains: k) ifTrue: [ opts add: a key. opts add: a value ] ].
	out := ''.
	langProblem := langVars isEmpty
		 ifTrue: [ self error: 'model involves no values of accepted types.' ]
		ifFalse: [ | ks f |
			ks := langVars keys.
			f := ks first.
			(ks allButFirst inject: ('var ' , f , ' : ' , (langVars at: f)) into: 
			[:s :x | s := s , Character cr , ('var ' , x , ' : ' , (langVars at: x)). s ])].
	(program checkOption: #debug)
		ifTrue: [ 
			Transcript show: langProblem , Character lf ,  translatedProgram.
		].
	env := langEnv problem: langProblem.
	p1 := env hostProgram: translatedProgram in: (self targetLanguage) modifiableVars: langModifiableVars options: opts.
	out := p1 runAndCommit.
	(out = false) ifTrue: [^nil].
	ct := 1.
	model := out asArray collect: [:a | | ap f idx |
		ap := a first. 
		f := nil.
		idx := nil.
		(modelTmpVars includesKey: ap) ifTrue: [
			| of |
			of := modelTmpVars at: ap.
			ap := fromAtomMap at: of first.
			f := of second. 
			of third isCollection ifTrue: [ idx := ct ]
		].
		ct := ct + 1.
		{ap. f. idx. a fourth}
	].
	^model! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:01'!
getAtom: val

	^(toAtomMap includesKey: val) 
			ifTrue: [toAtomMap at: val]
			ifFalse: [self addAtom: val]! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:01'!
initParsers

	"initializes input and output parsers"
	
	super initParsers.
	toAtomMap := IdentityDictionary new.
	fromAtomMap := IdentityDictionary new.
	inputParser toAtomMap: toAtomMap.
	inputParser fromAtomMap: fromAtomMap
! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:21'!
inputParserClass

	^CoopLangProblemFlattenerInputParser! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 12:01'!
isAcceptedBaseType: tp

	^tp base isPrimitive
! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 9/19/2012 11:51'!
isAcceptedType: tp

	^self isAcceptedBaseType: tp
! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 22:59'!
langEnv

	^langEnv! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 12:29'!
langModifiableVars

	^langModifiableVars! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/3/2012 12:26'!
langVars

	^langVars! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:02'!
modelTmpVars

	^modelTmpVars! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/1/2012 21:26'!
object: o fieldAt: f ofType: tp getAtom: atom isCollection: c
	"accessor for the atom representing field f of object o"

	| val |
	val := self object: o fieldAt: f ofType: tp.
	^atom 
		ifTrue: [
			c ifTrue: [
				val collect: [:v | self getAtom: v ]
			]
			ifFalse: [
				self getAtom: val
			]
		]
		ifFalse: [val]! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:02'!
outputParserClass

	^nil! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:09'!
parse: program
	"given raw hosted program, translates it to one understood by hosted language"

	| part2 part1 nl |
	translatedProgram isNil ifTrue: [
		nl := Character lf.
		part2 := (inputParser matchAll: program with: #programExpr) , nl.
		part1 := self translateInvariants.
		translatedProgram :=  part1 , part2 , translatedProgramTail.
	]! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:27'!
propagatedOptions

	"options that stay after flattening"

	^#(debug truncateReals)! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:02'!
removeVar: item

	"FIXME"
	program environment variables removeKey: item.! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:02'!
setPrimitivesEnv
	"for the environment in the language of the hosted program sets up the primitive types: null."

	atomCtr := 0.
	({nil}) do: [:i | self addAtom: i ].
	^atomCtr! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 5/31/2012 23:48'!
targetLanguage

	^#Z3! !

!CoopLangProblemFlattener methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 01:12'!
translateInvariants

	| part1 el env cs vars |
	part1 := WriteStream with: ''.
	el := Character lf.
	env := program environment.
	cs := env classes.
	vars := env variables.
	cs keys do: [:cid | | insts cinvs |
		insts := self instancesOf: cid.
		insts isEmpty ifFalse: [
			cinvs := self invariantsOf: cid.
			cinvs isEmpty ifFalse: [
				vars at: #this put: (CoopLangType of: cid).
				insts do: [:o | 
					toAtomMap at: #this put: (toAtomMap at: o).
					env envAt: #this put: o.
					cinvs do: [:cinv |
						part1 nextPutAll: (inputParser match: cinv third with: #expr), el
					].
					env envRemove: #this.
					self resetParsers.
				].
				self removeVar: #this.
			]
		]
	].
	^part1 contents! !

Object subclass: #CoopLangCassowaryExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangCassowaryExamples methodsFor: 'interactive examples' stamp: 'yo 7/31/2012 11:19'!
openInspectorOnIncrementalAddition2

	"
	CoopLangCassowaryExamples new openInspectorOnIncrementalAddition2
	"
	
	|  env p1 |
	env := CoopLangs newProblem: '
	var x, y : Real
	'.
	env eval: 'this.x = this.streamOf(10)'.
	env eval: 'this.y = this.streamOf(nil)'.
	p1 := env hostProgram: '
	y = x+5
	x<=20
	' in: #Cassowary modifiableVars: #(x y).
	p1 setupIncrementalRun: #(x) strengths: {ClStrength strong}.

	env at: #p1 put: p1.
	env eval: 'this.solver = $$(solver(() ->
		this.p1._updateValue_newValue("x".asSymbol(), @x)
		this.p1.resolveAndCommit(), ["x"], ["x", "y"]))'.

	KSEventStreamInspector new object: env; running: true; open.	
! !

Object subclass: #CoopLangDatalogExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangDatalogExamples methodsFor: 'as yet unclassified' stamp: 'hs 10/3/2012 00:50'!
movableBoxes

	"
	CoopLangDatalogExamples new movableBoxes
	"
	
	|  env Box |
	env := CoopLangs newModel: '
class Box : Thing
	Attributes
		contents : Set ( Box )
relation DragBox(a: Box)
relation Movable(a: Box)
	Rules
		Movable(a) <--
			DragBox(a) || 
			exists b : Box | (Box_contents(b, a) && Movable(b))
' andProblem: '
var a, b, c, d, e, f: Box
'.
	Box := env getClass: #Box.
	#(a b c d e f) do: [:n | Box new var: n].
	(env at: #a) contents: {env at: #b. env at: #c}.
	(env at: #b) contents: {env at: #d}.
	(env at: #e) contents: {env at: #f}.
	(env relations at: #DragBox) add: {env at: #a}.
	env resolveRelations: {#debug. true}.
	Transcript show: (env relations at: #Movable) tuples.
! !

Object subclass: #CoopLangRelation
	instanceVariableNames: 'id name type head body intensional fn tuples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/28/2012 13:30'!
add: e

	fn ifTrue: [ self removeTupleFor: e first ].
	tuples add: e.! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
addAll: es

	es do: [:e | self add: e]! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
body

	^body! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
body: n

	^body := n! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 01:52'!
domainType

	^type first! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
fn

	^fn! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
fn: b

	^fn := b! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
head

	^head! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
head: n

	^head := n! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 16:11'!
id

	^id! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 16:11'!
id: n

	^id := n! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
initialize

	intensional := false.
	fn := false.
	tuples := OrderedCollection new.! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
intensional

	^intensional! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
intensional: b

	^intensional := b! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 16:11'!
name

	^name! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 16:11'!
name: n

	^name := n! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 01:52'!
rangeType

	^type second! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
remove: e

	^tuples remove: e! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
removeAll: es

	^tuples removeAll: es! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:01'!
removeTupleFor: e

	| tuple | 
	tuple := nil.
	tuples do: [:tp | (tp first = e) ifTrue: [ tuple := tp ] ].
	tuple isNil ifFalse: [ tuples remove: tuple ].! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/28/2012 13:23'!
removeTuplesFor: e

	| rmTuples | 
	rmTuples := OrderedCollection new.
	tuples do: [:tp | (tp first = e) ifTrue: [ rmTuples add: tp ] ].
	tuples removeAll: rmTuples.! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:02'!
tuples

	^tuples! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:02'!
type

	^type! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 00:02'!
type: n

	^type := n! !

!CoopLangRelation methodsFor: 'as yet unclassified' stamp: 'hs 8/30/2012 13:18'!
unary

	^type size == 1! !

Object subclass: #CoopLangSimpleSearch
	instanceVariableNames: 'board variables prob tryThese currentPosition varsSearchedPerLevel goalPositionsPerLevel currentScore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangSimpleSearch commentStamp: 'tk 4/1/2013 16:21' prior: 0!
A CoopLangSimpleSearch is a very simple solver that enumerates the range of the variables by brute force.

Instance Variables
	board  			A 2D Matrix where variables (pieces) are stored.  Nil or a number in a square means it is unoccupied.  A subclass of PuzzleBoard.
				  
	variables		An Array of variable objects (i.e. a piece in a position).  Each variable object may have variables inside it.  Responds to variables with a list of variable setters.  Responds to ranges with an array of arrays or intervals of values. 
			
	currentPosition		If we are solving in position-order (searchByPosition = true), this is the square we are trying to fill now.  runByPosition uses it, and considers the variables in any order. 
			
	varsSearchedPerLevel		If we are solving in position-order (searchByPosition = true), variables (pieces) are tested in any order.  For each pieces placed, its index in 'variables'.  So can easily consider the next variable when this one exhausted.   A variable is in use if ((board atLoc: var position) == var).
			
	goalPositionsPerLevel		The piece at this level was placed in order to cover this square.  When remove it reset, currentPosition := goalPositionsPerLevel at: level.
			
	prob		Holds the knowledge and statement of the problem being searched.  A subclass of PuzzleDescription.
			
	tryThese			current array of variables being submitted.
				
	currentScore		
	
	results:				{self.  an OrderedCollection of arrays of variables at the moment all had goodScore}
	
!

!CoopLangSimpleSearch class methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:51'!
exampleElsFill6x2
	"Fit four pieces into a 6 by 2 rectangle.  Each piece is an 'L' with 3 squares.
		CoopLangSimpleSearch exampleElsFill6x2
	"
	
	( FillTheBoard new fourElsFill6x2 ) explore
! !

!CoopLangSimpleSearch class methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:50'!
exampleEvolveWeasel
	"Evolve the sentence 'methinks it is like a weasel' as explained in The Blind Watchmaker by Richard Dawkins.  Initialize letters randomly and start changing from there."

	( EvolveAPhrase new evolveWeasel ) explore
	! !

!CoopLangSimpleSearch class methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:48'!
exampleFullSudoku4x4
	"Set up the problem of making a 4 by 4 Sudoku board.  Create a completely filled-in Sudoku board.  Initialize with 0 in every cell.  Place 1-4 in each cell.  Each row has no repeats, Each column has no repeats, Each Group of 2x2 has no repeats."
	
	SudokuFullMaker new solveSudoku4x4 explore
	
! !

!CoopLangSimpleSearch class methodsFor: 'as yet unclassified' stamp: 'tk 12/16/2012 09:49'!
exampleFullSudoku9x9
	"Set up the problem of making a 9 by 9 Sudoku board.  Create a completely filled-in Sudoku board.  Initialize with 0 in every cell.  Place 1-9 in each cell.  Each row has no repeats, Each column has no repeats, Each Group of 3x3 has no repeats."
	
	SudokuFullMaker new solveSudoku9x9 explore
	
! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/29/2013 21:13'!
advancePosition
	"move currentPosition forward along the board."
	
	(board emptyAtLoc: currentPosition) ifTrue: [
		self error: 'Why moving on when no piece here?'].
	[currentPosition := board locAfter: currentPosition.
	 board emptyAtLoc: currentPosition] whileFalse.! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/14/2012 16:58'!
board

	^ board! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/14/2012 16:58'!
board: anObject

	board := anObject! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/20/2013 06:09'!
board: aBoard intoText: morphOrNil
	"Shortcut for displaying a board"
	prob board: aBoard intoText: morphOrNil! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 8/15/2012 13:00'!
check: mileStones
	"Report when we reach these placements"
	
	tryThese size > 0 ifTrue: [
		mileStones do: [:pp | 
			tryThese last = pp ifTrue: [
				Transcript cr; show: pp; space; space; show: tryThese size printString.
				"(tryThese size = 2 and: [tryThese last position = (2@3)]) ifTrue: [self halt]."
				]]].
	! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 4/1/2013 15:34'!
currentPosition

	^ currentPosition! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 4/1/2013 15:34'!
currentPosition: anObject

	currentPosition := anObject! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/12/2012 16:36'!
currentScore

	^ currentScore! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/12/2012 16:36'!
currentScore: anObject

	currentScore := anObject! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 1/27/2013 10:24'!
displayMorph
	"place on the screen to show a board"
	^ prob displayMorph! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 2/23/2013 23:16'!
goodList: goodList permute: remaining successDo: successBlock
	"Run through remaining variables, evaluating each concatenated to goodList.  If one works, puruse the subproblem.  When remaining is empty, eval successBlock"
	
	| more |
	remaining do: [:aVar |
		(more := goodList copy) addLast: aVar. 
		(prob evaluate: more) >= prob goodScore ifTrue: ["good so far"
			remaining size = 1 
				ifTrue: [
					"possible copy into board"
					successBlock value: more] 
				ifFalse: [
					self goodList: more permute: (remaining copyWithout: aVar) 
						successDo: successBlock]
				]].
	self halt.! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/26/2013 19:49'!
initialize

	tryThese := OrderedCollection new.
	currentPosition := 1@1.   "only used when (searchByPosition = true)"
! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/28/2013 08:58'!
nextVariable: level
	"return the next variable (piece) that has not been placed to cover currentPosition"
	
	| newVar vsl |
	vsl := (varsSearchedPerLevel at: level).
	[(vsl := vsl + 1) > variables size ifTrue: [
		varsSearchedPerLevel at: level put: 0.
		^ nil].
	 newVar := variables at: vsl.
	"is this variable (piece) on the board already?"
	 (board atLoc: newVar position) == newVar] whileTrue.
	
	"found a piece"
	 varsSearchedPerLevel at: level put: vsl.
	prob restrict: newVar positionsNear: currentPosition.
	 ^ newVar! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/25/2013 19:12'!
optimizeRangeOrder
	"for each range, we are free to do it in any order.  See if there is a better order."  
	| ip list xRange xSpan yRange ySpan sortBlock sorted |
	
	"For boards filled with pieces, it is better to vary the smallest coordinate of position fastest (5 rather than 12).  Makes the effects of a move be felt sooner."
	variables do: [:vv |
		ip := vv getters indexOf: #position.
		ip > 0 ifTrue: [
			list := vv ranges at: ip.
			list first isPoint ifTrue: [
				xRange := Set new.
				yRange := Set new.
				list do: [:vvv | xRange add: vvv x.  yRange add: vvv y].
				xRange := xRange asSortedCollection.
				yRange := yRange asSortedCollection.
				xSpan := xRange last - xRange first.
				ySpan := yRange last - yRange first.
				sortBlock := xSpan < ySpan	"sort on the largest"
					ifTrue: [ [:aPt :bPt | aPt y < bPt y] ]
					ifFalse: [ [:aPt :bPt | aPt x < bPt x] ].
				sorted := SortedCollection sortBlock: sortBlock.
				vv ranges at: ip put: (sorted addAll: list) asArray.
				
				
				]]].! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/14/2012 16:58'!
prob

	^ prob! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 12/14/2012 16:58'!
prob: anObject

	prob := anObject! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 3/26/2013 19:55'!
run
	"solve the puzzle"
	"add an object
		init vars inside it
			loop on range of each inner var.
				evaluate
					if OK, add another variable.  If all vars are in, record this solution."

	| goingUp latest res score backTrackCnt |
	prob oneVariableAtATime ifFalse: [^ self runFull].
	"We are allowed to evaluate partial solutions (to see if they are illegal)"
	prob permutation ifTrue: [^ self runPermutation].
	tryThese := OrderedCollection new.
	prob badMoveStaysBad ifFalse: [self error: 'need to do permutations'].
	prob searchByPosition ifTrue: [^ self runByPosition].
	goingUp := false.
	backTrackCnt := 0.
	
	[goingUp ifFalse: [score := prob evaluate: tryThese].	"evaluate the current state!!"
	 goingUp not & (score >= prob goodScore) 
		ifFalse: ["this config does not work"
			goingUp := false.
			prob removePiecesFromBoard ifTrue: [prob remove: tryThese last].
			(res := tryThese last advanceState) 
				ifNil: ["this piece has tried everything it can do"
					backTrackCnt := backTrackCnt + 1. 
					"tryThese size = 1" true ifFalse: [
						2 to: tryThese size do: [:ii | 
							(prob piece: tryThese first isSameAs: (tryThese at: ii)) ifFalse: [
								self error: 'need to shuffle pieces']].
						^ self].	"done"
					tryThese last initState.	"in case backtrack twice and pieces stay on the board"
					tryThese removeLast.
					tryThese size = 0 ifTrue: [^ self].	"all done!!"
					goingUp := true]
				"ifNotNil: [] go to top of loop and evaluate this"
				]
		ifTrue: ["works.  go down"
			"self check: mileStones."
			tryThese size = variables size 
				ifFalse: [
					tryThese addLast: (latest := variables at: tryThese size + 1).
		 			latest initState]
				ifTrue: ["all variables set, and it worked.  Record it.  Advance state"
					(prob acceptSolution: variables) ifTrue: [
						prob results addLast: prob snapshot.
						prob results size >= prob stopAfterNSolutions ifTrue: [^ self]].
					prob removePiecesFromBoard ifTrue: [prob remove: tryThese last]..
					(res := tryThese last advanceState) 
						ifNil: ["this piece has tried everything it can do"
							tryThese size = 1 ifTrue: [^ self].	"done"
							tryThese removeLast.
							score := prob goodScore - 1.	"fake to advance older piece"
							goingUp := true]
						"ifNotNil: [] go to top of loop and evaluate this"
					]].
	 	true] whileTrue.! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 4/6/2013 23:34'!
runByPosition
	"solve the puzzle.  Squares are considered in order.  Each must be filled before going to the next.  The Piece that fills it may have its actual position in another square."
	"take a variable, verify that it is not on the board ((board atLoc: var position) ~~ var), remember its old position range, restrict that range, try it.  When fails, go to the next var.
	 add an object (variable) to the board
		init vars inside it
			loop on range of each inner var.
				evaluate
					if OK, add another variable.  If all vars are in, record this solution."

	| goingUp latest res score backTrackCnt |
	prob oneVariableAtATime ifFalse: [^ self runFull].
	"We are allowed to evaluate partial solutions (to see if they are illegal)"
	prob permutation ifTrue: [^ self runPermutation].
	tryThese := OrderedCollection new.
	prob badMoveStaysBad ifFalse: [self error: 'need to do permutations'].
	goingUp := false.
	backTrackCnt := 0.
	varsSearchedPerLevel := Array new: variables size withAll: 0.	"parallel to TryThese"
	goalPositionsPerLevel := Array new: variables size.		"parallel to TryThese"
	currentPosition := 1@0.
	"at each position, run through all unused variables.  construct a limited range for position.  "
	
	[goingUp ifFalse: [score := prob evaluate: tryThese].	"evaluate the current state!!"
	 goingUp not & (score >= prob goodScore) 
		ifFalse: ["this config does not work"
			goingUp := false.
			prob removePiecesFromBoard ifTrue: [
				prob remove: tryThese last].
			(res := tryThese last advanceState)   "range of positions is restricted"
				ifNil: ["this piece has tried everything it can do"
					tryThese last initState.	"in case backtrack twice and pieces stay on the board"
					tryThese removeLast.
					(latest := self nextVariable: tryThese size + 1) 
						ifNil: [
							backTrackCnt := backTrackCnt + 1. 
							tryThese size = 0 ifTrue: [^ self].	"all done!!"
							varsSearchedPerLevel at: tryThese size + 1 put: 0.
							currentPosition := goalPositionsPerLevel at: tryThese size.
							goingUp := true]
						ifNotNil: [tryThese addLast: latest.
							latest initState]]	"new variable at this position"
				"ifNotNil: [] go to top of loop and evaluate this"
				]
		ifTrue: ["works.  go down"
			"self check: mileStones."
			goalPositionsPerLevel atWrap: tryThese size put: currentPosition.
			tryThese size = variables size 
				ifFalse: [
					self advancePosition.	"move currentPosition".
					tryThese addLast: (latest := self nextVariable: tryThese size + 1).
		 			latest initState]
				ifTrue: ["all variables set, and it worked.  Record it.  Advance state"
					(prob acceptSolution: variables) ifTrue: [
						prob results addLast: prob snapshot.
						prob results size >= prob stopAfterNSolutions ifTrue: [^ self]].
					prob removePiecesFromBoard ifTrue: [prob remove: tryThese last]..
					(res := tryThese last advanceState) 
						ifNil: ["this piece has tried everything it can do"
							tryThese last initState.	"in case backtrack twice and pieces stay on the board"
							tryThese removeLast.
							(latest := self nextVariable: tryThese size + 1) 
								ifNil: [
									backTrackCnt := backTrackCnt + 1. 
									tryThese size = 0 ifTrue: [^ self].	"all done!!"
									varsSearchedPerLevel at: tryThese size + 1 put: 0.
									currentPosition := goalPositionsPerLevel at: tryThese size.
									score := prob goodScore - 1.	"fake to advance older piece"
									goingUp := true]
								ifNotNil: [tryThese addLast: latest]].	"new variable at this position"
						"ifNotNil: [] go to top of loop and evaluate this"
					]].
	 	true] whileTrue.! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 1/20/2013 18:51'!
runFull
	"solve the puzzle.  All pieces must be on the board (or with values) for any evaluation to happen."
	"add all pieces
		initance variables inside it
			loop on the range of each inner variable.
				evaluate
					if OK record this solution."

	| goingUp latest res score   gg which |
	"oneVariableAtATime is false"
	tryThese := variables copy.	"not deep copy"
	prob badMoveStaysBad ifFalse: [self error: 'need to do permutations'].
	goingUp := false.
	which := 1.
	(tryThese at: which) initState.
	currentScore := prob evaluate: tryThese.
	"choice:  copy & change.  don't copy and Be able to set state back"
	
	[goingUp ifFalse: [score := prob evaluate: tryThese].
	 gg := goingUp.
	 gg not & (score < currentScore) ifTrue: ["was correct, and we undid it!!"
		"to find multiple solutions, this needs to continue on...."
		(tryThese at: which) prevState	"set it back"
			ifNil: ["first time.  will find it again"
				score := currentScore := currentScore - 1]
			ifNotNil: [
				currentScore := score - 1 "go down"]].
	 gg | (score = currentScore) ifTrue: ["this config does not work"
		goingUp := false.
		(res := (tryThese at: which) advanceState) 
			ifNil: ["this piece has tried everything it can do"
				Transcript cr; show: prob snapshot.
				which = 1 ifTrue: [
					2 to: tryThese size do: [:ii | 
						(prob piece: tryThese first isSameAs: (tryThese at: ii)) ifFalse: [
							self error: 'need to shuffle pieces']].
					^ self].	"done"
				which := which - 1.
				goingUp := true]
			"ifNotNil: [] go to top of loop and evaluate this"
			].
			
	gg not & (score > currentScore) ifTrue: ["works.  go down"
		"self check: mileStones."
		prob board: nil "use latest results" intoText: prob displayMorph.
			"partial progress" 
		which = variables size 
			ifFalse: [
				latest := variables at: (which := which + 1).
	 			latest initState]
			ifTrue: ["all variables set, and it worked.  Record it.  Advance state"
				prob results addLast: prob snapshot.
				prob results size >= prob stopAfterNSolutions ifTrue: [^ self].
				].
			currentScore := score].
	 true] whileTrue.! !

!CoopLangSimpleSearch methodsFor: 'run' stamp: 'tk 2/24/2013 09:42'!
runPermutation
	"solve the puzzle.  Vars is a set of objects.  We are looking for a good permutation of them.  No internal variables in the objects."
	"add an object from the pool that has not been used so far
			evaluate
				if OK, add another variable.  If all vars are in, record this solution."

	^ self goodList: (OrderedCollection new: variables size + 4) permute: variables 
			successDo: [:list | 
				(prob acceptSolution: list) ifTrue: [
					tryThese := list.
					prob results addLast: prob snapshot.
					prob results size >= prob stopAfterNSolutions ifTrue: [^ self]]]
			! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 8/13/2012 13:27'!
tryThese

	^ tryThese! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 8/13/2012 13:27'!
tryThese: anObject

	tryThese := anObject! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 8/10/2012 15:17'!
variables

	^ variables! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 8/10/2012 15:17'!
variables: anObject

	variables := anObject! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 4/1/2013 15:34'!
varsSearchedPerLevel

	^ varsSearchedPerLevel! !

!CoopLangSimpleSearch methodsFor: 'accessing' stamp: 'tk 4/1/2013 15:34'!
varsSearchedPerLevel: anObject

	varsSearchedPerLevel := anObject! !

Object subclass: #CoopLangType
	instanceVariableNames: 'name parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

CoopLangType class
	instanceVariableNames: 'Int Real Bool Types'!

CoopLangType class
	instanceVariableNames: 'Int Real Bool Types'!

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:35'!
Bool

	^Bool! !

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:34'!
Int

	^Int! !

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 02:35'!
Real

	^Real! !

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 18:41'!
initializePrimitives

	Types := IdentityDictionary new.
	Int := CoopLangType of: #Int.
	Real := CoopLangType of: #Real.
	Bool := CoopLangType of: #Bool.! !

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 19:15'!
of: name

	"instanciates the named type"
	^(Types includesKey: name) 
		ifTrue: [ Types at: name ]
		ifFalse: [ 
			| res |
			res := CoopLangType new name: name; yourself.
			Types at: name put: res.
			res ]! !

!CoopLangType class methodsFor: 'as yet unclassified' stamp: 'hs 5/28/2012 19:14'!
of: name with: params

	"instanciates the parameterized named type"
	
	^params isNil
		ifTrue: [ self of: name ] 
		ifFalse: [ CoopLangType new 
			name: name; 
			parameters: (params isNil ifTrue: [ nil ] ifFalse: [ params collect: [:p | self of: p ]]); 
			yourself
		]! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 00:23'!
asString

	^name , (parameters isNil 
		ifTrue: [ '' ] 
		ifFalse: [ '(' , (parameters inject: ' ' into: [:z :x | z := z , x , ' ' ])  , ')'])! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 14:50'!
base

	"FIXME"
	^parameters isNil ifTrue: [ self ] ifFalse: [ parameters first ]! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 14:57'!
isBool
	
	^#Bool = name! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 00:06'!
isCollection

	^self isParameterized! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/7/2012 19:39'!
isInt
	
	^#Int = name! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 14:56'!
isNumeric
	
	^self isInt or: [ self isReal ]! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 00:20'!
isParameterized

	^parameters isNil not! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/9/2012 14:57'!
isPrimitive
	
	^self isInt or: [ self isReal or: [ self isBool ] ] ! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/7/2012 19:39'!
isReal
	
	^#Real = name! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:13'!
isReference
	
	^self isPrimitive not! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 15:12'!
name

	^name! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 15:12'!
name: n

	name := n! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 15:27'!
parameters

	^parameters! !

!CoopLangType methodsFor: 'as yet unclassified' stamp: 'hs 5/6/2012 15:27'!
parameters: ps

	^parameters := ps! !

Object subclass: #CoopLangZ3Examples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!CoopLangZ3Examples commentStamp: '<historical>' prior: 0!
A CoopLangZ3Tests is


	To run Z3 examples:
	1) Download Z3 SMT solver from:
		http://research.microsoft.com/en-us/um/redmond/projects/z3/download.html
		(there is one link for mac there)
	2) Create a symbolic link called /usr/local/bin/z3 from the tool's binary location $tool/bin/z3   

!

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
circleEquation1

	"
	CoopLangZ3Examples new circleEquation1
	"
	
	| ll f a env p1 |
	ll := JMorph new openInWorld.
f := (Form extent: 100@100 depth: 32) fillColor: Color white.
ll window add: (a := JBox newTexture: f).

a handlerAs: CoopLangs.
env := a handler.
env at: #form put: f.
env problem: '
var x, y, r: Real
var reverse: Bool
'.
p1 := env hostProgram: '
x ^ 2 + y ^ 2 = r ^ 2
y = 0.0 || (reverse <=> y < 0.0)
' in: #Z3 modifiableVars: #(y).
env at: #x put: -10.
env at: #p1 put: p1.
env eval:
'this.reverse = false
this.incr = 2.0
this.r = 10.0
this.timer = $$(timerE(500))
this.x = $$(-10 fby @x + @incr at @timer)
this.y = $$(@x.mapE((x) -> this.p1.get("y")))
this.stopTimer = $$(@x.mapE((x) -> 
	if @reverse
		if x + @incr < -@r
			this.timer = null
	else
		if x + @incr > @r
			this.reverse = true
			this.incr = -1 * @incr
		))
'.
env eval:
'this.plot = $$(lift((x, y) ->
	this.form._colorAt_put(P(x+50, y+50), Color.black())
	this.whole._invalidRect(), @x, @y))
'.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
fallEquation1

	"
	CoopLangZ3Examples new fallEquation1
	"
	
	| ll f a env p1 |
	ll := JMorph new openInWorld.
f := (Form extent: 800@600 depth: 32) fillColor: Color black.
ll window add: (a := JBox newTexture: f).

a handlerAs: CoopLangs.
env := a handler.
env at: #form put: f.
env problem: '
var g, t, h: Real
'.
p1 := env hostProgram: '
h = 0.5 * g * t ^ 2
' in: #Z3 modifiableVars: #(h).
env at: #p1 put: p1.
env eval:
'this.timer = $$(timerE(400))
this.g = 9.8
this.t = $$(0.0 fby @t + 1.0 at @timer)
this.h = $$(@t.mapE((t) -> this.p1.get("h")))
this.stopTimer = $$(@t.mapE((t) -> if @h >= 150 
	this.timer = null))'.
env eval:
'this.plot = $$(lift((h) ->
	this.form._colorAt_put(P(70, h+50), Color.yellow())
	this.whole.invalidRect(), @h))
'.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:14'!
fallEquation2

	"
	CoopLangZ3Examples new fallEquation2
	"
	
	| ll f a env p1 Vector Mass n g mods |
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env model: '
class Vector : Thing
	Attributes
		x, y: Real
class Mass : Thing
	Attributes
		position0, velocity0, position, velocity: Vector
	Constraints
		this.velocity.x = g.x * t + this.velocity0.x
		this.velocity.y = g.y * t + this.velocity0.y
		this.position.x = 0.5 * this.velocity.x * t + this.velocity0.x * t + this.position0.x
		this.position.y = 0.5 * this.velocity.y * t + this.velocity0.y * t + this.position0.y
	'.
	env problem: '
var t: Real
var g, m1Position, m1Velocity, m2Position, m2Velocity: Vector
var m1: Mass
	'.
	mods := OrderedCollection new.
	Vector := env getClass: #Vector.
	Mass := env getClass: #Mass.
	n := 2.
	g := Vector new x: 0.0; y: 9.8; yourself.
	(1 to: n) do: [:i | | pos0 vel0 pos vel m mn mnp0 mnv0 mnp mnv |
		pos0 := Vector new x: 50.0; y: 200.0; yourself.
		vel0 := Vector new x: i * 5.0; y: i * -10.0 - 20.0; yourself.
		pos := Vector new x: pos0 x ; y: pos0 y; yourself.
		vel := Vector new x: vel0 x ; y: vel0 y; yourself.
		m := Mass new position0: pos0; velocity0: vel0; position: pos; velocity: vel; yourself.
		mn := (#m , i) asSymbol.
		env at: mn put: m.
		mnp0 :=(mn , #Position0) asSymbol.
		mnv0 := (mn , #Velocity0) asSymbol.
		mnp :=(mn , #Position) asSymbol.
		mnv := (mn , #Velocity) asSymbol.
		env at: mnp0 put: pos0.
		env at: mnv0 put: vel0.
		env at: mnp put: pos.
		env at: mnv put: vel.
		mods addAll: {pos. vel}.
	].
	env at: #g put: g.
	env at: #t put: 0.0.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: mods modifiableAttributes: #((Vector x) (Vector y)).
	env at: #p1 put: p1.
	env eval:
'this.timer = $$(timerE(400))
this.t = $$(0.0 fby @t + 1.0 at @timer)
this.dummy = $$(@t.mapE((t) -> this.p1.runAndCommit()))
this.m1Positionp = $$(P(@m1Position.x, @m1Position.y))
this.m2Positionp = $$(P(@m2Position.x, @m2Position.y))
this.stopTimer = $$(@t.mapE((t) -> if @y1 >= 300 
	this.timer = null))
'.
	env eval: 'this.plot1 = $$(lift((pos) ->
	this.form._colorAt_put(pos, Color.yellow())
	this.whole._invalidRect(), @m1Positionp))
	this.plot2 = $$(lift((pos) ->
	this.form._colorAt_put(pos, Color.green())
	this.whole._invalidRect(), @m2Positionp))
	'.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:14'!
fallEquation2F

	"
	CoopLangZ3Examples new fallEquation2F
	"
	
	| ll f a env p1 Vector Mass n g mods |
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env model: '
class Vector : Thing
	Attributes
		x, y: Real
class Mass : Thing
	Attributes
		position0, velocity0, position, velocity: Vector
	Constraints
		this.velocity.x = g.x * t + this.velocity0.x
		this.velocity.y = g.y * t + this.velocity0.y
		this.position.x = 0.5 * this.velocity.x * t + this.velocity0.x * t + this.position0.x
		this.position.y = 0.5 * this.velocity.y * t + this.velocity0.y * t + this.position0.y
	'.
	env problem: '
var t: Real
var g, m1Position, m1Velocity, m2Position, m2Velocity: Vector
var m1: Mass
	'.
	mods := OrderedCollection new.
	Vector := env getClass: #Vector.
	Mass := env getClass: #Mass.
	n := 2.
	g := Vector new x: 0.0; y: 9.8; yourself.
	(1 to: n) do: [:i | | pos0 vel0 pos vel m mn mnp0 mnv0 mnp mnv |
		pos0 := Vector new x: 50.0; y: 200.0; yourself.
		vel0 := Vector new x: i * 5.0; y: i * -10.0 - 20.0; yourself.
		pos := Vector new x: pos0 x ; y: pos0 y; yourself.
		vel := Vector new x: vel0 x ; y: vel0 y; yourself.
		m := Mass new position0: pos0; velocity0: vel0; position: pos; velocity: vel; yourself.
		mn := (#m , i) asSymbol.
		env at: mn put: m.
		mnp0 :=(mn , #Position0) asSymbol.
		mnv0 := (mn , #Velocity0) asSymbol.
		mnp :=(mn , #Position) asSymbol.
		mnv := (mn , #Velocity) asSymbol.
		env at: mnp0 put: pos0.
		env at: mnv0 put: vel0.
		env at: mnp put: pos.
		env at: mnv put: vel.
		mods addAll: {pos. vel}.
	].
	env at: #g put: g.
	env at: #t put: 0.0.
	p1 := env hostProgram: '
	true
	' in: #Z3 modifiableObjects: mods modifiableAttributes: #((Vector x) (Vector y)) options: #(flatten true instantiateQuantifiers true).
	env at: #p1 put: p1.
	env eval:
'this.timer = $$(timerE(500))
this.t = $$(0.0 fby @t + 1.0 at @timer)
this.dummy = $$(@t.mapE((t) -> this.p1.runAndCommit()))
this.m1Positionp = $$(P(@m1Position.x, @m1Position.y))
this.m2Positionp = $$(P(@m2Position.x, @m2Position.y))
this.stopTimer = $$(@t.mapE((t) -> if @y1 >= 300 
	this.timer = null))
'.
	env eval: 'this.plot1 = $$(lift((pos) ->
	this.form._colorAt_put(pos, Color.yellow())
	this.whole._invalidRect(), @m1Positionp))
	this.plot2 = $$(lift((pos) ->
	this.form._colorAt_put(pos, Color.green())
	this.whole.invalidRect(), @m2Positionp))
	'.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
openInspector1

	"
	CoopLangZ3Examples new openInspector1
	"
	
	| env p1 obj |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	env at: #x put: 10.
	env at: #y put: nil.
	p1 := env hostProgram: '
	y * y <= x
	(y + 1) * (y + 1) > x
	y >= 0
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	obj := env eval: 'this.y = $$(@x.mapE((x) -> this.p1.get("y")))'.
	KSEventStreamInspector new object: env; running: true; open.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
openInspector2

	"
	CoopLangZ3Examples new openInspector2
	"

	| env p1 obj |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	p1 := env hostProgram: '
	y ^ 2 <= x
	(y + 1) ^ 2 > x
	y >= 0
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	obj := env eval: 
'this.timer = $$(timerE(100))
this.x = $$(0 fby @x + 10 at @timer)
this.y = $$(@x.mapE((x) -> this.p1.get("y")))
this.stopTimer = $$(@x.mapE((x) -> if x >= 250
		this.timer = null))'.
	KSEventStreamInspector new object: env; running: true; open.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
openInspector3

	"
	CoopLangZ3Examples new openInspector3
	"

	| env p1 obj |
	env := CoopLangs newProblem: '
var r, x, y: Real
var reverse: Bool
	'.
	p1 := env hostProgram: '
x ^ 2 + y ^ 2 = r ^ 2
reverse <=> y < 0.0
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	obj := env eval: 
'this.reverse = false
this.incr = 1.0
this.r = 10.0
this.timer = $$(timerE(1000))
this.x = $$(-11.0 fby @x + @incr at @timer)
this.y = $$(@x.mapE((x) -> this.p1.get("y")))
this.stopTimer = $$(@x.mapE((x) ->
	if x >= @r
		if reverse
			this.timer = null
		else
			this.incr = -1.0
			this.reverse = true))
'.
	KSEventStreamInspector new object: env; running: true; open.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'yo 7/31/2012 11:10'!
openInspector4

	"
	CoopLangZ3Examples new openInspector4
	"
	
	| env p1 |
	env := CoopLangs newProblem: '
	var x, y: Int
	'.
	env eval: 'this.x = this.streamOf(10)'.
	env eval: 'this.y = this.streamOf(nil)'.
	p1 := env hostProgram: '
	y * y <= x
	(y + 1) * (y + 1) > x
	y >= 0
	' in: #Z3 modifiableVars: #(y).
	env at: #p1 put: p1.
	env eval: 'this.solver = $$(solver(() ->
		Transcript.show("solver is trigged.").cr()
		this.p1.runAndCommit(), ["x"], ["x", "y"]))'.
	KSEventStreamInspector new object: env; running: true; open.
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/28/2012 14:13'!
spring1
	
	"
	CoopLangZ3Examples new spring1
	"
	
	| ll f a env p1 FreeMass Mass Spring mass1 mass2 spring g pos01 pos02 t |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env model: CoopLangsLibrary SpringsAndMasses1D.
	env problem: '
var t, dt, g : Real
var mass1: Mass
var mass2: FreeMass
var spring : Spring
	'.
	FreeMass := env getClass: #FreeMass.
	Mass := env getClass: #Mass.
	Spring := env getClass: #Spring.
	t := 0.0.
	g := 9.8.
	pos01 := 0.0.
	pos02 := 50.0.
	mass1 := Mass new position: pos01; var: #mass1.
	mass2 := FreeMass new mass: 100.0; position: pos02; velocity: 0.0; acceleration: g; var: #mass2.
	spring := Spring new naturalLength: 50.0; k: 50.0; end1: mass1; end2: mass2; var: #spring.
	mass1 beams: { spring }.
	mass2 beams: { spring }.
	env at: #t put: t.
	env at: #g put: g.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 readOnlyVars: #(g) readOnlyObjects: {mass1} readOnlyAttributes: #((Spring end1) (Spring end2) (Spring k) (Spring naturalLength) (FreeMass mass) (FreeMass position0) (FreeMass beams) (Mass position) (Mass beams)) options: #(instantiateQuantifiers true setLogic AUFNIRA).
	env at: #p1 put: p1.
	env eval: 'this.form._colorAt_put(P(100, 100), Color._red())'.
	env eval: 'this.timer = $$(timerE(500))
	this.x0 = $$(0.0 fby @x0 + 1.0 at @timer)
	this.dummy = $$(@x0.mapE((x0) -> this.p1._runAndCommit()))
	this.y = $$(@dummy.mapE((dummy) -> @mass2.position))
	'.
	env eval:
'this.plot = $$(lift((x0, y) ->
	this.form._colorAt_put(P(100 + x0, 100 + y), Color._green())
	this.whole._invalidRect(), @x0, @y))
'.

	
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/28/2012 14:14'!
spring1F
	
	"
	CoopLangZ3Examples new spring1F
	"
	
	| ll f a env p1 FreeMass Mass Spring mass1 mass2 spring g pos01 pos02 t |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env model: CoopLangsLibrary SpringsAndMasses1D.
	env problem: '
var t, dt, g : Real
var mass1: Mass
var mass2: FreeMass
var spring : Spring
	'.
	FreeMass := env getClass: #FreeMass.
	Mass := env getClass: #Mass.
	Spring := env getClass: #Spring.
	t := 0.0.
	g := 9.8.
	pos01 := 0.0.
	pos02 := 50.0.
	mass1 := Mass new position: pos01; var: #mass1.
	mass2 := FreeMass new mass: 100.0; position: pos02; velocity: 0.0; acceleration: g; var: #mass2.
	spring := Spring new naturalLength: 50.0; k: 50.0; end1: mass1; end2: mass2; var: #spring.
	mass1 beams: { spring }.
	mass2 beams: { spring }.
	env at: #t put: t.
	env at: #g put: g.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 readOnlyVars: #(g) readOnlyObjects: {mass1} readOnlyAttributes: #((Spring end1) (Spring end2) (Spring k) (Spring naturalLength) (FreeMass mass) (FreeMass position0) (FreeMass beams) (Mass position) (Mass beams)) options: #(flatten true instantiateQuantifiers true setLogic AUFNIRA).
	env at: #p1 put: p1.
	env eval: 'this.form._colorAt_put(P(100, 100), Color._red())'.
	env eval: 'this.timer = $$(timerE(500))
	this.x0 = $$(0.0 fby @x0 + 1.0 at @timer)
	this.dummy = $$(@x0.mapE((x0) -> this.p1._runAndCommit()))
	this.y = $$(@dummy.mapE((dummy) -> @mass2.position))
	'.
	env eval:
'this.plot = $$(lift((x0, y) ->
	this.form._colorAt_put(P(100 + x0, 100 + y), Color._green())
	this.whole._invalidRect(), @x0, @y))
'.

	
! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:17'!
spring2F
	
	"
	CoopLangZ3Examples new spring2F
	"
	
	| ll a f fline fbox env p1 numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env at: #ll put: ll.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1: Mass
var mass2: FreeMass
var spring : Spring
var mass1Position, mass2Weight, mass2Force, mass2Position, mass2Velocity, mass2Acceleration : Point
var springForce : Vector
	'.
	numMasses := 2.
	numSprings := 1.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. true}.
	problemInfo at: #springEnds put: #((1 2)).
	problemInfo at: #positions0 put: #((0.0 0.0) (0.0 50.0)).
	problemInfo at: #springsInfo put: #((50.0 50.0 50.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(nil 100.0).
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects)  modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
		edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 1]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 1]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr1y,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1y,48+curr2y), P(48+curr1y,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(500))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 50
		this.timer = null))
	this.xo1 = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.yo1 = $$(@xo1.mapE((xo1) -> @mass1.position.y))
	this.xo2 = $$(@yo1.mapE((yo1) -> @mass2.position.x))
	this.yo2 = $$(@xo2.mapE((xo2) -> @mass2.position.y))
	this.pointoxs = [ this.xo1, this.xo2 ]
	this.pointoys = [ this.yo1, this.yo2 ]
	'.
	env eval:
	'this.erased = $$(lift((xo1, yo1, xo2, yo2) ->
	this.erase()
	this.whole._invalidRect(), @xo1, @yo1, @xo2, @yo2))
	'.
	env eval:
	'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.pointxs = [ this.x1, this.x2 ]
	this.pointys = [ this.y1, this.y2 ]
	'.
	env eval:
	'this.plot = $$(lift((x1, y1, x2, y2) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2))
	'.
	KSEventStreamInspector new object: env; running: true; open.
	! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:18'!
spring3F
	
	"
	CoopLangZ3Examples new spring3F
	"
	
	| ll a f fline fbox env p1 numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1: Mass
var mass2: FreeMass
var spring : Spring
var springForce, mass1Position, mass2Weight, mass2Force, mass2Position, mass2Velocity, mass2Acceleration : Point
	'.
	numMasses := 2.
	numSprings := 1.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 2)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((0.0 0.0) (30.0 40.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((50.0 50.0 50.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(nil 100.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects) modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 1]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 1]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(500))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 100
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.pointoxs = [ this.x1o, this.x2o ]
	this.pointoys = [ this.y1o, this.y2o ]
	'.
	env eval:
	'this.erased = $$(lift((x1o, y1o, x2o, y2o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o, @x2o, @y2o))
	'.
	env eval:
	'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.pointxs = [ this.x1, this.x2 ]
	this.pointys = [ this.y1, this.y2 ]
	'.
	env eval:
	'this.plot = $$(lift((x1, y1, x2, y2) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2))
	'.
	KSEventStreamInspector new object: env; running: true; open.! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:19'!
spring4F
	
	"
	CoopLangZ3Examples new spring4F
	"
	
	| ll a f env p1  fbox fline  problemInfo numMasses numSprings edges edgesStr |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass2: Mass
var mass3, mass4: FreeMass
var spring1, spring2 : Spring
var mass1Position, mass2Position, mass3Weight, mass3Force, mass3Position, mass3Velocity, mass3Acceleration,  mass4Weight, mass4Force, mass4Position, mass4Velocity, mass4Acceleration : Point
var spring1Force, spring2Force : Vector
	'.
	numMasses := 4.
	numSprings := 2.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. false. true. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 3) (2 4)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((0.0 0.0) (40.0 0.0) (0.0 30.0) (40.0 30.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((20.0 30.0 30.0) (20.0 30.0 30.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(nil nil 100.0 200.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects) "massJoints , massJointForces , massJointEndForces , { spring1. spring2.  mass3Weight. mass3Force. mass3Position. mass3Velocity. mass3Acceleration. mass4Weight. mass4Force. mass4Position. mass4Velocity. mass4Acceleration. spring1Force. spring2Force }" modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 2]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 2]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(1000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 100
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o ]
	this.pointoys = [ this.y1o,  this.y2o, this.y3o, this.y4o ]
	'.
	env eval: 'this.erased = $$(lift((x1o, y1o, x2o, y2o, x3o, y3o, x4o, y4o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o, @x2o, @y2o, @x3o, @y3o, @x4o, @y4o))
	'.
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y))
	this.pointxs = [ this.x1, this.x2, this.x3, this.x4 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4 ]
	'.
	env eval: 'this.plot = $$(lift((x1, y1, x2, y2,  x3, y3, x4, y4) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2, @x3, @y3, @x4, @y4))
	'."
	res := p1 runAndCommit.
	Transcript show: ('' , res , Character lf).
	Transcript show: ('' , mass3 force , Character lf).
	Transcript show: ('' , mass4 force , Character lf).
	Transcript show: ('' , mass3 joint force , Character lf).
	Transcript show: ('' , mass4 joint force , Character lf).
	Transcript show: ('' , mass3 position , Character lf).
	Transcript show: ('' , mass4 position , Character lf)."
	KSEventStreamInspector new object: env; running: true; open.! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:19'!
spring5F
	
	"
	CoopLangZ3Examples new spring5F
	"
	
	| ll a f env p1 fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass2: Mass
var mass3: FreeMass
var spring1, spring2 : Spring
var mass1Position, mass2Position, mass3Weight, mass3Force, mass3Position, mass3Velocity, mass3Acceleration : Point
var spring1Force, spring2Force : Vector
	'.
	numMasses := 3.
	numSprings := 2.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. false. true}.
	problemInfo at: #springEnds put: #((1 3) (2 3)).
	problemInfo at: #positions0 put: #((0.0 0.0) (80.0 0.0) (40.0 30.0)).
	problemInfo at: #springsInfo put: #((50.0 50.0 50.0) (50.0 50.0 25.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(100.0 100.0 100.0).
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects:  (problemInfo at: #modifiableObjects) modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 2]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 2]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(1000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 50
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.pointoxs = [ this.x1o, this.x2o, this.x3o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o ]
	'.
	env eval:
	'this.erased = $$(lift((x1o, y1o, x2o, y2o, x3o, y3o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o, @x2o, @y2o, @x3o, @y3o))
	'.
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.pointxs = [ this.x1, this.x2, this.x3 ]
	this.pointys = [ this.y1, this.y2, this.y3 ]
	'.
	env eval:
	'this.plot = $$(lift((x1, y1, x2, y2,  x3, y3) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2, @x3, @y3))
	'."
	res := p1 runAndCommit.
	Transcript show: '' , res , Character lf.
	Transcript show: ('' , mass1 position , Character lf).
	Transcript show: ('' , mass2 position , Character lf).
	Transcript show: ('' , mass3 position , Character lf).
	Transcript show: ('' , mass3 force , Character lf).
	Transcript show: ('' , mass3 weight , Character lf).
	Transcript show: ('' , spring1 length , Character lf).
	Transcript show: ('' , spring2 length , Character lf).
	Transcript show: ('' , spring1 force , Character lf).
	Transcript show: ('' , spring2 force , Character lf).
	Transcript show: ('' , spring2 end1 position , Character lf).
	Transcript show: ('' , spring2 end2 position , Character lf)."
	
KSEventStreamInspector new object: env; running: true; open.! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:20'!
spring6F
	
	"
	CoopLangZ3Examples new spring6F
	"
	
	| ll a f env p1  fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass2: Mass
var mass3, mass4: FreeMass
var spring1, spring2, spring3 , spring3p : Spring
var mass1Position, mass2Position, mass3Weight, mass3Force, mass3Position, mass3Velocity, mass3Acceleration,  mass4Weight, mass4Force, mass4Position, mass4Velocity, mass4Acceleration : Point
var spring1Force, spring2Force, spring3Force, spring3pForce : Vector
	'.
	numMasses := 4.
	numSprings := 3.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. false. true. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 3) (2 4) (3 4)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((0.0 0.0) (110.0 0.0) (30.0 40.0) (80.0 40.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(nil nil 50.0 50.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.10
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects) modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 3]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 3]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(1000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 30
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o, this.y4o ]
	'.
	env eval:
	'this.erased = $$(lift((x1o, y1o, x2o, y2o, x3o, y3o, x4o, y4o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o, @x2o, @y2o, @x3o, @y3o, @x4o, @y4o))
	'.
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y + 0))
	this.pointxs = [ this.x1, this.x2, this.x3, this.x4 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4 ]
	'.
	env eval: 'this.plot = $$(lift((x1, y1, x2, y2, x3, y3, x4, y4) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2, @x3, @y3, @x4, @y4))
	'."
	p1 runAndCommit.
	Transcript show: ('' , mass3 force , Character lf).
	Transcript show: ('' , mass4 force , Character lf).
	Transcript show: ('' , mass3 position , Character lf).
	Transcript show: ('' , mass4 position , Character lf).
	Transcript show: ('' , spring1 force , Character lf).
	Transcript show: ('' , spring2 force , Character lf).
	Transcript show: ('' , spring3 force , Character lf).
	Transcript show: ('' , spring1 length , Character lf).
	Transcript show: ('' , spring2 length , Character lf).
	Transcript show: ('' , spring3 length , Character lf)."
	
KSEventStreamInspector new object: env; running: true; open.! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:20'!
spring7F
	
	"
	CoopLangZ3Examples new spring7F
	"
	
	| env p1  a f ll fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld extent: 800@600..
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass2: Mass
var mass3, mass4, mass5, mass6, mass7, mass8 : FreeMass
var spring1, spring2, spring3 , spring3p, spring4, spring5, spring6, spring7, spring8, spring9, spring10, spring6p, spring7p, spring8p, spring9p, spring10p : Spring
var mass1Position, mass2Position, mass3Weight, mass3Force, mass3Position, mass3Velocity, mass3Acceleration,  mass4Weight, mass4Force, mass4Position, mass4Velocity, mass5Weight, mass5Force, mass5Position, mass5Velocity, mass6Weight, mass6Force, mass6Position, mass6Velocity, mass7Weight, mass7Force, mass7Position, mass7Velocity, mass8Weight, mass8Force, mass8Position, mass8Velocity : Point
var spring1Force, spring2Force, spring3Force, spring3pForce, spring4Force, spring5Force, spring6Force, spring7Force, spring8Force, spring9Force, spring10Force, spring6pForce, spring7pForce, spring8pForce, spring9pForce, spring10pForce : Vector
	'.
	numMasses := 8.
	numSprings := 10.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. false. true. true. true. true. true. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 3) (2 4) (3 4) (5 7) (6 8) (7 8) (1 5) (2 6) (3 7) (4 8)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((0.0 0.0) (110.0 0.0) (30.0 40.0) (80.0 40.0) (0.0 50.0) (110.0 50.0) (30.0 90.0) (80.0 90.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(nil nil 10.0 10.0 10.0 10.0 10.0 10.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects)
	modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 10]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 10]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(2000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr > 50
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	'.
	env eval: 'this.x5o = $$(@y4o.mapE((y4o) -> @mass5.position.x))
	this.y5o = $$(@x5o.mapE((x5o) -> @mass5.position.y))
	this.x6o = $$(@y5o.mapE((y5o) -> @mass6.position.x))
	this.y6o = $$(@x6o.mapE((x6o) -> @mass6.position.y))
	this.x7o = $$(@y6o.mapE((y6o) -> @mass7.position.x))
	this.y7o = $$(@x7o.mapE((x7o) -> @mass7.position.y))
	this.x8o = $$(@y7o.mapE((y7o) -> @mass8.position.x))
	this.y8o = $$(@x8o.mapE((x8o) -> @mass8.position.y))
	this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o, this.x5o, this.x6o, this.x7o, this.x8o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o, this.y4o, this.y5o, this.y6o, this.y7o, this.y8o ]
	'.
	env eval: 'this.erased = $$(lift((x1o, y1o, x2o, y2o, x3o, y3o, x4o, y4o, x5o, y5o, x6o, y6o, x7o, y7o, x8o, y8o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o, @x2o, @y2o, @x3o, @y3o, @x4o, @y4o, @x5o, @y5o, @x6o, @y6o, @x7o, @y7o, @x8o, @y8o))
	'.
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y))
	'.
	env eval: 'this.x5 = $$(@y4.mapE((y4) -> @mass5.position.x))
	this.y5 = $$(@x5.mapE((x5) -> @mass5.position.y))
	this.x6 = $$(@y5.mapE((y5) -> @mass6.position.x))
	this.y6 = $$(@x6.mapE((x6) -> @mass6.position.y))
	this.x7 = $$(@y6.mapE((y6) -> @mass7.position.x))
	this.y7 = $$(@x7.mapE((x7) -> @mass7.position.y))
	this.x8 = $$(@y7.mapE((y7) -> @mass8.position.x))
	this.y8 = $$(@x8.mapE((x8) -> @mass8.position.y))
	this.pointxs = [ this.x1, this.x2, this.x3, this.x4, this.x5, this.x6, this.x7, this.x8 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4, this.y5, this.y6, this.y7, this.y8 ]
	'.
	env eval: 'this.plot = $$(lift((x1, y1, x2, y2,  x3, y3, x4, y4, x5, y5, x6, y6, x7, y7, x8, y8) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1, @x2, @y2, @x3, @y3, @x4, @y4, @x5, @y5, @x6, @y6, @x7, @y7, @x8, @y8))
'.
	Transcript show: (env at: #mass1) position.
	Transcript show: (env at: #mass2) position.
	Transcript show: (env at: #mass3) position.
	Transcript show: (env at: #mass4) position.
	Transcript show: (env at: #mass5) position.
	Transcript show: (env at: #mass6) position.
	Transcript show: (env at: #mass7) position.
	Transcript show: (env at: #mass8) position.
	
	"p1 runAndCommit."
KSEventStreamInspector new object: env; running: true; open.! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:20'!
spring8F
	
	"
	CoopLangZ3Examples new spring8F
	"
	
	| env p1  a f ll fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld extent: 800@600.
	f := (Form extent: 800@600 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass6, mass12, mass17: Mass
var mass2, mass3, mass4, mass5 , mass7 , mass8 , mass9 , mass10 , mass11, mass13, mass14, mass15, mass16, mass18, mass19, mass20 : FreeMass
var spring1 , spring2 , spring3 , spring4 , spring5 , spring6 , spring7 , spring8 , spring9 , spring10 , spring11 , spring12 , spring13 , spring14 , spring15 , spring16 , spring17 , spring18 , spring19 , spring20 , spring21 , spring22 , spring23 , spring24 , spring25 , spring26 , spring27 , spring28 , spring29 , spring30 , spring31 , spring32 , spring33 , spring34 , spring35 : Spring
var mass1Position , mass2Position , mass3Position , mass4Position , mass5Position , mass6Position , mass7Position , mass8Position , mass9Position , mass10Position , mass11Position , mass12Position , mass13Position , mass14Position , mass15Position , mass16Position , mass17Position , mass18Position , mass19Position , mass20Position , mass21Position,  mass1Velocity , mass2Velocity , mass3Velocity , mass4Velocity , mass5Velocity , mass6Velocity , mass7Velocity , mass8Velocity , mass9Velocity , mass10Velocity , mass11Velocity , mass12Velocity , mass13Velocity , mass14Velocity , mass15Velocity , mass16Velocity , mass17Velocity , mass18Velocity , mass19Velocity , mass20Velocity , mass21Velocity,  mass1Acceleration , mass2Acceleration , mass3Acceleration , mass4Acceleration , mass5Acceleration , mass6Acceleration , mass7Acceleration , mass8Acceleration , mass9Acceleration , mass10Acceleration , mass11Acceleration , mass12Acceleration , mass13Acceleration , mass14Acceleration , mass15Acceleration , mass16Acceleration , mass17Acceleration , mass18Acceleration , mass19Acceleration , mass20Acceleration , mass21Acceleration, mass1Weight , mass2Weight , mass3Weight , mass4Weight , mass5Weight , mass6Weight , mass7Weight , mass8Weight , mass9Weight , mass10Weight , mass11Weight , mass12Weight , mass13Weight , mass14Weight , mass15Weight , mass16Weight , mass17Weight , mass18Weight , mass19Weight , mass20Weight , mass21Weight: Point
var spring1Force , spring2Force , spring3Force , spring4Force , spring5Force , spring6Force , spring7Force , spring8Force , spring9Force , spring10Force , spring11Force , spring12Force , spring13Force , spring14Force , spring15Force , spring16Force , spring17Force , spring18Force , spring19Force , spring20Force , spring21Force , spring22Force , spring23Force , spring24Force , spring25Force , spring26Force , spring27Force , spring28Force , spring29Force , spring30Force , spring31Force , spring32Force , spring33Force , spring34Force , spring35Force : Vector
	'.
	numMasses := 18.
	numSprings := 27.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. true. true. true. true. false. true. true. true. true. true. false. true. true. true. true. false. true. true. true. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 2) (2 3) (3 4) (4 5) (5 11) (1 6) (6 7) (7 8) (8 9) (9 10) (1 7) (2 8) (3 9) (4 10) (2 7) (3 8) (4 9) (5 10) (11 16) (16 15) (15 14) (14 13) (13 12) (12 17) (17 18) (12 18) (13 18) ). "(startMass endMass)" "(15 21) (21 11)  (19 20)  (20 15) (14 20) (18 19) (13 19) (14 19)"
	problemInfo at: #positions0 put: #((37.0 44.0) (99.0  44.0) (161.0  45.0) (222.0  45.0) (283.0  47.0) (37.0  205.0) (99.0  147.0) (160.0  109.0) (221.0  86.0) (282.0  73.0) (343.0  72.0) (649.0  44.0) (587.0  44.0) (525.0  45.0) (464.0  45.0) (403.0  47.0) (649.0  205.0) (587.0  147.0) (526.0  109.0) (465.0  86.0) (404.0 73.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.20
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects)
	modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 27]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 27]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(2000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr >= 20
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	'.
	env eval: 'this.x5o = $$(@y4o.mapE((y4o) -> @mass5.position.x))
	this.y5o = $$(@x5o.mapE((x5o) -> @mass5.position.y))
	this.x6o = $$(@y5o.mapE((y5o) -> @mass6.position.x))
	this.y6o = $$(@x6o.mapE((x6o) -> @mass6.position.y))
	this.x7o = $$(@y6o.mapE((y6o) -> @mass7.position.x))
	this.y7o = $$(@x7o.mapE((x7o) -> @mass7.position.y))
	this.x8o = $$(@y7o.mapE((y7o) -> @mass8.position.x))
	this.y8o = $$(@x8o.mapE((x8o) -> @mass8.position.y))
	'.
	env eval: 'this.x9o = $$(@y8o.mapE((y8o) -> @mass9.position.x))
	this.y9o = $$(@x9o.mapE((x9o) -> @mass9.position.y))
	this.x10o = $$(@y9o.mapE((y9o) -> @mass10.position.x))
	this.y10o = $$(@x10o.mapE((x10o) -> @mass10.position.y))
	this.x11o = $$(@y10o.mapE((y10o) -> @mass11.position.x))
	this.y11o = $$(@x11o.mapE((x11o) -> @mass11.position.y))
	this.x12o = $$(@y11o.mapE((y11o) -> @mass12.position.x))
	this.y12o = $$(@x12o.mapE((x12o) -> @mass12.position.y))
	'.
	env eval: 'this.x13o = $$(@y12o.mapE((y12o) -> @mass13.position.x))
	this.y13o = $$(@x13o.mapE((x13o) -> @mass13.position.y))
	this.x14o = $$(@y13o.mapE((y13o) -> @mass14.position.x))
	this.y14o = $$(@x14o.mapE((x14o) -> @mass14.position.y))
	this.x15o = $$(@y14o.mapE((y14o) -> @mass15.position.x))
	this.y15o = $$(@x15o.mapE((x15o) -> @mass15.position.y))
	this.x16o = $$(@y15o.mapE((y15o) -> @mass16.position.x))
	this.y16o = $$(@x16o.mapE((x16o) -> @mass16.position.y))
	'.
	env eval: 'this.x17o = $$(@y16o.mapE((y16o) -> @mass17.position.x))
	this.y17o = $$(@x17o.mapE((x17o) -> @mass17.position.y))
	this.x18o = $$(@y17o.mapE((y17o) -> @mass18.position.x))
	this.y18o = $$(@x18o.mapE((x18o) -> @mass18.position.y))
	//this.x19o = $$(@y18o.mapE((y18o) -> @mass19.position.x))
	//this.y19o = $$(@x19o.mapE((x19o) -> @mass19.position.y))
	//this.x20o = $$(@y19o.mapE((y19o) -> @mass20.position.x))
	//this.y20o = $$(@x20o.mapE((x20o) -> @mass20.position.y))
	//this.x21o = $$(@y20o.mapE((y20o) -> @mass21.position.x))
	//this.y21o = $$(@x21o.mapE((x21o) -> @mass21.position.y))
	'.
	env eval: 
	'this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o, this.x5o, this.x6o, this.x7o, this.x8o, this.x9o, this.x10o, this.x11o, this.x12o, this.x13o, this.x14o, this.x15o, this.x16o, this.x17o, this.x18o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o, this.y4o, this.y5o, this.y6o, this.y7o, this.y8o, this.y9o, this.y10o, this.y11o, this.y12o, this.y13o, this.y14o, this.y15o, this.y16o, this.y17o, this.y18o ]
	'.
	"x1o, y1o , x2o, y2o , x3o, y3o , x4o, y4o , x5o, y5o , x6o, y6o , x7o, y7o , x8o, y8o, x9o, y9o , x10o, y10o , x11o, y11o , x12o, y12o , x13o, y13o , x14o, y14o , x15o, y15o , x16o, y16o, x17o, y17o , x18o, y18o , x19o, y19o , x20o, y20o , x21o, y21o"
	env eval: 'this.erased = $$(lift((x1o, y1o , x2o, y2o , x3o, y3o , x4o, y4o , x5o, y5o , x6o, y6o , x7o, y7o , x8o, y8o, x9o, y9o , x10o, y10o , x11o, y11o , x12o, y12o , x13o, y13o , x14o, y14o , x15o, y15o , x16o, y16o, x17o, y17o , x18o, y18o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o , @x2o, @y2o , @x3o, @y3o , @x4o, @y4o , @x5o, @y5o , @x6o, @y6o , @x7o, @y7o , @x8o, @y8o, @x9o, @y9o , @x10o, @y10o , @x11o, @y11o , @x12o, @y12o , @x13o, @y13o , @x14o, @y14o , @x15o, @y15o , @x16o, @y16o, @x17o, @y17o , @x18o, @y18o))
	'.
	"@x1o, @y1o , @x2o, @y2o , @x3o, @y3o , @x4o, @y4o , @x5o, @y5o , @x6o, @y6o , @x7o, @y7o , @x8o, @y8o, @x9o, @y9o , @x10o, @y10o , @x11o, @y11o , @x12o, @y12o , @x13o, @y13o , @x14o, @y14o , @x15o, @y15o , @x16o, @y16o, @x17o, @y17o , @x18o, @y18o , @x19o, @y19o , @x20o, @y20o , @x21o, @y21o"
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y))
	'.
	env eval: 'this.x5 = $$(@y4.mapE((y4) -> @mass5.position.x))
	this.y5 = $$(@x5.mapE((x5) -> @mass5.position.y))
	this.x6 = $$(@y5.mapE((y5) -> @mass6.position.x))
	this.y6 = $$(@x6.mapE((x6) -> @mass6.position.y))
	this.x7 = $$(@y6.mapE((y6) -> @mass7.position.x))
	this.y7 = $$(@x7.mapE((x7) -> @mass7.position.y))
	this.x8 = $$(@y7.mapE((y7) -> @mass8.position.x))
	this.y8 = $$(@x8.mapE((x8) -> @mass8.position.y))
	'.
	env eval: 'this.x9 = $$(@y8.mapE((y8) -> @mass9.position.x))
	this.y9 = $$(@x9.mapE((x9) -> @mass9.position.y))
	this.x10 = $$(@y9.mapE((y9) -> @mass10.position.x))
	this.y10 = $$(@x10.mapE((x10) -> @mass10.position.y))
	this.x11 = $$(@y10.mapE((y10) -> @mass11.position.x))
	this.y11 = $$(@x11.mapE((x11) -> @mass11.position.y))
	this.x12 = $$(@y11.mapE((y11) -> @mass12.position.x))
	this.y12 = $$(@x12.mapE((x12) -> @mass12.position.y))
	'.
	env eval: 'this.x13 = $$(@y12.mapE((y12) -> @mass13.position.x))
	this.y13 = $$(@x13.mapE((x13) -> @mass13.position.y))
	this.x14 = $$(@y13.mapE((y13) -> @mass14.position.x))
	this.y14 = $$(@x14.mapE((x14) -> @mass14.position.y))
	this.x15 = $$(@y14.mapE((y14) -> @mass15.position.x))
	this.y15 = $$(@x15.mapE((x15) -> @mass15.position.y))
	this.x16 = $$(@y15.mapE((y15) -> @mass16.position.x))
	this.y16 = $$(@x16.mapE((x16) -> @mass16.position.y))
	'.
	env eval: 'this.x17 = $$(@y16.mapE((y16) -> @mass17.position.x))
	this.y17 = $$(@x17.mapE((x17) -> @mass17.position.y))
	this.x18 = $$(@y17.mapE((y17) -> @mass18.position.x))
	this.y18 = $$(@x18.mapE((x18) -> @mass18.position.y))
	//this.x19 = $$(@y18.mapE((y18) -> @mass19.position.x))
	//this.y19 = $$(@x19.mapE((x19) -> @mass19.position.y))
	//this.x20 = $$(@y19.mapE((y19) -> @mass20.position.x))
	//this.y20 = $$(@x20.mapE((x20) -> @mass20.position.y))
	//this.x21 = $$(@y20.mapE((y20) -> @mass21.position.x))
	//this.y21 = $$(@x21.mapE((x21) -> @mass21.position.y))
	'.
	env eval: 
	'this.pointxs = [ this.x1, this.x2, this.x3, this.x4, this.x5, this.x6, this.x7, this.x8, this.x9, this.x10, this.x11, this.x12, this.x13, this.x14, this.x15, this.x16, this.x17, this.x18 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4, this.y5, this.y6, this.y7, this.y8, this.y9, this.y10, this.y11, this.y12, this.y13, this.y14, this.y15, this.y16, this.y17, this.y18 ]
	'.
	"x1, y1 , x2, y2 , x3, y3 , x4, y4 , x5, y5 , x6, y6 , x7, y7 , x8, y8, x9, y9 , x10, y10 , x11, y11 , x12, y12 , x13, y13 , x14, y14 , x15, y15 , x16, y16, x17, y17 , x18, y18 , x19, y19 , x20, y20 , x21, y21"
	env eval: 'this.plot = $$(lift((x1, y1 , x2, y2 , x3, y3 , x4, y4 , x5, y5 , x6, y6 , x7, y7 , x8, y8, x9, y9 , x10, y10 , x11, y11 , x12, y12 , x13, y13 , x14, y14 , x15, y15 , x16, y16, x17, y17 , x18, y18) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1 , @x2, @y2 , @x3, @y3 , @x4, @y4 , @x5, @y5 , @x6, @y6 , @x7, @y7 , @x8, @y8, @x9, @y9 , @x10, @y10 , @x11, @y11 , @x12, @y12 , @x13, @y13 , @x14, @y14 , @x15, @y15 , @x16, @y16 , @x17, @y17 , @x18, @y18))
	'.
	"@x1, @y1 , @x2, @y2 , @x3, @y3 , @x4, @y4 , @x5, @y5 , @x6, @y6 , @x7, @y7 , @x8, @y8, @x9, @y9 , @x10, @y10 , @x11, @y11 , @x12, @y12 , @x13, @y13 , @x14, @y14 , @x15, @y15 , @x16, @y16 , @x17, @y17 , @x18, @y18 , @x19, @y19 , @x20, @y20 , @x21, @y21"
	"Transcript show: (env at: #mass1) position.
	Transcript show: (env at: #mass2) position.
	Transcript show: (env at: #mass3) position.
	Transcript show: (env at: #mass4) position.
	Transcript show: (env at: #mass5) position.
	Transcript show: (env at: #mass6) position.
	Transcript show: (env at: #mass7) position.
	Transcript show: (env at: #mass8) position."
	
	"p1 runAndCommit."
"KSEventStreamInspector new object: env; running: true; open."! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:20'!
spring8FO
	
	"
	CoopLangZ3Examples new spring8FO
	"
	
	| env p1  a f ll fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld extent: 800@600..
	f := (Form extent: 1024@768 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass6, mass12, mass17: Mass
var mass2, mass3, mass4, mass5 , mass7 , mass8 , mass9 , mass10 , mass11, mass13, mass14, mass15, mass16, mass18, mass19, mass20, mass21 : FreeMass
var spring1 , spring2 , spring3 , spring4 , spring5 , spring6 , spring7 , spring8 , spring9 , spring10 , spring11 , spring12 , spring13 , spring14 , spring15 , spring16 , spring17 , spring18 , spring19 , spring20 , spring21 , spring22 , spring23 , spring24 , spring25 , spring26 , spring27 , spring28 , spring29 , spring30 , spring31 , spring32 , spring33 , spring34 , spring35 : Spring
var mass1Position , mass2Position , mass3Position , mass4Position , mass5Position , mass6Position , mass7Position , mass8Position , mass9Position , mass10Position , mass11Position , mass12Position , mass13Position , mass14Position , mass15Position , mass16Position , mass17Position , mass18Position , mass19Position , mass20Position , mass21Position,  mass1Velocity , mass2Velocity , mass3Velocity , mass4Velocity , mass5Velocity , mass6Velocity , mass7Velocity , mass8Velocity , mass9Velocity , mass10Velocity , mass11Velocity , mass12Velocity , mass13Velocity , mass14Velocity , mass15Velocity , mass16Velocity , mass17Velocity , mass18Velocity , mass19Velocity , mass20Velocity , mass21Velocity,  mass1Acceleration , mass2Acceleration , mass3Acceleration , mass4Acceleration , mass5Acceleration , mass6Acceleration , mass7Acceleration , mass8Acceleration , mass9Acceleration , mass10Acceleration , mass11Acceleration , mass12Acceleration , mass13Acceleration , mass14Acceleration , mass15Acceleration , mass16Acceleration , mass17Acceleration , mass18Acceleration , mass19Acceleration , mass20Acceleration , mass21Acceleration, mass1Weight , mass2Weight , mass3Weight , mass4Weight , mass5Weight , mass6Weight , mass7Weight , mass8Weight , mass9Weight , mass10Weight , mass11Weight , mass12Weight , mass13Weight , mass14Weight , mass15Weight , mass16Weight , mass17Weight , mass18Weight , mass19Weight , mass20Weight , mass21Weight: Point
var spring1Force , spring2Force , spring3Force , spring4Force , spring5Force , spring6Force , spring7Force , spring8Force , spring9Force , spring10Force , spring11Force , spring12Force , spring13Force , spring14Force , spring15Force , spring16Force , spring17Force , spring18Force , spring19Force , spring20Force , spring21Force , spring22Force , spring23Force , spring24Force , spring25Force , spring26Force , spring27Force , spring28Force , spring29Force , spring30Force , spring31Force , spring32Force , spring33Force , spring34Force , spring35Force : Vector
	'.
	numMasses := 21.
	numSprings := 35.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. true. true. true. true. false. true. true. true. true. true. false. true. true. true. true. false. true. true. true. true}. "which masses are free"
	problemInfo at: #springEnds put: #((1 2) (2 3) (3 4) (4 5) (5 11) (1 6) (6 7) (7 8) (8 9) (9 10) (1 7) (2 8) (3 9) (4 10) (2 7) (3 8) (4 9) (5 10) (11 16) (16 15) (15 14) (14 13) (13 12) (12 17) (17 18) (18 19) (19 20) (20 15) (15 21) (21 11) (12 18) (13 18) (13 19) (14 19) (14 20)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((37.0 44.0) (99.0  44.0) (161.0  45.0) (222.0  45.0) (283.0  47.0) (37.0  205.0) (99.0  147.0) (160.0  109.0) (221.0  86.0) (282.0  73.0) (343.0  72.0) (649.0  44.0) (587.0  44.0) (525.0  45.0) (464.0  45.0) (403.0  47.0) (649.0  205.0) (587.0  147.0) (526.0  109.0) (465.0  86.0) (404.0 73.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0) (50.0 50.0 10.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0 10.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.25
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects)
	modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	"(1 2) (2 3) (3 4) (4 5) (5 11) (1 6) (6 7) (7 8) (8 9) (9 10) (1 7) (2 8) (3 9) (4 10) (2 7) (3 8) (4 9) (5 10) (11 16) (16 15) (15 14) (14 13) (13 12) (12 17) (17 18) (18 19) (19 20) (20 15) (15 21) (21 11) (12 18) (13 18) (13 19) (14 19) (14 20)"
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 35]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 35]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(2000))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr >= 5
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	'.
	env eval: 'this.x5o = $$(@y4o.mapE((y4o) -> @mass5.position.x))
	this.y5o = $$(@x5o.mapE((x5o) -> @mass5.position.y))
	this.x6o = $$(@y5o.mapE((y5o) -> @mass6.position.x))
	this.y6o = $$(@x6o.mapE((x6o) -> @mass6.position.y))
	this.x7o = $$(@y6o.mapE((y6o) -> @mass7.position.x))
	this.y7o = $$(@x7o.mapE((x7o) -> @mass7.position.y))
	this.x8o = $$(@y7o.mapE((y7o) -> @mass8.position.x))
	this.y8o = $$(@x8o.mapE((x8o) -> @mass8.position.y))
	'.
	env eval: 'this.x9o = $$(@y8o.mapE((y8o) -> @mass9.position.x))
	this.y9o = $$(@x9o.mapE((x9o) -> @mass9.position.y))
	this.x10o = $$(@y9o.mapE((y9o) -> @mass10.position.x))
	this.y10o = $$(@x10o.mapE((x10o) -> @mass10.position.y))
	this.x11o = $$(@y10o.mapE((y10o) -> @mass11.position.x))
	this.y11o = $$(@x11o.mapE((x11o) -> @mass11.position.y))
	this.x12o = $$(@y11o.mapE((y11o) -> @mass12.position.x))
	this.y12o = $$(@x12o.mapE((x12o) -> @mass12.position.y))
	'.
	env eval: 'this.x13o = $$(@y12o.mapE((y12o) -> @mass13.position.x))
	this.y13o = $$(@x13o.mapE((x13o) -> @mass13.position.y))
	this.x14o = $$(@y13o.mapE((y13o) -> @mass14.position.x))
	this.y14o = $$(@x14o.mapE((x14o) -> @mass14.position.y))
	this.x15o = $$(@y14o.mapE((y14o) -> @mass15.position.x))
	this.y15o = $$(@x15o.mapE((x15o) -> @mass15.position.y))
	this.x16o = $$(@y15o.mapE((y15o) -> @mass16.position.x))
	this.y16o = $$(@x16o.mapE((x16o) -> @mass16.position.y))
	'.
	env eval: 'this.x17o = $$(@y16o.mapE((y16o) -> @mass17.position.x))
	this.y17o = $$(@x17o.mapE((x17o) -> @mass17.position.y))
	this.x18o = $$(@y17o.mapE((y17o) -> @mass18.position.x))
	this.y18o = $$(@x18o.mapE((x18o) -> @mass18.position.y))
	this.x19o = $$(@y18o.mapE((y18o) -> @mass19.position.x))
	this.y19o = $$(@x19o.mapE((x19o) -> @mass19.position.y))
	this.x20o = $$(@y19o.mapE((y19o) -> @mass20.position.x))
	this.y20o = $$(@x20o.mapE((x20o) -> @mass20.position.y))
	this.x21o = $$(@y20o.mapE((y20o) -> @mass21.position.x))
	this.y21o = $$(@x21o.mapE((x21o) -> @mass21.position.y))
	'.
	env eval: 
	'this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o, this.x5o, this.x6o, this.x7o, this.x8o, this.x9o, this.x10o, this.x11o, this.x12o, this.x13o, this.x14o, this.x15o, this.x16o, this.x17o, this.x18o, this.x19o, this.x20o, this.x21o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o, this.y4o, this.y5o, this.y6o, this.y7o, this.y8o, this.y9o, this.y10o, this.y11o, this.y12o, this.y13o, this.y14o, this.y15o, this.y16o, this.y17o, this.y18o, this.y19o, this.y20o, this.y21o ]
	'.
	"x1o, y1o , x2o, y2o , x3o, y3o , x4o, y4o , x5o, y5o , x6o, y6o , x7o, y7o , x8o, y8o, x9o, y9o , x10o, y10o , x11o, y11o , x12o, y12o , x13o, y13o , x14o, y14o , x15o, y15o , x16o, y16o, x17o, y17o , x18o, y18o , x19o, y19o , x20o, y20o , x21o, y21o"
	env eval: 'this.erased = $$(lift((x1o, y1o , x2o, y2o , x3o, y3o , x4o, y4o , x5o, y5o , x6o, y6o , x7o, y7o , x8o, y8o, x9o, y9o , x10o, y10o , x11o, y11o , x12o, y12o , x13o, y13o , x14o, y14o , x15o, y15o , x16o, y16o, x17o, y17o , x18o, y18o, x19o, y19o , x20o, y20o , x21o, y21o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o , @x2o, @y2o , @x3o, @y3o , @x4o, @y4o , @x5o, @y5o , @x6o, @y6o , @x7o, @y7o , @x8o, @y8o, @x9o, @y9o , @x10o, @y10o , @x11o, @y11o , @x12o, @y12o , @x13o, @y13o , @x14o, @y14o , @x15o, @y15o , @x16o, @y16o, @x17o, @y17o , @x18o, @y18o , @x19o, @y19o , @x20o, @y20o , @x21o, @y21o))
	'.
	"@x1o, @y1o , @x2o, @y2o , @x3o, @y3o , @x4o, @y4o , @x5o, @y5o , @x6o, @y6o , @x7o, @y7o , @x8o, @y8o, @x9o, @y9o , @x10o, @y10o , @x11o, @y11o , @x12o, @y12o , @x13o, @y13o , @x14o, @y14o , @x15o, @y15o , @x16o, @y16o, @x17o, @y17o , @x18o, @y18o , @x19o, @y19o , @x20o, @y20o , @x21o, @y21o"
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y))
	'.
	env eval: 'this.x5 = $$(@y4.mapE((y4) -> @mass5.position.x))
	this.y5 = $$(@x5.mapE((x5) -> @mass5.position.y))
	this.x6 = $$(@y5.mapE((y5) -> @mass6.position.x))
	this.y6 = $$(@x6.mapE((x6) -> @mass6.position.y))
	this.x7 = $$(@y6.mapE((y6) -> @mass7.position.x))
	this.y7 = $$(@x7.mapE((x7) -> @mass7.position.y))
	this.x8 = $$(@y7.mapE((y7) -> @mass8.position.x))
	this.y8 = $$(@x8.mapE((x8) -> @mass8.position.y))
	'.
	env eval: 'this.x9 = $$(@y8.mapE((y8) -> @mass9.position.x))
	this.y9 = $$(@x9.mapE((x9) -> @mass9.position.y))
	this.x10 = $$(@y9.mapE((y9) -> @mass10.position.x))
	this.y10 = $$(@x10.mapE((x10) -> @mass10.position.y))
	this.x11 = $$(@y10.mapE((y10) -> @mass11.position.x))
	this.y11 = $$(@x11.mapE((x11) -> @mass11.position.y))
	this.x12 = $$(@y11.mapE((y11) -> @mass12.position.x))
	this.y12 = $$(@x12.mapE((x12) -> @mass12.position.y))
	'.
	env eval: 'this.x13 = $$(@y12.mapE((y12) -> @mass13.position.x))
	this.y13 = $$(@x13.mapE((x13) -> @mass13.position.y))
	this.x14 = $$(@y13.mapE((y13) -> @mass14.position.x))
	this.y14 = $$(@x14.mapE((x14) -> @mass14.position.y))
	this.x15 = $$(@y14.mapE((y14) -> @mass15.position.x))
	this.y15 = $$(@x15.mapE((x15) -> @mass15.position.y))
	this.x16 = $$(@y15.mapE((y15) -> @mass16.position.x))
	this.y16 = $$(@x16.mapE((x16) -> @mass16.position.y))
	'.
	env eval: 'this.x17 = $$(@y16.mapE((y16) -> @mass17.position.x))
	this.y17 = $$(@x17.mapE((x17) -> @mass17.position.y))
	this.x18 = $$(@y17.mapE((y17) -> @mass18.position.x))
	this.y18 = $$(@x18.mapE((x18) -> @mass18.position.y))
	this.x19 = $$(@y18.mapE((y18) -> @mass19.position.x))
	this.y19 = $$(@x19.mapE((x19) -> @mass19.position.y))
	this.x20 = $$(@y19.mapE((y19) -> @mass20.position.x))
	this.y20 = $$(@x20.mapE((x20) -> @mass20.position.y))
	this.x21 = $$(@y20.mapE((y20) -> @mass21.position.x))
	this.y21 = $$(@x21.mapE((x21) -> @mass21.position.y))
	'.
	env eval: 
	'this.pointxs = [ this.x1, this.x2, this.x3, this.x4, this.x5, this.x6, this.x7, this.x8, this.x9, this.x10, this.x11, this.x12, this.x13, this.x14, this.x15, this.x16, this.x17, this.x18, this.x19, this.x20, this.x21 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4, this.y5, this.y6, this.y7, this.y8, this.y9, this.y10, this.y11, this.y12, this.y13, this.y14, this.y15, this.y16, this.y17, this.y18, this.y19, this.y20, this.y21 ]
	'.
	"x1, y1 , x2, y2 , x3, y3 , x4, y4 , x5, y5 , x6, y6 , x7, y7 , x8, y8, x9, y9 , x10, y10 , x11, y11 , x12, y12 , x13, y13 , x14, y14 , x15, y15 , x16, y16, x17, y17 , x18, y18 , x19, y19 , x20, y20 , x21, y21"
	env eval: 'this.plot = $$(lift((x1, y1 , x2, y2 , x3, y3 , x4, y4 , x5, y5 , x6, y6 , x7, y7 , x8, y8, x9, y9 , x10, y10 , x11, y11 , x12, y12 , x13, y13 , x14, y14 , x15, y15 , x16, y16, x17, y17 , x18, y18, x19, y19 , x20, y20 , x21, y21) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1 , @x2, @y2 , @x3, @y3 , @x4, @y4 , @x5, @y5 , @x6, @y6 , @x7, @y7 , @x8, @y8, @x9, @y9 , @x10, @y10 , @x11, @y11 , @x12, @y12 , @x13, @y13 , @x14, @y14 , @x15, @y15 , @x16, @y16 , @x17, @y17 , @x18, @y18 , @x19, @y19 , @x20, @y20 , @x21, @y21))
	'.
	"@x1, @y1 , @x2, @y2 , @x3, @y3 , @x4, @y4 , @x5, @y5 , @x6, @y6 , @x7, @y7 , @x8, @y8, @x9, @y9 , @x10, @y10 , @x11, @y11 , @x12, @y12 , @x13, @y13 , @x14, @y14 , @x15, @y15 , @x16, @y16 , @x17, @y17 , @x18, @y18 , @x19, @y19 , @x20, @y20 , @x21, @y21"
	"Transcript show: (env at: #mass1) position.
	Transcript show: (env at: #mass2) position.
	Transcript show: (env at: #mass3) position.
	Transcript show: (env at: #mass4) position.
	Transcript show: (env at: #mass5) position.
	Transcript show: (env at: #mass6) position.
	Transcript show: (env at: #mass7) position.
	Transcript show: (env at: #mass8) position."
	
	"p1 runAndCommit."
"KSEventStreamInspector new object: env; running: true; open."! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'hs 8/26/2012 03:20'!
spring9F
	
	"
	CoopLangZ3Examples new spring9F
	"
	
	| env p1  a f ll fbox fline numMasses numSprings problemInfo edges edgesStr |
	
	ll := JMorph new openInWorld." extent: 800@600."
	f := (Form extent: 1024@768 depth: 32) fillColor: Color black.
	fline := (Form extent: 1@1 depth: 8) fillWhite.
	fbox := (Form extent: 5@5 depth: 8) fillColor: Color red.
	ll window add: (a := JBox newTexture: f).
	a handlerAs: CoopLangs.
	env := a handler.
	env at: #form put: f.
	env at: #fline put: fline.
	env at: #fbox put: fbox.
	env model: CoopLangsLibrary Point , CoopLangsLibrary Vector , CoopLangsLibrary SpringsAndMasses2D.
	env problem: '
var t, dt : Real 
var g : Point
var mass1, mass3, mass6, mass8: Mass
var mass2, mass3, mass4, mass5 , mass7 , mass8 , mass9 : FreeMass
var spring1 , spring2 , spring3 , spring4 , spring5 , spring6 , spring7 , spring8 , spring9 , spring10 , spring11 , spring12 : Spring
var mass1Position , mass2Position , mass3Position , mass4Position , mass5Position , mass6Position , mass7Position , mass8Position, mass1Velocity , mass2Velocity , mass3Velocity , mass4Velocity , mass5Velocity , mass6Velocity , mass7Velocity , mass8Velocity, mass9Velocity, mass1Acceleration , mass2Acceleration , mass3Acceleration , mass4Acceleration , mass5Acceleration , mass6Acceleration , mass7Acceleration , mass8Acceleration , mass9Acceleration, mass1Weight , mass2Weight , mass3Weight , mass4Weight , mass5Weight , mass6Weight , mass7Weight , mass8Weight , mass9Weight : Point
var spring1Force , spring2Force , spring3Force , spring4Force , spring5Force , spring6Force , spring7Force , spring8Force , spring9Force , spring10Force , spring11Force , spring12Force , spring13Force , spring14Force , spring15Force , spring16Force , spring17Force , spring18Force , spring19Force , spring20Force , spring21Force , spring22Force , spring23Force , spring24Force , spring25Force , spring26Force , spring27Force , spring28Force , spring29Force , spring30Force , spring31Force , spring32Force , spring33Force , spring34Force , spring35Force : Vector
	'.
	numMasses := 9.
	numSprings := 12.
	problemInfo := IdentityDictionary new.
	problemInfo at: #freeMasses0 put: {false. true. false. true. true. false. true. false. true }. "which masses are free"
	problemInfo at: #springEnds put: #((1 2) (2 4) (4 3) (3 1) (2 5) (5 4) (5 7) (5 9) (7 6) (6 8) (8 9) (9 7)). "(startMass endMass)"
	problemInfo at: #positions0 put: #((0.0 0.0) (30.0 0.0) (0.0 80.0) (30.0 40.0) (60.0 40.0) (120.0 0.0) (90.0 0.0) (120.0 80.0) (90.0 40.0)). "initial positions of masses"
	problemInfo at: #springsInfo put: #((30.0 30.0 10.0) (40.0 40.0 10.0) (50.0 50.0 10.0) (80.0 80.0 10.0) (50.0 50.0 10.0) (30.0 30.0 10.0) (50.0 50.0 10.0) (30.0 30.0 10.0) (30.0 30.0 10.0) (80.0 80.0 10.0) (50.0 50.0 10.0) (40.0 40.0 10.0)). "(naturalLength length k)"
	problemInfo at: #massVals put: #(1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0 1.0). "mass values for free masses"
	self springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env.
	p1 := env hostProgram: '
	dt = t - old(t)
	dt = 0.20
	' in: #Z3 modifiableVars: #(t dt) modifiableObjects: (problemInfo at: #modifiableObjects)
	modifiableAttributes: #((Spring length) (Point x) (Point y) (Vector magnitude) (Vector x) (Vector y))
	options: #(debug true flatten true instantiateQuantifiers true truncateReals true setLogic AUFNIRA).
	env at: #p1 put: p1.
	"(1 2) (2 3) (3 4) (4 5) (5 11) (1 6) (6 7) (7 8) (8 9) (9 10) (1 7) (2 8) (3 9) (4 10) (2 7) (3 8) (4 9) (5 10) (11 16) (16 15) (15 14) (14 13) (13 12) (12 17) (17 18) (18 19) (19 20) (20 15) (15 21) (21 11) (12 18) (13 18) (13 19) (14 19) (14 20)"
	edges := problemInfo at: #springEnds.
	edgesStr := (edges allButFirst inject: ('[ [', edges first first , ', ' , edges first second , ']') into: [:s :x | s := '' , s , ', [' , x first , ', ' , x second , ']'. s ]) , ' ]'.
	env eval:
	'this.edges = ' , edgesStr , '
	'.
	env eval:
	'this.erase = () ->
	for i in [0 .. 12]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointoxs[pt1].currentValue()
		var curr1y = this.pointoys[pt1].currentValue()
		var curr2x = this.pointoxs[pt2].currentValue()
		var curr2y = this.pointoys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._black())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._black())
	'.
	env eval:
	'this.draw = () ->
	for i in [0 .. 12]
		var edge = this.edges[i]
		var pt1 = edge[0] - 1
		var pt2 = edge[1] - 1
		var curr1x = this.pointxs[pt1].currentValue()
		var curr1y = this.pointys[pt1].currentValue()
		var curr2x = this.pointxs[pt2].currentValue()
		var curr2y = this.pointys[pt2].currentValue()
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fline, P(50+curr1x,50+curr1y), P(50+curr2x,50+curr2y),  Display._boundingBox(), Form._over(), Color._green())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr1x,48+curr1y), P(48+curr1x,48+curr1y),  Display._boundingBox(), Form._over(), Color._red())
		this.form._drawLine_from_to_clippingBox_rule_fillColor(this.fbox, P(48+curr2x,48+curr2y), P(48+curr2x,48+curr2y),  Display._boundingBox(), Form._over(), Color._red())
	'.
	env eval: 'this.timer = $$(timerE(1500))
	this.ctr = $$(0 fby @ctr + 1 at @timer)
	this.stopTimer = $$(@ctr.mapE((ctr) -> if ctr >= 50
		this.timer = null))
	this.x1o = $$(@timer.mapE((timer) -> @mass1.position.x))
	this.y1o = $$(@x1o.mapE((x1o) -> @mass1.position.y))
	this.x2o = $$(@y1o.mapE((y1o) -> @mass2.position.x))
	this.y2o = $$(@x2o.mapE((x2o) -> @mass2.position.y))
	this.x3o = $$(@y2o.mapE((y2o) -> @mass3.position.x))
	this.y3o = $$(@x3o.mapE((x3o) -> @mass3.position.y))
	this.x4o = $$(@y3o.mapE((y3o) -> @mass4.position.x))
	this.y4o = $$(@x4o.mapE((x4o) -> @mass4.position.y))
	'.
	env eval: 'this.x5o = $$(@y4o.mapE((y4o) -> @mass5.position.x))
	this.y5o = $$(@x5o.mapE((x5o) -> @mass5.position.y))
	this.x6o = $$(@y5o.mapE((y5o) -> @mass6.position.x))
	this.y6o = $$(@x6o.mapE((x6o) -> @mass6.position.y))
	this.x7o = $$(@y6o.mapE((y6o) -> @mass7.position.x))
	this.y7o = $$(@x7o.mapE((x7o) -> @mass7.position.y))
	this.x8o = $$(@y7o.mapE((y7o) -> @mass8.position.x))
	this.y8o = $$(@x8o.mapE((x8o) -> @mass8.position.y))
	'.
	env eval: 'this.x9o = $$(@y8o.mapE((y8o) -> @mass9.position.x))
	this.y9o = $$(@x9o.mapE((x9o) -> @mass9.position.y))
	'.
	env eval: 
	'this.pointoxs = [ this.x1o, this.x2o, this.x3o, this.x4o, this.x5o, this.x6o, this.x7o, this.x8o, this.x9o ]
	this.pointoys = [ this.y1o, this.y2o, this.y3o, this.y4o, this.y5o, this.y6o, this.y7o, this.y8o, this.y9o ]
	'.
	env eval: 'this.erased = $$(lift((x1o, y1o , x2o, y2o , x3o, y3o , x4o, y4o , x5o, y5o , x6o, y6o , x7o, y7o , x8o, y8o, x9o, y9o) ->
	this.erase()
	this.whole._invalidRect(), @x1o, @y1o , @x2o, @y2o , @x3o, @y3o , @x4o, @y4o , @x5o, @y5o , @x6o, @y6o , @x7o, @y7o , @x8o, @y8o, @x9o, @y9o))
	'.
	env eval: 'this.dummy = $$(@erased.mapE((erased) -> this.p1._runAndCommit()))
	this.x1 = $$(@dummy.mapE((dummy) -> @mass1.position.x))
	this.y1 = $$(@x1.mapE((x1) -> @mass1.position.y))
	this.x2 = $$(@y1.mapE((y1) -> @mass2.position.x))
	this.y2 = $$(@x2.mapE((x2) -> @mass2.position.y))
	this.x3 = $$(@y2.mapE((y2) -> @mass3.position.x))
	this.y3 = $$(@x3.mapE((x3) -> @mass3.position.y))
	this.x4 = $$(@y3.mapE((y3) -> @mass4.position.x))
	this.y4 = $$(@x4.mapE((x4) -> @mass4.position.y))
	'.
	env eval: 'this.x5 = $$(@y4.mapE((y4) -> @mass5.position.x))
	this.y5 = $$(@x5.mapE((x5) -> @mass5.position.y))
	this.x6 = $$(@y5.mapE((y5) -> @mass6.position.x))
	this.y6 = $$(@x6.mapE((x6) -> @mass6.position.y))
	this.x7 = $$(@y6.mapE((y6) -> @mass7.position.x))
	this.y7 = $$(@x7.mapE((x7) -> @mass7.position.y))
	this.x8 = $$(@y7.mapE((y7) -> @mass8.position.x))
	this.y8 = $$(@x8.mapE((x8) -> @mass8.position.y))
	'.
	env eval: 'this.x9 = $$(@y8.mapE((y8) -> @mass9.position.x))
	this.y9 = $$(@x9.mapE((x9) -> @mass9.position.y))
	'.
	env eval: 
	'this.pointxs = [ this.x1, this.x2, this.x3, this.x4, this.x5, this.x6, this.x7, this.x8, this.x9 ]
	this.pointys = [ this.y1, this.y2, this.y3, this.y4, this.y5, this.y6, this.y7, this.y8, this.y9 ]
	'.
	env eval: 'this.plot = $$(lift((x1, y1 , x2, y2 , x3, y3 , x4, y4 , x5, y5 , x6, y6 , x7, y7 , x8, y8, x9, y9 ) ->
	this.draw()
	this.whole._invalidRect(), @x1, @y1 , @x2, @y2 , @x3, @y3 , @x4, @y4 , @x5, @y5 , @x6, @y6 , @x7, @y7 , @x8, @y8, @x9, @y9))
	'.
	"Transcript show: (env at: #mass1) position.
	Transcript show: (env at: #mass2) position.
	Transcript show: (env at: #mass3) position.
	Transcript show: (env at: #mass4) position.
	Transcript show: (env at: #mass5) position.
	Transcript show: (env at: #mass6) position.
	Transcript show: (env at: #mass7) position.
	Transcript show: (env at: #mass8) position."
	
	"p1 runAndCommit."
"KSEventStreamInspector new object: env; running: true; open."! !

!CoopLangZ3Examples methodsFor: 'interactive examples' stamp: 'AHB 7/31/2012 14:29'!
springInit: problemInfo numMasses: numMasses numSprings: numSprings env: env

	" setup for spring simulation tests "
	
	| Point Vector Joint JointEnd Mass FreeMass Spring dt t g massJointForces springJointEndForces massJoints springJointEnds masses positions springs velocities accelerations freeMassIdxs massForces springForces weights |
	
	Point := env getClass: #Point.  
	Vector := env getClass: #Vector.
	Joint := env getClass: #Joint.
	JointEnd := env getClass: #JointEnd.
	Mass := env getClass: #Mass.
	FreeMass := env getClass: #FreeMass.
	Spring := env getClass: #Spring.
	dt := 0.25.
	t := 0.0.
	g := Point new x: 0.0; y: 10.0; yourself.
	massJointForces := OrderedCollection new.
	springJointEndForces := OrderedCollection new.
	massJoints :=  OrderedCollection new.
	springJointEnds := OrderedCollection new.
	positions := OrderedCollection new.
	masses := OrderedCollection new.
	springs := OrderedCollection new.
	velocities := OrderedCollection new.
	accelerations := OrderedCollection new.
	massForces := OrderedCollection new.
	springForces := OrderedCollection new.
	freeMassIdxs := OrderedCollection new.
	weights := OrderedCollection new.
	1 to: numMasses do: [:i | | pt isFree res v0 ac0 w0 mf0 mj0 pos |
		isFree := (problemInfo at: #freeMasses0) at: i.	
		v0 := nil.
		ac0 := nil.
		w0 := nil.
		mf0 := nil.
		isFree ifTrue: [
			v0 := Point new x: 0.0; y: 0.0; yourself.
			ac0 := Point new x: 0.0; y: 10.0; yourself.
			w0 := Point new.
			mf0 := Point new.
		].
		velocities add: v0.
		accelerations add: ac0.
		weights add: w0.
		massForces add: mf0.
		pos := (problemInfo at: #positions0) at: i.
		positions add: (Point new x: pos first; y: pos second; yourself).
		pt := Point new.
		massJointForces add: pt.
		mj0 :=  Joint new force: pt; ends: {}; yourself.
		massJoints add: mj0.
		res := isFree ifTrue: [ FreeMass new ] ifFalse: [ Mass new ].
		res position: (positions at: i); joint: mj0.
		isFree ifTrue: [
			freeMassIdxs add: i.
			res mass: ((problemInfo at: #massVals) at: i); velocity: (velocities at: i); acceleration: (accelerations at: i); weight: (weights at: i); force: (massForces at: i).
		].
		mj0 body: res.
		masses add: res.
		env at: (#mass , i) asSymbol put: (masses at: i).
		env at: (#mass , i , #Position) asSymbol put: (positions at: i).
		env at: (#mass , i , #JointForce) asSymbol put: (massJointForces at: i).
		((problemInfo at: #freeMasses0) at: i) ifTrue: [
			env at: (#mass , i , #Weight) asSymbol put: (weights at: i).
			env at: (#mass , i , #Force) asSymbol put: (massForces at: i).
			env at: (#mass , i , #Velocity) asSymbol put: (velocities at: i).
			env at: (#mass , i , #Acceleration) asSymbol put: (accelerations at: i).
		].
	].	
	1 to: numSprings do: [:i | | j pt es efs ends info |
		es := OrderedCollection new.
		efs := OrderedCollection new.
		ends := (problemInfo at: #springEnds) at: i.
		1 to: 2 do: [:k | | m je |
			pt := Point new.
			m := ends at: k.
			j := massJoints at: m.
			efs add: pt.
			je := JointEnd new joint: j; force: pt; yourself.
			es add: je.
			j ends: (j ends , {je}).
			springJointEndForces add: pt.
			springJointEnds add: je.
			env at: (#spring, i , #JointEnd , k) asSymbol put: je.
			env at: (#spring, i , #JointEnd , k , #Force) asSymbol put: pt.
		].
		springForces add: Vector new.
		info := (problemInfo at: #springsInfo) at: i.
		springs add: (Spring new naturalLength: info first; k: info third; force: (springForces at: i); end1: es first; end2: es second; length: info second; yourself).
		env at: (#spring , i) asSymbol put: (springs at: i).
		env at: (#spring , i , #Force) asSymbol put: (springForces at: i).
	].
	env at: #t put: t.
	env at: #dt put: dt.
	env at: #g put: g.
	problemInfo at: #modifiableObjects put: (massJoints , massJointForces , springJointEndForces , springs , weights , massForces , velocities , accelerations , springForces , (freeMassIdxs collect: [:i | (masses at: i) position ])).
	
	! !

!CoopLangZ3Examples methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:32'!
testPuzzle2
	" 
	CoopLangZ3Examples new testPuzzle2
	Rotating rings puzzle.  In this early vesion, the solver can change the order of numbers on the rings.
	"
	|  env p1 Ring rings ring1 ring2 ring3 ring4 |
	env := CoopLangs newModel: '
class Ring : Thing
	Attributes
		i1, i2, i3, i4 : Int
	Constraints
		this.i1 = 1 || this.i1 = 10 || this.i1 = 100 || this.i1 = 1000
		this.i2 = 1 || this.i2 = 10 || this.i2 = 100 || this.i2 = 1000
		this.i3 = 1 || this.i3 = 10 || this.i3 = 100 || this.i3 = 1000
		this.i4 = 1 || this.i4 = 10 || this.i4 = 100 || this.i4 = 1000
		this.i1 + this.i2 + this.i3 + this.i4 = 1111
	' andProblem: '
var ring1, ring2, ring3, ring4 : Ring
	'.
	Ring := env getClass: #Ring.
	ring1 := Ring new.
	ring2 := Ring new.
	ring3 := Ring new.
	ring4 := Ring new.
	env at: #ring1 put: ring1.
	env at: #ring2 put: ring2.
	env at: #ring3 put: ring3.
	env at: #ring4 put: ring4.
	rings := {ring1. ring2. ring3. ring4}.
	p1 := env hostProgram: '
	all ring1 : Ring | all ring2 : Ring | (ring1 !!= ring2 => (ring1.i1 !!= ring2.i1 && ring1.i2 !!= ring2.i2 && ring1.i3 !!= ring2.i3 && ring1.i4 !!= ring2.i4))
	' in: #Z3 readOnlyObjects: {} readOnlyAttributes: #().
	p1 runAndCommit.
	rings do: [:ring |
		Transcript cr;  show: '' , ring i1 , ' ' , ring i2 , ' ' , ring i3 , ' ' , ring i4 , Character lf ].! !

!CoopLangZ3Examples methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:32'!
testPuzzle5
	" 
	CoopLangZ3Examples new testPuzzle5
	Rotating rings puzzle (yes it is like a slot machine...).  Solver cannot change a ring, only rotate it.  Rings have identity -- looking forward to when we can say for all Ring, if ringA !!= RingB ...
	"
	|  env p1 rings ring1 ring2 ring3 ring4 |
	env := CoopLangs newModel: '
class Ring : Thing
	Attributes
		i1, i2, i3, i4, identity : Int
class Ring1 : Ring
	Constraints
		this.i1 = 1 <=> ((this.i2 = 1 && this.i3 = 100 && this.i4 = 1000) || (this.i2 = 100 && this.i3 = 1000 && this.i4 = 1))
		this.i1 = 100 <=> (this.i2 = 1000 && this.i3 = 1 && this.i4 = 1)
		this.i1 = 1000 <=> (this.i2 = 1 && this.i3 = 1 && this.i4 = 100)
		this.i1 = 1 || this.i1 = 100 || this.i1 = 1000
class Ring2 : Ring
	Constraints
		this.i1 = 1 <=> ( this.i2 = 10 && this.i3 = 10 && this.i4 = 1000)
		this.i1 = 10 <=> (( this.i2 = 10 && this.i3 = 1000 && this.i4 = 1) || ( this.i2 = 1000 && this.i3 = 1 && this.i4 = 10))
		this.i1 = 1000 <=> ( this.i2 = 1 && this.i3 = 10 && this.i4 = 10)
		this.i1 = 1 || this.i1 = 10 || this.i1 = 1000
class Ring3 : Ring
	Constraints
		this.i1 = 1 <=> ( this.i2 = 10 && this.i3 = 100 && this.i4 = 1000)
		this.i1 = 10 <=> ( this.i2 = 100 && this.i3 = 1000 && this.i4 = 1)
		this.i1 = 100 <=> (( this.i2 = 100 && this.i3 = 1 && this.i4 = 10) || ( this.i2 = 1 && this.i3 = 10 && this.i4 = 100))
		this.i1 = 1 || this.i1 = 10 || this.i1 = 100 
class Ring4 : Ring
	Constraints
		this.i1 = 10 <=> ( this.i2 = 100 && this.i3 = 1000 && this.i4 = 1000)
		this.i1 = 100 <=> ( this.i2 = 1000 && this.i3 = 1000 && this.i4 = 10)
		this.i1 = 1000 <=> (( this.i2 = 1 && this.i3 = 10 && this.i4 = 100) ||  ( this.i2 = 10 && this.i3 = 100 && this.i4 = 1000))
		this.i1 = 10 || this.i1 = 100 || this.i1 = 1000
	' andProblem: '
var ring1 : Ring1
var ring2 : Ring2
var ring3 : Ring3
var ring4 : Ring4
	'.
	ring1 := (env getClass: #Ring1) new.
	ring2 := (env getClass: #Ring2) new.
	ring3 := (env getClass: #Ring3) new.
	ring4 := (env getClass: #Ring4) new.
	ring1 identity: 11.	"necessary to distinguish ring1from ring2 so hostProgram can force them to be different"
	ring2 identity: 22.
	ring3 identity: 33.
	ring4 identity: 44.
	env at: #ring1 put: ring1.
	env at: #ring2 put: ring2.
	env at: #ring3 put: ring3.
	env at: #ring4 put: ring4.
	rings := {ring1. ring2. ring3. ring4}.
	p1 := env hostProgram: '
(ring1.i1 !!= ring2.i1) && (ring1.i2 !!= ring2.i2) && (ring1.i3 !!= ring2.i3) && (ring1.i4 !!= ring2.i4)
(ring1.i1 !!= ring3.i1) && (ring1.i2 !!= ring3.i2) && (ring1.i3 !!= ring3.i3) && (ring1.i4 !!= ring3.i4)
(ring1.i1 !!= ring4.i1) && (ring1.i2 !!= ring4.i2) && (ring1.i3 !!= ring4.i3) && (ring1.i4 !!= ring4.i4)
(ring2.i1 !!= ring3.i1) && (ring2.i2 !!= ring3.i2) && (ring2.i3 !!= ring3.i3) && (ring2.i4 !!= ring3.i4)
(ring2.i1 !!= ring4.i1) && (ring2.i2 !!= ring4.i2) && (ring2.i3 !!= ring4.i3) && (ring2.i4 !!= ring4.i4)
(ring3.i1 !!= ring4.i1) && (ring3.i2 !!= ring4.i2) && (ring3.i3 !!= ring4.i3) && (ring3.i4 !!= ring4.i4)
	' in: #Z3 readOnlyObjects: {} readOnlyAttributes: #((Ring1 identity) (Ring2 identity) (Ring3 identity) (Ring4 identity)).
	p1 runAndCommit.
	Transcript cr;  show: '===='.
	rings do: [:ring |
		Transcript cr;  show: '' , ring i1 , ' ' , ring i2 , ' ' , ring i3 , ' ' , ring i4 , Character lf ].! !

!CoopLangZ3Examples methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 18:32'!
testPuzzle6
	" 
	CoopLangZ3Examples new testPuzzle6
	Rotating rings puzzle (yes it is like a slot machine...).  Solver cannot change a ring, only rotate it.
		Separate ring for each class -- no need for an id in each ring.
	"
	|  env p1 rings ring1 ring2 ring3 ring4 |
	env := CoopLangs newModel: '
class Ring : Thing
	Attributes
		i1, i2, i3, i4 : Int
class Ring1 : Ring
	Constraints
		this.i1 = 1 <=> ((this.i2 = 1 && this.i3 = 100 && this.i4 = 1000) || (this.i2 = 100 && this.i3 = 1000 && this.i4 = 1))
		this.i1 = 100 <=> (this.i2 = 1000 && this.i3 = 1 && this.i4 = 1)
		this.i1 = 1000 <=> (this.i2 = 1 && this.i3 = 1 && this.i4 = 100)
		this.i1 = 1 || this.i1 = 100 || this.i1 = 1000
class Ring2 : Ring
	Constraints
		this.i1 = 1 <=> ( this.i2 = 10 && this.i3 = 10 && this.i4 = 1000)
		this.i1 = 10 <=> (( this.i2 = 10 && this.i3 = 1000 && this.i4 = 1) || ( this.i2 = 1000 && this.i3 = 1 && this.i4 = 10))
		this.i1 = 1000 <=> ( this.i2 = 1 && this.i3 = 10 && this.i4 = 10)
		this.i1 = 1 || this.i1 = 10 || this.i1 = 1000
class Ring3 : Ring
	Constraints
		this.i1 = 1 <=> ( this.i2 = 10 && this.i3 = 100 && this.i4 = 1000)
		this.i1 = 10 <=> ( this.i2 = 100 && this.i3 = 1000 && this.i4 = 1)
		this.i1 = 100 <=> (( this.i2 = 100 && this.i3 = 1 && this.i4 = 10) || ( this.i2 = 1 && this.i3 = 10 && this.i4 = 100))
		this.i1 = 1 || this.i1 = 10 || this.i1 = 100 
class Ring4 : Ring
	Constraints
		this.i1 = 10 <=> ( this.i2 = 100 && this.i3 = 1000 && this.i4 = 1000)
		this.i1 = 100 <=> ( this.i2 = 1000 && this.i3 = 1000 && this.i4 = 10)
		this.i1 = 1000 <=> (( this.i2 = 1 && this.i3 = 10 && this.i4 = 100) ||  ( this.i2 = 10 && this.i3 = 100 && this.i4 = 1000))
		this.i1 = 10 || this.i1 = 100 || this.i1 = 1000
	' andProblem: '
var ring1 : Ring1
var ring2 : Ring2
var ring3 : Ring3
var ring4 : Ring4
	'.
	ring1 := (env getClass: #Ring1) new.
	ring2 := (env getClass: #Ring2) new.
	ring3 := (env getClass: #Ring3) new.
	ring4 := (env getClass: #Ring4) new.
	env at: #ring1 put: ring1.
	env at: #ring2 put: ring2.
	env at: #ring3 put: ring3.
	env at: #ring4 put: ring4.
	rings := {ring1. ring2. ring3. ring4}.
	p1 := env hostProgram: '
(ring1.i1 !!= ring2.i1) && (ring1.i2 !!= ring2.i2) && (ring1.i3 !!= ring2.i3) && (ring1.i4 !!= ring2.i4)
(ring1.i1 !!= ring3.i1) && (ring1.i2 !!= ring3.i2) && (ring1.i3 !!= ring3.i3) && (ring1.i4 !!= ring3.i4)
(ring1.i1 !!= ring4.i1) && (ring1.i2 !!= ring4.i2) && (ring1.i3 !!= ring4.i3) && (ring1.i4 !!= ring4.i4)
(ring2.i1 !!= ring3.i1) && (ring2.i2 !!= ring3.i2) && (ring2.i3 !!= ring3.i3) && (ring2.i4 !!= ring3.i4)
(ring2.i1 !!= ring4.i1) && (ring2.i2 !!= ring4.i2) && (ring2.i3 !!= ring4.i3) && (ring2.i4 !!= ring4.i4)
(ring3.i1 !!= ring4.i1) && (ring3.i2 !!= ring4.i2) && (ring3.i3 !!= ring4.i3) && (ring3.i4 !!= ring4.i4)
	' in: #Z3 readOnlyObjects: {} readOnlyAttributes: #().
	p1 runAndCommit.
	Transcript cr;  show: '===='.
	rings do: [:ring |
		Transcript cr;  show: '' , ring i1 , ' ' , ring i2 , ' ' , ring i3 , ' ' , ring i4 , Character lf ].! !

!CoopLangZ3Examples methodsFor: 'as yet unclassified' stamp: 'tk 12/11/2012 14:49'!
testSudoku4x4
	" 
	CoopLangZ3Examples new testSudoku4x4
	Sudoku with a 4 by 4 board.  Numbers 1 to 4.
	"
	|  env p1 cols col1 col2 col3 col4 |
	env := CoopLangs newModel: '
class Column : Thing
	Attributes
		i1, i2, i3, i4 : Int
	Constraints
		this.i1 = 1 || this.i1 = 2 || this.i1 = 3 || this.i1 = 4
		this.i2 = 1 || this.i2 = 2 || this.i2 = 3 || this.i2 = 4
		this.i3 = 1 || this.i3 = 2 || this.i3 = 3 || this.i3 = 4
		this.i4 = 1 || this.i4 = 2 || this.i4 = 3 || this.i4 = 4
	' andProblem: '
var col1, col2, col3, col4 : Column
	'.
	col1 := (env getClass: #Column) new.
	col2 := (env getClass: #Column) new.
	col3 := (env getClass: #Column) new.
	col4 := (env getClass: #Column) new.
	env at: #col1 put: col1.
	env at: #col2 put: col2.
	env at: #col3 put: col3.
	env at: #col4 put: col4.
	cols := {col1. col2. col3. col4}.
"Numbers is a row must be different, read down for terms in the same row, i.e.  i1 in all columns.
 Numbers is a column must be different, read down for terms in the same column, i.e.  col1.
 Numbers is a group must be different, read down for terms in the same group, i.e.  col1.i1, col1.i2, col2.i1, col2.i2 "
	p1 := env hostProgram: '
(col1.i1 !!= col2.i1) && (col1.i2 !!= col2.i2) && (col1.i3 !!= col2.i3) && (col1.i4 !!= col2.i4)
(col1.i1 !!= col3.i1) && (col1.i2 !!= col3.i2) && (col1.i3 !!= col3.i3) && (col1.i4 !!= col3.i4)
(col1.i1 !!= col4.i1) && (col1.i2 !!= col4.i2) && (col1.i3 !!= col4.i3) && (col1.i4 !!= col4.i4)
(col2.i1 !!= col3.i1) && (col2.i2 !!= col3.i2) && (col2.i3 !!= col3.i3) && (col2.i4 !!= col3.i4)
(col2.i1 !!= col4.i1) && (col2.i2 !!= col4.i2) && (col2.i3 !!= col4.i3) && (col2.i4 !!= col4.i4)
(col3.i1 !!= col4.i1) && (col3.i2 !!= col4.i2) && (col3.i3 !!= col4.i3) && (col3.i4 !!= col4.i4)
(col1.i1 !!= col1.i2) && (col2.i1 !!= col2.i2) && (col3.i1 !!= col3.i2) && (col4.i1 !!= col4.i2)
(col1.i1 !!= col1.i3) && (col2.i1 !!= col2.i3) && (col3.i1 !!= col3.i3) && (col4.i1 !!= col4.i3)
(col1.i1 !!= col1.i4) && (col2.i1 !!= col2.i4) && (col3.i1 !!= col3.i4) && (col4.i1 !!= col4.i4)
(col1.i2 !!= col1.i3) && (col2.i2 !!= col2.i3) && (col3.i2 !!= col3.i3) && (col4.i2 !!= col4.i3)
(col1.i2 !!= col1.i4) && (col2.i2 !!= col2.i4) && (col3.i2 !!= col3.i4) && (col4.i2 !!= col4.i4)
(col1.i3 !!= col1.i4) && (col2.i3 !!= col2.i4) && (col3.i3 !!= col3.i4) && (col4.i3 !!= col4.i4)
(col1.i1 !!= col1.i2) && (col1.i3 !!= col1.i4) && (col3.i1 !!= col3.i2) && (col3.i3 !!= col3.i4)
(col1.i1 !!= col2.i1) && (col1.i3 !!= col2.i3) && (col3.i1 !!= col4.i1) && (col3.i3 !!= col4.i3)
(col1.i1 !!= col2.i2) && (col1.i3 !!= col2.i4) && (col3.i1 !!= col4.i2) && (col3.i3 !!= col4.i4)
(col1.i2 !!= col2.i1) && (col1.i4 !!= col2.i3) && (col3.i2 !!= col4.i1) && (col3.i4 !!= col4.i3)
(col1.i2 !!= col2.i2) && (col1.i4 !!= col2.i4) && (col3.i2 !!= col4.i2) && (col3.i4 !!= col4.i4)
(col2.i1 !!= col2.i2) && (col2.i3 !!= col2.i4) && (col4.i1 !!= col4.i2) && (col4.i3 !!= col4.i4)
	' in: #Z3 readOnlyObjects: {} readOnlyAttributes: #().
	p1 runAndCommit.
	Transcript cr;  show: '===='.
	cols do: [:col |
		Transcript cr;  show: '' , col i1 , ' ' , col i2 , ' ' , col i3 , ' ' , col i4 , Character lf ].! !

Object subclass: #CoopLangsGuestProgram
	instanceVariableNames: 'language program modifiableVars modifiableAttrs modifiableObjs options environment solver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages'!

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 15:49'!
apply
	
	"runs the program on input and returns output denoted as 'result'..."
	
	^self apply: nil! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 9/25/2012 14:18'!
apply: input
	
	"runs the program on input and returns output denoted as 'result'..."
	| m0 |
	environment at: #input put: input.
	m0 := self run.
	^(m0 at: #output)
	! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 5/23/2012 11:26'!
checkOption: opt

	"check if user option is specified"
	
	^(self getOption: opt) isNil not! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/28/2012 11:19'!
endIncrementalRun
	solver endIncrementalRun! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:33'!
environment
	
	^environment! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:33'!
environment: env

	environment := env! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 13:19'!
get: var
	"gets the value of var. if var is modifiable compute it first."

	| relp env |
	relp := var asSymbol.
	env := (self isModifiableVar: var) 
		ifTrue: [ self run ]
		ifFalse: [ environment ].
	^env isNil ifTrue: [ nil ] ifFalse: [ env at: relp ]! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/8/2012 16:40'!
getOption: opt

	"gets value for user option if specified"
	^(options includesKey: opt)
		ifTrue: [ options at: opt ]
		ifFalse: [ nil ]
			! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:21'!
isModifiableAttr: rel
	"is this relation marked as modifiable"

	^modifiableAttrs contains: rel! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:21'!
isModifiableObj: o
	"is this object marked as modifiable"

	^modifiableObjs contains: o! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'mg 5/12/2014 10:11'!
isModifiableVar: v
	"is this variable marked as modifiable"

	^modifiableVars includes: v! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:34'!
language
	
	^language! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:34'!
language: lang
	
	^language := lang! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:22'!
modifiableAttrs
	
	^modifiableAttrs! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 8/26/2012 02:02'!
modifiableAttrs: mAttrs
	
	| rels |
	rels := environment relations.
	mAttrs do: [:r | (rels includesKey: r) ifFalse: [ self error: 'no such relation ' , r ] ].
	modifiableAttrs := mAttrs! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:22'!
modifiableObjs
	
	^modifiableObjs! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:22'!
modifiableObjs: mObjs
	
	modifiableObjs := mObjs! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:22'!
modifiableVars
	
	^modifiableVars! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:23'!
modifiableVars: mVars
	
	| vars |
	vars := environment variables.
	mVars do: [:r | (vars includesKey: r) ifFalse: [ self error: 'no such var ' , r ] ].
	modifiableVars := mVars! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 12:13'!
options
	
	^options! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 5/8/2012 12:13'!
options: x
	
	^options := x! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/18/2012 16:12'!
printModifiables

	Transcript show: 'modifiable variables: ' , modifiableVars , Character lf.
	Transcript show: 'modifiable attributes: ' , modifiableAttrs , Character lf.
	Transcript show: 'modifiable objects: ' , modifiableObjs , Character lf.! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:34'!
program

	^program! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 4/27/2012 16:34'!
program: p
	
	^program := p! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/28/2012 18:10'!
resolveAndCommit
	solver resolveAndCommit! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/24/2012 16:41'!
run
	"gets the right solver given the language of the given program, then runs the solver on program"
	| m0 m |

	solver := self runInit.
	m0 := solver run.
	^m0 isNil 
		ifTrue: [ nil ]
		ifFalse: [
			m := IdentityDictionary new.
			m0 do: [:x | m at: x first put: x fourth ].
			m
		]
	! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/24/2012 16:41'!
runAndCommit
	"gets the right solver given the language of the given program, then runs the solver on program"
	solver := self runInit.
	^solver runAndCommit! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/24/2012 16:41'!
runInit
	"find the specified language and sanity check environment"
	solver := CoopLang newProgram: self.
	"self sanityCheckEnvironment." "<--- undefined values now defaulted"
	^solver! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'hs 6/7/2012 11:00'!
sanityCheckEnvironment

	"check readonly variables are set in the environment"

	| vars env |

	vars := environment variables.
	env := environment environment.
	vars keys do: [:v | ((self isModifiableVar: v) or: [env includesKey: v])
			ifFalse: [ self error: 'var ' , v , ' is not modifiable, yet undefined.' ] ]! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/28/2012 11:19'!
setupIncrementalRun: editVars
	"incremental version of runAndCommit.  Gets the right solver given the language of the given program, then get it set up for repeatedly solving a problem involving changing the values of the variables in editVars."
	solver := self runInit.
	^solver setupIncrementalRun: editVars! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/28/2012 19:05'!
setupIncrementalRun: editVars strengths: strengths
	"incremental version of runAndCommit.  Gets the right solver given the language of the given program, then get it set up for repeatedly solving a problem involving changing the values of the variables in editVars."
	solver := self runInit.
	^solver setupIncrementalRun: editVars strengths: strengths! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/27/2012 16:05'!
solver
	^solver! !

!CoopLangsGuestProgram methodsFor: 'as yet unclassified' stamp: 'AHB 7/28/2012 11:24'!
updateValue: var newValue: x
	"incrementally update the value for variable var"
	solver updateValue: var newValue: x! !

Object subclass: #CoopLangsLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Libraries'!

!CoopLangsLibrary commentStamp: 'hs 5/24/2012 21:49' prior: 0!
CoopLangsLibrary:

	here is where we keep models (class defs) for reuse!

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 7/18/2012 13:00'!
ElectricalComponents

	^'class Node: Thing
	Attributes
		voltage: Real
		leads: Set (Lead)
	Constraints
		sum(this.leads.current) = 0.0
class Lead: Thing
	Attributes
		node: Node
		current: Real
class TwoLeadedThing: Thing
	Attributes
    		lead1, lead2: Lead
	Constraints
		this.lead1.current + this.lead2.current = 0.0
class Resistor: TwoLeadedThing
	Attributes
		resistance: Real
	Constraints
		this.lead1.node.voltage - this.lead2.node.voltage = this.resistance * this.lead2.current
class Wire: TwoLeadedThing
	Constraints
		//this.resistance = 0.0
		this.lead1.node.voltage = this.lead2.node.voltage 
class Battery: TwoLeadedThing
	Attributes
		voltage: Real
	Constraints
		this.lead1.node.voltage - this.lead2.node.voltage = this.voltage
class Diode: TwoLeadedThing
	Attributes
		voltage: Real
		isaturation: Real
		vthreshold: Real
	Constraints
		this.lead1.current = this.isaturation * e ^ ((this.lead1.node.voltage - this.lead2.node.voltage) / this.vthreshold)
'! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'AHB 6/13/2012 10:31'!
GeometricObjects

	^
'Strengths required, strong, medium, weak

class Point : Thing
	Attributes
		x, y : Real

class Line : Thing
	Attributes
		end1, end2 : Point

class LineWithStay : Thing
	Attributes
		end1, end2 : Point
	Constraints
		[weak]  end1, end2 stay
'

"alternate versions of stay: 
	[weak] this stay
	[weak] end1.x, end1.y, end2.x, end2.y stay
"
! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 6/12/2012 19:39'!
IntPoint

	^
'class Point : Thing
	Attributes
		x, y : Int
'! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 6/12/2012 14:03'!
Point

	^
'class Point : Thing
	Attributes
		x, y : Real
'! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 6/12/2012 15:47'!
SpringsAndMasses1D

	^
'class Mass : Thing
	Attributes
		position : Real
		beams : Set ( Spring )
class FreeMass: Mass
	Attributes
		mass : Real
		velocity, acceleration, weight, force : Real
	Constraints
		this.weight = this.mass * g
		this.force = this.weight + sum (this.beams.force)
		this.force = this.mass * this.acceleration
		this.velocity = 0.5 * (this.acceleration + old(this.acceleration)) * dt + old(this.velocity)
		this.position = 0.5 * (this.velocity + old(this.velocity)) * dt + old(this.position)
class Spring : Thing
	Attributes
		force, end1Force, end2Force : Real
		naturalLength, k, length : Real
		end1: Mass
		end2: FreeMass
	Constraints
		this.length = this.end2.position - this.end1.position
		this.force = - this.k * (this.length - this.naturalLength)
		this.end1Force = this.force
		this.end1Force + this.end2Force = 0.0
'! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 6/12/2012 15:50'!
SpringsAndMasses2D

	^
'class Mass : Thing
	Attributes
		position : Point
		joint : Joint
class FreeMass : Mass
	Attributes
		mass : Real
		velocity, acceleration, weight, force : Point
	Constraints
		this.weight.x = this.mass * g.x
		this.weight.y = this.mass * g.y
		this.force.x = this.weight.x + this.joint.force.x
		this.force.y = this.weight.y + this.joint.force.y
		this.force.x = this.mass * this.acceleration.x
		this.force.y = this.mass * this.acceleration.y
		this.velocity.x = 0.5 * (this.acceleration.x + old(this.acceleration.x)) * dt + old(this.velocity.x)
		this.velocity.y = 0.5 * (this.acceleration.y + old(this.acceleration.y)) * dt + old(this.velocity.y)
		this.position.x = 0.5 * (this.velocity.x + old(this.velocity.x)) * dt + old(this.position.x)
		this.position.y = 0.5 * (this.velocity.y + old(this.velocity.y)) * dt + old(this.position.y)
class Joint : Thing
	Attributes
		body : Mass
		force : Point
		ends : Set (JointEnd)
	Constraints
		this.force.x = sum (this.ends.force.x)
		this.force.y = sum (this.ends.force.y)
class JointEnd : Thing
	Attributes
		joint : Joint
		force : Point
class TwoEndedThing : Thing
	Attributes
		end1, end2: JointEnd
	Constraints
		this.end1.force.x + this.end2.force.x = 0.0
		this.end1.force.y + this.end2.force.y = 0.0
class Spring : TwoEndedThing
	Attributes
		force : Vector
		naturalLength, k, length : Real
	Constraints
		this.force.magnitude = - this.k * (this.length - this.naturalLength)
		this.length >= 0.0
		this.length ^ 2.0 = (old(this.end2.joint.body.position.x) - old(this.end1.joint.body.position.x)) ^ 2.0 + (old(this.end2.joint.body.position.y) - old(this.end1.joint.body.position.y)) ^ 2.0
		this.force.x = (old(this.end2.joint.body.position.x) - old(this.end1.joint.body.position.x)) / this.length * this.force.magnitude
		this.force.y = (old(this.end2.joint.body.position.y) - old(this.end1.joint.body.position.y)) / this.length * this.force.magnitude
		this.end2.force.x = this.force.x
		this.end2.force.y = this.force.y
'! !

!CoopLangsLibrary class methodsFor: 'library definitions' stamp: 'hs 6/12/2012 19:39'!
Vector

	^
'class Vector : Point
	Attributes
		magnitude : Real
	Constraints
		this.magnitude ^ 2.0 = this.x ^ 2.0 + this.y ^ 2.0
'! !

Object subclass: #PuzzleDescription
	instanceVariableNames: 'solver higherScoreIsGood goodScore badMoveStaysBad oneVariableAtATime removePiecesFromBoard permutation searchByPosition stopAfterNSolutions results displayMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!PuzzleDescription commentStamp: 'tk 4/6/2013 23:52' prior: 0!
A PuzzleDescription is the superclass of a specific kind of puzzle that we are trying to solve.

### Note that row is y and col is x.  But atLoc: (row@col) but needs to be (col@row).  Propogate this.  ###

solver			the CoopLangSimpleSearch that is doing the solving.  It calls back to ask for my inst vars.

badMoveStaysBad		true if adding more pieces to the board won't fix an illegal placement

goodScore			the number returned by evalaute: that means this works.

higherScoreIsGood		(false if lower is better as in golf)

oneVariableAtATime	true if A partially filled board is OK

removePiecesFromBoard	true if it is OK to remove pieces from the board.
	
permutation 		true if the solution is simply the proper permutation of the variables.
		
searchByPosition	true if each board position must be filled in order.  Any variable can be put into any square.  The order of searching the variables is not important. 

results		an Ordered collection of solutions.  A combination of varialbes that worked.

stopAfterNSolutions	1 if you only want one solution.  10000 if you want lots.

displayMorph		A TextMorph that to show the state of the problem.  Can be the board or some other kind of display.

Convention is that the PuzzlePiece instance is installed in each square it covers.
If pieces can be removed from the board, 
	If it occupies one square, define position
	If it occupies many squares, define squares.
	Default searches entire board for it.
		
To do:
[ ] add location to SudokuCell so it knows.
[ ] update the test methods
[ ] Solve actual Sudoku by restrincting range of some cells to a single number
[ ] Make board use a fixed width font.
[ ] write the essay.
[ ] remove the island area computation.

[Y] some display for 'el' -- add ID to each piece ABCD
[Y] some way to display "el" pieces
[N] Explore the AMB class and use it??!

PuzzleDescription subclass: #EvolveAPhrase
	instanceVariableNames: 'goal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!EvolveAPhrase methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2012 22:57'!
evaluate: varArray
	"Return the number of matches.  No interaction between letters, so don't really need the board (array of current variables)."
	
	| matches |
	matches := 0.
	varArray with: goal do: [:var :gChar |
		var letter = gChar ifTrue: [matches := matches +1]]..
	^ matches! !

!EvolveAPhrase methodsFor: 'as yet unclassified' stamp: 'tk 1/20/2013 18:51'!
evolveWeasel
	"Evolve the sentence 'methinks it is like a weasel' as explained in The Blind Watchmaker by Richard Dawkins.  Initialize randomly and start changing from there.
	( EvolveAPhrase new evolveWeasel ) explore
	"
	| piece board vars |
	self goal: 'methinks it is like a weasel'.
	board := PuzzleBoard rows: goal size columns: 1.
	solver board: board.
	vars := OrderedCollection new.
	board withIndicesDo: [:cell :row :col | "store the variables in the board"
		piece := (LetterVariable new).
		piece set: #letter range: ($a to: $z) asArray, {$ }.
		piece randomState.
		board at: row at: col put: piece.
		vars addLast: piece].

	"self initialize."
	solver variables: vars.
	higherScoreIsGood := true.
	oneVariableAtATime := false.	"all variables needed to evaluate"
	"define same:as:"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 1.
	removePiecesFromBoard := false.	"letters stay where they are"
	displayMorph := self initTextOfSingleChars: nil.   "no spaces"
	solver run.
	self board: nil "use latest results" intoText: displayMorph.
	^ { solver.  results }! !

!EvolveAPhrase methodsFor: 'accessing' stamp: 'tk 12/15/2012 10:09'!
goal

	^ goal! !

!EvolveAPhrase methodsFor: 'accessing' stamp: 'tk 12/15/2012 10:09'!
goal: anObject

	goal := anObject! !

PuzzleDescription subclass: #FillTheBoard
	instanceVariableNames: 'maxFootprint approvalBlock lastID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!FillTheBoard commentStamp: 'tk 4/6/2013 23:48' prior: 0!
A FillTheBoard is the problem description for pieces trying to fill a board completely.  Board has ElPiece instances in the squares.  An Integers in a square means it is empty.

maxFootprint		A Set of squares.  Each is a position where a flip of a piece can be placed (origin there) and still cover the square (0,0).  A subset of these offset to the current position is where a specific piece can be based and cover the current position.

approvalBlock		A one-arg-block.  From the size of a blank area on the board, return true if it is OK (exactly the right size for a piece).  (0 = area mod: piece size).

lastID		highest integer used on the board to indicate a blank square  (used for tracing the empty areas).!

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/6/2013 22:25'!
add: piece at: loc
	"try to add just one square of a piece.  Return true if it is unoccupied and on the board.  Fill in that square with the piece object."
	
	| brd res |
	brd := solver board.
	res := brd atLoc: loc ifInvalid: #outOfBounds.
	res == #outOfBounds ifTrue: [^ false].
	((res == nil) or: [res isInteger]) ifFalse: [^ false].
	brd atLoc: loc put: piece.
	^ true! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/28/2013 09:21'!
approvalBlock

	^ approvalBlock! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/28/2013 09:21'!
approvalBlock: anObject

	approvalBlock := anObject! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 12/18/2012 21:04'!
boardIntoText: aTextMorph
	"Put up a board that is a textMorph with one character for each cell.  Here a piece may cover mor than one cell."
	
	| spacers |
	"For now, don't look at results, only at the current state of the board"
	spacers := aTextMorph valueOfProperty: #spacers.
		"string of char between cells (space), and at end of line (return), or nil"
	aTextMorph contents: (String streamContents: [:strm |
		solver board withIndicesDo: [:cell :row :col | "store the variables in the board"
			strm nextPut: (
				cell		ifNil: [$ ]
						ifNotNil: [cell displayString first "old value"]).
			spacers ifNotNil: [
				strm nextPut: (col = solver board columnCount 
					ifTrue: [spacers second] "cr"
					ifFalse: [spacers first])].  "space"
			]]).
	ActiveWorld doOneCycle.	"show it"
	Delay forMilliseconds: 150.
! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 4/1/2013 15:36'!
evaluate: varArray
	"Return a score for placing the last piece in varArray on the board.  1 means they all fit. 0 means they don't..  varArray can by of any length.  The previous pieces do fit.
	Only the last piece in varArray has changed. "
	
	"later allow board to start at position other than 1@1"
	"later do expanded board, with margins, so can just index a square outside the board"
	
	| sqs piece coverPos |
	varArray size = 0 ifTrue: [^ 1].
	piece := varArray last.
	piece placeTries: piece placeTries + 1.
	sqs := piece squares.	"in absolute coords"
	coverPos := searchByPosition not. 	"false"
	sqs withIndexDo: [:loc :ind |
		loc = solver currentPosition ifTrue: [coverPos :=  true].
		(solver board emptyAtLoc: loc) ifFalse: [
			"If main square occupied, no flip will fit.  Skip them"
			loc = piece position ifTrue: ["main square"
				piece placeTries: piece placeTries - 1.	"undo the +1"
				"may want to test if flip is a var"
				piece advanceSkipVars: #(flip)].
			^ 0]].
	coverPos ifFalse: [^ 0].	"did not cover goal square"
	"The place for this piece is empty.  Put it on the board."
	sqs withIndexDo: [:loc :ind |
		solver board atLoc: loc put: piece].
	
	"This new piece does fit on the board"
	"Test if any new isolated blank areas are of the right size."
	"((AreaTracer new) search: sqs
		problem: self
		approvalBlock: approvalBlock) ifFalse: [
			sqs do: [:pt | solver board atLoc: pt put: nil].
			^ 0].   "
	piece placeSuccesses: piece placeSuccesses + 1.
	^ 1
	
	"Optimization when all pieces are identical (or varArray can be permuted):  FIrst column must be occupied by some part of piece 1.  Assumes that all pieces are identical"
	"varArray size = 1 ifTrue: [
		(varArray first squares includes: 1@1) ifFalse: [^ 0]]."

	"Optimization when all pieces are identical (or varArray can be permuted):  The newly placed piece must be touching some other piece."
	"varArray size > 1 ifTrue: [
		(self touchesAnotherPiece: varArray last) ifFalse: [
			self remove: varArray last.
			^ 0]]."

! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/20/2013 05:46'!
fourElsFill6x2
	"Fit four pieces into a 6 by 2 rectangle.  Each piece is an 'L' with 3 squares.
	( FillTheBoard new fourElsFill6x2 ) explore
	"
	
	| piece board vars |
	board := PuzzleBoard rows: 6 columns: 2.
	solver board: board.
	vars := OrderedCollection new.
	1 to: 4 do: [:ii |
		piece := (ElPiece new).
		piece flipList: {{0@0. 1@0.  0@1}.
			{0@0. 0@1.  -1@0}.
			{0@0. -1@0.  0@ -1}.
			{0@0. 0@ -1. 1@0}.}.
		piece set: #position range: (1@1 corner: board extent).
		piece set: #flip range: (1 to: piece numberOfFlips).
		piece id: (#('A' 'B' 'C' 'D') at: ii).
		vars addLast: piece].

	"self initialize."
	solver variables: vars.
	higherScoreIsGood := true.
	goodScore := 1.
	oneVariableAtATime := true.	"a subset of the variables can be evaluated"
	"define same:as:"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 2.
	removePiecesFromBoard := true.	"cells stay where they are.  0 means empty"
	approvalBlock := [:cnt | cnt \\ 3 = 0].	"size of an isolated blank area is OK"
	displayMorph := self initTextOfSingleChars: (String space, String cr).   "spacers"
	solver run.
	self board: #() "use latest results" intoText: displayMorph.
	^ { solver.  results }
"self first  board: (self second at: 1) intoText: nil"! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/7/2013 14:00'!
initialize

	super initialize.
	lastID := 0.! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/6/2013 23:01'!
lastID

	^ lastID! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/6/2013 23:01'!
lastID: anObject

	lastID := anObject! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/28/2013 22:26'!
makeFootprint
	"From a given starting square, collect the offset of every square reachable by any flip of any piece"
	
	maxFootprint := Set new.
	solver variables do: [:vv |
		vv flipList do: [:list |
			list do: [:offset | maxFootprint add: (0@0) - offset]]].! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/28/2013 09:21'!
maxFootprint

	^ maxFootprint! !

!FillTheBoard methodsFor: 'accessing' stamp: 'tk 3/28/2013 09:21'!
maxFootprint: anObject

	maxFootprint := anObject! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 3/29/2013 20:34'!
pemtominoesFill5x12
	"Fit the 12 pentominoes into a 5 by 12 rectangle.  Each piece has 5 squares.  CP has the pieces made by FindPieceEdgePath.
	( FillTheBoard new pemtominoesFill5x12 ) explore
	"
	
	solver board: (PuzzleBoard rows: 12 columns: 5).
	solver variables: (CP finalPieces copy).
	solver variables doWithIndex: [:piece :ind |
		piece set: #position range: (1@1 corner: solver board extent).
		piece set: #flip range: (1 to: piece numberOfFlips).
		piece id: (Character alphabet copyFrom: ind to: ind) asUppercase.
		piece initState ].
	higherScoreIsGood := true.
	goodScore := 1.
	oneVariableAtATime := true.	"a subset of the variables can be evaluated"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 2.
	removePiecesFromBoard := true.	"cells stay where they are.  0 means empty"
	approvalBlock := [:cnt | cnt \\ 5 = 0].	"size of an isolated blank area is OK"
	searchByPosition := true.
	self makeFootprint.
	displayMorph := self initTextOfSingleChars: (String space, String cr).   "spacers"
	solver run.
	self board: #() "use latest results" intoText: displayMorph.
	^ { solver.  results }
"self first  board: (self second at: 1) intoText: nil"

"	self board: solver board intoText: displayMorph.	"
! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 12/15/2012 22:46'!
piece: piece1 isSameAs: piece2
	"return true if they are considered to be the same.  All 'EL' pieces are the same."
	
	^ (piece1 isKindOf: ElPiece) and: [piece2 isKindOf: ElPiece]! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 4/1/2013 15:58'!
restrict: newVar positionsNear: aPosition
	"set range of newVar to be only the board positions that are nearby and not occupied.  A subset of the master list of offsets of squares that some piece can cover (maxFootprint).  "
	
	| brd reachable res rr |
	reachable := self maxFootprint collect: [:pt | pt + aPosition].
	reachable := reachable asSet.
	rr := newVar fullPositionRange select: [:pt2 | reachable includes: pt2].
	brd := solver board.
	rr := rr select: [:pt3 | 
		res := brd atLoc: pt3 ifInvalid: #outOfBounds.
		"know it is in-bounds"
		(res == nil) or: [res isInteger]].
	newVar ranges at: (newVar getters indexOf: #position) put: rr.
! !

!FillTheBoard methodsFor: 'as yet unclassified' stamp: 'tk 12/20/2012 19:28'!
touchesAnotherPiece: ptOrPiece
	"return true if this square or piece adjoins another piece.  Want a square that shares an edge that is not #outOfBounds, nor nil, nor my same piece."

	| marker there |
	ptOrPiece isPoint 
		ifFalse: ["a piece"
			ptOrPiece squares 
				do: [:newSq |
					(self touchesAnotherPiece: newSq) ifTrue: [^ true]].
			^ false]

		ifTrue: ["one square that is occupied"
			marker := solver board atLoc: ptOrPiece ifInvalid: #outOfBounds.
				"whatever we put into a square of this placed piece"
			marker = #outOfBounds ifTrue: [
				self error: 'the squares of a a placed piece should all be legal'].
			(solver board squaresAround: ptOrPiece) 
				do: [:sq |
					there := solver board atLoc: sq ifInvalid: #outOfBounds.
					(((there ~~ nil) and: [there ~~ #outOfBounds]) 
						and: [there ~~ marker]) ifTrue: [^ true]].
			^ false]

! !

PuzzleDescription subclass: #FindPentominoes
	instanceVariableNames: 'edgeLists kindOfPiece'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 3/2/2013 09:06'!
acceptSolution: varArray
	"Determine if this piece already exists in results, rotated, or flipped and then translated.  This snapshot vs. the prior results"

	| this |
	this := solver board copy.
	"just slide to the upper left.  See if it is already in the solutions."
	this := this slideToLowerLeft.

	results do: [:aBoard |
		aBoard = this ifTrue: [^ false]].  "already have it"

	^ true		"it is new"! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 12/20/2012 19:30'!
add: piece at: loc
	"try to add just one square of a piece.  Return true if it is unoccupied and on the board.  Fill in that square with the piece object."
	
	| brd res |
	brd := solver board.
	res := brd atLoc: loc ifInvalid: #outOfBounds.
	res == #outOfBounds ifTrue: [^ false].
	res ifNotNil: [^ false].
	brd atLoc: loc put: piece.
	^ true! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 1/7/2013 19:08'!
evaluate: varArray
	"Return a score for placing the pieces in varArray on the board.  1 means they all fit. 0 means they don't..  Start with a clean board and place the pieces on it.  varArray can by of any length.
	Only the last piece in varArray has changed. "
	
	"later allow board to start at position other than 1@1"
	"later do expanded board, with margins, so can just index a square outside the board"
	
	| |
	solver board atAllPut: nil.
	varArray do: [:piece |
		(self add: piece at: piece position) ifFalse: [^ 0]].
	
	"The pieces do fit on the board"
	"Optimization:  square 1 must be in the first column.  Assumes that all squares are identical."
	varArray size > 0 ifTrue: [
		(varArray first position x = 1) ifFalse: [^ 0]].
	
	"Optimization.  The newly placed piece must be touching some other piece."
	varArray size > 1 ifTrue: [
		(self touchesAnotherPiece: varArray last) ifFalse: [^ 0]].

	^ 1! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 2/9/2013 08:06'!
findThePentominoes
	"Find all ways that 5 squares can be attached along their borders.  Flips and rotations of a solution is the same solution.
	( FindPentominoes new findThePentominoes ) explore
	"
	
	| piece board vars |
	board := PuzzleBoard rows: 5 columns: 5.  "5 x 3 gives the same result"
	solver board: board.
	vars := OrderedCollection new.
	1 to: 5 do: [:ii |
		piece := (OneSquare new).	"put its location into the number slot"
		piece set: #position range: board extent.
		vars addLast: piece].

	"self initialize."
	solver variables: vars.
	higherScoreIsGood := true.
	goodScore := 1.
	oneVariableAtATime := true.	"a subset of the variables can be evaluated"
	"define same:as:"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 200.
	removePiecesFromBoard := true.	""
	displayMorph := self initTextOfSingleChars: ("spacers" String space, String cr).   
	solver run.
	self board: nil "use latest results" intoText: displayMorph.
	Smalltalk at: #PentoShapes put: { solver.  results }.
	^ { solver.  results }
	
"self first  board: (self second at: 21) intoText: nil"! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 12/28/2012 14:29'!
piece: piece1 isSameAs: piece2
	"return true if they are considered to be the same.  This refers to the squares within a penrominoe.  All squares are the same.."
	
	^ (piece1 isKindOf: OneSquare) and: [piece2 isKindOf: OneSquare]! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 3/8/2013 16:20'!
remove: aPiece
	"take this piece off the board.  It must be there now.
	Could just (board removeAll: aPiece).  But may have large boards. equality."
	
	(solver board atLoc: aPiece position ifInvalid: #outOfBounds) 
			== aPiece ifFalse: [^ self].  "piece not really there"
	solver board atLoc: aPiece position put: nil.
! !

!FindPentominoes methodsFor: 'kind of piece' stamp: 'tk 12/28/2012 15:08'!
segmentListFor: aBoard
	"unsorted list of all edges.  Each is two points stored in a rectangle that has zero area.  Remove all interior edges (each occurs twice, once from each square."
	
	| edges squares edges2 |
	squares := OrderedCollection new.
	aBoard do: [:aCell | aCell ifNotNil: [squares add: aCell]].
		"square must remember its location.  check it here?"
	edges := OrderedCollection new.
	squares do: [:sq |
		edges add: (sq location corner: sq location + (0@1)).	"left side"
		edges add: (sq location + (1@0) corner: sq location + (1@1)).	"right side"
		edges add: (sq location corner: sq location + (1@0)).	"top"
		edges add: (sq location + (0@1) corner: sq location + (1@1)).	"bottom"
		].
	edges2 := edges asBag.
	"remove all the edges that occur more than once"
	edges2 valuesAndCounts keysAndValuesRemove: [:object :count | count > 1].
	^ edges2! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 3/2/2013 09:06'!
snapshot
	"return an array that saves the info from this solution"
	
	| thisSolution |
	displayMorph ifNotNil: [
		self board: (results size > 0 ifTrue: [results last copy] ifFalse: [OrderedCollection new])
			intoText: displayMorph].

	thisSolution := solver board copy.
	"preserve the locations of the cells"
	thisSolution withIndicesDo: [:cell :row :col | 
		 thisSolution at: row at: col put: cell copy].
	"record the entire board"
	^ thisSolution slideToLowerLeft! !

!FindPentominoes methodsFor: 'find all pentos' stamp: 'tk 12/20/2012 19:26'!
touchesAnotherPiece: ptOrPiece
	"return true if this square or piece adjoins another piece.  Want a square that shares an edge that is not #outOfBounds, nor nil, nor my same piece."

	| marker there |
	ptOrPiece isPoint 
		ifFalse: ["a piece"
			^ self touchesAnotherPiece: ptOrPiece position]

		ifTrue: ["one square that is occupied"
			marker := solver board atLoc: ptOrPiece ifInvalid: #outOfBounds.
				"whatever we put into a square of this placed piece"
			marker = #outOfBounds ifTrue: [
				self error: 'the squares of a a placed piece should all be legal'].
			(solver board squaresAround: ptOrPiece) 
				do: [:sq |
					there := solver board atLoc: sq ifInvalid: #outOfBounds.
					(((there ~~ nil) and: [there ~~ #outOfBounds]) 
						and: [there ~~ marker]) ifTrue: [^ true]].
			^ false]


! !

PuzzleDescription subclass: #FindPieceEdgePath
	instanceVariableNames: 'pieceBoards pieces finalPieces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!FindPieceEdgePath commentStamp: 'tk 2/24/2013 16:51' prior: 0!
A FindPieceEdgePath manages the conversion from 63 oriented pentominoes to the 12 pieces needed by a FillTheBoard solver.

See findEdgePath:.  It converts a single 5x5 piece of 5 squares into a path of (straight, left, left, straight, right...).  This can be compared with the path from another piece to see if they are rotations of each other. This is to get the 12 pieces and the squares of their orientations.  The 'puzzle' here is to assemble the edges of the piece in the right order, to form a perimeter.

board is a column of edges.  Problem is to put the right edge in each position.  No duplicates.  Next piece must go in just one place -- the next open square.  Consider all remaining pieces.  Say this by:

Two pieces are the same if you can rotate one's edgeList and get the other's edgeList.  Or, reverse the list and rotate it.

pieceBoards	Array of 5x5 boards with five squars on each one.  The raw pieces.  resuts from FindPentominoes.
	
pieces			Array of ElPieces, corresponding to pieceBoards.  With edgePath filled in.
			
finalPieces		Array of ElPieces, with flipList filled in.  No duplicates.  All orientations of a single piece are in one ElPiece.!

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/3/2013 17:41'!
collectMany: many startOver: startOver
	"Take a list of 63 boards with 5 squares each, from FindPentominoes, and find the edge-list for each, and make 63 pentomino pieces."

	| ind elp pair raw |
	startOver ifTrue: [self rawBoards: pieceBoards].
		"forget any processing we did"
	[ind := pieces size + 1.
	 pair := (FindPieceEdgePath new) findEdgePath: (raw := pieceBoards at: ind).
	 pieces addLast: (elp := ElPiece new).
	 "a provisional piece.  Will be merged with its other orientations" 
	 elp edgeList: pair second first.	"board or not?"
	 "set flipList of relative squares"
	 elp flipList: {self squareOffsetsOf: raw} asOrderedCollection. 
	 elp turnList: (elp edgeList collect: [:ee | ee turn]).
	 (ind < pieceBoards size) & many ] whileTrue.
	
	 "when solving later, next square might need to be filled by a square that is not square 1 of that flip -- how do that?  Try many different squares to fill?"! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/3/2013 18:02'!
combineFlips
	"Find the 12 true pentominos.  Fill in finalPieces.  Store 1, 2, 4, 8 offsets of squares (flips) and also edge lists in each ElPiece."
	
	| finalP got pfInd |
	pieces do: [:flippedPiece |
		pfInd := 0.
		got := false.
		[(pfInd := pfInd + 1) <= finalPieces size 
			ifFalse: [false]
			ifTrue: [
				finalP := finalPieces at: pfInd.
				(self edgeList: flippedPiece turnList sameAs: finalP turnList) 
					ifTrue: [ "a new flip of it"
						finalP flipList add: flippedPiece flipList first.
						"finalP edgeList add: flippedPiece edgeList first.
							no.  know it is the same"
						got := true].
				got not]] whileTrue.
		got ifFalse: ["new piece"
			finalPieces addLast: flippedPiece copy.
			finalPieces last id: finalPieces size.
			].
		].! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/3/2013 18:11'!
edgeList: list1 sameAs: other
	"See if two orientations (flips) are the same.  rotate one edgelist and compare it with the other.  Then reverse it and compare again.  List is #(left, right, straight, straight, right, ...)"
	
	| list2 list3 |
	list2 := other class == OrderedCollection
		ifTrue: [other copy]	"we will mangle it"
		ifFalse: [other asOrderedCollection].
	list1 size = list2 size ifFalse: [^false].	
	1 to: list1 size do: [:ind | 
		(list1 hasEqualElements: list2) ifTrue: [^ true].
		list2 addLast: (list2 removeFirst)].

	list3 := list2 reversed.
	list1 size = list3 size ifFalse: [^false].	
	1 to: list1 size do: [:ind | 
		(list1 hasEqualElements: list3) ifTrue: [^ true].
		list3 addLast: (list3 removeFirst)].

	^ false! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 2/28/2013 23:05'!
evaluate: varArray
	"Can the last edge on the board (the last in the single row), come after the next to last edge?  If so, fill in the next to last edge's turn symbol (left, right, straight).
	If two edge midpoints are on a right triangle that is 0.5 0.5 and squareRoot(0.25), then yes.  If the are 1.0 apart, then yes, they are straight.  (But not OK for two points across from each other on the same square.  Same center point.)
	Needs to go clockwise.  Check the second edge placed for that.
	If the center of old square is the center of new square, the turn is #right.  Else #left."
	
	| previous current distance |
	varArray size = 0 ifTrue: [^ 1].
	current := varArray last.
	varArray size = 1 ifTrue: [
		current position: 1@1.
		solver board atLoc: 1@1 put: current.
		^ 1].
	previous := (varArray last: 2) first.
	distance := previous midpoint dist: current midpoint.
	"Transcript cr; show: distance; space; show: varArray size."
	distance = 1.0 | (distance = 0.5 sqrt) ifFalse: [^ 0].	"not adjacent"
	(previous center dist: current center) > 1.9 ifTrue: [^0].		"max of 1.0 for straight edge"
	distance = 1.0 
		ifTrue: ["straight"
			previous center = current center ifTrue: [^0].	"across one square. not along edges"
			previous turn: #straight]
		ifFalse: [
			previous turn: (previous center = current center 
				ifTrue: [#right] ifFalse: [#left]).
			].
	varArray size = 2 
		ifTrue: ["first placement.  Is it clockwise?"
			(self isClockwise: previous then: current) ifFalse: [^0] ]	"not placed"
		ifFalse: [
			varArray size = solver variables size ifTrue: [
			"set the turn for the last (current) edge"
			(self evaluate: {current. varArray first}) < 1 ifTrue: [
				self error: 'Oops!!  not a closed loop of edges!!']]].
	current position: varArray size@1.
	solver board atLoc: varArray size@1 put: current.
	^ 1! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
finalPieces

	^ finalPieces! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
finalPieces: anObject

	finalPieces := anObject! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/3/2013 08:43'!
findEdgePath: pieceBoard
	"Given a board with 5 squares (a pentominoe piece), find a path of (left, right, straight, straight, right, ...) that traces its perimeter.  Caller will Construct an ElPiece and store the edge path back into it.  Store the ElPiece into the pieces.  
	Later we can tell if two pieces are the same by rotating the path and comparing it to another path.  Reverse the path to flip the piece over.  
	An EdgePoint has the center point of the edge, the center of the square, a place for its turn symbol (left, right, straight) to the next edge.  Position is its index in the edge list." 
	
	| board vars |
	vars := self makeEdges: pieceBoard.		"array of EdgePoints"
	board := PuzzleBoard rows: 1 columns: vars size.  "holds EdgePoints"
	solver board: board.
	solver variables: vars.
	higherScoreIsGood := true.
	goodScore := 1.
	permutation := true.
	stopAfterNSolutions := 1.
	displayMorph := nil.   "no display"
	solver run.
	^ { solver.  results }
	
	"These not needed for a permutation:"
	"oneVariableAtATime := true.	a subset of the variables can be evaluated"
	"badMoveStaysBad := true. 	adding more variables (pieces) won't fix an illegal placement"
	"removePiecesFromBoard := true.	cells stay where they are.  0 means empty"
! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/2/2013 22:18'!
isClockwise: previous then: current
	"return true if the two edges are a clockwise path.  Current knows its turn."
	
	previous turn == #left ifTrue: [
		^ previous center ~= current center].
	previous turn == #right ifTrue: [
		^ previous center = current center].
	"straight"
	^ (previous midpoint to: current midpoint "end" sideOf: previous center) == #right
	"Point to:sideOf: returns #left, #right, #center if the otherPoint lies to the left, right or on the line from self to end"
	" (0@0 to: 2@0 sideOf: 1@1) is #left.  Y goes upwards.  To the right is clockwise
	"
! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 2/24/2013 00:06'!
makeEdges: pieceBoard
	"Starting with the board that represents a pentominoe piece (with 5 squares on it), make an array of EdgePoints of the midpoints of the edges.  Eliminate any points that occur twice (they are in the interior of the piece)."
	
	| list ep idx midpoints |
	list := OrderedCollection new.
	midpoints := OrderedCollection new.
	pieceBoard do: [:aSquare | 
		aSquare ifNotNil: [
			{1@0. 0@ -1. -1@0. 0@1} do: [:direction |
				ep := EdgePoint new.
				ep center: aSquare position - (0.5@0.5).
				ep midpoint: (ep center + (0.5 * direction)).	  "midpoint of an edge"
				idx := midpoints indexOf: ep midpoint.
				idx > 0 
					ifTrue: ["point is there twice.  An interior point"
						list removeAt: idx.
						midpoints removeAt: idx]
					ifFalse: ["point is new"
						list add: ep.
						midpoints add: ep midpoint]]]].
	^ list! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
pieceBoards

	^ pieceBoards! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
pieceBoards: anObject

	pieceBoards := anObject! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
pieces

	^ pieces! !

!FindPieceEdgePath methodsFor: 'accessing' stamp: 'tk 2/28/2013 22:48'!
pieces: anObject

	pieces := anObject! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 2/24/2013 16:55'!
rawBoards: rawPieceBoards
	"Take a list of 63 boards with 5 squares each, from FindPentominoes, find the edge-list for each, and collect the 12 actual pentominoes."

	pieceBoards := rawPieceBoards.
	pieces := OrderedCollection new.
	finalPieces := OrderedCollection new.
	
	! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/8/2013 16:19'!
remove: aPiece
	"take this piece off the board.  Called by permutation."
	
	solver board at: solver tryThese size at: 1 put: nil.
! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 3/20/2013 05:58'!
snapshot
	"return an array that saves the info from this solution"

	^ solver tryThese "copy??"! !

!FindPieceEdgePath methodsFor: 'as yet unclassified' stamp: 'tk 2/28/2013 22:45'!
squareOffsetsOf: rawPieceBoard
	"from the board of squares, extract a list of offsets of those squares.  choose a square in column 1 as the base."
	| relSqs base |
	relSqs := OrderedCollection new.
	rawPieceBoard withIndicesDo: [:square :row :col |
		square ifNotNil: [relSqs add: col@row]].
	"find one in Column 1"
	base := relSqs detect: [:pt | pt x = 1].
	^ relSqs collect: [:ppt | ppt - base]! !

!PuzzleDescription methodsFor: 'solve' stamp: 'tk 12/20/2012 19:49'!
acceptSolution: varArray
	"as a default always accept the solution"
	
	^ true! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
badMoveStaysBad

	^ badMoveStaysBad! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
badMoveStaysBad: anObject

	badMoveStaysBad := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/18/2012 12:04'!
board

	^ solver board! !

!PuzzleDescription methodsFor: 'display' stamp: 'tk 3/20/2013 06:08'!
board: aBoard intoText: aTextMorph
	"Put up a board that is a textMorph with one character for each cell.  Override this to show your puzzle's variables."
	
	| list spacers it textMorph |
	textMorph := aTextMorph ifNil: [
		displayMorph ifNil: [^ self]].
	list := aBoard ifNil: [results size > 0
			ifTrue: [results last copy] ifFalse: [OrderedCollection new]]
		ifNotNil: [aBoard].
	list := (list isKindOf: PuzzleBoard) 
		ifTrue: [list := list asOrderedCollection]
		ifFalse: [list copy].
	spacers := textMorph valueOfProperty: #spacers.
		"string of char between cells (space), and at end of line (return), or nil"
	textMorph contents: (String streamContents: [:strm |
		solver board withIndicesDo: [:cell :row :col | "store the variables in the board"
			strm nextPut: (
				list isEmpty ifTrue: [cell
						ifNil: [$ ]
						ifNotNil: [cell displayString first "old value"]]
					ifFalse: [it := list removeFirst.
						it ifNil: [$-] 
							ifNotNil: [it isInteger ifTrue: [it printString last]
								ifFalse: [(it displayString withBlanksTrimmed, ' ') first]]]).
			spacers ifNotNil: [
				strm nextPut: (col = solver board columnCount 
					ifTrue: [spacers second] "cr"
					ifFalse: [spacers first])].  "space"
			].
		strm cr; nextPutAll: results size printString ]).
	ActiveWorld doOneCycle.	"show it"
	(Delay forMilliseconds: 150) wait.
	"Sensor waitClickButton."
! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/18/2012 12:20'!
displayMorph

	^ displayMorph! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/18/2012 12:20'!
displayMorph: anObject

	displayMorph := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
goodScore

	^ goodScore! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
goodScore: anObject

	goodScore := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
higherScoreIsGood

	^ higherScoreIsGood! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
higherScoreIsGood: anObject

	higherScoreIsGood := anObject! !

!PuzzleDescription methodsFor: 'display' stamp: 'tk 3/9/2013 19:26'!
initTextOfSingleChars: spacers
	"put up a board that is a textMorph with one character for each cell"
	
	| tt pixelWidth max |
	tt := TextMorph boldAuthoringPrototype.
	spacers 
		ifNil: [tt removeProperty: #spacers]
		ifNotNil: [tt setProperty: #spacers toValue: spacers].
	max := self board columnCount max: self board rowCount.
	pixelWidth := max * (spacers ifNil: [1] ifNotNil: [2]) * 18. "char width"
	tt position: (Display width - pixelWidth - 30) @ 40.
	tt name: 'TheBoard'.
	ActiveWorld addMorph: tt.
	tt width: 250.
	self board: OrderedCollection new intoText: tt.
	^ tt! !

!PuzzleDescription methodsFor: 'initialize-release' stamp: 'tk 3/26/2013 16:44'!
initialize

	solver := CoopLangSimpleSearch new.
	solver prob: self.

	"User should override these"
	higherScoreIsGood := true.
	goodScore := 1.
	badMoveStaysBad := true.	"adding more pieces won't fix an illegal placement"
	oneVariableAtATime  := true.	"a subset of the variables can be evaluated"
	permutation := false.		"searching for a permutation of the variables"
	removePiecesFromBoard  := false.	"they stay on the board the entire time"
	searchByPosition := false.
	stopAfterNSolutions := 1.
	results := OrderedCollection new.
! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
noDifference

	^ noDifference! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
noDifference: anObject

	noDifference := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
oneVariableAtATime

	^ oneVariableAtATime! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
oneVariableAtATime: anObject

	oneVariableAtATime := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 2/23/2013 17:15'!
permutation

	^ permutation! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 2/23/2013 17:15'!
permutation: anObject

	permutation := anObject! !

!PuzzleDescription methodsFor: 'solve' stamp: 'tk 12/14/2012 22:50'!
piece: piece1 isSameAs: piece2
	"return true if they are considered to be the same.  May want to override this."
	
	^ piece1 stateArray = piece2 stateArray! !

!PuzzleDescription methodsFor: 'solve' stamp: 'tk 3/8/2013 16:22'!
remove: aPiece
	"Take this piece off the board.  It might or might not be there now.
	FOr speed, a piece should know its squares.
	squares for a piece that covers multiple squares.
	position for some kinds of pieces.
	Pay attention to equality issues."
	
	| sqs |
	(aPiece respondsTo: #squares) ifTrue: [
		sqs := aPiece squares.
		(solver board atLoc: sqs first ifInvalid: #outOfBounds) == aPiece ifFalse: [
			^ self].  "piece not really there"
		^ sqs do: [:loc | solver board atLoc: loc put: nil]].

	(aPiece respondsTo: #position) ifTrue: [
		(solver board atLoc: aPiece position ifInvalid: #outOfBounds) 
				== aPiece ifFalse: [^ self].  "piece not really there"
		^ solver board atLoc: aPiece position put: nil].

	"slow fallback"
	solver board withIndicesDo: [:pc :nRow :nCol | 
		pc == aPiece ifTrue: [solver board at: nRow at: nCol put: nil]].! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
removePiecesFromBoard

	^ removePiecesFromBoard! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
removePiecesFromBoard: anObject

	removePiecesFromBoard := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
results

	^ results! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
results: anObject

	results := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 3/29/2013 20:32'!
searchByPosition

	^ searchByPosition! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 3/29/2013 20:32'!
searchByPosition: anObject

	searchByPosition := anObject! !

!PuzzleDescription methodsFor: 'solve' stamp: 'tk 3/20/2013 05:57'!
snapshot
	"return an array that saves the info from this solution"
	
	| solution |
	solution := solver tryThese deepCopy.
	displayMorph ifNotNil: [
		self board: solution intoText: displayMorph.
		ActiveWorld doOneCycle].

	^ solution
	"or possibly record the entire board"! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/18/2012 12:20'!
solver

	^ solver! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/18/2012 12:20'!
solver: anObject

	solver := anObject! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
stopAfterNSolutions

	^ stopAfterNSolutions! !

!PuzzleDescription methodsFor: 'accessing' stamp: 'tk 12/14/2012 15:26'!
stopAfterNSolutions: anObject

	stopAfterNSolutions := anObject! !

PuzzleDescription subclass: #SudokuFullMaker
	instanceVariableNames: 'groupDeltas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!SudokuFullMaker methodsFor: 'as yet unclassified' stamp: 'tk 3/8/2013 17:37'!
evaluate: varArray
	"return a score for a board with the cells in varArray filled in.  1 means the new number does not coflict on any row, column, or group.. 0 means it does..  Start with a clean board and place the numbers on it.  varArray can by of any length.
	Only the last piece in varArray has changed.  We know the board is legal without it."
"For now, cells are always consitered in the same order.  varArray size tells where the location of that variable.  If we want to consider them in another order, store the loc in each variable."

	| rowNum colNum thisNum groupPair pair groupWidth brd |
	varArray size = 0 ifTrue: [^ 1].	"OK so far"
	thisNum := varArray last number.
	thisNum = 0 ifTrue: [^ 0].	"zero means cell is blank"
	brd := solver board.
	groupWidth := brd rowCount sqrt asInteger.  "3"
	"ugly because we don't know the coordinates of this cell"
	rowNum := (varArray size -1 // brd rowCount "9") + 1.
	colNum := (varArray size -1 \\ brd rowCount) + 1.
	"verify the right variable is there"
	(brd at: rowNum at: colNum) == varArray last ifFalse: [self error: 'cell is gone'].
	
	"test if already in this Row"
	((1 to: brd columnCount) count: [:colInd | 
		colInd = colNum 
			ifTrue: ["don't count one we just put in" false]
			ifFalse: [(brd at: rowNum at: colInd) number = thisNum]
		]) > 0 ifTrue: [^ 0].	"this number is already there"

	"test if already in this Column"
	((1 to: brd rowCount) count: [:rowInd | 
		rowInd = rowNum 
			ifTrue: ["don't count one we just put in" false]
			ifFalse: [(brd at: rowInd at: colNum) number = thisNum]
		]) > 0 ifTrue: [^ 0].	"this number is already there"

	"test if already in this Group"
	"find starting coords"
	groupPair :=  (colNum -1 // groupWidth * groupWidth + 1) @ 
				(rowNum -1 // groupWidth * groupWidth + 1).
	(groupDeltas count: [:pairIn | 
		pair := groupPair + pairIn.
		(pair y = rowNum and: [pair x = colNum]) 
			ifTrue: ["don't count one we just put in" false]
			ifFalse: [(brd atLoc: pair) number = thisNum]
		]) > 0 ifTrue: [^ 0].	"this number is already there"
	^ 1! !

!SudokuFullMaker methodsFor: 'as yet unclassified' stamp: 'tk 1/20/2013 18:53'!
solveSudoku4x4
	"Set up the problem of making a 4 by 4 Sudoku board.  Create a completely filled-in Sudoku board.  Initialize with 0 in every cell.  Place 1-4 in each cell.  Each row has no repeats, Each column has no repeats, Each Group of 2x2 has no repeats.
	SudokuFullMaker new solveSudoku4x4 explore.
	"
	
	| piece board vars boardWidth groupWidth |
	boardWidth := 4.   "use 4 as a test case"
	board := PuzzleBoard rows: boardWidth columns: boardWidth.
	solver board: board.
	vars := OrderedCollection new.
	board withIndicesDo: [:cell :row :col | "store the variables in the board"
		piece := (SudokuCell new).
		piece set: #number range: (0 to: boardWidth).
		piece number: 0.
		board at: row at: col put: piece.
		vars addLast: piece].
	groupWidth := board rowCount sqrt asInteger.  "2"
	groupDeltas := Array streamContents: [: strm |
		0 to: groupWidth-1 do: [:rr | 
			0 to: groupWidth-1 do: [:cc | strm nextPut: rr@cc]]].
		"0@0 0@1 1@0 1@1"

	"self initialize."
	solver variables: vars.
	higherScoreIsGood := true.
	goodScore := 1.
	oneVariableAtATime := true.	"a subset of the variables can be evaluated"
	"define same:as:"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 2.
	removePiecesFromBoard := false.	"cells stay where they are.  0 means empty"
	displayMorph := self initTextOfSingleChars: (String space, String cr).   "spacers"
	solver run.
	self board: nil "use latest results" intoText: displayMorph.
	^ { solver.  results }! !

!SudokuFullMaker methodsFor: 'as yet unclassified' stamp: 'tk 1/20/2013 18:53'!
solveSudoku9x9
	"Set up the problem of making a 9 by 9 Sudoku board.  Create a completely filled-in Sudoku board.  Initialize with 0 in every cell.  Place 1-9 in each cell.  Each row has no repeats, Each column has no repeats, Each Group of 3x3 has no repeats.
	SudokuFullMaker new solveSudoku9x9 explore.
	"
	
	| piece board vars boardWidth groupWidth |
	boardWidth := 9.   "use 4 as a test case"
	board := PuzzleBoard rows: boardWidth columns: boardWidth.
	solver board: board.
	vars := OrderedCollection new.
	board withIndicesDo: [:cell :row :col | "store the variables in the board"
		piece := (SudokuCell new).
		piece set: #number range: (0 to: boardWidth).
		piece number: 0.
		board at: row at: col put: piece.
		vars addLast: piece].
	groupWidth := board rowCount sqrt asInteger.  "3"
	groupDeltas := Array streamContents: [: strm |
		0 to: groupWidth-1 do: [:rr | 
			0 to: groupWidth-1 do: [:cc | strm nextPut: rr@cc]]].
		"0@0 0@1 0@2  ...  2@2"

	"self initialize."
	solver variables: vars.
	higherScoreIsGood := true.
	goodScore := 1.
	oneVariableAtATime := true.	"a subset of the variables can be evaluated"
	"define same:as:"
	badMoveStaysBad := true. 	"adding more variables (pieces) won't fix an illegal placement"
	stopAfterNSolutions := 10.
	removePiecesFromBoard := false.	"cells stay where they are.  0 means empty"
	displayMorph := self initTextOfSingleChars: (String space, String cr).   "spacers"
	solver run.
	self board: nil "use latest results" intoText: displayMorph.
	^ { solver.  results }! !

Object subclass: #PuzzlePiece
	instanceVariableNames: 'getters setters ranges indicies fullPositionRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!PuzzlePiece commentStamp: 'tk 3/20/2013 05:11' prior: 0!
A PuzzlePiece holds one or more variables.  Some combination of the variable values in all of the PuzzlePieces is the solution to this problem.  Each variable has a range.  Try all combinations of the values by calling advanceState.
	A piece may stay at the same place on the board always, or may be added and removed at different places.  (See removePiecesFromBoard:)
	In order to make a subclass look like the kind of class that the user would make for this piece, it has instance variables for each of its variables.
	The evaluate method (in the user's subclass) can have side-effects.  It places the piece on the board (if removePiecesFromBoard is true).  It can also speed things up by skipping variable values.  If a piece's primary square is already occupied, skip over all flips of that piece at the same position.  See advanceSkipVars:.

getters
	- list of the names of all of the variables to be searched

setters
	- list of their setters

ranges
	- list of intervals or arrays of values that each variable can take

indicies
	- list of how far along each variable is in its range.  Current values are (thisRange at: ind).
!

PuzzlePiece subclass: #EdgePoint
	instanceVariableNames: 'position midpoint center turn useMe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
center

	^ center! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
center: anObject

	center := anObject! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
midpoint

	^ midpoint! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
midpoint: anObject

	midpoint := anObject! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
position

	^ position! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
position: anObject

	position := anObject! !

!EdgePoint methodsFor: 'printing' stamp: 'tk 2/23/2013 23:42'!
printOn: strm
	strm nextPutAll: 'edgePoint ', midpoint printString! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
turn

	^ turn! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/9/2013 08:55'!
turn: anObject

	turn := anObject! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/12/2013 13:57'!
useMe

	^ useMe! !

!EdgePoint methodsFor: 'accessing' stamp: 'tk 2/12/2013 13:57'!
useMe: anObject

	useMe := anObject! !

PuzzlePiece subclass: #ElPiece
	instanceVariableNames: 'flip position id flipList edgeList turnList placeTries placeSuccesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!ElPiece commentStamp: 'tk 3/25/2013 11:17' prior: 0!
An ElPiece is a piece made of three squares that goes on a board.  It is what you can make with three squares joined on edges.  

Instance Variables
	flip			index into flipList -- the orientation of this piece
	dir			orientiation of the piece (X to the right, y goes down)
				1		2		3		4
				[][]		[][]		  []		[]
				[]		  []		[][]		[][]
							
	position	Point on the board
	flipList 		list of (list of squares in this orientation)
	edgeList	(optional) list of edges to go around the perimeter of this piece clockwise.
					(left, right, straight, straight, right, ...)
	placeTries 	number of times this piece was considered to place on the board, and the initial square was empty.
	placeSuccesses	number of times this piece was successfully placed on the board
	(smallest ratio placeSuccesses/placeTries indicates the hardest piece.  Place this piece first among the unplaced pieces.)!

!ElPiece methodsFor: 'testing' stamp: 'tk 4/3/2013 10:27'!
= other

	other class == self class ifFalse: [^ false].
	id = other id ifFalse: [^ false].
	flip = other flip ifFalse: [^ false].
	position = other position ifFalse: [^ false].
	^ true! !

!ElPiece methodsFor: 'testing' stamp: 'tk 12/18/2012 20:04'!
displayString

	^ id! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 2/24/2013 17:05'!
edgeList

	^ edgeList! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 2/24/2013 17:05'!
edgeList: anObject

	edgeList := anObject! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 1/24/2013 18:40'!
flip

	^ flip! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 1/24/2013 18:40'!
flip: anObject

	flip := anObject! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 1/24/2013 18:40'!
flipList

	^ flipList! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 1/24/2013 18:40'!
flipList: anObject

	flipList := anObject! !

!ElPiece methodsFor: 'testing' stamp: 'tk 1/24/2013 18:52'!
hash
	^ flip hash bitXor: position hash! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 12/18/2012 20:03'!
id

	^ id! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 12/18/2012 20:03'!
id: anObject

	id := anObject! !

!ElPiece methodsFor: 'testing' stamp: 'tk 3/25/2013 22:11'!
initialize

	super initialize.
	placeTries := placeSuccesses := 1.! !

!ElPiece methodsFor: 'testing' stamp: 'tk 1/24/2013 18:41'!
numberOfFlips
	"For this piece, how many orientations are there?"
	
	^ flipList size! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 11:18'!
placeSuccesses

	^ placeSuccesses! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 11:18'!
placeSuccesses: anObject

	placeSuccesses := anObject! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 11:18'!
placeTries

	^ placeTries! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 11:18'!
placeTries: anObject

	placeTries := anObject! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 8/10/2012 16:02'!
position

	^ position! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 8/10/2012 16:02'!
position: anObject

	position := anObject! !

!ElPiece methodsFor: 'testing' stamp: 'tk 3/4/2013 22:11'!
postCopy

	super postCopy.
	flipList := flipList copy.! !

!ElPiece methodsFor: 'testing' stamp: 'tk 4/6/2013 23:40'!
printOn: strm

	super printOn: strm.
	strm space; nextPutAll: id asString.
	strm space; nextPutAll: position printString.
	strm space; nextPutAll: flip printString.
	! !

!ElPiece methodsFor: 'testing' stamp: 'tk 1/24/2013 18:57'!
squares
	"return a list of points of squares covered by this piece in this orientation"
	
	^ (flipList at: flip) collect: [:sq | sq + position]! !

!ElPiece methodsFor: 'testing' stamp: 'tk 3/25/2013 14:41'!
successRatio
	"fraction of the time I can be placed"
	
	placeTries < 1 ifTrue: [^ 0.9].
	^ placeSuccesses asFloat / placeTries! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/3/2013 12:00'!
turnList

	^ turnList! !

!ElPiece methodsFor: 'accessing' stamp: 'tk 3/3/2013 12:00'!
turnList: anObject

	turnList := anObject! !

PuzzlePiece subclass: #LetterVariable
	instanceVariableNames: 'letter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!LetterVariable methodsFor: 'accessing' stamp: 'tk 8/18/2012 09:56'!
letter

	^ letter! !

!LetterVariable methodsFor: 'accessing' stamp: 'tk 8/18/2012 09:56'!
letter: anObject

	letter := anObject! !

!LetterVariable methodsFor: 'testing' stamp: 'tk 12/15/2012 10:14'!
prevState
	"go to the previous value that this object can have.  Return nil if at start already."
	
	| rr ind |
	rr := ranges at: 1 "letter".
	ind := indicies at: 1.
	(ind := ind - 1) < 1 
		ifTrue: [^ nil]
		ifFalse: [indicies at: 1 put: ind.
			letter := rr at: ind]
	"^ self"! !

!LetterVariable methodsFor: 'testing' stamp: 'tk 12/12/2012 16:27'!
printOn: strm

	"super printOn: strm."
	strm space; nextPutAll: letter asString; space.
	! !

!LetterVariable methodsFor: 'testing' stamp: 'tk 12/15/2012 10:11'!
randomState
	"a random state"

	| ii |
	indicies at: 1 "letter" put: (ii := (ranges at: 1) size atRandom).
	letter := (ranges at: 1) at: ii.
! !

PuzzlePiece subclass: #OneSquare
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!OneSquare methodsFor: 'accessing' stamp: 'tk 1/14/2013 21:45'!
= other
	^ self class == other class! !

!OneSquare methodsFor: 'accessing' stamp: 'tk 1/14/2013 21:45'!
hash
	^ position hash! !

!OneSquare methodsFor: 'accessing' stamp: 'tk 12/20/2012 18:08'!
position

	^ position! !

!OneSquare methodsFor: 'accessing' stamp: 'tk 12/20/2012 18:08'!
position: anObject

	position := anObject! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 3/20/2013 05:45'!
advanceSkipVars: listOfGetters
	"Skip over a bunch of states by setting variables to the last value in their range.  Do this in evaluate when we know that this piece won't fit and a minor varuable can't change that.  If a piece's primary square is already occupied, skip over all flips of that piece at the same position.
		Check that these are the variables that advanceState will change next (most rapidly)"
	
	| num varInds |
	num := listOfGetters size.
	listOfGetters asSet = (getters last: num) asSet
		ifFalse: [^ self error: listOfGetters printString, ' must be the last vars defined with set:range:'].
	varInds := (1 to: getters size) last: num.
	varInds do: [:whichVar |
		indicies at: whichVar put: (ranges at: whichVar) size.
		self perform: (setters at: whichVar) with: ((ranges at: whichVar) last)].
	"next advanceState will skip all of those states"! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2012 17:31'!
advanceState
	"go to the next enumeration of the values that this object can have.  Set my instance variables.  Return nil when done."

	| thisIndex |
	indicies size to: 1 by: -1 do: [:whichVar |
		(thisIndex := (indicies at: whichVar) + 1) <= (ranges at: whichVar) size 
			ifTrue: [
				indicies at: whichVar put: thisIndex.
				self perform: (setters at: whichVar) with: ((ranges at: whichVar) at: thisIndex).
				^ self] 
			ifFalse: ["exhausted this range.  Go up to previous variable"
				indicies at: whichVar put: 1.
				self perform: (setters at: whichVar) with: ((ranges at: whichVar) at: 1).
				]].
	"we have tried all combinations"
	^ nil! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 3/26/2013 20:00'!
advanceStateExceptPosition
	"Go to the next enumeration of the values that this object can have.  But, leave the position variable alone.  The run routine is managing that.  Set my instance variables.  Return nil when done."
	
	"positionRange positionIndex"

	| thisIndex |
	indicies size to: 1 by: -1 do: [:whichVar |
		(getters at: whichVar) == #position ifFalse: [
			(thisIndex := (indicies at: whichVar) + 1) <= (ranges at: whichVar) size 
				ifTrue: [
					indicies at: whichVar put: thisIndex.
					self perform: (setters at: whichVar) with: ((ranges at: whichVar) at: thisIndex).
					^ self] 
				ifFalse: ["exhausted this range.  Go up to previous variable"
					indicies at: whichVar put: 1.
					self perform: (setters at: whichVar) with: ((ranges at: whichVar) at: 1).
					]]].
	"we have tried all combinations"
	^ nil! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 12/18/2012 12:02'!
displayString
	"override this to return a string that goes in a TextMorph of the board"
	
	^ getters size = 1 ifTrue: [(self perform: getters first) asString] ifFalse: [' ']! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/28/2013 08:39'!
fullPositionRange

	^ fullPositionRange! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/28/2013 08:39'!
fullPositionRange: anObject

	fullPositionRange := anObject! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
getters

	^ getters! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
getters: anObject

	getters := anObject! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
indicies

	^ indicies! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
indicies: anObject

	indicies := anObject! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2012 17:37'!
initState
	"a starting state"
	1 to: indicies size do: [:whichVar |
		indicies at: whichVar put: 1.
		self perform: (setters at: whichVar) with: ((ranges at: whichVar) at: 1)].! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2012 09:09'!
initialize

	getters := Array new.
	setters := Array new.
	ranges := Array new.
	indicies := Array new.! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
ranges

	^ ranges! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
ranges: anObject

	ranges := anObject! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 3/28/2013 08:26'!
set: varName range: intervalOrRectangle
	"Establish a varuable in the search.  A subclass of GamePiece should have this as an instance variable. Remember the range of its values."
	
	| va base ww varNum vn |
	varNum := getters indexOf: (vn := varName asSymbol).
	varNum = 0 ifTrue: ["add this variable"
		varNum := getters size + 1.
		getters := getters, (Array with: vn).
		setters := setters, (Array with: (vn, ':') asSymbol).
		ranges := ranges, (Array with: nil).
		indicies := indicies, (Array with: nil)].
			"index into my range to tell which values have been tried"
	
	"Range must be an array of values"
	va := intervalOrRectangle.
	(va isKindOf: Point) ifTrue: [va := 1@1 corner: va].
	(va isKindOf: PuzzleBoard) ifTrue: [va := (1@1 corner: va extent)].
	(va isKindOf: Interval) ifTrue: [va := va asArray].
	(va isKindOf: Rectangle) ifTrue: [
		"origin and corner must be integer points"
		"expand to a linear array of points"
		base := va origin - (1@1).
		va := Array new: (ww := va width + 1) * (va height + 1).
		1 to: va size do: [:ind |
			va at: ind put: base + ((ind -1 \\ ww + 1) @ (ind -1 // ww + 1))]].
	ranges at: varNum put: va.		"order may be changed by optimizeRangeOrder"
	indicies at: varNum put: 0.
	varName = #position ifTrue: [fullPositionRange := va].
! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
setters

	^ setters! !

!PuzzlePiece methodsFor: 'accessing' stamp: 'tk 3/25/2013 18:56'!
setters: anObject

	setters := anObject! !

!PuzzlePiece methodsFor: 'as yet unclassified' stamp: 'tk 12/14/2012 22:50'!
stateArray
	"Return an Array with the current state of the variables"
	| res |
	res := Array new: indicies size.
	1 to: indicies size do: [:whichVar |
		res at: whichVar put: ((ranges at: whichVar) at: (indicies at: whichVar))].
	^ res! !

PuzzlePiece subclass: #SudokuCell
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CooperatingLanguages-Examples'!

!SudokuCell methodsFor: 'accessing' stamp: 'tk 12/14/2012 17:32'!
number

	^ number! !

!SudokuCell methodsFor: 'accessing' stamp: 'tk 12/14/2012 17:32'!
number: anObject

	number := anObject! !

!SudokuCell methodsFor: 'accessing' stamp: 'tk 12/14/2012 22:42'!
printOn: strm

	strm space; nextPutAll: number asString; space.
	! !
